	common datafiles, orbit, fname
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common paths, lastpath, currentpath, origpath, shlbfile
	common lisapp_prefs, app_prefs
	common bg_info, fnamestub, candobgs, bgname, bgpathtouse
	common fullpaths, app_path, data_path, bg_path, output_path
	common global_subsets, subset_events, subset_flashes, subset_groups, subset_areas, $
			subset_viewtimes, subset_one_seconds
			
@lisotd.pro
@lisapp_GlobalRoutines.pro
@lisapp_CreatePrefs.pro
@lisapp_QuickView.pro
@lisapp_ChooseBounds.pro
@lisapp_Analysis.pro
@lisapp_Export.pro
@lisapp_Verify.pro
@lisapp_Help.pro

pro lisapp

	common datafiles, orbit, fname
	common sysinfo,   version
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisbase, lisb
	common menuids, writelisbutton, plot_spatial_button, plot_array_button, verify_inbounds_button, ql_vt_button, ql_ev_button, $
					ql_ar_button, ql_fl_button, ql_gr_button, ql_menu, ed_ev_button, ed_gr_button, ed_fl_button, ed_ar_button, $
					ed_vt_button, ed_os_button, vd_menu, ql_bgfp_button, ql_al_button, plot_bg_button, $
					an_pix_button, an_bg_button, animate_menu, plot_nav_button, verify_regeo_button, exbg_button, $
					paths_prefs_button, graphics_prefs_button,doublepixels_button, add_vdata_button,plot_ts_button,afge_button, $
					densitybg_button, density_button, movieframe_button, export_menu, qlbrowse
					
					
	common active_windows, plot_array_flag, plot_geographic_flag
	common basewids, splash_win_id, start2, end2, area2, flash2, group2, event2, name, vt2, bg2, os2, im2
	common otd_boom, boom
	common paths, lastpath, currentpath, origpath, shlbfile
	common icons, otdimg, lisimg, otdred, otdgreen, otdblue, lisred, lisgreen, lisblue
	common lisapp_colors, red,green,blue
	common lisapp_prefs, app_prefs
	common fullpaths, app_path, data_path, bg_path, output_path
	common bg_info, fnamestub, candobgs, bgname, bgpathtouse

	!quiet = 1
	
	inbox = lonarr(2,16384)
	boom = bytarr(16384)
	openr,lun,'boom_box.dat',/get_lun
	readf,lun,inbox
	close,lun,/all
	boom = inbox(0,*)
	read_gif,'otdinsert.gif',otdimg,otdred,otdgreen,otdblue
	read_gif,'lisinsert.gif',lisimg,lisred,lisgreen,lisblue
	
	incolors = bytarr(4,136)
	openr,lun,'lisapp.ct',/get_lun
	readf,lun,incolors
	close,lun,/all
	
	red = incolors(1,*)
	green = incolors(2,*)
	blue = incolors(3,*)
	app_prefs = new_prefs_struct()
	openr,lun,'lisapp.prefs',/get_lun
	readu,lun,app_prefs
	close,lun
	free_lun,lun
	
	if (not iswindows(0)) then device,pseudo=8

	osfam = !version.os_family
	if (osfam eq 'MacOS') then begin
		; separator = 58
		separator = ''
	endif else begin 
		if (osfam eq 'unix') then begin
			; separator =47
			separator = '/'
		endif else begin
			; separator = 92
			separator = '\'
		endelse
	endelse
	
	if (app_prefs.paths.lisapp ne string(replicate(byte(32),132))) then begin
		origpath = strip_132(app_prefs.paths.lisapp)
		app_path = origpath
		print,'Original path found: '+origpath
	endif else begin
		origpath = ''
		cd, current=temppath
		origpath = temppath+separator
		lastpath = origpath
		app_path = origpath
		print,'Original path not found, using: '+origpath
	endelse
	if (app_prefs.paths.data ne string(replicate(byte(32),132))) then begin
		currentpath = strip_132(app_prefs.paths.data)
		cd, currentpath
		lastpath = currentpath
		data_path = currentpath
		print,'Data path found: '+currentpath
	endif else begin
		currentpath = origpath
		cd, currentpath
		data_path = origpath
		lastpath = ''
		print,'Data path not found, using: '+currentpath
	endelse
	if (app_prefs.paths.backgrounds ne string(replicate(byte(32),132))) then begin
		bg_path = strip_132(app_prefs.paths.backgrounds)
	endif else begin
		bg_path = data_path
	endelse
	if ((app_prefs.paths.output ne string(replicate(byte(32),132))) and (app_prefs.paths.output ne '')) then begin
		output_path = strip_132(app_prefs.paths.output)
	endif else begin
		output_path = app_path
	endelse
	bgpathtouse = bg_path
	
	plot_array_flag = 0 & plot_geographic_flag = 0
		
	readparams = [app_prefs.input.lis.area, app_prefs.input.lis.flash, app_prefs.input.lis.group, app_prefs.input.lis.event, $
				app_prefs.input.lis.viewtime, app_prefs.input.lis.onesecond]
	readparamsotd = [app_prefs.input.otd.area, app_prefs.input.otd.flash, app_prefs.input.otd.group, app_prefs.input.otd.event, $
				app_prefs.input.otd.viewtime, app_prefs.input.otd.onesecond]
	
	lisb = Widget_Base(column=1, title='LIS/OTD Analysis Suite', mbar=bar, tlb_frame_attr=8, scr_xsize=635, scr_ysize=250, $
				scroll=0,/align_center)
	
	; *****************
	; *** FILE MENU ***
	; *****************
	
	file_menu = widget_button(bar, value='File', /menu)
	
		getinfobutton = Widget_button(file_menu,value='Get Info...')
		loadlisbutton = Widget_Button(file_menu,value='Open orbit...')
		add_vdata_button = widget_button(file_menu,value='Add more vdata')
		writelisbutton = Widget_Button(file_menu,value='Save orbit as...')
		widget_control,writelisbutton,sensitive=0
		widget_control,add_vdata_button,sensitive=0
		prefs_menu = widget_button(file_menu, value='Preferences', /menu)
		
			lis_prefs_button = widget_button(prefs_menu, value='Input Settings')
			paths_prefs_button = widget_button(prefs_menu, value='Paths')
			graphics_prefs_button = widget_button(prefs_menu, value='Graphics')

		quitbutton = Widget_Button(file_menu,value='Quit')

	; No Longer Used!
	
	; *****************	
	; *** EDIT MENU ***
	; *****************
	
	; edit_menu = widget_button(bar, value='Edit', /menu)

		
	
	; **********************
	; *** QUICKVIEW MENU ***
	; **********************
	
	plot_menu = widget_button(bar, value='QuickView', /menu)

		qlbrowse = widget_button(plot_menu,value='Browse Image')
		plot_array_button = widget_button(plot_menu, value='Pixel Array')
		an_bg_button  = widget_button(plot_menu, value='Background Images')	
		ql_menu = widget_button(plot_menu, value='QuickLook',/menu)
	
			ql_vt_button = widget_button(ql_menu, value='QL Viewtimes')
			ql_ar_button = widget_button(ql_menu, value='QL Areas')
			ql_fl_button = widget_button(ql_menu, value='QL Flashes')
			ql_gr_button = widget_button(ql_menu, value='QL Groups')
			ql_ev_button = widget_button(ql_menu, value='QL Events')
			ql_bgfp_button = widget_button(ql_menu, value='QL Background Footprints')
			ql_al_button = widget_button(ql_menu, value='QL Alert Flags')
				
	
	; *********************
	; *** ANALYSIS MENU *** 
	; *********************
	
	animate_menu = widget_button(bar, value='Analysis',/menu)

		plot_nav_button = widget_button(animate_menu,value='Navigation Data')
		an_pix_button = widget_button(animate_menu, value='Pixel Animation')
		;plot_spatial_button = widget_button(animate_menu, value='Geographic')
		exbg_button = widget_button(animate_menu,value='Thresholds and Glint')
		plot_ts_button = widget_button(animate_menu,value='Flash Analysis')
		
	
	; *******************
	; *** EXPORT MENU ***
	; *******************

	export_menu = widget_button(bar, value='Export',/menu)
	
		vd_menu = widget_button(export_menu, value='Vdatas',/menu)
		
			ed_ar_button = widget_button(vd_menu,value='Areas')
			ed_fl_button = widget_button(vd_menu,value='Flashes')
			ed_gr_button = widget_button(vd_menu,value='Groups')
			ed_ev_button = widget_button(vd_menu,value='Events')
			ed_vt_button = widget_button(vd_menu,value='Viewtimes')
			ed_os_button = widget_button(vd_menu,value='One Seconds')
		
			widget_control, vd_menu, sensitive=0
			widget_control, ed_ar_button, sensitive=0
			widget_control, ed_fl_button, sensitive=0
			widget_control, ed_gr_button, sensitive=0
			widget_control, ed_ev_button, sensitive=0
			widget_control, ed_vt_button, sensitive=0
			widget_control, ed_os_button, sensitive=0

		plot_bg_button	= widget_button(export_menu, value='Location Plot')
		
		density_button = widget_button(export_menu, value='Density Map')
		
		densitybg_button = widget_button(export_menu, value='Density Map w/ BGs')
		
		movieframe_button = widget_button(export_menu, value='Movie Frames')
		
	; *******************
	; *** VERIFY MENU ***
	; *******************
	
	verify_menu = widget_button(bar, value='Verify', /menu)
	
		verify_inbounds_button = widget_button(verify_menu, value='Data in bounds')
		verify_regeo_button = widget_button(verify_menu,value='Re-Geolocation')
		doublepixels_button = widget_button(verify_menu,value='Repeat Events')
		afge_button = widget_button(verify_menu,value='AFGE Hierarchy')
	
	; ******************
	; *** TOOLS MENU ***
	; ******************
	
	tools_menu = widget_button(bar,value='Tools',/menu)
	
		tools_dt = widget_button(tools_menu,value='Date/Time Conversions')
		tools_flag = widget_button(tools_menu,value='Alert Flag Decoder')
		
		widget_control,tools_flag,sensitive=0
	
	; *****************
	; *** HELP MENU ***
	; *****************
	
	help_menu = widget_button(bar, value='Help', /menu)
	
		help_flags = widget_button(help_menu,value='Flags',/menu)
		
		help_flags_alert_summary = widget_button(help_flags,value='Alert Summary')
		help_flags_instrument = widget_button(help_flags,value='Instrument Alert')
		help_flags_platform   = widget_button(help_flags,value='Platform Alert')
		help_flags_external   = widget_button(help_flags,value='External Alert')
		help_flags_processing = widget_button(help_flags,value='Processing Alert')
		help_flags_ephem      = widget_button(help_flags,value='Ephemeris Quality')
		help_flags_attitude   = widget_button(help_flags,value='Attitude Quality')
		
		widget_control,help_flags_ephem,sensitive=0
		widget_control,help_flags_attitude,sensitive=0
	
	; **************************
	; *** MAIN DISPLAY PANEL ***
	; **************************
	
	main = widget_base(column=1,lisb,scroll=0, /align_center)
	
		name = widget_label(main,value='                 No orbits loaded yet                ',/align_center)
		
		main2 = widget_base(column=2,main,scroll=0,/align_center)
		
		splash = widget_draw(main2, colors=220,retain=2, frame=0, scr_xsize=86, scr_ysize=69, /align_left)
		summ1  = widget_base(row=2, main2, /align_right)
		
		start1 = widget_label(summ1, value='Start: ',/align_left)
		start2 = widget_label(summ1, value=' 00/00/00 00:00:00.000 UTC',/align_right)
		end1   = widget_label(summ1, value='End  : ',/align_left)
		end2   = widget_label(summ1, value=' 00/00/00 00:00:00.000 UTC',/align_right)
		
		summ2 = widget_base(main,column=4,/align_center)
		
		arealab = widget_label(summ2, value='Areas:     ',/align_left)
		area2 = widget_label(summ2,value='-----',/align_right)
		flashlab= widget_label(summ2, value='Flashes:   ',/align_left)
		flash2 = widget_label(summ2,value='-----',/align_right)
		grouplab= widget_label(summ2, value='Groups:    ',/align_left)
		group2 = widget_label(summ2,value='-----',/align_right)
		eventlab= widget_label(summ2, value='Events:    ',/align_left)
		event2 = widget_label(summ2,value='-----',/align_right)
		vtlab =    widget_label(summ2,value='Viewtimes: ',/align_left)
		vt2   =  widget_label(summ2,value='-----',/align_right)
		oslab =    widget_label(summ2,value='OneSecond: ',/align_left)
		os2   =  widget_label(summ2,value='-----',/align_right)
		bglab =    widget_label(summ2,value='Summaries: ',/align_left)
		bg2   =  widget_label(summ2,value='-----',/align_right)
		imlab =    widget_label(summ2,value='Images:    ',/align_left)
		im2   =  widget_label(summ2,value='-----',/align_right)

		gotparams = readparams
		gotparams[*] = 0
		candobgs = 0 & bgname = '' 
		new_sensitize_menus
		
		Widget_Control, lisb, /realize
		widget_control, verify_inbounds_button, sensitive = 0
		widget_control, verify_regeo_button, sensitive=0
		widget_control, exbg_button, sensitive=0
		widget_control, doublepixels_button,sensitive=0
		
		Widget_Control, splash, get_value=splash_win_id
	
;	read_gif,'lis.gif',lisimg,r,g,b
;	tvlct,r,g,b
;	wset,splash_win_id
;	tv,lisimg
	
	version = get_version()	
	if (version eq 4) then begin
		xmanager, 'lisapp', lisb, event='lisapp_menu_event'
	endif else if (version ge 5) then begin
			xmanager, 'lisapp', lisb, event='lisapp_menu_event', /no_block
		   endif else begin
		   	version = -1
		   	print, 'Unsupported IDL Version!'
		   endelse
end

pro lisapp_menu_event, event

	common datafiles, orbit, fname
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisbase, lisb
	common menuids, writelisbutton, plot_spatial_button, plot_array_button, verify_inbounds_button, ql_vt_button, ql_ev_button, $
					ql_ar_button, ql_fl_button, ql_gr_button, ql_menu, ed_ev_button, ed_gr_button, ed_fl_button, ed_ar_button, $
					ed_vt_button, ed_os_button, vd_menu, ql_bgfp_button, ql_al_button, plot_bg_button, $
					an_pix_button, an_bg_button, animate_menu, plot_nav_button, verify_regeo_button, exbg_button, $
					paths_prefs_button, graphics_prefs_button,doublepixels_button, add_vdata_button,plot_ts_button,afge_button, $
					densitybg_button, density_button, movieframe_button, export_menu, qlbrowse
	common active_windows, plot_array_flag, plot_geographic_flag
	common sensor_read, this_sensor, file_format
	common basewids, splash_win_id, start2, end2, area2, flash2, group2, event2, name, vt2, bg2, os2, im2
	common vtgrids, vtgrid, vtgridmask
	common bggrids, bggrid, bggridmask
	common icons, otdimg, lisimg, otdred, otdgreen, otdblue, lisred, lisgreen, lisblue
	common paths, lastpath, currentpath, origpath, shlbfile
	common sysinfo, version
	common bg_info, fnamestub, candobgs, bgname
	
	gotafileyet = 0
	widget_control, event.id, get_value=buttonvalue
	
	case buttonvalue of
		'Get Info...' : begin
						; Note you can't change the filter manually on Windows platform, so trap for that
						iswin = isonlywindows()
						if (iswin eq 1) then begin
							filstr = ""
						endif else begin
							filstr = "*SC*"
						endelse
						fname = compatible_pickfile(version,/read,filter=filstr,/must_exist)
						if (fname ne '') then begin
							which_sensor, fname, file_format
							if (file_format eq 'lis') then begin
								getvdcounts, fname, vdsizes
								READ_orbit_summary,fname,orbit_summary,status=status,_EXTRA=e
								TAI93_start = orbit_summary.TAI93_start
								TAI93_end   = orbit_summary.TAI93_end
								dt = new_datetime_structure(2)
								dt(0).tai93 = tai93_start
								dt(1).tai93 = tai93_end
								calc_datetime,dt
								msgstr = strarr(10)
								if (dt[0].utc.year ge 2000) then begin
									labyear = dt[0].utc.year-2000
								endif else begin
									labyear = dt[0].utc.year-1900	
								endelse
								msgstr(0) = fname
								msgstr(1) = string(format='("   Start:  ",(I2.2),"/",(I2.2),"/",(I2)," (",(I3.3),")   ",(I2.2),":",(I2.2),":",(F6.3)," UTC")', $
										dt(0).utc.month, dt(0).utc.day, labyear, dt(0).utc.doy, dt(0).utc.hour, dt(0).utc.minute, dt(0).utc.second)
								if (dt[1].utc.year ge 2000) then begin
									labyear = dt[1].utc.year-2000
								endif else begin
									labyear = dt[1].utc.year-1900
								endelse
								msgstr(2) = string(format='("   End  :  ",(I2.2),"/",(I2.2),"/",(I2)," (",(I3.3),")   ",(I2.2),":",(I2.2),":",(F6.3)," UTC")', $
										dt(1).utc.month, dt(1).utc.day, labyear, dt(1).utc.doy, dt(1).utc.hour, dt(1).utc.minute, dt(1).utc.second)
								msgstr(3)  = string(format='((I6),"    Areas")',vdsizes(2))
								msgstr(4)  = string(format='((I6),"    Flashes")',vdsizes(3))
								msgstr(5)  = string(format='((I6),"    Groups")',vdsizes(4))
								msgstr(6)  = string(format='((I6),"    Events")',vdsizes(5))
								msgstr(7)  = string(format='((I6),"    Viewtimes")',vdsizes(6))
								msgstr(8)  = string(format='((I6),"    Backgrounds")',vdsizes(7))
								msgstr(9)  = string(format='((I6),"    One-Seconds")',vdsizes(8))
								numlines = 10
								has_raster='false'
								h = hdf_open(fname,/read)
								if (h ne -1) then begin
									hdf_close,h
									h = hdf_open(fname,/read)
									r8n = hdf_dfr8_nimages(fname)
									hdf_close,h
									hdf_dfr8_restart
									if (r8n gt 0) then begin
										h = hdf_open(fname,/read)
										hdf_dfr8_getinfo,fname,r8w,r8h,r8hp
										hdf_dfr8_restart
										hdf_close,h
										has_raster='true'
										; print,r8w,r8h,r8hp
										h = hdf_open(fname,/read)
										browseimage=bytarr(r8w,r8h)
										hdf_dfr8_getimage,fname,browseimage,palette
										hdf_dfr8_restart
										hdf_close,h
									endif
								endif
							endif else begin
								if (file_format eq 'otd') then begin
									getoldvdcounts, fname, vdsizes
									READ_OLD_orbit_attributes,fname,orbit_attributes,status=status,_EXTRA=e
									TAI93_start = orbit_attributes.TAI93_start
									TAI93_end   = orbit_attributes.TAI93_end
									dt = new_datetime_structure(2)
									dt(0).tai93 = tai93_start
									dt(1).tai93 = tai93_end
									calc_datetime,dt							
									msgstr = strarr(10)
									msgstr(0) = fname
									msgstr(1) = string(format='("   Start:  ",(I2.2),"/",(I2.2),"/",(I4)," (",(I3.3),")   ",(I2.2),":",(I2.2),":",(F6.3)," UTC")', $
											dt(0).utc.month, dt(0).utc.day, dt(0).utc.year, dt(0).utc.doy, dt(0).utc.hour, dt(0).utc.minute, dt(0).utc.second)
									msgstr(2) = string(format='("   End  :  ",(I2.2),"/",(I2.2),"/",(I4)," (",(I3.3),")   ",(I2.2),":",(I2.2),":",(F6.3)," UTC")', $
											dt(1).utc.month, dt(1).utc.day, dt(1).utc.year, dt(1).utc.doy, dt(1).utc.hour, dt(1).utc.minute, dt(1).utc.second)
									msgstr(3)  = string(format='((I6),"    Areas")',vdsizes(0))
									msgstr(4)  = string(format='((I6),"    Flashes")',vdsizes(1))
									msgstr(5)  = string(format='((I6),"    Groups")',vdsizes(2))
									msgstr(6)  = string(format='((I6),"    Events")',vdsizes(3))
									msgstr(7)  = string(format='((I6),"    Viewtimes")',vdsizes(8))
									msgstr(8)  = string(format='((I6),"    Backgrounds")',vdsizes(6))
									msgstr(9)  = string(format='((I6),"    One-Seconds")',6100)
									numlines = 10
									has_raster='false'						
								endif else begin
									retval = dialog_message('This does not appear to be a LIS/OTD HDF file!',/error)
									numlines = 0
								endelse
							endelse
							if (numlines gt 0) then begin
								infob = widget_base(group_leader=lisb,/modal,tlb_frame_attr=1,scroll=0,title='HDF File Information',/base_align_center,row=5)
								infol = lonarr(numlines)
								for i=0,2,1 do begin
									infol(i) = widget_label(infob,value=msgstr(i),/align_center)
								endfor
								infob2 = widget_base(infob,column=2)
								infob3 = widget_base(infob2,row=numlines-3,/base_align_center,/align_center)
								if (has_raster eq 'true') then begin
									infob4 = widget_draw(infob2,colors=220,/align_center,xsize=r8w,ysize=r8h,retain=2)
								endif
								for i=3,numlines-1,1 do begin
									infol(i) = widget_label(infob3,value=msgstr(i),/align_center)
								endfor
								
								infodone = widget_button(infob,value='Done',/align_center)
								widget_control,infob,/realize
								if (has_raster eq 'true') then begin
									widget_control,infob4,get_value=browse_win_id
									wset,browse_win_id
									tvlct,palette(0,*),palette(1,*),palette(2,*)
									tv,rotate(browseimage,7)
								endif
								widget_control,infob,cancel_button=infodone
								xmanager, 'hdf_file_info', infob, event='selfkill'
							endif
						endif
					end
		'Open orbit...' :  begin
						; Note you can't change the filter manually on Windows platform, so trap for that
						iswin = isonlywindows()
						if (iswin eq 1) then begin
							filstr = ""
						endif else begin
							filstr = "*SC*"
						endelse
						fname = compatible_pickfile(version,/read, filter=filstr, /must_exist)						
						if (fname ne '') then begin
							print,'*'+fname+'*'
							vtgrid = fltarr(1,1)
							vtgrid(0,0) = -1
							vtgridmask = fltarr(1,1)
							vtgridmask(0,0) = -1
							bggrid = fltarr(1,1)
							bggrid(0,0) = -1
							bggridmask = fltarr(1,1)
							bggridmask(0,0) = -1
							osfam = !version.os_family
							if (osfam eq 'MacOS') then begin
								separator = 58
							endif else begin 
								if (osfam eq 'unix') then begin
									separator =47
								endif else begin
									separator = 92
								endelse
							endelse
							fnameb = byte(fname)
							dirmarks = max(where(fnameb eq separator))
							fnamesz = size(fnameb)
							fnamelen = fnamesz(1)
							if (dirmarks eq -1) then begin
								fnamestub = fname
							endif else begin
								fnamebstub = fnameb(dirmarks+1:fnamelen-1)
								fnamestub = string(fnamebstub)
							endelse
							
;							print,fnamestub
	
							 which_sensor, fname, sensor
							 if (sensor ne 'unknown') then begin
						 		widget_control,event.top,sensitive=0
						 		readstring = make_readstring(fname,sensor)
						 		print,systime()
						 		result=execute(readstring)
						 		print,systime()
						 		if (sensor eq 'lis') then gotparams = readparams
						 		if (sensor eq 'otd') then gotparams = readparamsotd
						 		file_format = sensor
						 		if (sensor eq 'otd') then begin
									this_sensor = 'otd'
								endif else begin
									this_sensor = determine_sensor()
								endelse
								sensor = this_sensor	
						 		widget_control,event.top,/sensitive
								if (sensor eq 'otd') then begin									
									img = otdimg
									tvlct,otdred,otdgreen,otdblue
									wset,splash_win_id & 	if (not iswindows(0)) then device,pseu=8
									tv,img
								endif else begin
									img = lisimg
									tvlct,lisred,lisgreen,lisblue
									wset,splash_win_id & 	if (not iswindows(0)) then device,pseu=8
									tv,img
								endelse
								se = new_datetime_structure(2)
								se(0).TAI93 = orbit.orbit_summary.TAI93_start
								se(1).TAI93 = orbit.orbit_summary.TAI93_end
								calc_datetime,se
								offset = 1900
								if (se[0].utc.year ge 2000) then offset = 2000
								sy = se(0).utc.year-offset 
								ey = se(1).utc.year-offset
								if (sy gt 100) then sy = sy - 100
								if (ey gt 100) then ey = ey - 100
								
								startstr = string(format='((I2.2),"/",(I2.2),"/",(I2.2)," (",(I3.3),") ",(I2.2),":",(I2.2),":",(F6.3))', $
											se(0).utc.month, se(0).utc.day, sy, se(0).utc.doy, se(0).utc.hour, se(0).utc.minute,       $
											se(0).utc.second)
								endstr   = string(format='((I2.2),"/",(I2.2),"/",(I2.2)," (",(I3.3),") ",(I2.2),":",(I2.2),":",(F6.3))',   $
											se(1).utc.month, se(1).utc.day, sy, se(1).utc.doy, se(1).utc.hour, se(1).utc.minute,       $
											se(1).utc.second)
								widget_control,start2,set_value=startstr
								widget_control,end2,set_value=endstr
								widget_control,name,set_value=fnamestub
								
								find_bg_file
										 		
								new_sensitize_menus
								
							 endif else begin
							 	errid = widget_message('Error - was unable to read file "'+fname+'"',title='Unrecognized File',/error)
							 endelse
						endif				
					 end
		'Add more vdata': begin
							add_more_vdata
					  end
		'Save orbit as...' :  begin
							fname = compatible_pickfile(version,/write)
							if (fname ne '') then begin 
							widget_control,event.top,sensitive=0		
							write_orbit, fname, orbit
							widget_control,event.top,/sensitive
						endif
					 end
		'Quit'	    : begin
						if (origpath ne string(replicate(byte(32),132))) then begin
							cd,origpath
						endif
						origpath = '' & lastpath = '' & currentpath = ''
						app_path = '' & data_path = '' & bg_path = '' & output_path = ''
						orbit = 0
						widget_control, event.top, /destroy
					 end
		'Input Settings' : begin
						lisapp_getlisreadparams, event.top
					  end
		'Paths'		 : begin
						pathswid
					   end
		'Graphics'		 : begin
						prefs_graphics, event.top
					   end
		'Pixel Array' 	 : begin
						if (plot_array_flag eq 0) then plot_array
					   end
		'Geographic'	 : begin
						if (plot_geographic_flag eq 0) then plot_geographic
					   end
		'Data in bounds' : begin
						verify_data_inbounds, event.top
					   end
		'Re-Geolocation'  : begin
						verify_regeolocation, event
					   end
		'Browse Image'	  : begin
						quicklook_browse_image, event
					    end
		'QL Viewtimes' 	  : begin
						quicklook_viewtimes, event
					    end
		'QL Areas'	  : begin
						quicklook_areas, event
					    end
		'QL Flashes'	  : begin
						quicklook_flashes, event
					    end
		'QL Groups'	  : begin
						quicklook_groups, event
					    end
		'QL Events'	  : begin
						quicklook_events, event
					    end
		'QL Background Footprints': begin
						quicklook_bg_footprints
					    end
	     'QL Alert Flags':	begin
	     					  quicklook_alert_flags
	     					end
		'Background Images': begin
						animate_bgs, event
						end

		'Navigation Data': begin
						choose_bounds,0
						; plot_nav, event
				   end
		'Pixel Animation'	  : begin
						choose_bounds,1
						;animate_events, event
					    end
		'Thresholds and Glint':begin
						;examine_bgs,lisb
						choose_bounds,2
						end
		'Flash Analysis': begin
						choose_bounds, 3
				       end
		'Events'		  : begin
						choose_bounds, 4
						; ev_table, event, sort(orbit.point.lightning.event(*).TAI93_time)
					    end
		'Groups'		  : begin
						choose_bounds, 5
						; gr_table, event, sort(orbit.point.lightning.group(*).TAI93_time)
					    end
		'Flashes'		  : begin
						choose_bounds,6
						; fl_table, event, sort(orbit.point.lightning.flash(*).TAI93_time)		
					    end
		'Areas'		  : begin
						choose_bounds, 7
						; ar_table, event, sort(orbit.point.lightning.area(*).TAI93_time)								
					    end
		'Viewtimes'	  : begin
						choose_bounds, 8
						; vt_table, event, sort(orbit.point.viewtime(*).TAI93_start)
					    end
		'One Seconds'	  : begin
						choose_bounds, 9
						; os_table, event, lindgen(orbit.orbit_summary.one_second_count)
					    end
		'Location Plot'	 : begin
						;select_bgs
						choose_bounds,10
					   end
		'Density Map':begin
						choose_bounds,11
				   end
		'Density Map w/ BGs':begin
						choose_bounds,12
					end
		'Movie Frames':begin
						choose_bounds,13	
				   end
				   
		'Alert Summary'  : begin
						flaghelp_alert_summary,lisb
					   end
		'Instrument Alert' : begin
						flaghelp_instrument_alert,lisb
						end
		'Platform Alert': begin
						flaghelp_platform_alert,lisb
					  end
		'External Alert':begin
						flaghelp_external_alert,lisb
					  end
		'Processing Alert':begin
						flaghelp_processing_alert,lisb
					   end
		'Date/Time Conversions':begin
						datetime_tool,lisb
						end
		'Repeat Events':begin
						verify_doublepixels
					end
		'AFGE Hierarchy':begin
						verify_afge_tree
					end
	endcase
	
end

pro new_sensitize_menus

	common datafiles, orbit, fname
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisbase, lisb
	common menuids, writelisbutton, plot_spatial_button, plot_array_button, verify_inbounds_button, ql_vt_button, ql_ev_button, $
					ql_ar_button, ql_fl_button, ql_gr_button, ql_menu, ed_ev_button, ed_gr_button, ed_fl_button, ed_ar_button, $
					ed_vt_button, ed_os_button, vd_menu, ql_bgfp_button, ql_al_button, plot_bg_button, $
					an_pix_button, an_bg_button, animate_menu, plot_nav_button, verify_regeo_button, exbg_button, $
					paths_prefs_button, graphics_prefs_button,doublepixels_button, add_vdata_button,plot_ts_button,afge_button, $
					densitybg_button, density_button, movieframe_button, export_menu, qlbrowse
	common active_windows, plot_array_flag, plot_geographic_flag
	common sensor_read, this_sensor, file_format
	common basewids, splash_win_id, start2, end2, area2, flash2, group2, event2, name, vt2, bg2, os2, im2
	common vtgrids, vtgrid, vtgridmask
	common bggrids, bggrid, bggridmask
	common icons, otdimg, lisimg, otdred, otdgreen, otdblue, lisred, lisgreen, lisblue
	common paths, lastpath, currentpath, origpath, shlbfile
	common sysinfo, version
	common cando,	canbrowse, canpixarray, canbgimg, canqlvt, canqla, canqlf, canqlg, canqle, canqlbgf, caqlaf, $
				cannav, canpixan, canthrgl, canflan,canvda,canvdf,canvdg,canvde,canvdvt,canvdos,canloc,candens, $
					candensbg, canmovfrm
	common bg_info, fnamestub, candobgs, bgname, bgpathtouse
					
	canbrowse = 0 & canpixarray = 1 & canbgimg = 0 & canqlvt = 1 & canqla = 1 & canqlf = 1 
	canqlg = 1 & canqle = 1 & canqlbgf = 0 & canqlaf = 1 & cannav = 1 & canpixan = 1 & canthrgl = 1 & canflan = 1 
	canvda = 1 & canvdf = 1 & canvdg = 1 & canvde = 1 & canvdvt = 1 & canvdos = 1 & canloc = 1 & candens = 1 & canmovfrm = 1

	; print,gotparams
	
	; For each vdata, do bit ops to turn things on and off
	
		; Check to see if this appears to be a no-lightning file (single AFGE entries)
		
		readafileyet = (total(gotparams[0:5]) gt 0)
		if readafileyet then begin
			got_ltg = ((orbit.point.point_summary.area_count gt 1) or (orbit.point.point_summary.flash_count gt 1) $
				or (orbit.point.point_summary.group_count gt 1) or (orbit.point.point_summary.event_count gt 1))
		endif else begin
			got_ltg = 0
		endelse
		
		; Areas
		gotthis = gotparams[0] and got_ltg
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canqla    = canqla    and gotthis
		canflan   = canflan   and gotthis
		canvda    = canvda    and gotthis
		
		; Flashes
		gotthis = gotparams[1] and got_ltg
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canqlf    = canqlf    and gotthis
		canflan   = canflan   and gotthis
		canvdf    = canvdf    and gotthis
		candens   = candens   and gotthis
		
		; Groups
		gotthis = gotparams[2] and got_ltg
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canqlg    = canqlg    and gotthis
		canpixan  = canpixan  and gotthis
		canflan   = canflan   and gotthis
		canvdg    = canvdg    and gotthis
		candens   = candens   and gotthis
		
		; Events
		gotthis	= gotparams[3] and got_ltg
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canpixarray = canpixarray and gotthis
		canqle    = canqle    and gotthis
		canpixan  = canpixan  and gotthis
		canthrgl  = canthrgl  and gotthis
		canflan   = canflan   and gotthis
		canvde    = canvde    and gotthis
		candens   = candens   and gotthis
		canmovfrm = canmovfrm and gotthis
		
		; Viewtimes
		gotthis = gotparams[4]
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canqlvt   = canqlvt   and gotthis
		canvdvt   = canvdvt   and gotthis
		candens   = candens   and gotthis
		
		; One Seconds
		gotthis = gotparams[5]
		canbrowse = canbrowse or  gotthis
		canbgimg  = canbgimg  or  gotthis
		canqlbgf  = canqlbgf  or  gotthis
		canqlaf   = canqlaf   and gotthis
		cannav    = cannav    and gotthis
		canthrgl  = canthrgl  and gotthis
		canflan   = canflan   and gotthis
		canvda    = canvda    and gotthis
		canvdf    = canvdf    and gotthis
		canvdg    = canvdg    and gotthis
		canvde    = canvde    and gotthis
		canvdvt   = canvdvt   and gotthis
		canvdos   = canvdos   and gotthis
		canloc    = canloc    and gotthis
		candens   = candens   and gotthis
		canmovfrm = canmovfrm and gotthis
	
	; Consider whether we've found a BG file or not...

	canbgimg = canbgimg and candobgs
	canthrgl = canthrgl and candobgs
	canloc   = canloc and candobgs
	candensbg = candens and candobgs
	
	; QuickView Menu
	
	widget_control,qlbrowse,sensitive=canbrowse
	widget_control,plot_array_button,sensitive=canpixarray
	widget_control,an_bg_button,sensitive=canbgimg
	widget_control,ql_vt_button,sensitive=canqlvt
	widget_control,ql_ar_button,sensitive=canqla
	widget_control,ql_fl_button,sensitive=canqlf
	widget_control,ql_gr_button,sensitive=canqlg
	widget_control,ql_ev_button,sensitive=canqle
	widget_control,ql_bgfp_button,sensitive=canqlbgf
	widget_control,ql_al_button,sensitive=canqlaf
	
	; Analysis Menu
	
	widget_control,plot_nav_button,sensitive=cannav
	widget_control,an_pix_button,sensitive=canpixan
	widget_control,exbg_button,sensitive=canthrgl
	widget_control,plot_ts_button,sensitive=canflan
	
	; Export Menu
	
	widget_control,ed_ar_button,sensitive=canvda
	widget_control,ed_fl_button,sensitive=canvdf
	widget_control,ed_gr_button,sensitive=canvdg
	widget_control,ed_ev_button,sensitive=canvde
	widget_control,ed_vt_button,sensitive=canvdvt
	widget_control,ed_os_button,sensitive=canvdos
	widget_control,plot_bg_button,sensitive=canloc
	widget_control,density_button,sensitive=candens
	widget_control,densitybg_button,sensitive=candensbg
	widget_control,movieframe_button,sensitive=canmovfrm
	
	; Sensitive File Menu Stuff
	
	widget_control, add_vdata_button,sensitive= $
	 	(total(gotparams(0:5)) ne 6 and total(gotparams(0:5)) gt 0)
	widget_control, writelisbutton, sensitive= $
		(total(gotparams) eq 6)

	; Sensitize submenus

	widget_control, ql_menu, sensitive= $
		(canqla or canqlf or canqlg or canqle or canqlbgf or canqlaf or canqlvt)
	widget_control, vd_menu, sensitive= $
		(canvda or canvdf or canvdg or canvde or canvdvt or canvdos)
	
	; Sensitize Verify Menu Stuff
	
	widget_control,afge_button,sensitive= $
		((total(gotparams(0:3)) eq 4) and got_ltg)
	widget_control,verify_regeo_button,sensitive= $
		(((gotparams(5) eq 1 and gotparams(3) eq 1)) and got_ltg)
	widget_control,doublepixels_button,sensitive= $
		(((gotparams(3) eq 1) and got_ltg))
	widget_control,verify_inbounds_button,sensitive= $
		(total(gotparams(0:5)) gt 0)

	; Update main panel display

	if (gotparams(0) eq 1) then begin
		widget_control,area2,set_value=string(orbit.point.point_summary.area_count*got_ltg)
	endif else begin
		widget_control,area2,set_value='-----'
	endelse
	if (gotparams(1) eq 1) then begin
		widget_control,flash2,set_value=string(orbit.point.point_summary.flash_count*got_ltg)
	endif else begin
		widget_control,flash2,set_value='-----'
	endelse
	if (gotparams(2) eq 1) then begin
		widget_control,group2,set_value=string(orbit.point.point_summary.group_count*got_ltg)
	endif else begin
		widget_control,group2,set_value='-----'
	endelse
	if (gotparams(3) eq 1) then begin
		 widget_control,event2,set_value=string(orbit.point.point_summary.event_count*got_ltg)
	endif else begin
		widget_control,event2,set_value='-----'
	endelse
	if (gotparams(4) eq 1) then begin
		widget_control,vt2,set_value=string(orbit.point.point_summary.vt_count)
	endif else begin
		widget_control,vt2,set_value='-----'
	endelse
	if (total(gotparams[0:5]) gt 0) then begin
		widget_control,bg2,set_value=string(orbit.point.point_summary.bg_count)
	endif else begin
		widget_control,bg2,set_value='-----'
	endelse
	if (gotparams(5) eq 1) then begin
		widget_control,os2,set_value=string(orbit.orbit_summary.one_second_count)
	endif else begin	
		widget_control,os2,set_value='-----'
	endelse
	if (candobgs eq 1) then begin	
		widget_control,im2,set_value=string(orbit.point.point_summary.bg_count)
	endif else begin
		widget_control,im2,set_value='-----'
	endelse

end

pro add_more_vdata

	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisbase, lisb
	common addids, addb, options, addbutton, cancelbutton, donthave
	common sysinfo, version
	common kludge, passthru,passposs
	
	addb = Widget_Base(column=1, title='Select Vdata to Add', tlb_frame_attr=8, scroll=0, $
				event_pro='add_more_vdata_event',/modal,group_leader=lisb, /base_align_center)

	possibilities = ['Areas','Flashes','Groups','Events','Viewtimes','One-Seconds']
	passthru = ['area','flash','group','event','viewtime','one_second']
	
	donthave = strarr(6-total(gotparams(*)))
	passposs = strarr(6-total(gotparams(*)))
	donthaveidx = 0
	for i =0,5,1 do begin
		if (gotparams(i) eq 0) then begin
			donthave(donthaveidx) = possibilities(i)
			passposs(donthaveidx) = passthru(i)
			donthaveidx = donthaveidx + 1
		endif
	endfor
	
	options = CW_Bgroup(addb,donthave,label_left='Remaining Vdatas:',frame=1,set_value=0,/exclusive,column=2,/return_name,event_func='toggle_prefs')
	
	enact = Widget_base(addb, column=2, group_leader = topid,/align_center)
	
	Widget_Control, enact, /realize
	
	addbutton = Widget_Button(enact, value='Add')
	cancelbutton = Widget_Button(enact, value='Cancel')

	Widget_Control, addb, cancel_button = cancelbutton
	Widget_Control, addb, /realize
	xmanager, 'add_more_vdata', addb, event='add_more_vdata_event'
	
end

pro add_more_vdata_event, event
	common addids, addb, options, addbutton, cancelbutton, donthave
	common datafiles, orbit, fname
	common kludge, passthru, passposs
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	case 1 of 
		(event.id eq options): begin
							widget_control, event.id, get_value = buttonvalue
						end
		(event.id eq cancelbutton):begin
							widget_control, addb, /destroy
						end
		(event.id eq addbutton):begin
							widget_control, options, get_value = buttonvalue
							; print,donthave(buttonvalue)
							widget_control, addb, /destroy
							add_vdata, orbit, fname, passposs(buttonvalue)
							case passposs(buttonvalue) of
								'area': begin
										gotparams(0) = 1
									   end
								'flash':begin
										gotparams(1) = 1
									   end
								'group':begin
										gotparams(2) = 1
									   end
								'event':begin
										gotparams(3) = 1
									   end
								'viewtime':begin
										gotparams(4) = 1
									   end
								'one_second':begin
										gotparams(5) = 1
									   end
							endcase
							new_sensitize_menus
						end
	endcase

end


pro datetime_tool,lisb

	common dtt, dtb, dtyr, dtmo, dtdy, dtdoy, dthr, dtmi, dtse, dttai, dtgps
	common dtt2, dtb1
	
	dtb = widget_base(group_leader=lisb,title='Date/Time Conversions',row=11)
	msgstr = 'Enter one or more fields, then "Calculate".  Hit "Reset" to perform another conversion.'
	dtmsg = widget_text(dtb,ysize=3,scr_xsize=300,value=msgstr,/wrap,/scroll)
	widget_control,dtmsg,set_text_top_line=0
	dttai = cw_field(dtb,title='TAI93     ',value='')
	dtyr = cw_field(dtb,title='Year       ',value='')
	dtmo = cw_field(dtb,title='Month      ',value='')
	dtdy = cw_field(dtb,title='Day        ',value='')
	dthr = cw_field(dtb,title='Hour       ',value='')
	dtmi = cw_field(dtb,title='Minute     ',value='')
	dtse = cw_field(dtb,title='Second     ',value='')
	dtgps = cw_field(dtb,title='GPS       ',value='')
	dtdoy= cw_field(dtb,title='Day of Year',value='')
	dtbb = widget_base(dtb,column=3)
	dtb1 = widget_button(dtbb,value='Calculate')
	dtb2 = widget_button(dtbb,value='Reset')
	dtb3 = widget_button(dtbb,value='Done')
	
	widget_control,dtb,/realize
	xmanager,'datetime_tool',dtb,event='datetime_event',/no_block
end

pro datetime_event,event

	common dtt, dtb, dtyr, dtmo, dtdy, dtdoy, dthr, dtmi, dtse, dttai, dtgps
	common dtt2, dtb1
	
	widget_control, event.id, get_value=buttonvalue
	
	case buttonvalue of 
		'Done':begin
			widget_control,dtb,/destroy
			  end
		'Reset':begin
			widget_control,dtyr,set_value=''
			widget_control,dtmo,set_value=''
			widget_control,dtdy,set_value=''
			widget_control,dtdoy,set_value=''
			widget_control,dthr,set_value=''
			widget_control,dtmi,set_value=''
			widget_control,dtse,set_value=''
			widget_control,dttai,set_value=''
			widget_control,dtgps,set_value=''
			widget_control,dtb1,/sensitive
			end
		'Calculate': begin
			widget_control,dtyr,get_value=in_year
			widget_control,dtmo,get_value=in_month
			widget_control,dtdy,get_value=in_day
			widget_control,dtdoy,get_value=in_doy
			widget_control,dthr,get_value=in_hour
			widget_control,dtmi,get_value=in_minute
			widget_control,dtse,get_value=in_second
			widget_control,dttai,get_value=in_tai
			widget_control,dtgps,get_value=in_gps
			dt = new_datetime_structure(1)
			if (in_year(0) ne '') then dt.utc.year = fix(in_year(0))
			if (in_month(0) ne '') then dt.utc.month = fix(in_month(0))
			if (in_day(0) ne '') then dt.utc.day = fix(in_day(0))
			if (in_hour(0) ne '') then dt.utc.hour = fix(in_hour(0))
			if (in_minute(0) ne '') then dt.utc.minute = fix(in_minute(0))
			if (in_second(0) ne '') then dt.utc.second = double(in_second(0))
			if (in_tai(0) ne '') then dt.tai93 = double(in_tai(0))
			if (in_gps(0) ne '') then dt.gps = double(in_gps(0))
			if (in_doy(0) ne '') then dt.utc.doy = fix(in_doy(0))
			calc_datetime,dt
			if (dt.utc.year gt -99) then  widget_control,dtyr,set_value=string(format='(I4)',dt.utc.year)
			if (dt.utc.month gt -99) then widget_control,dtmo,set_value=string(format='(I2.2)',dt.utc.month)
			if (dt.utc.day gt -99) then   widget_control,dtdy,set_value=string(format='(I2.2)',dt.utc.day)
			if (dt.utc.second gt -99) then widget_control,dtse,set_value=string(format='(F6.3)',dt.utc.second)
			if (dt.utc.hour gt -99) then widget_control,dthr,set_value=string(format='(I2.2)',dt.utc.hour)
			if (dt.utc.minute gt -99) then widget_control,dtmi,set_value=string(format='(I2.2)',dt.utc.minute)
			if (dt.tai93 gt -99) then widget_control,dttai,set_value=string(format='(F15.3)',dt.tai93)
			if (dt.gps gt -99) then widget_control,dtgps,set_value=string(format='(F15.3)',dt.gps)
			if (dt.utc.doy gt -99) then widget_control,dtdoy,set_value=string(format='(I3.3)',dt.utc.doy)
			widget_control,dtb1,sensitive=0
			end
	endcase
end

pro read_cal_hdfs, ac, dc
	common paths, lastpath, currentpath, origpath, shlbfile
	cd, origpath
	dc = fltarr(2,128,128,3)
	ac = fltarr(2,41,128,4)
	osfam = !version.os_family
	if (osfam eq 'unix') then begin
		filename=origpath+'/calibration_dc.hdf'
	endif else begin
		filename 	= origpath+'calibration_dc.hdf'
	endelse
	fileid   	= HDF_OPEN(filename)
	sd_id 	= HDF_SD_START(filename,/read)
	sds_id	= HDF_SD_SELECT(sd_id,0)
	HDF_SD_GETDATA,sds_id,dc
	HDF_SD_ENDACCESS,sds_id	
	HDF_SD_END,sd_id
	HDF_CLOSE,fileid
	close,/all

	if (osfam eq 'unix') then begin
		filename=origpath+'/calibration_ac.hdf'
	endif else begin
		filename 	= origpath+'calibration_ac.hdf'
	endelse
	fileid   	= HDF_OPEN(filename)
	sd_id 	= HDF_SD_START(filename,/read)
	sds_id	= HDF_SD_SELECT(sd_id,0)
	HDF_SD_GETDATA,sds_id,ac
	HDF_SD_ENDACCESS,sds_id	
	HDF_SD_END,sd_id
	HDF_CLOSE,fileid
	close,/all
	cd,currentpath
end


pro find_bg_file
	common fullpaths, app_path, data_path, bg_path, output_path
	common datafiles, orbit, fname
	common sensor_read, this_sensor, file_format
	common bg_info, fnamestub, candobgs, bgname, bgpathtouse
	
	foundbg = 0
	if (file_format eq 'otd') then begin
		filename = fname
		foundbg = 1
		;print,'Its an OTD file; bgs should be inside'
	endif else begin
		bfname = byte(fname)
		capS = where(bfname eq 83,count)
		if (count lt 1) then begin
			; print,"I cant find the background file - is this a standard LIS/OTD name?"
			foundbg = 0
			;print,'LIS file but funky name'
		endif else begin
			sc_index = 0
			fnamesz = size(bfname)
			fnamelen = fnamesz(1)
			naming = 'old'
			for i = 0,count-1,1 do begin
				if (capS(i) le (fnamelen-3)) then begin
					if ((bfname(capS(i)+1) eq 67) and (bfname(capS(i)+2) eq 73)) then begin
						sc_index = capS(i)
						naming = 'old'
					endif else	 begin
						if ((bfname(capS(i)+1) eq 67)) then begin
							sc_index = capS(i)
							naming = 'new'
						endif 
					endelse									
				endif
			endfor
			if (naming eq 'old') then begin
				bfname(sc_index) = 66 & bfname(sc_index+1) = 65 & bfname(sc_index+2) = 67
			endif else begin
				bfname(sc_index) = 66 & bfname(sc_index+1) = 71
			endelse
			filename = string(bfname)
			; print,'Loading background file ',bfname
			foundbg = HDF_ishdf(filename)
			if (foundbg eq 1) then begin
				;print,'LIS file, standard name'
				cd,current=thispath
				bgpathtouse = thispath
			endif else begin
				;print,'LIS file, not in same directory as SC data'
			endelse
		endelse
	endelse
	
	; If the file is OTD format, or LIS format and in the proper naming convention and same
	;   directory, foundbg should be 1 now.  If not, the file is possibly in another directory.
	;   First check the default background path specified in the user preferences...
	
	if (foundbg eq 0) then begin
		; Recreate a new path+name based on the user-supplied background path...
		
		; Don't need the code below; bg_path should have a proper sepearator already
		; Add better end-of-string checking in case user has set it wrong...
		
		osfam = !version.os_family
		if (osfam eq 'MacOS') then begin
			; separator = 58
			separator = ''
		endif else begin 
			if (osfam eq 'unix') then begin
				; separator =47
				separator = '/'
			endif else begin
				; separator = 92
				separator = '\'
			endelse
		endelse
		
		bfname = byte(bgpathtouse+fnamestub)
		capS = where(bfname eq 83,count)
		if (count lt 1) then begin
			; print,"I can't find the background file - is this a standard LIS/OTD name?"
			foundbg = 0
			;print,'LIS file, still funky name'
		endif else begin
			sc_index = 0
			fnamesz = size(bfname)
			fnamelen = fnamesz(1)
			naming = 'old'
			for i = 0,count-1,1 do begin
				if (capS(i) le (fnamelen-3)) then begin
					if ((bfname(capS(i)+1) eq 67) and (bfname(capS(i)+2) eq 73)) then begin
						sc_index = capS(i)
						naming = 'old'
					endif else	 begin
						if ((bfname(capS(i)+1) eq 67)) then begin
							sc_index = capS(i)
							naming = 'new'
						endif 
					endelse									
				endif
			endfor
			if (naming eq 'old') then begin
				bfname(sc_index) = 66 & bfname(sc_index+1) = 65 & bfname(sc_index+2) = 67
			endif else begin
				bfname(sc_index) = 66 & bfname(sc_index+1) = 71
			endelse
			filename = string(bfname)
			; print,'Loading background file ',bfname
			foundbg = HDF_ishdf(filename)
			if (foundbg eq 1) then begin
				;print,'LIS file, in user-specified BG directory'
				cd,current=thispath
				bgpathtouse = thispath
			endif else begin
				;print,'LIS file, but I give up - cant find it!'
			endelse
		endelse
	endif
	
	if (foundbg eq 1) then begin
		candobgs = 1
		bgname = filename
	endif else begin
		candobgs = 0
		bgname = ''
		result = dialog_message("Could not find a matching background file ... do you want to locate it manually?",$
				/question)
		if (result eq 'Yes') then begin
			bgname = dialog_pickfile(/read,get_path=bg_path,/noconfirm,/must_exist)
			;print,bgname
			if (bgname eq '') then begin
				candobgs = 0
			endif else begin
				candobgs = HDF_ishdf(bgname)
				;print,candobgs
				bgpathtouse = bg_path
			endelse
		endif
	endelse
			
;	uid=-1
;	if HDF_ishdf(filename) ne 1 then begin
;		message,"File "+filename+" is not an HDF file."
;	endif
;	
;	fileid=HDF_OPEN(filename,/read)
;	printf,uid," FILENAME       : ",filename
;
;	sd_id=HDF_SD_START(filename,/read)
;	HDF_SD_FILEINFO,sd_id,nmfsds,nglobatts
;	
;	wset,bgwaitdraw_id & 	if (not iswindows(0)) then device,pseu=8
;	
;	tvlct,red,green,blue
;	
;	for i=0,nmfsds-1 do begin
;		sds_id=HDF_SD_SELECT(sd_id,i)
;	     	HDF_SD_GETINFO,sds_id,name=n,ndims=r,type=t,natts=nats,$
;	                         hdf_type=h,unit=u
;	          	          	
;	     	if r gt 0 then HDF_SD_GETINFO,sds_id,dims=dims else dims=0
;	
;		for j=0,nats-1 do begin
;		 	HDF_SD_ATTRINFO,sds_id,j,name=n,type=t,count=c,data=d,$
;	                            hdf_type=h
;	     	endfor
;	       		  
;          	inbg = intarr(128,128)
;          	for iii=0,num_requested-1,1 do begin
;         		; print,iii
;          		hdf_sd_getdata,sds_id,inbg,start=[0,0,bg_indices(iii)],count=[128,128,1];
;			bgs_requested(*,*,iii) = inbg	
;			msgstr = string(format='("Loading image ",(I3)," of ",(I3))',iii+1,num_requested)
;			widget_control,bgwaitm,set_value=msgstr
 ;         		tv,fix(64.*float(inbg)/float(max(inbg)))
  ;        	endfor
;
;		HDF_SD_ENDACCESS,sds_id
;	endfor
;	for i=0,nglobatts-1 do begin
;		HDF_SD_ATTRINFO,sd_id,i,name=n,type=t,count=c,data=d
;	endfor
			   
;	HDF_SD_END,sd_id
		
end

