@lisapp_GlobalRoutines.pro

pro choose_bounds, action
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format
	common bounds_common, boundstype_select, analyze_area_button, analyze_flash_button, $
		analyze_groups_button, analyze_events_button, bounds_done_button, latmax_slider, $
		latmin_slider, lonmin_slider, lonmax_slider, zoom_in_button, zoom_out_button, $
		zoom_reset_button, bounds_map, bounds_map_id, timemin_slider, timemax_slider, $
		mapbase, bounds, zoom_level, mapbase0
	common bounds_common2, btype
	common bounds_common3, timebounds
	common bounds_common4, fcolors
	common bounds_common5, deglab
	common bounds_common6, slidbounds
	common bounds_common7, boundspd	
	common bounds_presets, presets
	common nadirs, nadir_lats, nadir_lons, in_map_window, in_map_window_ct, mintime, maxtime
	common fov, num_cross, crosstimes, fov1, fov2
	common timslid, timemin_label,timemax_label
	common bounds_common8, execute_button, action_droplist
	common cando,	canbrowse, canpixarray, canbgimg, canqlvt, canqla, canqlf, canqlg, canqle, canqlbgf, caqlaf, $
				cannav, canpixan, canthrgl, canflan,canvda,canvdf,canvdg,canvde,canvdvt,canvdos,canloc,candens, $
					candensbg, canmovfrm
	common action_com, possible_actions, possible_actions_indices, possible_actions_rev_indices
		
	nadir_lats = fltarr(orbit.orbit_summary.one_second_count)
	nadir_lons = fltarr(orbit.orbit_summary.one_second_count)
	temp = fltarr(orbit.orbit_summary.one_second_count,2)
	xpix = intarr(orbit.orbit_summary.one_second_count)
	ypix = intarr(orbit.orbit_summary.one_second_count)
	xpix(*) = 63.5
	ypix(*) = 63.5
	
	get_vector_pointing_vector,this_sensor,xpix, ypix, look_vector
	get_vector_earth_intersection,look_vector,orbit.one_second(*).TAI93_time,	$
								  temp, 12000.0D , return_code
	nadir_lats = temp(*,0)
	nadir_lons = temp(*,1)
	temp = 0 & xpix = 0 & ypix = 0
	
	bounds = fltarr(100,5)
	slidbounds = fltarr(100,5)
	
	timebounds = fltarr(2)
	boundspd_choices = ['(Presets)','North America','   US Midwest','   US Southeast','   US Florida', $
				    'Atlantic','   Gulf & Caribbean','   North Atlantic','   GATE Region', $
				    'South America','   Brazil', $
				    'Africa','   Madagascar', $
				    'Maritime Continent','   Australia','   New Zealand']
			
	presets = intarr(4,15)
	presets = [[20,-125,50,-65],[30,-115,50,-85],[23,-100,37,-77],[24,-89,31,-77],$
			[-20,-90,50,0],[10,-110,40,-50],[0,-85,65,-10],[-20,-60,25,10],$
			[-65,-110,15,-15],[-35,-90,7,-30],$
			[-35,-35,45,65],[-35,30,-5,65],$
			[-50,100,0,180],[-40,110,-10,160],[-50,150,-30,180]]
			
	chbb = widget_base(group_leader=lisb,row=3,title='Select space or time bounds')

	chbbt = widget_base(chbb,column=3,frame=1)
	chbbtl = widget_base(chbbt,row=1,frame=1)
	boundstype_select = cw_bgroup(chbbtl,['Spatial','Temporal'],label_top='Bounds type:',/exclusive,/no_release)
	chbbtr = widget_base(chbbt,column=2)
;	chbbtrl = widget_base(chbbtr,row=2)
;	inbounds_areas   = widget_label(chbbtrl,value='Areas   :         ')
;	inbounds_flashes = widget_label(chbbtrl,value='Flashes :         ')
;	chbbtrr = widget_base(chbbtr,row=2)
;	inbounds_groups  = widget_label(chbbtrr,value='Groups  :         ')
;	inbounds_events  = widget_label(chbbtrr,value='Events  :         ')
	chbbtrrr = widget_base(chbbt,column=3)
	chbbtrrr1 = widget_base(chbbtrrr,row=2)
	analyze_area_button = widget_label(chbbtrrr1,value='      Areas',xsize=150)
	analyze_flash_button = widget_label(chbbtrrr1,value='      Flashes',xsize=150)
	chbbtrrr2 = widget_base(chbbtrrr,row=2)
	analyze_groups_button = widget_label(chbbtrrr2,value='      Groups',xsize=150)
	analyze_events_button = widget_label(chbbtrrr2,value='      Events',xsize=150)
	chbbtrrr3 = widget_base(chbbtrrr,row=3)
	
	; Create the pulldown based on what data has been loaded
	
	numpossacts = 14
	thisact = 0
	actindices = bytarr(numpossacts)
	actshere   = strarr(numpossacts)
	actrevind  = bytarr(numpossacts)
	
	baseactions = ['Navigation Data','Pixel Animation','Thresholds and Glint','Flash Analysis','View/Export Events','View/Export Groups','View/Export Flashes','View/Export Areas',$
			'View/Export Viewtimes','View/Export One-Seconds','Location Plot','Density Map','Density Map w/ BGs','Make Movie Frames']
	if (cannav eq 1) then begin
		actindices(thisact) = 0
		actshere(thisact) = baseactions(0)
		actrevind(0) = thisact
		thisact = thisact + 1
	endif
	if (canpixan eq 1) then begin
		actindices(thisact) = 1
		actshere(thisact) = baseactions(1)
		actrevind(1) = thisact
		thisact = thisact + 1
	endif
	if (canthrgl eq 1) then begin
		actindices(thisact) = 2
		actshere(thisact) = baseactions(2)
		actrevind(2) = thisact
		thisact = thisact + 1
	endif
	if (canflan eq 1) then begin
		actindices(thisact) = 3
		actshere(thisact) = baseactions(3)
		actrevind(3) = thisact
		thisact = thisact + 1
	endif
	if (canvde eq 1) then begin
		actindices(thisact) = 4
		actshere(thisact) = baseactions(4)
		actrevind(4) = thisact
		thisact = thisact + 1
	endif
	if (canvdg eq 1) then begin
		actindices(thisact) = 5
		actshere(thisact) = baseactions(5)
		actrevind(5) = thisact
		thisact = thisact + 1
	endif
	if (canvdf eq 1) then begin
		actindices(thisact) = 6
		actshere(thisact) = baseactions(6)
		actrevind(6) = thisact
		thisact = thisact + 1
	endif
	if (canvda eq 1) then begin
		actindices(thisact) = 7
		actshere(thisact) = baseactions(7)
		actrevind(7) = thisact
		thisact = thisact + 1
	endif
	if (canvdvt eq 1) then begin
		actindices(thisact) = 8
		actshere(thisact) = baseactions(8)
		actrevind(8) = thisact
		thisact = thisact+1
	endif
	if (canvdos eq 1) then begin
		actindices(thisact) = 9
		actshere(thisact) = baseactions(9)
		actrevind(9) = thisact
		thisact = thisact + 1
	endif
	if (canloc eq 1) then begin
		actindices(thisact) = 10
		actshere(thisact) = baseactions(10)
		actrevind(10) = thisact
		thisact = thisact + 1
	endif
	if (candens eq 1) then begin
		actindices(thisact) = 11
		actshere(thisact) = baseactions(11)
		actrevind(11) = thisact
		thisact = thisact + 1
	endif
	if (candensbg eq 1) then begin
		actindices(thisact) = 12
		actshere(thisact) = baseactions(12)
		actrevind(12) = thisact
		thisact = thisact + 1
	endif
	if (canmovfrm eq 1) then begin
		actindices(thisact) = 13
		actshere(thisact) = baseactions(13)
		actrevind(13) = thisact
		thisact = thisact + 1
	endif
	
	possible_actions = actshere(0:thisact-1)   
	; We assume this routine hasn't been called unless one of the above is possible ...
	;   this is the job of NEW_SENSITIZE_MENUS
	possible_actions_indices = actindices(0:thisact-1)
	possible_actions_rev_indices = actrevind
	
	action_droplist = widget_droplist(chbbtrrr3,/align_left,value=possible_actions)
	widget_control,action_droplist,set_droplist_select=possible_actions_rev_indices[action]
	widget_control,action_droplist,set_uvalue=possible_actions_rev_indices[action]
	
	execute_button =  widget_button(chbbtrrr3,value='Execute',xsize=150)
	bounds_done_button = widget_button(chbbtrrr3,value='Done',xsize=150)
	
	chbbm = widget_base(chbb,row=1,frame=1)
	chbbmt = widget_base(chbbm,column=2)
	chbbmtl = widget_base(chbbmt,row=4)
	deglab = widget_label(chbbmtl,value='   (Deg)   ')
	latmax_slider = widget_slider(chbbmtl,/vertical,ysize=125,title='Max Lat',min=-90.0,max=90.0,value=90.0)
	latmin_slider = widget_slider(chbbmtl,/vertical,ysize=125,title='Min Lat',min=-90.0,max=90.0,value=-90.0)
	chbbmtlb = widget_base(chbbmtl,row=3)
	zoom_in_button = widget_button(chbbmtlb,value='Zoom In',xsize=100)
	zoom_out_button = widget_button(chbbmtlb,value='Zoom Out',xsize=100)
	zoom_reset_button = widget_button(chbbmtlb,value='Reset',xsize=100)
	
	chbbmtr = widget_base(chbbmt,row=3)
	boundspd = widget_droplist(chbbmtr,/align_left,value=boundspd_choices)
	bounds_map = widget_draw(chbbmtr,colors=220,xsize=540,ysize=270,retain=2)
	chbbmtrb = widget_base(chbbmtr,column=2)
	lonmin_slider = widget_slider(chbbmtrb,xsize=260,title='Min Lon',min=-180.0,max=180.0,value=-180.0)
	lonmax_slider = widget_slider(chbbmtrb,xsize=260,title='Max Lon',min=-180.0,max=180.0,value=180.0)
		
	chbbb = widget_base(chbb,row=2,frame=1)
	chbbbt = widget_base(chbbb)
	chbbbb = widget_base(chbbb,column=2)
	chbbbb1 = widget_base(chbbb,row=2)
	chbbbb2 = widget_base(chbbb,row=2)
	timemin_label = widget_label(chbbbb1,xsize=325,value='               ')
	timemin_slider = widget_slider(chbbbb1,xsize=325,title='Min Time',min=0,max=orbit.orbit_summary.one_second_count-1,value=0)
	timemax_label = widget_label(chbbbb2,xsize=325,value='               ')
	timemax_slider = widget_slider(chbbbb2,xsize=325,title='Max Time',min=0,max=orbit.orbit_summary.one_second_count-1,value=orbit.orbit_summary.one_second_count-1)
	
	widget_control,chbb,/realize
	
	widget_control,bounds_map,get_value=bounds_map_id
	widget_control,boundspd,set_uvalue=0

	; Find dateline crossing time(s)
	
	num_cross = 0
	crosstimes = lonarr(2)
	nadirs = fltarr(2,orbit.orbit_summary.one_second_count)
	get_nadir_locations, orbit.one_second(*).TAI93_time, nadirs
	initial_lon = nadirs[1,0]
	crosstimes[0] = -1
	for i=1,orbit.orbit_summary.one_second_count-1,1 do begin
		dellon = nadirs[1,i]-initial_lon
		if (abs(dellon) gt 180) then begin
			crosstimes[num_cross] = i
			num_cross = num_cross+1
		endif
		initial_lon = nadirs[1,i]
	endfor
	
	; Get path bounds
	
	case this_sensor of 
		'lis':begin
				fovrg = 650.0
			end
		'otd':begin
				fovrg = 1300.0
			end
	endcase
	fov1 = fltarr(2,orbit.orbit_summary.one_second_count)
	fov2 = fltarr(2,orbit.orbit_summary.one_second_count)
	
	for i =0, orbit.orbit_summary.one_second_count-1,1 do begin
		thisnadir = [nadirs[1,i],nadirs[0,i]]
		result1 = ll_arc_distance(thisnadir,fovrg/6371.0,0.0,/degrees)
		result2 = ll_arc_distance(thisnadir,fovrg/6371.0,180,/degrees)
		fov1[0,i] = result1[1]
		fov2[0,i] = result2[1]
		fov1[1,i] = thisnadir[0]
		fov2[1,i] = thisnadir[0]
	endfor

	
			
	wset,bounds_map_id
	tvlct,red,green,blue
	map_set,/continents,xmargin=[0,0],ymargin=[0,0],/noerase,color=0,con_color=32,/noborder

	; plot point data
	; To optimize speed, prefer flashes (if available), then groups and events
	
	if (canqlf eq 1) then begin
		glints = orbit.point.lightning.flash(*).glint_index
		fcolors = bytarr(orbit.point.point_summary.flash_count)
		night = where(glints le 0,nightct)
		day   = where(glints gt 0, dayct)
		if (nightct gt 0) then begin
			fcolors(night) = 72
		endif
		if (dayct gt 0) then begin
			fcolors(day) = 88
		endif
		
		plots,orbit.point.lightning.flash(*).location(1),orbit.point.lightning.flash(*).location(0),psym=4,color=fcolors
	endif else begin if (canqlg eq 1) then begin
			glints = orbit.point.lightning.group(*).glint_index
			fcolors = bytarr(orbit.point.point_summary.group_count)
			night = where(glints le 0,nightct)
			day   = where(glints gt 0, dayct)
			if (nightct gt 0) then begin
				fcolors(night) = 72
			endif
			if (dayct gt 0) then begin
				fcolors(day) = 88
			endif
			plots,orbit.point.lightning.group(*).location(1),orbit.point.lightning.group(*).location(0),psym=4,color=fcolors
		endif else begin if (canqle eq 1) then begin
				glints = orbit.point.lightning.event(*).glint_index
				fcolors = bytarr(orbit.point.point_summary.event_count)
				night = where(glints le 0,nightct)
				day   = where(glints gt 0, dayct)
				if (nightct gt 0) then begin
					fcolors(night) = 72
				endif
				if (dayct gt 0) then begin
					fcolors(day) = 88
				endif
				plots,orbit.point.lightning.event(*).location(1),orbit.point.lightning.event(*).location(0),psym=4,color=fcolors
			endif else begin
				; Maybe plot nadirs here?  Add this later
			endelse
		endelse
	endelse
	
	mapbase0 = tvrd()
	mapbase = mapbase0
	
	widget_control,timemin_slider,sensitive=0
	widget_control,timemax_slider,sensitive=0
	widget_control,boundstype_select,set_value=0
	widget_control,zoom_out_button,sensitive=0
	widget_control,zoom_reset_button,sensitive=0
	
	; Disable for now
	;widget_control,analyze_area_button,sensitive=0
	;widget_control,analyze_flash_button,sensitive=1
	;widget_control,analyze_groups_button,sensitive=0
	;widget_control,analyze_events_button,sensitive=0
	
	btype=0
	zoom_level = 2
	bounds(0:2,0) = -90.0 & bounds(0:2,1) = 90.0 & bounds(0:2,2) = -180.0 & bounds(0:2,3) = 180.0 & bounds(0:2,4) = 0
	slidbounds(0:2,0) = -90.0 & slidbounds(0:2,1) = 90.0 & slidbounds(0:2,2) = -180.0 & slidbounds(0:2,3) = 180.0 & slidbounds(0:2,4) = 0

	in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
					(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
	if (time_in_plot_ct le 0) then begin
		minidx = 0 & maxidx = orbit.orbit_summary.one_second_count
	endif else begin
		minidx = min(in_map_window)
		maxidx = max(in_map_window)
		if (this_sensor eq 'otd') then begin
			minidx = minidx - 90
			maxidx = maxidx + 90
		endif else begin
			minidx = minidx - 45
			maxidx = maxidx + 45
		endelse
		minidx = max([0,minidx])
		maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
	endelse
	widget_control,timemin_slider,set_value=minidx
	widget_control,timemax_slider,set_value=maxidx
	mintime = minidx & maxtime = maxidx 		
	timemin = orbit.one_second[0].TAI93_time
	timemax = orbit.one_second[orbit.orbit_summary.one_second_count-1].TAI93_time
	
	startdt = new_datetime_structure(1)
	startdt.tai93 = double(timemin)
	calc_datetime,startdt
	enddt = new_datetime_structure(1)
	enddt.tai93 = double(timemax)
	calc_datetime,enddt
	
	widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
	widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)

	
;	window,12,xsize=720,ysize=360,retain=2
;	plots,fov1[1,*],fov1[0,*],psym=3
;	plots,fov2[1,*],fov2[0,*],psym=3
;	plots,nadirs[1,*],nadirs[0,*],psym=3
		

	xmanager, 'Select Bounds', chbb, event='bounds_handler',/no_block
	
end

pro update_labels_byspace
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format
	common bounds_common, boundstype_select, analyze_area_button, analyze_flash_button, $
		analyze_groups_button, analyze_events_button, bounds_done_button, latmax_slider, $
		latmin_slider, lonmin_slider, lonmax_slider, zoom_in_button, zoom_out_button, $
		zoom_reset_button, bounds_map, bounds_map_id, timemin_slider, timemax_slider, $
		mapbase, bounds, zoom_level, mapbase0
	common bounds_common2, btype
	common bounds_common3, timebounds
	common bounds_common4, fcolors
	common bounds_common5, deglab
	common bounds_common6, slidbounds
	common bounds_common7, boundspd	
	common bounds_presets, presets
	common bounds_lab_common, nev, ng, nf, na
	common bounds_lab_common2, thislatmin, thislatmax, thislonmin, thislonmax, $
						slidlatmin, slidlatmax, slidlonmin, slidlonmax
	common cando,	canbrowse, canpixarray, canbgimg, canqlvt, canqla, canqlf, canqlg, canqle, canqlbgf, caqlaf, $
				cannav, canpixan, canthrgl, canflan,canvda,canvdf,canvdg,canvde,canvdvt,canvdos,canloc,candens, $
					candensbg, canmovfrm

	ng = 0 & nev = 0 & nf = 0 & na = 0
	if (canqlf eq 1) then begin
		inbounds = where(orbit.point.lightning.flash(*).location(0) ge thislatmin and $
			 orbit.point.lightning.flash(*).location(0) le thislatmax and $
			 orbit.point.lightning.flash(*).location(1) ge thislonmin and $
			 orbit.point.lightning.flash(*).location(1) le thislonmax,inboundsct)
		nf = inboundsct
		if (nf gt 0) then begin
			ng = total(orbit.point.lightning.flash(inbounds).child_count)
			nev = total(orbit.point.lightning.flash(inbounds).grandchild_count)
			ua = uniq(orbit.point.lightning.flash(inbounds).parent_address, $
					sort(orbit.point.lightning.flash(inbounds).parent_address))
			uasz = size(ua)
			case uasz[0] of 
				0:begin
					na = uasz[0]
				  end
				1:begin
					na = uasz[1]
				  end
			endcase
		endif else begin
			nf = 0 & ng = 0 & nev = 0 & na = 0
		endelse
	endif else begin if (canqlg eq 1) then begin
				inb = where(orbit.point.lightning.group(*).location(0) ge thislatmin and $
					 orbit.point.lightning.group(*).location(0) le thislatmax and $
					 orbit.point.lightning.group(*).location(1) ge thislonmin and $
					 orbit.point.lightning.group(*).location(1) le thislonmax,inbct)
				ng = inbct
				if (ng gt 0) then begin
					nev = total(orbit.point.lightning.group(inb).child_count)
					uf = uniq(orbit.point.lightning.group(inb).parent_address, $
							sort(orbit.point.lightning.group(inb).parent_address))
					ufsz = size(uf)
					case ufsz[0] of 
						0: begin
							nf = ufsz & na = 0
						   end
						1: begin
							nf = ufsz[1] & na = 0
						   end
					endcase
				endif else begin
					ng = 0 & nev = 0 & nf = 0 & na = 0
				endelse
			endif else begin if (canqle eq 1) then begin
					inb = where(orbit.point.lightning.event(*).location(0) ge thislatmin and $
						 orbit.point.lightning.event(*).location(0) le thislatmax and $
						 orbit.point.lightning.event(*).location(1) ge thislonmin and $
						 orbit.point.lightning.event(*).location(1) le thislonmax,inbct)
					nev = inbct
					if (nev gt 0) then begin
						ug = uniq(orbit.point.lightning.event(inb).parent_address, $
								sort(orbit.point.lightning.event(inb).parent_address))
						ugsz = size(ug)
						case ugsz[0] of
							0: begin
								ng = ngsz & nf = 0 & na = 0
							   end
							1: begin
								ng = ngsz[1] & nf = 0 & na = 0
							   end
						endcase
					endif else begin
						ng = 0 & nev = 0 & nf = 0 & na = 0
					endelse
				endif
			endelse 
	endelse
	flab = string(format='((I4)," Flashes")',nf)
	widget_control,analyze_flash_button,set_value=flab
	alab = string(format='((I4)," Areas")',na)
	widget_control,analyze_area_button,set_value=alab
	glab = string(format='((I5)," Groups")',ng)
	widget_control,analyze_groups_button,set_value=glab
	elab = string(format='((I5)," Events")',nev)
	widget_control,analyze_events_button,set_value=elab
end

pro update_labels_bytime
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format
	common bounds_common, boundstype_select, analyze_area_button, analyze_flash_button, $
		analyze_groups_button, analyze_events_button, bounds_done_button, latmax_slider, $
		latmin_slider, lonmin_slider, lonmax_slider, zoom_in_button, zoom_out_button, $
		zoom_reset_button, bounds_map, bounds_map_id, timemin_slider, timemax_slider, $
		mapbase, bounds, zoom_level, mapbase0
	common bounds_common2, btype
	common bounds_common3, timebounds
	common bounds_common4, fcolors
	common bounds_common5, deglab
	common bounds_common6, slidbounds
	common bounds_common7, boundspd	
	common bounds_presets, presets
	common bounds_lab_common, nev, ng, nf, na

end

pro replot_items_inbounds, inorout
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format
	common bounds_common, boundstype_select, analyze_area_button, analyze_flash_button, $
		analyze_groups_button, analyze_events_button, bounds_done_button, latmax_slider, $
		latmin_slider, lonmin_slider, lonmax_slider, zoom_in_button, zoom_out_button, $
		zoom_reset_button, bounds_map, bounds_map_id, timemin_slider, timemax_slider, $
		mapbase, bounds, zoom_level, mapbase0
	common bounds_common2, btype
	common bounds_common3, timebounds
	common bounds_common4, fcolors
	common bounds_common5, deglab
	common bounds_common6, slidbounds
	common bounds_common7, boundspd	
	common bounds_presets, presets
	common bounds_lab_common, nev, ng, nf, na			
	common cando,	canbrowse, canpixarray, canbgimg, canqlvt, canqla, canqlf, canqlg, canqle, canqlbgf, caqlaf, $
				cannav, canpixan, canthrgl, canflan,canvda,canvdf,canvdg,canvde,canvdvt,canvdos,canloc,candens, $
					candensbg, canmovfrm
	common bounds_lab_common2, thislatmin, thislatmax, thislonmin, thislonmax, $
						slidlatmin, slidlatmax, slidlonmin, slidlonmax
	
	wset,bounds_map_id

	tvlct,red,green,blue
	;print,'drawing map'
	
	case inorout of 
		0: begin
			map_set,/continents,E_Continents={countries:1},/usa,xmargin=[0,0],ymargin=[0,0],color=0,con_color=32,/noborder, $
				limit=[thislatmin,thislonmin,thislatmax,thislonmax]
			testlatmin = thislatmin & testlatmax = thislatmax
			testlonmin = thislonmin & testlonmax = thislonmax
		   end
		1: begin
			map_set,/continents,E_Continents={countries:1},/usa,xmargin=[0,0],ymargin=[0,0],color=0,con_color=32,/noborder, $
				limit=[slidlatmin,slidlonmin,slidlatmax,slidlonmax]
			testlatmin = slidlatmin & testlatmax = thislatmax
			testlonmin = slidlonmin & testlonmax = thislonmax
		   end
	endcase
				
	;print,'testing in bounds'

	if (canqlf eq 1) then begin
		inbounds = where(orbit.point.lightning.flash(*).location(0) ge testlatmin and $
					 orbit.point.lightning.flash(*).location(0) le testlatmax and $
					 orbit.point.lightning.flash(*).location(1) ge testlonmin and $
					 orbit.point.lightning.flash(*).location(1) le testlonmax,inboundsct)
		if (inboundsct gt 0) then begin
			plots,orbit.point.lightning.flash(inbounds).location(1),orbit.point.lightning.flash(inbounds).location(0),psym=4,color=fcolors(inbounds)
		endif
	endif else begin if (canqlg eq 1) then begin
				inbounds = where(orbit.point.lightning.group(*).location(0) ge testlatmin and $
							 orbit.point.lightning.group(*).location(0) le testlatmax and $
							 orbit.point.lightning.group(*).location(1) ge testlonmin and $
							 orbit.point.lightning.group(*).location(1) le testlonmax,inboundsct)
				if (inboundsct gt 0) then begin
					plots,orbit.point.lightning.group(inbounds).location(1),orbit.point.lightning.group(inbounds).location(0),psym=4,color=fcolors(inbounds)
				endif 
			endif else begin if (canqle eq 1) then begin
						inbounds = where(orbit.point.lightning.event(*).location(0) ge testlatmin and $
									 orbit.point.lightning.event(*).location(0) le testlatmax and $
									 orbit.point.lightning.event(*).location(1) ge testlonmin and $
									 orbit.point.lightning.event(*).location(1) le testlonmax,inboundsct)
						if (inboundsct gt 0) then begin
							plots,orbit.point.lightning.event(inbounds).location(1),orbit.point.lightning.event(inbounds).location(0),psym=4,color=fcolors(inbounds)
						endif 
					endif
			endelse
	endelse
end
				

pro bounds_handler, event
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format
	common bounds_common, boundstype_select, analyze_area_button, analyze_flash_button, $
		analyze_groups_button, analyze_events_button, bounds_done_button, latmax_slider, $
		latmin_slider, lonmin_slider, lonmax_slider, zoom_in_button, zoom_out_button, $
		zoom_reset_button, bounds_map, bounds_map_id, timemin_slider, timemax_slider, $
		mapbase, bounds, zoom_level, mapbase0
	common bounds_common2, btype
	common bounds_common3, timebounds
	common bounds_common4, fcolors
	common bounds_common5, deglab
	common bounds_common6, slidbounds
	common bounds_common7, boundspd	
	common bounds_presets, presets
	common nadirs, nadir_lats, nadir_lons, in_map_window, in_map_window_ct, mintime, maxtime
	common fov, num_cross, crosstimes, fov1, fov2
	common timslid, timemin_label,timemax_label
	common localsave, mapbase1
	common bounds_common8, execute_button, action_droplist
	common action_com, possible_actions, possible_actions_indices, possible_actions_rev_indices
	common cando,	canbrowse, canpixarray, canbgimg, canqlvt, canqla, canqlf, canqlg, canqle, canqlbgf, caqlaf, $
				cannav, canpixan, canthrgl, canflan,canvda,canvdf,canvdg,canvde,canvdvt,canvdos,canloc,candens, $
					candensbg, canmovfrm
	common bounds_lab_common, nev, ng, nf, na
	common bounds_lab_common2, thislatmin, thislatmax, thislonmin, thislonmax, $
						slidlatmin, slidlatmax, slidlonmin, slidlonmax
	
	case 1 of 
		(event.id eq boundstype_select): begin
			; print,'Select Type'
			widget_control,boundstype_select,get_value=btype
			case btype of
				0:begin
					zoom_level = 2
					slidlatmin = slidbounds(zoom_level,0) & slidlatmax = slidbounds(zoom_level,1) 
					slidlonmin = slidbounds(zoom_level,2) & slidlonmax = slidbounds(zoom_level,3)
					labarr = ['(Deg)','(Deg x10)']
					widget_control,deglab,set_value=labarr(bounds(zoom_level,4))
					widget_control,latmin_slider,set_slider_min = slidlatmin
					widget_control,latmin_slider,set_slider_max = slidlatmax
					widget_control,latmax_slider,set_slider_min = slidlatmin
					widget_control,latmax_slider,set_slider_max = slidlatmax
					widget_control,lonmin_slider,set_slider_min = slidlonmin
					widget_control,lonmin_slider,set_slider_max = slidlonmax
					widget_control,lonmax_slider,set_slider_min = slidlonmin
					widget_control,lonmax_slider,set_slider_max = slidlonmax
					latmin = bounds(zoom_level,0) & latmax = bounds(zoom_level,1) 
					lonmin = bounds(zoom_level,2) & lonmax = bounds(zoom_level,3)
					widget_control,latmin_slider,set_value=latmin
					widget_control,latmax_slider,set_value=latmax
					widget_control,lonmin_slider,set_value=lonmin
					widget_control,lonmax_slider,set_value=lonmax
					widget_control, latmax_slider, get_value = latmax
					widget_control, latmin_slider, get_value = latmin
					widget_control, lonmin_slider, get_value = lonmin
					widget_control, lonmax_slider, get_value = lonmax
					widget_control, latmin_slider, set_value = min([latmin,latmax])
					widget_control, latmax_slider, set_value = max([latmin,latmax])
					bounds(zoom_level,0) = latmin
					bounds(zoom_level,1) = latmax
					bounds(zoom_level,2) = lonmin
					bounds(zoom_level,3) = lonmax
					slidminlat = float(slidbounds(zoom_level,0))/float(10.^slidbounds(zoom_level,4))
					slidmaxlat = float(slidbounds(zoom_level,1))/float(10.^slidbounds(zoom_level,4))
					slidminlon = float(slidbounds(zoom_level,2))/float(10.^slidbounds(zoom_level,4))
					slidmaxlon = float(slidbounds(zoom_level,3))/float(10.^slidbounds(zoom_level,4))
					thislatmin = float(latmin)/float(10.^bounds(zoom_level,4))
					thislatmax = float(latmax)/float(10.^bounds(zoom_level,4))
					thislonmin = float(lonmin)/float(10.^bounds(zoom_level,4))
					thislonmax = float(lonmax)/float(10.^bounds(zoom_level,4))
					latminidx = fix(270.0*(thislatmin-slidminlat)/(slidmaxlat-slidminlat))
					latmaxidx = fix(270.0*(thislatmax-slidminlat)/(slidmaxlat-slidminlat))
					lonminidx = fix(540.0*(thislonmin-slidminlon)/(slidmaxlon-slidminlon))
					lonmaxidx = fix(540.0*(thislonmax-slidminlon)/(slidmaxlon-slidminlon))
					xvect = [lonminidx,lonmaxidx,lonmaxidx,lonminidx,lonminidx]
					yvect = [latmaxidx,latmaxidx,latminidx,latminidx,latmaxidx]
					sbounds=polyfillv(xvect,yvect,540,270)
					newimage = mapbase
					if (sbounds(0) ne -1) then begin
						newimage(sbounds) = newimage(sbounds) + 5
					endif
					wset,bounds_map_id
					tvlct,red,green,blue
					tv,newimage
					
					update_labels_byspace
										
					in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
									(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
					if (time_in_plot_ct le 0) then begin
						minidx = 0 & maxidx = orbit.orbit_summary.one_second_count-1
					endif else begin
						minidx = min(in_map_window)
						maxidx = max(in_map_window)
						if (this_sensor eq 'otd') then begin
							minidx = minidx - 90
							maxidx = maxidx + 90
						endif else begin
							minidx = minidx - 45
							maxidx = maxidx + 45
						endelse
						minidx = max([0,minidx])
						maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
					endelse
					widget_control,timemin_slider,set_value=minidx
					widget_control,timemax_slider,set_value=maxidx
					mintime = minidx & maxtime = maxidx 		
					widget_control,timemin_slider,set_value=minidx
					widget_control,timemax_slider,set_value=maxidx
					mintime = minidx & maxtime = maxidx 		
					timemin = orbit.one_second[minidx].TAI93_time
					timemax = orbit.one_second[maxidx].TAI93_time
					
					startdt = new_datetime_structure(1)
					startdt.tai93 = double(timemin)
					calc_datetime,startdt
					enddt = new_datetime_structure(1)
					enddt.tai93 = double(timemax)
					calc_datetime,enddt
					
					widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
					widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)
					widget_control,timemin_slider,sensitive=0
					widget_control,timemax_slider,sensitive=0
					widget_control,latmax_slider,sensitive=1
					widget_control,latmin_slider,sensitive=1
					widget_control,lonmax_slider,sensitive=1
					widget_control,lonmin_slider,sensitive=1
					widget_control,zoom_in_button,sensitive=1
					widget_control,zoom_out_button,sensitive=1
					widget_control,zoom_reset_button,sensitive=1
				  end
				1:begin
					widget_control, timemin_slider, get_value = timeidxmin
					widget_control, timemax_slider, get_value = timeidxmax
					widget_control, timemin_slider, set_value = min([timeidxmin,timeidxmax])
					widget_control, timemax_slider, set_value = max([timeidxmin,timeidxmax])
					widget_control, timemin_slider, get_value = timeidxmin
					widget_control, timemax_slider, get_value = timeidxmax
					timemin = orbit.one_second[timeidxmin].TAI93_time
					timemax = orbit.one_second[timeidxmax].TAI93_time
					wset,bounds_map_id
					tvlct,red,green,blue
					tv,mapbase0
					mapbase = mapbase0
					if (num_cross eq 0 or crosstimes[0] lt timeidxmin or crosstimes[0] gt timeidxmax) then begin
						; print,'one segment'
						vectsize = 2*(timeidxmax-timeidxmin)
						if (vectsize gt 1) then begin
							; print,vectsize
							xvect = fltarr(vectsize+1)
							yvect = fltarr(vectsize+1)
							idx = 0
							xvect[0:timeidxmax-timeidxmin] = fov1[1,timeidxmin:timeidxmax]
							yvect[0:timeidxmax-timeidxmin] = fov1[0,timeidxmin:timeidxmax]
							idx = timeidxmax-timeidxmin
							for j = timeidxmax, timeidxmin, -1 do begin
								xvect[idx] = fov2[1,j]
								yvect[idx] = fov2[0,j]
								idx = idx + 1
							endfor
							xvect[vectsize-1] = xvect[0] & yvect[vectsize-1] = yvect[0]
							xvect = 540*(xvect+180.0)/(180.0+180.0)
							yvect = 270*(yvect+90.0)/(90.0+90.0)
							sbounds = polyfillv(xvect,yvect,540,270)
							newimage = mapbase
							if (sbounds(0) ne -1) then begin
								newimage(sbounds) = newimage(sbounds) + 5
							endif
							wset,bounds_map_id
							tvlct,red,green,blue
							tv,newimage	
						endif			
					endif	 else begin
						; print,'two segments'
						vectsize = 2*(crosstimes[0]-timeidxmin)
						; print,vectsize
						xvect = fltarr(vectsize+1)
						yvect = fltarr(vectsize+1)
						idx = 0
						xvect[0:crosstimes[0]-timeidxmin-1] = fov1[1,timeidxmin:crosstimes[0]-1]
						yvect[0:crosstimes[0]-timeidxmin-1] = fov1[0,timeidxmin:crosstimes[0]-1]
						idx = crosstimes[0]-timeidxmin
						for j = crosstimes[0]-1, timeidxmin, -1 do begin
							xvect[idx] = fov2[1,j]
							yvect[idx] = fov2[0,j]
							idx = idx + 1
						endfor
						xvect[vectsize] = xvect[0] & yvect[vectsize] = yvect[0]
						xvect = 540*(xvect+180.0)/(180.0+180.0)
						yvect = 270*(yvect+90.0)/(90.0+90.0)
						sbounds = polyfillv(xvect,yvect,540,270)
						newimage = mapbase
						if (sbounds(0) ne -1) then begin
							newimage(sbounds) = newimage(sbounds) + 5
						endif
						
						vectsize = 2*(timeidxmax-crosstimes[0])
						; print,vectsize
						xvect = fltarr(vectsize+1)
						yvect = fltarr(vectsize+1)
						idx = 0
						xvect[0:timeidxmax-crosstimes[0]] = fov1[1,crosstimes[0]:timeidxmax]
						yvect[0:timeidxmax-crosstimes[0]] = fov1[0,crosstimes[0]:timeidxmax]
						idx = timeidxmax-crosstimes[0]
						for j = timeidxmax, crosstimes[0], -1 do begin
							xvect[idx] = fov2[1,j]
							yvect[idx] = fov2[0,j]
							idx = idx + 1
						endfor
						xvect[vectsize-1] = xvect[0] & yvect[vectsize-1] = yvect[0]
						xvect = 540*(xvect+180.0)/(180.0+180.0)
						yvect = 270*(yvect+90.0)/(90.0+90.0)
						sbounds = polyfillv(xvect,yvect,540,270)
						if (sbounds(0) ne -1) then begin
							newimage(sbounds) = newimage(sbounds) + 5
						endif
						wset,bounds_map_id
						tvlct,red,green,blue
						tv,newimage				
					endelse
					widget_control,timemin_slider,sensitive=1
					widget_control,timemax_slider,sensitive=1
					widget_control,latmax_slider,sensitive=0
					widget_control,latmin_slider,sensitive=0
					widget_control,lonmax_slider,sensitive=0
					widget_control,lonmin_slider,sensitive=0
					widget_control,zoom_in_button,sensitive=0
					widget_control,zoom_out_button,sensitive=0
					widget_control,zoom_reset_button,sensitive=0
				  end
			endcase
			end
		(event.id eq analyze_area_button):begin
			; print,'Analyze area'
			end
		(event.id eq analyze_flash_button):begin
			widget_control,boundstype_select,get_value=btype
			case btype of
				0:begin
					widget_control, latmax_slider, get_value = latmax
					widget_control, latmin_slider, get_value = latmin
					widget_control, lonmin_slider, get_value = lonmin
					widget_control, lonmax_slider, get_value = lonmax
					if (bounds(zoom_level,4) eq 1) then begin
						latmax = float(latmax)/10. & latmin = float(latmin)/10. 
						lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
					endif
					inbounds = where(orbit.point.lightning.flash(*).location(0) ge latmin and $
								 orbit.point.lightning.flash(*).location(0) le latmax and $
								 orbit.point.lightning.flash(*).location(1) ge lonmin and $
								 orbit.point.lightning.flash(*).location(1) le lonmax,inboundsct)
				end
			    1:begin
					widget_control, timemin_slider, get_value = timeidxmin
					widget_control, timemax_slider, get_value = timeidxmax
					timemin = orbit.one_second[timeidxmin].TAI93_time
					timemax = orbit.one_second[timeidxmax].TAI93_time
					inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
								 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
					if (inboundsct le 0) then begin
						inboundsct = 0
					endif
				end
			endcase			    		
			if (inboundsct gt 0) then begin
				flash_window,orbit.point.lightning.flash(inbounds),inboundsct,event.top
			endif
			end
		(event.id eq bounds_done_button):begin
			; print,'Done'
			widget_control,event.top,/destroy
			end
		(event.id eq action_droplist):begin
			widget_control,action_droplist,set_uvalue=event.index
			end
		(event.id eq execute_button):begin
			widget_control,action_droplist,get_uvalue=action
			; print,action
			case possible_actions_indices[action] of
				0:begin
					; Navigation Data
					widget_control,timemin_slider, get_value=timeidxmin
					widget_control,timemax_slider, get_value=timeidxmax
					case this_sensor of 
						'lis':begin
								padding = 45
							 end
						'otd':begin
								padding = 90
							end
					endcase
					timeidxmin = max([0,timeidxmin-padding])
					timeidxmax = min([orbit.orbit_summary.one_second_count-1,timeidxmax+padding])
					plot_nav,event,timeidxmin,timeidxmax
				  end
				1:begin
					; Pixel animation
					widget_control,timemin_slider, get_value=timeidxmin
					widget_control,timemax_slider, get_value=timeidxmax
					case this_sensor of 
						'lis':begin
								padding = 45
							 end
						'otd':begin
								padding = 90
							end
					endcase
					timeidxmin = max([0,timeidxmin-padding])
					timeidxmax = min([orbit.orbit_summary.one_second_count-1,timeidxmax+padding])
					animate_events,event,timeidxmin,timeidxmax
				  end
				2:begin
					; Thresholds and Glint
					widget_control,timemin_slider, get_value=timeidxmin
					widget_control,timemax_slider, get_value=timeidxmax
					case this_sensor of 
						'lis':begin
								padding = 45
							 end
						'otd':begin
								padding = 90
							end
					endcase
					timeidxmin = max([0,timeidxmin-padding])
					timeidxmax = min([orbit.orbit_summary.one_second_count-1,timeidxmax+padding])
					timemin = orbit.one_second[timeidxmin].TAI93_time
					timemax = orbit.one_second[timeidxmax].TAI93_time
					inwin = where(orbit.point.bg_summary[*].TAI93_time ge timemin and $
							   orbit.point.bg_summary[*].TAI93_time le timemax,inwinct)
					if (inwinct gt 0) then begin
						first = min(inwin)
						last = max(inwin)
						examine_bgs,event,first,last
					endif
					end
				3:begin
					; Flash Analysis
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.flash(*).location(0) ge latmin and $
										 orbit.point.lightning.flash(*).location(0) le latmax and $
										 orbit.point.lightning.flash(*).location(1) ge lonmin and $
										 orbit.point.lightning.flash(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
										 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						flash_window,orbit.point.lightning.flash(inbounds),inboundsct,event.top
					endif				
				  end
				4:begin
					; Event vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.event(*).location(0) ge latmin and $
										 orbit.point.lightning.event(*).location(0) le latmax and $
										 orbit.point.lightning.event(*).location(1) ge lonmin and $
										 orbit.point.lightning.event(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.event(*).TAI93_time ge timemin and $
										 orbit.point.lightning.event(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						ev_table,event,inbounds
					endif								
						
				  end
				5:begin
					; Group vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.group(*).location(0) ge latmin and $
										 orbit.point.lightning.group(*).location(0) le latmax and $
										 orbit.point.lightning.group(*).location(1) ge lonmin and $
										 orbit.point.lightning.group(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.group(*).TAI93_time ge timemin and $
										 orbit.point.lightning.group(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						gr_table,event,inbounds
					endif								
			
				  end
				6:begin
					; Flash vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.flash(*).location(0) ge latmin and $
										 orbit.point.lightning.flash(*).location(0) le latmax and $
										 orbit.point.lightning.flash(*).location(1) ge lonmin and $
										 orbit.point.lightning.flash(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
										 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						fl_table,event,inbounds
					endif								
				  end
				7:begin
					; Area vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.area(*).location(0) ge latmin and $
										 orbit.point.lightning.area(*).location(0) le latmax and $
										 orbit.point.lightning.area(*).location(1) ge lonmin and $
										 orbit.point.lightning.area(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.area(*).TAI93_time ge timemin and $
										 orbit.point.lightning.area(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						ar_table,event,inbounds
					endif											
				  end
				8:begin
					; Viewtime vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.viewtime(*).location(0) ge latmin and $
										 orbit.point.viewtime(*).location(0) le latmax and $
										 orbit.point.viewtime(*).location(1) ge lonmin and $
										 orbit.point.viewtime(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.viewtime(*).TAI93_end ge timemin and $
										 orbit.point.viewtime(*).TAI93_start le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						vt_table,event,inbounds
					endif											
					
				  end
				9:begin
					; One second vdata
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							get_nadir_locations, orbit.one_second(*).TAI93_time, nadirs
							case this_sensor of 
								'lis':begin
										padding = 45.0
									 end
								'otd':begin
										padding = 90.0
									end
							endcase
							inbounds = where(nadirs(0,*) ge latmin and $
										 nadirs(0,*) le latmax and $
										 nadirs(1,*) ge lonmin and $
										 nadirs(1,*) le lonmax,inboundsct)
							print,inboundsct
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif else begin
								thisstart = min(orbit.one_second[inbounds].TAI93_time)
								thisend   = max(orbit.one_second[inbounds].TAI93_time)
								padstart = max([orbit.orbit_summary.TAI93_start,thisstart-padding])
								padend   = min([orbit.orbit_summary.TAI93_end,thisend+padding])
								inbounds = where(orbit.one_second[*].TAI93_time ge padstart and $
											 orbit.one_second[*].TAI93_time le padend,inboundsct)
								print,inboundsct,thisstart,thisend,padstart,padend
							endelse
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							case this_sensor of 
								'lis':begin
										padding = 45.0
									 end
								'otd':begin
										padding = 90.0
									end
							endcase
							timemin = orbit.one_second[timeidxmin].TAI93_time-padding
							timemax = orbit.one_second[timeidxmax].TAI93_time+padding
							inbounds = where(orbit.one_second(*).TAI93_time ge timemin and $
										 orbit.one_second(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						os_table,event,inbounds
					endif						
				  end
				10:begin
					; Location Plot
					
					initial_selection = bytarr(orbit.point.point_summary.bg_count)
					widget_control,boundstype_select,get_value=btype
					widget_control, timemin_slider, get_value = timeidxmin
					widget_control, timemax_slider, get_value = timeidxmax
					timemin = orbit.one_second[timeidxmin].TAI93_time
					timemax = orbit.one_second[timeidxmax].TAI93_time
					
					for i = 0, orbit.point.point_summary.bg_count-1,1 do begin
						if (orbit.point.bg_summary[i].TAI93_time ge timemin and $
						    orbit.point.bg_summary[i].TAI93_time le timemax) then begin
						   initial_selection[i] = 1
						endif
					endfor
					select_bgs, initial_selection
				  end
				11:begin
					; Density Map
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.flash(*).location(0) ge latmin and $
										 orbit.point.lightning.flash(*).location(0) le latmax and $
										 orbit.point.lightning.flash(*).location(1) ge lonmin and $
										 orbit.point.lightning.flash(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
										 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif else begin
								latmax = max(orbit.point.lightning.flash(*).location(0))
								lamin = min(orbit.point.lightning.flash(*).location(0))
								lonmax = max(orbit.point.lightning.flash(*).location(1))
								lonmin = min(orbit.point.lightning.flash(*).location(1))
							endelse
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						show_density_map, fname, orbit, (latmax+latmin)/2., (lonmax+lonmin)/2., lisb				
					endif 				
				  end
				12:begin
					; Density Map
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.flash(*).location(0) ge latmin and $
										 orbit.point.lightning.flash(*).location(0) le latmax and $
										 orbit.point.lightning.flash(*).location(1) ge lonmin and $
										 orbit.point.lightning.flash(*).location(1) le lonmax,inboundsct)
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
										 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif else begin
								latmax = max(orbit.point.lightning.flash(*).location(0))
								lamin = min(orbit.point.lightning.flash(*).location(0))
								lonmax = max(orbit.point.lightning.flash(*).location(1))
								lonmin = min(orbit.point.lightning.flash(*).location(1))
							endelse
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						show_both_map, (latmax+latmin)/2., (lonmax+lonmin)/2.				
					endif 				
				  end
				13:begin
					; Make Movie Frames
					widget_control,boundstype_select,get_value=btype
					case btype of
						0:begin
							widget_control, latmax_slider, get_value = latmax
							widget_control, latmin_slider, get_value = latmin
							widget_control, lonmin_slider, get_value = lonmin
							widget_control, lonmax_slider, get_value = lonmax
							if (bounds(zoom_level,4) eq 1) then begin
								latmax = float(latmax)/10. & latmin = float(latmin)/10. 
								lonmax = float(lonmax)/10. & lonmin = float(lonmin)/10.
							endif
							inbounds = where(orbit.point.lightning.event(*).location(0) ge latmin and $
										 orbit.point.lightning.event(*).location(0) le latmax and $
										 orbit.point.lightning.event(*).location(1) ge lonmin and $
										 orbit.point.lightning.event(*).location(1) le lonmax,inboundsct)
							if (inboundsct gt 0) then begin	
								timemin = max([min(orbit.point.lightning.event(inbounds).TAI93_time)-45.,$
											orbit.orbit_summary.TAI93_start])
								timemax = min([max(orbit.point.lightning.event(inbounds).TAI93_time)+45.,$
											orbit.orbit_summary.TAI93_end])
							endif
						end
					    1:begin
							widget_control, timemin_slider, get_value = timeidxmin
							widget_control, timemax_slider, get_value = timeidxmax
							timemin = orbit.one_second[timeidxmin].TAI93_time
							timemax = orbit.one_second[timeidxmax].TAI93_time
							inbounds = where(orbit.point.lightning.event(*).TAI93_time ge timemin and $
										 orbit.point.lightning.event(*).TAI93_time le timemax,inboundsct)
							if (inboundsct le 0) then begin
								inboundsct = 0
							endif
						end
					endcase			    		
					if (inboundsct gt 0) then begin
						movie_prefs,lisb,timemin,timemax
					endif
				  end
			endcase
			end
		(event.id eq boundspd):begin
			widget_control,boundspd,set_uvalue=event.index
			tvlct,red,green,blue
			selection = event.index
			if (selection gt 0) then begin
				; Scale current slider bounds to degrees for comparison
				
				thislatmin = slidbounds(zoom_level,0) 
				thislatmax = slidbounds(zoom_level,1)
				thislonmin = slidbounds(zoom_level,2)
				thislonmax = slidbounds(zoom_level,3)
				
				; Convert to whole degrees, not x10
				
				scaler = float(10.^slidbounds(zoom_level,4))
				thislatmin = float(thislatmin)/scaler
				thislatmax = float(thislatmax)/scaler
				thislonmin = float(thislonmin)/scaler
				thislonmax = float(thislonmax)/scaler
				
				; If new bounds are larger than current slider bounds, grow box as needed
				
				if ((presets(0,selection-1) lt thislatmin) or $
				    (presets(2,selection-1) gt thislatmax) or $
				    (presets(1,selection-1) lt thislonmin) or $
				    (presets(3,selection-1) gt thislonmax)) then begin
					slidbounds(zoom_level,0) = min([thislatmin,presets(0,selection-1)])
					slidbounds(zoom_level,1) = max([thislatmax,presets(2,selection-1)])
					slidbounds(zoom_level,2) = min([thislonmin,presets(1,selection-1)])
					slidbounds(zoom_level,3) = max([thislonmax,presets(3,selection-1)])	
					if (((slidbounds(zoom_level,1)-slidbounds(zoom_level,0)) lt 10) or $
						((slidbounds(zoom_level,3)-slidbounds(zoom_level,2)) lt 10) ) then begin
						upscale = 10
						zoomed = 1
					endif else begin
						upscale = 1
						zoomed = 0
					endelse
					slidbounds(zoom_level,0:3) = slidbounds(zoom_level,0:3)*upscale
					slidbounds(zoom_level,4) = zoomed & bounds(zoom_level,4) = zoomed
					thislatmin = float(slidbounds(zoom_level,0))/float(upscale)
					thislatmax = float(slidbounds(zoom_level,1))/float(upscale)
					thislonmin = float(slidbounds(zoom_level,2))/float(upscale)
					thislonmax = float(slidbounds(zoom_level,3))/float(upscale)
					map_set,/continents,/usa,E_Continents={countries:1},xmargin=[0,0],ymargin=[0,0],color=0,con_color=32,/noborder,$
						limit=[thislatmin,thislonmin,thislatmax,thislonmax]
					inbounds = where(orbit.point.lightning.flash(*).location(0) ge thislatmin and $
								 orbit.point.lightning.flash(*).location(0) le thislatmax and $
								 orbit.point.lightning.flash(*).location(1) ge thislonmin and $
								 orbit.point.lightning.flash(*).location(1) le thislonmax,inboundsct)
					if (inboundsct le 0) then begin
						inboundsct = 0
						widget_control,analyze_flash_button,sensitive=0
					endif else begin
						widget_control,analyze_flash_button,sensitive=1
					endelse
					if (inboundsct gt 0) then begin
						plots,orbit.point.lightning.flash(inbounds).location(1),orbit.point.lightning.flash(inbounds).location(0),psym=4,color=fcolors(inbounds)
					endif
					
					mapbase = tvrd()
				endif else begin
					upscale = fix(10.^bounds(zoom_level,4))
					zoomed = bounds(zoom_level,4)
					slidbounds(zoom_level,4) = bounds(zoom_level,4)
				endelse
				labarr = ['(Deg)','(Deg x10)']
				widget_control,deglab,set_value=labarr(bounds(zoom_level,4))
				widget_control,latmax_slider,set_slider_min=slidbounds(zoom_level,0)
				widget_control,latmax_slider,set_slider_max=slidbounds(zoom_level,1)
				widget_control,latmin_slider,set_slider_min=slidbounds(zoom_level,0)
				widget_control,latmin_slider,set_slider_max=slidbounds(zoom_level,1)
				widget_control,lonmax_slider,set_slider_min=slidbounds(zoom_level,2)
				widget_control,lonmax_slider,set_slider_max=slidbounds(zoom_level,3)
				widget_control,lonmin_slider,set_slider_min=slidbounds(zoom_level,2)
				widget_control,lonmin_slider,set_slider_max=slidbounds(zoom_level,3)
				bounds(zoom_level,0)=presets(0,selection-1)*upscale
				bounds(zoom_level,1)=presets(2,selection-1)*upscale
				bounds(zoom_level,2)=presets(1,selection-1)*upscale
				bounds(zoom_level,3)=presets(3,selection-1)*upscale
				widget_control,latmin_slider,set_value=bounds(zoom_level,0)
				widget_control,latmax_slider,set_value=bounds(zoom_level,1)
				widget_control,lonmin_slider,set_value=bounds(zoom_level,2)
				widget_control,lonmax_slider,set_value=bounds(zoom_level,3)
				slidminlat = float(slidbounds(zoom_level,0))/float(10.^slidbounds(zoom_level,4))
				slidmaxlat = float(slidbounds(zoom_level,1))/float(10.^slidbounds(zoom_level,4))
				slidminlon = float(slidbounds(zoom_level,2))/float(10.^slidbounds(zoom_level,4))
				slidmaxlon = float(slidbounds(zoom_level,3))/float(10.^slidbounds(zoom_level,4))
				thislatmin = float(bounds(zoom_level,0))/float(10.^bounds(zoom_level,4))
				thislatmax = float(bounds(zoom_level,1))/float(10.^bounds(zoom_level,4))
				thislonmin = float(bounds(zoom_level,2))/float(10.^bounds(zoom_level,4))
				thislonmax = float(bounds(zoom_level,3))/float(10.^bounds(zoom_level,4))
				latminidx = fix(270.0*(thislatmin-slidminlat)/(slidmaxlat-slidminlat))
				latmaxidx = fix(270.0*(thislatmax-slidminlat)/(slidmaxlat-slidminlat))
				lonminidx = fix(540.0*(thislonmin-slidminlon)/(slidmaxlon-slidminlon))
				lonmaxidx = fix(540.0*(thislonmax-slidminlon)/(slidmaxlon-slidminlon))
				xvect = [lonminidx,lonmaxidx,lonmaxidx,lonminidx,lonminidx]
				yvect = [latmaxidx,latmaxidx,latminidx,latminidx,latmaxidx]
				sbounds=polyfillv(xvect,yvect,540,270)
				newimage = mapbase
				if (sbounds(0) ne -1) then begin
					newimage(sbounds) = newimage(sbounds) + 5
				endif
				wset,bounds_map_id
				tvlct,red,green,blue
				tv,newimage
				
				update_labels_byspace
				
				in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
								(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
				if (time_in_plot_ct le 0) then begin
					minidx = 0 & maxidx = orbit.orbit_summary.one_second_count-1
				endif else begin
					minidx = min(in_map_window)
					maxidx = max(in_map_window)
					if (this_sensor eq 'otd') then begin
						minidx = minidx - 90
						maxidx = maxidx + 90
					endif else begin
						minidx = minidx - 45
						maxidx = maxidx + 45
					endelse
					minidx = max([0,minidx])
					maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
				endelse
				widget_control,timemin_slider,set_value=minidx
				widget_control,timemax_slider,set_value=maxidx
				mintime = minidx & maxtime = maxidx 		
				timemin = orbit.one_second[minidx].TAI93_time
				timemax = orbit.one_second[maxidx].TAI93_time
				
				startdt = new_datetime_structure(1)
				startdt.tai93 = double(timemin)
				calc_datetime,startdt
				enddt = new_datetime_structure(1)
				enddt.tai93 = double(timemax)
				calc_datetime,enddt
				
				widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
				widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)
			endif				
			end
		(event.id eq timemin_slider or event.id eq timemax_slider):begin
			widget_control, timemin_slider, get_value = timeidxmin
			widget_control, timemax_slider, get_value = timeidxmax
			widget_control, timemin_slider, set_value = min([timeidxmin,timeidxmax])
			widget_control, timemax_slider, set_value = max([timeidxmin,timeidxmax])
			widget_control, timemin_slider, get_value = timeidxmin
			widget_control, timemax_slider, get_value = timeidxmax
			timemin = orbit.one_second[timeidxmin].TAI93_time
			timemax = orbit.one_second[timeidxmax].TAI93_time
			
			startdt = new_datetime_structure(1)
			startdt.tai93 = double(timemin)
			calc_datetime,startdt
			enddt = new_datetime_structure(1)
			enddt.tai93 = double(timemax)
			calc_datetime,enddt
			
			widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
			widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)

			inbounds = where(orbit.point.lightning.flash(*).TAI93_time ge timemin and $
						 orbit.point.lightning.flash(*).TAI93_time le timemax,inboundsct)
			if (inboundsct le 0) then begin
				inboundsct = 0
				ng = 0 & nev = 0 & na = 0
			endif else begin
				ng = total(orbit.point.lightning.flash(inbounds).child_count)
				nev = total(orbit.point.lightning.flash(inbounds).grandchild_count)
				ua = uniq(orbit.point.lightning.flash(inbounds).parent_address, $
						sort(orbit.point.lightning.flash(inbounds).parent_address))
				uasz = size(ua)
				case uasz[0] of 
					0:begin
						na = uasz
					  end
					1:begin
						na = uasz[1]
					  end
				endcase
			endelse							
			flab = string(format='((I4)," Flashes")',inboundsct)
			widget_control,analyze_flash_button,set_value=flab
			alab = string(format='((I4)," Areas")',na)
			widget_control,analyze_area_button,set_value=alab
			glab = string(format='((I5)," Groups")',ng)
			widget_control,analyze_groups_button,set_value=glab
			elab = string(format='((I5)," Events")',nev)
			widget_control,analyze_events_button,set_value=elab
			if (num_cross eq 0 or crosstimes[0] lt timeidxmin or crosstimes[0] gt timeidxmax) then begin
				; print,'one segment'
				vectsize = max([2*(timeidxmax-timeidxmin),1])
				; print,vectsize
				if (vectsize gt 1) then begin
					xvect = fltarr(vectsize+1)
					yvect = fltarr(vectsize+1)
					idx = 0
					xvect[0:timeidxmax-timeidxmin] = fov1[1,timeidxmin:timeidxmax]
					yvect[0:timeidxmax-timeidxmin] = fov1[0,timeidxmin:timeidxmax]
					idx = timeidxmax-timeidxmin
					for j = timeidxmax, timeidxmin, -1 do begin
						xvect[idx] = fov2[1,j]
						yvect[idx] = fov2[0,j]
						idx = idx + 1
					endfor
					xvect[vectsize-1] = xvect[0] & yvect[vectsize-1] = yvect[0]
					xvect = 540*(xvect+180.0)/(180.0+180.0)
					yvect = 270*(yvect+90.0)/(90.0+90.0)
					sbounds = polyfillv(xvect,yvect,540,270)
					newimage = mapbase
					if (sbounds(0) ne -1) then begin
						newimage(sbounds) = newimage(sbounds) + 5
					endif
					wset,bounds_map_id
					tvlct,red,green,blue
					tv,newimage
				endif				
			endif	 else begin
				; print,'two segments'
				vectsize = 2*(crosstimes[0]-timeidxmin)
				; print,vectsize
				xvect = fltarr(vectsize+1)
				yvect = fltarr(vectsize+1)
				idx = 0
				xvect[0:crosstimes[0]-timeidxmin-1] = fov1[1,timeidxmin:crosstimes[0]-1]
				yvect[0:crosstimes[0]-timeidxmin-1] = fov1[0,timeidxmin:crosstimes[0]-1]
				idx = crosstimes[0]-timeidxmin
				for j = crosstimes[0]-1, timeidxmin, -1 do begin
					xvect[idx] = fov2[1,j]
					yvect[idx] = fov2[0,j]
					idx = idx + 1
				endfor
				xvect[vectsize] = xvect[0] & yvect[vectsize] = yvect[0]
				xvect = 540*(xvect+180.0)/(180.0+180.0)
				yvect = 270*(yvect+90.0)/(90.0+90.0)
				sbounds = polyfillv(xvect,yvect,540,270)
				newimage = mapbase
				if (sbounds(0) ne -1) then begin
					newimage(sbounds) = newimage(sbounds) + 5
				endif
				
				vectsize = 2*(timeidxmax-crosstimes[0])
				; print,vectsize
				xvect = fltarr(vectsize+1)
				yvect = fltarr(vectsize+1)
				idx = 0
				xvect[0:timeidxmax-crosstimes[0]] = fov1[1,crosstimes[0]:timeidxmax]
				yvect[0:timeidxmax-crosstimes[0]] = fov1[0,crosstimes[0]:timeidxmax]
				idx = timeidxmax-crosstimes[0]
				for j = timeidxmax, crosstimes[0], -1 do begin
					xvect[idx] = fov2[1,j]
					yvect[idx] = fov2[0,j]
					idx = idx + 1
				endfor
				xvect[vectsize-1] = xvect[0] & yvect[vectsize-1] = yvect[0]
				xvect = 540*(xvect+180.0)/(180.0+180.0)
				yvect = 270*(yvect+90.0)/(90.0+90.0)
				sbounds = polyfillv(xvect,yvect,540,270)
				if (sbounds(0) ne -1) then begin
					newimage(sbounds) = newimage(sbounds) + 5
				endif
				wset,bounds_map_id
				tvlct,red,green,blue
				tv,newimage				
			endelse
			
			end
		(event.id eq latmax_slider or event.id eq latmin_slider):begin
			;print,'Latslider'
			widget_control, latmax_slider, get_value = latmax
			widget_control, latmin_slider, get_value = latmin
			widget_control, lonmin_slider, get_value = lonmin
			widget_control, lonmax_slider, get_value = lonmax
			widget_control, latmin_slider, set_value = min([latmin,latmax])
			widget_control, latmax_slider, set_value = max([latmin,latmax])
			bounds(zoom_level,0) = latmin
			bounds(zoom_level,1) = latmax
			bounds(zoom_level,2) = lonmin
			bounds(zoom_level,3) = lonmax
			slidminlat = float(slidbounds(zoom_level,0))/float(10.^slidbounds(zoom_level,4))
			slidmaxlat = float(slidbounds(zoom_level,1))/float(10.^slidbounds(zoom_level,4))
			slidminlon = float(slidbounds(zoom_level,2))/float(10.^slidbounds(zoom_level,4))
			slidmaxlon = float(slidbounds(zoom_level,3))/float(10.^slidbounds(zoom_level,4))
			thislatmin = float(latmin)/float(10.^bounds(zoom_level,4))
			thislatmax = float(latmax)/float(10.^bounds(zoom_level,4))
			thislonmin = float(lonmin)/float(10.^bounds(zoom_level,4))
			thislonmax = float(lonmax)/float(10.^bounds(zoom_level,4))
			latminidx = fix(270.0*(thislatmin-slidminlat)/(slidmaxlat-slidminlat))
			latmaxidx = fix(270.0*(thislatmax-slidminlat)/(slidmaxlat-slidminlat))
			lonminidx = fix(540.0*(thislonmin-slidminlon)/(slidmaxlon-slidminlon))
			lonmaxidx = fix(540.0*(thislonmax-slidminlon)/(slidmaxlon-slidminlon))
			xvect = [lonminidx,lonmaxidx,lonmaxidx,lonminidx,lonminidx]
			yvect = [latmaxidx,latmaxidx,latminidx,latminidx,latmaxidx]
			sbounds=polyfillv(xvect,yvect,540,270)
			newimage = mapbase
			if (sbounds(0) ne -1) then begin
				newimage(sbounds) = newimage(sbounds) + 5
			endif
			wset,bounds_map_id
			tvlct,red,green,blue
			tv,newimage
			
			update_labels_byspace
			
;			in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
;							(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
			in_map_window = where((nadir_lats ge thislatmin) and (nadir_lons ge thislonmin) and $
							(nadir_lats le thislatmax) and (nadir_lons le thislonmax),time_in_plot_ct)
			if (time_in_plot_ct le 0) then begin
				minidx = 0 & maxidx = orbit.orbit_summary.one_second_count-1
			endif else begin
				minidx = min(in_map_window)
				maxidx = max(in_map_window)
				if (this_sensor eq 'otd') then begin
					minidx = minidx - 90
					maxidx = maxidx + 90
				endif else begin
					minidx = minidx - 45
					maxidx = maxidx + 45
				endelse
				minidx = max([0,minidx])
				maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
			endelse
			widget_control,timemin_slider,set_value=minidx
			widget_control,timemax_slider,set_value=maxidx
			mintime = minidx & maxtime = maxidx 		
			widget_control,timemin_slider,set_value=minidx
			widget_control,timemax_slider,set_value=maxidx
			mintime = minidx & maxtime = maxidx 		
			timemin = orbit.one_second[minidx].TAI93_time
			timemax = orbit.one_second[maxidx].TAI93_time
			
			startdt = new_datetime_structure(1)
			startdt.tai93 = double(timemin)
			calc_datetime,startdt
			enddt = new_datetime_structure(1)
			enddt.tai93 = double(timemax)
			calc_datetime,enddt
			
			widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
			widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)
			end
		(event.id eq lonmin_slider or event.id eq lonmax_slider):begin
			;print,'Lonslider'
			widget_control, latmax_slider, get_value = latmax
			widget_control, latmin_slider, get_value = latmin
			widget_control, lonmin_slider, get_value = lonmin
			widget_control, lonmax_slider, get_value = lonmax
			widget_control, lonmin_slider, set_value = min([lonmin,lonmax])
			widget_control, lonmax_slider, set_value = max([lonmin,lonmax])		
			bounds(zoom_level,0) = latmin
			bounds(zoom_level,1) = latmax
			bounds(zoom_level,2) = lonmin
			bounds(zoom_level,3) = lonmax
			slidminlat = float(slidbounds(zoom_level,0))/float(10.^slidbounds(zoom_level,4))
			slidmaxlat = float(slidbounds(zoom_level,1))/float(10.^slidbounds(zoom_level,4))
			slidminlon = float(slidbounds(zoom_level,2))/float(10.^slidbounds(zoom_level,4))
			slidmaxlon = float(slidbounds(zoom_level,3))/float(10.^slidbounds(zoom_level,4))
			thislatmin = float(latmin)/float(10.^bounds(zoom_level,4))
			thislatmax = float(latmax)/float(10.^bounds(zoom_level,4))
			thislonmin = float(lonmin)/float(10.^bounds(zoom_level,4))
			thislonmax = float(lonmax)/float(10.^bounds(zoom_level,4))
			
			latminidx = fix(270.0*(thislatmin-slidminlat)/(slidmaxlat-slidminlat))
			latmaxidx = fix(270.0*(thislatmax-slidminlat)/(slidmaxlat-slidminlat))
			lonminidx = fix(540.0*(thislonmin-slidminlon)/(slidmaxlon-slidminlon))
			lonmaxidx = fix(540.0*(thislonmax-slidminlon)/(slidmaxlon-slidminlon))
			xvect = [lonminidx,lonmaxidx,lonmaxidx,lonminidx,lonminidx]
			yvect = [latmaxidx,latmaxidx,latminidx,latminidx,latmaxidx]
			sbounds=polyfillv(xvect,yvect,540,270)
			newimage = mapbase
			if (sbounds(0) ne -1) then begin
				newimage(sbounds) = newimage(sbounds) + 5
			endif
			wset,bounds_map_id
			tvlct,red,green,blue
			tv,newimage		
			
			update_labels_byspace
			
;			in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
;							(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
			in_map_window = where((nadir_lats ge thislatmin) and (nadir_lons ge thislonmin) and $
							(nadir_lats le thislatmax) and (nadir_lons le thislonmax),time_in_plot_ct)

			if (time_in_plot_ct le 0) then begin
				minidx = 0 & maxidx = orbit.orbit_summary.one_second_count-1
			endif else begin
				minidx = min(in_map_window)
				maxidx = max(in_map_window)
				if (this_sensor eq 'otd') then begin
					minidx = minidx - 90
					maxidx = maxidx + 90
				endif else begin
					minidx = minidx - 45
					maxidx = maxidx + 45
				endelse
				minidx = max([0,minidx])
				maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
			endelse
			widget_control,timemin_slider,set_value=minidx
			widget_control,timemax_slider,set_value=maxidx
			mintime = minidx & maxtime = maxidx 		
			widget_control,timemin_slider,set_value=minidx
			widget_control,timemax_slider,set_value=maxidx
			mintime = minidx & maxtime = maxidx 		
			timemin = orbit.one_second[minidx].TAI93_time
			timemax = orbit.one_second[maxidx].TAI93_time
			
			startdt = new_datetime_structure(1)
			startdt.tai93 = double(timemin)
			calc_datetime,startdt
			enddt = new_datetime_structure(1)
			enddt.tai93 = double(timemax)
			calc_datetime,enddt
			
			widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
			widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)
			end
		(event.id eq zoom_in_button):begin
		
			zoom_level = zoom_level + 1
			prevlatmin = bounds(zoom_level-1,0) 
			prevlatmax = bounds(zoom_level-1,1)
			prevlonmin = bounds(zoom_level-1,2)
			prevlonmax = bounds(zoom_level-1,3)
			; Convert to whole degrees, not x10
			scaler = float(10.^slidbounds(zoom_level-1,4))
			thislatmin = float(prevlatmin)/scaler
			thislatmax = float(prevlatmax)/scaler
			thislonmin = float(prevlonmin)/scaler
			thislonmax = float(prevlonmax)/scaler
			if ( ((thislatmax-thislatmin) lt 10) or $
				((thislonmax-thislonmin) lt 10) ) then begin
				upscale = 10
				zoomed = 1
			endif else begin
				upscale = 1
				zoomed = 0
			endelse
			slidbounds(zoom_level,4) = zoomed
			slidbounds(zoom_level,0) = thislatmin*upscale
			slidbounds(zoom_level,1) = thislatmax*upscale
			slidbounds(zoom_level,2) = thislonmin*upscale
			slidbounds(zoom_level,3) = thislonmax*upscale
			bounds(zoom_level,4) = zoomed
			bounds(zoom_level,0) = thislatmin*upscale
			bounds(zoom_level,1) = thislatmax*upscale
			bounds(zoom_level,2) = thislonmin*upscale
			bounds(zoom_level,3) = thislonmax*upscale
			labarr = ['(Deg)','(Deg x10)']
			widget_control,deglab,set_value=labarr(bounds(zoom_level,4))
			widget_control,latmin_slider,set_slider_min = slidbounds(zoom_level,0)
			widget_control,latmin_slider,set_slider_max = slidbounds(zoom_level,1)
			widget_control,latmax_slider,set_slider_min = slidbounds(zoom_level,0)
			widget_control,latmax_slider,set_slider_max = slidbounds(zoom_level,1)
			widget_control,lonmin_slider,set_slider_min = slidbounds(zoom_level,2)
			widget_control,lonmin_slider,set_slider_max = slidbounds(zoom_level,3)
			widget_control,lonmax_slider,set_slider_min = slidbounds(zoom_level,2)
			widget_control,lonmax_slider,set_slider_max = slidbounds(zoom_level,3)
			widget_control,latmin_slider,set_value=bounds(zoom_level,0)
			widget_control,latmax_slider,set_value=bounds(zoom_level,1)
			widget_control,lonmin_slider,set_value=bounds(zoom_level,2)
			widget_control,lonmax_slider,set_value=bounds(zoom_level,3)
			
			latmin = bounds(zoom_level-1,0) & latmax = bounds(zoom_level-1,1) 
			lonmin = bounds(zoom_level-1,2) & lonmax = bounds(zoom_level-1,3)
			scaler = float(10.^bounds(zoom_level-1,4))
			thislatmin = float(latmin)/scaler
			thislatmax = float(latmax)/scaler
			thislonmin = float(lonmin)/scaler
			thislonmax = float(lonmax)/scaler
						
			replot_items_inbounds, 0
						
			mapbase = tvrd()
			
			widget_control,zoom_out_button,sensitive=1
			; print,bounds(0:5,*)
			;print,'done with zoom in'
			;print,zoom_level
			;print,bounds(0:zoom_level,*)	
			end
		(event.id eq zoom_out_button):begin

			
			zoom_level = zoom_level - 1
			slidlatmin = slidbounds(zoom_level,0) & slidlatmax = slidbounds(zoom_level,1) 
			slidlonmin = slidbounds(zoom_level,2) & slidlonmax = slidbounds(zoom_level,3)
			labarr = ['(Deg)','(Deg x10)']
			widget_control,deglab,set_value=labarr(bounds(zoom_level,4))
			widget_control,latmin_slider,set_slider_min = slidlatmin
			widget_control,latmin_slider,set_slider_max = slidlatmax
			widget_control,latmax_slider,set_slider_min = slidlatmin
			widget_control,latmax_slider,set_slider_max = slidlatmax
			widget_control,lonmin_slider,set_slider_min = slidlonmin
			widget_control,lonmin_slider,set_slider_max = slidlonmax
			widget_control,lonmax_slider,set_slider_min = slidlonmin
			widget_control,lonmax_slider,set_slider_max = slidlonmax
			latmin = bounds(zoom_level,0) & latmax = bounds(zoom_level,1) 
			lonmin = bounds(zoom_level,2) & lonmax = bounds(zoom_level,3)
			widget_control,latmin_slider,set_value=latmin
			widget_control,latmax_slider,set_value=latmax
			widget_control,lonmin_slider,set_value=lonmin
			widget_control,lonmax_slider,set_value=lonmax
			scaler = float(10.^bounds(zoom_level,4))
			slidlatmin = float(slidlatmin)/scaler
			slidlatmax = float(slidlatmax)/scaler
			slidlonmin = float(slidlonmin)/scaler
			slidlonmax = float(slidlonmax)/scaler
			thislatmin = float(latmin)/scaler
			thislatmax = float(latmax)/scaler
			thislonmin = float(lonmin)/scaler
			thislonmax = float(lonmax)/scaler
			
			wset,bounds_map_id
			tvlct,red,green,blue
			;map_set,/continents,E_Continents={countries:1},/usa,xmargin=[0,0],ymargin=[0,0],color=0,con_color=32,/noborder, $
			;	limit=[slidlatmin,slidlonmin,slidlatmax,slidlonmax]

			; plot point data
			;inbounds = where(orbit.point.lightning.flash(*).location(0) ge slidlatmin and $
			;			 orbit.point.lightning.flash(*).location(0) le slidlatmax and $
			;			 orbit.point.lightning.flash(*).location(1) ge slidlonmin and $
			;			 orbit.point.lightning.flash(*).location(1) le slidlonmax,inboundsct)
			;if (inboundsct gt 0) then begin
			;	plots,orbit.point.lightning.flash(inbounds).location(1),orbit.point.lightning.flash(inbounds).location(0),psym=4,color=fcolors(inbounds)
			;endif
			;inbounds = where(orbit.point.lightning.flash(*).location(0) ge thislatmin and $
			;			 orbit.point.lightning.flash(*).location(0) le thislatmax and $
			;			 orbit.point.lightning.flash(*).location(1) ge thislonmin and $
			;			 orbit.point.lightning.flash(*).location(1) le thislonmax,inboundsct)
			;			

			replot_items_inbounds, 1
			
			update_labels_byspace
			
			mapbase = tvrd()
			latminidx = fix(270.0*(thislatmin-slidlatmin)/(slidlatmax-slidlatmin))
			latmaxidx = fix(270.0*(thislatmax-slidlatmin)/(slidlatmax-slidlatmin))
			lonminidx = fix(540.0*(thislonmin-slidlonmin)/(slidlonmax-slidlonmin))
			lonmaxidx = fix(540.0*(thislonmax-slidlonmin)/(slidlonmax-slidlonmin))
			xvect = [lonminidx,lonmaxidx,lonmaxidx,lonminidx,lonminidx]
			yvect = [latmaxidx,latmaxidx,latminidx,latminidx,latmaxidx]
			sbounds=polyfillv(xvect,yvect,540,270)
			newimage = mapbase
			if (sbounds(0) ne -1) then begin
				newimage(sbounds) = newimage(sbounds) + 5
			endif
			tv,newimage
;			in_map_window = where((nadir_lats ge bounds(zoom_level,0)) and (nadir_lons ge bounds(zoom_level,2)) and $
;							(nadir_lats le bounds(zoom_level,1)) and (nadir_lons le bounds(zoom_level,3)),time_in_plot_ct)
			in_map_window = where((nadir_lats ge thislatmin) and (nadir_lons ge thislonmin) and $
							(nadir_lats le thislatmax) and (nadir_lons le thislonmax),time_in_plot_ct)
			if (time_in_plot_ct le 0) then begin
				minidx = 0 & maxidx = orbit.orbit_summary.one_second_count-1
			endif else begin
				minidx = min(in_map_window)
				maxidx = max(in_map_window)
				if (this_sensor eq 'otd') then begin
					minidx = minidx - 90
					maxidx = maxidx + 90
				endif else begin
					minidx = minidx - 45
					maxidx = maxidx + 45
				endelse
				minidx = max([0,minidx])
				maxidx = min([maxidx,orbit.orbit_summary.one_second_count-1])
			endelse
			widget_control,timemin_slider,set_value=minidx
			widget_control,timemax_slider,set_value=maxidx
			mintime = minidx & maxtime = maxidx 		
			timemin = orbit.one_second[minidx].TAI93_time
			timemax = orbit.one_second[maxidx].TAI93_time
			startdt = new_datetime_structure(1)
			startdt.tai93 = double(timemin)
			calc_datetime,startdt
			enddt = new_datetime_structure(1)
			enddt.tai93 = double(timemax)
			calc_datetime,enddt
			
			widget_control,timemin_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',startdt.utc.hour,startdt.utc.minute,startdt.utc.second)
			widget_control,timemax_label,set_value=string(format='((I2.2),":",(I2.2),":",(F6.3)," UTC")',enddt.utc.hour,enddt.utc.minute,enddt.utc.second)
			
			end
		(event.id eq zoom_reset_button):begin
		
			end
	endcase
end