function new_prefs_struct

	x = bytarr(132)
	x(*) = 32
	empty = string(x)
	
	this_prefs_input_sensor = {a_prefs_input_sensor, $
		area:1,flash:1,group:1,event:1, $
		viewtime:1,onesecond:1}
		
	this_prefs_input = {a_prefs_input, $
		lis:replicate(this_prefs_input_sensor,1), $
		otd:replicate(this_prefs_input_sensor,1)}

	this_prefs_graphics = {a_prefs_graphics, $
		hires:0, coasts:0, fill:0, $
		targetsize:800,persistence:3,delay:0}

	this_prefs_shlb = {a_prefs_shlb, $
		use_shlb:0, $
		shlb:empty}
		
	this_prefs_paths = {a_prefs_paths, $
		lisapp:empty, data:empty, backgrounds:empty, output:empty}

	this_prefs = {a_prefs, $
		input:replicate(this_prefs_input,1), $
		graphics:replicate(this_prefs_graphics,1), $
		paths:replicate(this_prefs_paths,1), $
		shlb:replicate(this_prefs_shlb,1)}

	return,this_prefs
end

pro create_prefs
	
	prefs = new_prefs_struct()
	openw,lun,'lisapp.prefs',/get_lun
	writeu,lun,prefs
	close,lun
	free_lun,lun

end

pro read_prefs

	prefs = new_prefs_struct()
	openr,lun,'lisapp.prefs',/get_lun
	readu,lun,prefs
	close,lun
	free_lun,lun
	stop
end

function pad_132, instr
	help,instr
	instrb = byte(instr)
	instrbsz = size(instrb)
	instrblen = instrbsz(1)
	outb = bytarr(132)
	outb(0:instrblen-1) = instrb(*)
	outb(instrblen:131) = 32
	outstr = string(outb)
	return,outstr

end
	
function strip_132, instr

	instrb = byte(instr)
	nonspace = where(instrb ne 32,nonspace_count)
	if (nonspace_count eq -1) then begin
		outstr = ''
	endif else begin
		lastnonspace = max(nonspace)
		outstrb = bytarr(lastnonspace+1)
		outstrb(*) = instrb(0:lastnonspace)
		outstr = string(outstrb)
	endelse
	return,outstr
end
	
PRO pathswid
	common menuids, writelisbutton, plot_spatial_button, plot_array_button, verify_inbounds_button, ql_vt_button, ql_ev_button, $
					ql_ar_button, ql_fl_button, ql_gr_button, ql_menu, ed_ev_button, ed_gr_button, ed_fl_button, ed_ar_button, $
					ed_vt_button, ed_os_button, vd_menu, ql_bgfp_button, ql_al_button, plot_bg_button, $
					an_pix_button, an_bg_button, animate_menu, plot_nav_button, verify_regeo_button, exbg_button, $
					paths_prefs_button, graphics_prefs_button,doublepixels_button, add_vdata_button,plot_ts_button,afge_button, $
					densitybg_button, density_button, movieframe_button, export_menu, qlbrowse
	common paths, lastpath, currentpath, origpath, shlbfile
	common lisapp_prefs, app_prefs
	common prefs_paths_com, prefs_pathsb, AppPathField, DataPathField, BGPathField, OutputPathField, $
					prefs_paths_applybut, prefs_paths_savebut, prefs_paths_donebut
     common prefs_paths_com2, AppPathButton, DataPathButton, BGPathButton, OutputPathButton
 	common fullpaths, app_path, data_path, bg_path, output_path
    
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  junk   = { CW_PDMENU_S, flags:0, name:'' }


  prefs_pathsb = WIDGET_BASE(GROUP_LEADER=lisb, $
      ROW=2, $
      MAP=1, $
      TITLE='Default Path Preferences', $
      UVALUE='prefs_pathsb')

  prefs_paths_entryb = WIDGET_BASE(prefs_pathsb, $
      ROW=4, $
      MAP=1, $
      TITLE='prefswid_paths_entry', $
      UVALUE='prefs_paths_entryb')

  prefs_paths_entryb1 = widget_base(prefs_paths_entryb,column=2)  
  AppPathButton = widget_button(prefs_paths_entryb1,value='Select...')
  FieldVal989 =  origpath 
  AppPathField = CW_FIELD( prefs_paths_entryb1,VALUE=FieldVal989, $
      ROW=1, $
      STRING=1, $
      TITLE='Application Path:', $
      UVALUE='AppPathField', $
      XSIZE=132)

  prefs_paths_entryb2 = widget_base(prefs_paths_entryb,column=2)  
  DataPathButton = widget_button(prefs_paths_entryb2,value='Select...')
  FieldVal1052 =  data_path
  DataPathField = CW_FIELD( prefs_paths_entryb2,VALUE=FieldVal1052, $
      ROW=1, $
      STRING=1, $
      TITLE='Data Path:          ', $
      UVALUE='DataPathField', $
      XSIZE=132)

  prefs_paths_entryb3 = widget_base(prefs_paths_entryb,column=2)
  BGPathButton = widget_button(prefs_paths_entryb3,value='Select...')
  FieldVal1115 =  bg_path 
  BGPathField = CW_FIELD( prefs_paths_entryb3,VALUE=FieldVal1115, $
      ROW=1, $
      STRING=1, $
      TITLE='Background Path:', $
      UVALUE='BGPathField', $
      XSIZE=132)

  prefs_paths_entryb4 = widget_base(prefs_paths_entryb,column=2)
  OutputPathButton = widget_button(prefs_paths_entryb4,value='Select...')
  FieldVal1178 =   output_path
  OutputPathField = CW_FIELD( prefs_paths_entryb4,VALUE=FieldVal1178, $
      ROW=1, $
      STRING=1, $
      TITLE='Output Path:      ', $
      UVALUE='OutputPathField', $
      XSIZE=132)


  prefs_paths_control = WIDGET_BASE(prefs_pathsb, $
      COLUMN=3, $
      MAP=1, $
      TITLE='prefswid_paths_control', $
      UVALUE='prefs_paths_control')

  prefs_paths_applybut = WIDGET_BUTTON( prefs_paths_control, $
      UVALUE='prefs_paths_applybut', $
      VALUE='Apply')

  prefs_paths_savebut = WIDGET_BUTTON( prefs_paths_control, $
      UVALUE='prefs_paths_savebut', $
      VALUE='Save')

  prefs_paths_donebut = WIDGET_BUTTON( prefs_paths_control, $
      UVALUE='prefs_paths_donebut', $
      VALUE='Done')


  WIDGET_CONTROL, prefs_pathsb, /REALIZE

  XMANAGER, 'prefs_pathsb', prefs_pathsb, EVENT_HANDLER='prefswid_paths_handler',/no_block
END

pro prefswid_paths_handler, event
	common prefs_paths_com, prefs_pathsb, AppPathField, DataPathField, BGPathField, OutputPathField, $
					prefs_paths_applybut, prefs_paths_savebut, prefs_paths_donebut
	common lisapp_prefs, app_prefs
	common paths, lastpath, currentpath, origpath, shlbfile
     common prefs_paths_com2, AppPathButton, DataPathButton, BGPathButton, OutputPathButton
	common fullpaths, app_path, data_path, bg_path, output_path

	case 1 of 
		(event.id eq AppPathField or event.id eq DataPathField or event.id eq BGPathField $
			or event.id eq OutputPathField): begin
									end
		(event.id eq prefs_paths_applybut): begin
				widget_control, AppPathField, get_value=app_path
				widget_control, DataPathField, get_value=data_path
				widget_control, BGPathField, get_value=bg_path
				widget_control, OutputPathField, get_value=output_path
				origpath = strip_132(app_path(0))
				currentpath = strip_132(data_path(0))
				lastpath = currentpath
				cd,currentpath
				widget_control, prefs_pathsb, /destroy
									end
		(event.id eq prefs_paths_savebut): begin
				cd, origpath 
				widget_control, AppPathField, get_value=app_path
				widget_control, DataPathField, get_value=data_path
				widget_control, BGPathField, get_value=bg_path
				widget_control, OutputPathField, get_value=output_path
				; print,app_path(0),data_path(0),bg_path(0),output_path(0)
				help,app_path,data_path,bg_path,output_path
				origpath = strip_132(app_path(0))
				currentpath = strip_132(data_path(0))
				lastpath = currentpath
				app_prefs.paths.lisapp = pad_132(app_path(0))
				app_prefs.paths.data   = pad_132(data_path(0))
				app_prefs.paths.backgrounds = pad_132(bg_path(0))
				app_prefs.paths.output = pad_132(output_path(0))
				openw,lun,'lisapp.prefs',/get_lun
				writeu,lun,app_prefs
				close,lun
				free_lun,lun
				cd, currentpath
				widget_control, prefs_pathsb, /destroy
					end
		(event.id eq prefs_paths_donebut): begin
				widget_control, prefs_pathsb, /destroy
					end
		(event.id eq AppPathButton): begin
				dumfile = dialog_pickfile(title='Select any file in the LISAPP directory.', $
							get_path = app_path)
				if (dumfile ne '') then begin
					widget_control, AppPathField, set_value=app_path
				endif
				end
		(event.id eq DataPathButton): begin
				dumfile = dialog_pickfile(title='Select any file in the HDF data file directory.', $
							get_path = data_path)
				if (dumfile ne '') then begin
					widget_control, DataPathField, set_value=data_path
				endif
				end
		(event.id eq BGPathButton): begin
				dumfile = dialog_pickfile(title='Select any file in the HDF background file directory.', $
							get_path = bg_path)
				if (dumfile ne '') then begin
					widget_control, BGPathField, set_value=bg_path
				endif
				end
		(event.id eq OutputPathButton): begin
				dumfile = dialog_pickfile(title='Select any file in the output file directory.', $
							get_path = output_path)
				if (dumfile ne '') then begin
					widget_control, OutputPathField, set_value=output_path
				endif
				end
		
	endcase
end

PRO prefs_graphicsb_Event, Event

  common prefs_graphics_com, prefs_graphics_mappingbuts, prefs_graphics_targetsizefield, $
  		prefs_graphics_delayslider, prefs_graphics_persistenceslider
  common lisapp_prefs, app_prefs
  common prefs_graphics_com2, prefs_graphicsb
  common paths, lastpath, currentpath, origpath, shlbfile
  common fullpaths, app_path, data_path, bg_path, output_path
  		
  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF 

  'prefs_graphics_mappingbuts': BEGIN
    ;  IF Event.Select THEN Sel = 'On' ELSE Sel = 'Off'
    ;  CASE Event.Value OF
    ;  0: Print,'Button Hi-Res Turned ', Sel
    ;  1: Print,'Button Coasts Turned ', Sel
    ;  2: Print,'Button Color Map BG Turned ', Sel
    ;  ELSE: Message,'Unknown button pressed'
    ;  ENDCASE
     END
  'prefs_graphics_targetsizefield': BEGIN
    ;  Print, 'Event for prefs_graphics_targetsizefield'
     END
  'prefs_graphics_persistenceslider': BEGIN
    ;  Print, 'Event for prefs_graphics_persistenceslider'
      END
  'prefs_graphics_delayslider': BEGIN
    ;  Print, 'Event for prefs_graphics_delayslider'
     END
  'prefs_graphics_applybut': BEGIN
	widget_control,prefs_graphics_mappingbuts,get_value=setvec
	; print,setvec
	app_prefs.graphics.hires = setvec(0)
	app_prefs.graphics.coasts = setvec(1)
	app_prefs.graphics.fill = setvec(2)
	widget_control,prefs_graphics_targetsizefield,get_value=tsize
	app_prefs.graphics.targetsize = tsize	
	widget_control,prefs_graphics_persistenceslider,get_value=persist
	app_prefs.graphics.persistence = persist
	widget_control,prefs_graphics_delayslider,get_value=delay
	app_prefs.graphics.delay = delay
	widget_control,prefs_graphicsb,/destroy
      END
  'prefs_graphics_savebut': BEGIN
	widget_control,prefs_graphics_mappingbuts,get_value=setvec
	app_prefs.graphics.hires = setvec(0)
	app_prefs.graphics.coasts = setvec(1)
	app_prefs.graphics.fill = setvec(2)
	widget_control,prefs_graphics_targetsizefield,get_value=tsize
	app_prefs.graphics.targetsize = tsize	
	widget_control,prefs_graphics_persistenceslider,get_value=persist
	app_prefs.graphics.persistence = persist
	widget_control,prefs_graphics_delayslider,get_value=delay
	app_prefs.graphics.delay = delay
	cd,origpath
	openw,lun,'lisapp.prefs',/get_lun
	writeu,lun,app_prefs
	close,lun
	free_lun,lun
	cd, currentpath
	widget_control,prefs_graphicsb,/destroy
      END
  'prefs_graphics_donebut': BEGIN
	widget_control,prefs_graphicsb,/destroy
      END
  ENDCASE
END


; DO NOT REMOVE THIS COMMENT: END prefs_graphicsb
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.



PRO prefs_graphics, lisb

  common prefs_graphics_com, prefs_graphics_mappingbuts, prefs_graphics_targetsizefield, $
  		prefs_graphics_delayslider, prefs_graphics_persistenceslider
  common prefs_graphics_com2, prefs_graphicsb

common lisapp_prefs, app_prefs



  prefs_graphicsb = WIDGET_BASE(GROUP_LEADER=lisb, $
      ROW=2, $
      MAP=1, $
      TITLE='Graphics Preferences', $
      UVALUE='prefs_graphicsb')

  prefs_graphics_controlsb = WIDGET_BASE(prefs_graphicsb, $
      COLUMN=3, $
      MAP=1, /grid_layout, $
      TITLE='prefs_graphics_controlsb', $
      UVALUE='prefs_graphics_controlsb')

  prefs_graphics_mappingb = WIDGET_BASE(prefs_graphics_controlsb, $
      ROW=2, $
      FRAME=3, $
      MAP=1, $
      TITLE='prefs_graphics_mappingb', $
      UVALUE='prefs_graphics_mappingb')

  LABEL22 = WIDGET_LABEL( prefs_graphics_mappingb, $
      UVALUE='LABEL22', $
      VALUE='MAPPING')

  Btns2806 = [ $
    'Hi-Res', $
    'Coasts', $
    'Color Map BG' ]
  prefs_graphics_mappingbuts = CW_BGROUP( prefs_graphics_mappingb, Btns2806, $
      ROW=3, $
      NONEXCLUSIVE=1, $
      UVALUE='prefs_graphics_mappingbuts', $
      SET_VALUE=[app_prefs.graphics.hires, app_prefs.graphics.coasts, app_prefs.graphics.fill])



  prefs_graphics_imageb = WIDGET_BASE(prefs_graphics_controlsb, $
      ROW=2, $
      FRAME=3, $
      MAP=1, $
      TITLE='prefs_graphics_imageb', $
      UVALUE='prefs_graphics_imageb')

  LABEL19 = WIDGET_LABEL( prefs_graphics_imageb, $
      UVALUE='LABEL19', $
      VALUE='IMAGES')

   FieldVal2960 = app_prefs.graphics.targetsize
   
  prefs_graphics_targetsizefield = CW_FIELD( prefs_graphics_imageb,VALUE=FieldVal2960, $
      COLUMN=1, $
      INTEGER=1, $
      TITLE='Image Target Size:', $
      UVALUE='prefs_graphics_targetsizefield')



  prefs_graphics_animb = WIDGET_BASE(prefs_graphics_controlsb, $
      ROW=3, $
      FRAME=3, $
      MAP=1, $
      TITLE='prefs_graphics_animb', $
      UVALUE='prefs_graphics_animb')

  LABEL20 = WIDGET_LABEL( prefs_graphics_animb, $
      UVALUE='LABEL20', $
      VALUE='ANIMATION')

   prefs_graphics_persistenceslider = WIDGET_SLIDER( prefs_graphics_animb, $
      MAXIMUM=50, $
      MINIMUM=1, $
      TITLE='Persistence (Groups)', $
      UVALUE='prefs_graphics_persistenceslider', $
      VALUE=app_prefs.graphics.persistence)

  prefs_graphics_delayslider = WIDGET_SLIDER( prefs_graphics_animb, $
      MAXIMUM=100, $
      MINIMUM=0, $
      TITLE='Frame Delay (x.1 ms)', $
      UVALUE='prefs_graphics_delayslider', $
      VALUE=app_prefs.graphics.delay)




  prefs_graphics_buttonsb = WIDGET_BASE(prefs_graphicsb, $
      COLUMN=3, $
      MAP=1, /grid_layout, $
      TITLE='prefs_graphics_buttonsb', $
      UVALUE='prefs_graphics_buttonsb')

  prefs_graphics_applybut = WIDGET_BUTTON( prefs_graphics_buttonsb, $
      UVALUE='prefs_graphics_applybut', $
      VALUE='Apply')

  prefs_graphics_savebut = WIDGET_BUTTON( prefs_graphics_buttonsb, $
      UVALUE='prefs_graphics_savebut', $
      VALUE='Apply & Save')

  prefs_graphics_donebut = WIDGET_BUTTON( prefs_graphics_buttonsb, $
      UVALUE='prefs_graphics_donebut', $
      VALUE='Done')


  WIDGET_CONTROL, prefs_graphicsb, /REALIZE

  XMANAGER, 'prefs_graphicsb', prefs_graphicsb, /no_block
END

function toggle_prefs, event
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	
	want = ['Areas','Flashes','Groups','Events','Viewtimes','One-Seconds']
	widget_control,event.id,get_value=buttonvalue
	setparams = buttonvalue
	; print,want(where(buttonvalue eq 1))
	return,1
end

function toggle_prefs_otd, event
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	
	want = ['Areas','Flashes','Groups','Events','Viewtimes','One-Seconds']
	widget_control,event.id,get_value=buttonvalue
	setparamsotd = buttonvalue
	; print,want(where(buttonvalue eq 1))
	return,1
end


	
pro lisapp_getlisreadparams, topid
	common lisapp_prefs, app_prefs
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common prefs2, prefb, sensor_select, options, enact, sensor_selected
	common prefswidids, optionsotd,native,setbutton,savebutton,donebutton, shlb_path_field
	common shlbcom, use_shlb
	
	common sysinfo, version
	
	setparams = readparams
	setparamsotd = readparamsotd
	
	sensor_selected = 0
	
	if (version eq 5) then begin
		prefb = Widget_Base(column=1, title='Set Input Parameters', tlb_frame_attr=8, scroll=0, event_pro='lisapp_getreadparams_event',/modal,group_leader=topid, /base_align_center)
	endif else begin
		prefb = Widget_Base(column=1, title='Set Input Parameters', tlb_frame_attr=8, scroll=0, event_pro='lisapp_getreadparams_event',group_leader=topid, /base_align_center)
	endelse
	

	options = CW_Bgroup(prefb,['Areas','Flashes','Groups','Events','Viewtimes','One-Seconds'],label_left='LIS Format',frame=1,set_value=readparams,/NONEXCLUSIVE,column=2,/return_name,event_func='toggle_prefs')
	optionsotd = CW_Bgroup(prefb,['Areas','Flashes','Groups','Events','Viewtimes','One-Seconds'],label_left='OTD Format',frame=1,set_value=readparamsotd,/NONEXCLUSIVE,column=2,/return_name,event_func='toggle_prefs_otd')
	nativeb = widget_base(prefb,column=1,frame=1)
	native = CW_Bgroup(nativeb,['Use native libraries'],label_top='For faster reads in MacOS, IRIX...',set_value=[app_prefs.shlb.use_shlb],/nonexclusive,column=1)
	
	enact = Widget_base(prefb, column=3, group_leader = topid,/align_center)
	
;	Widget_Control, enact, /realize
	
	setbutton = Widget_Button(enact, value='Apply')
	savebutton = Widget_Button(enact, value='Apply & Save')
	donebutton = Widget_Button(enact, value='Done')
	use_shlb = app_prefs.shlb.use_shlb
	
	if (version eq 5) then Widget_Control, prefb, cancel_button = donebutton
	Widget_Control, prefb, /realize
	xmanager, 'lisapp_getlisreadparams', prefb, event='lisapp_getreadparams_event'
	
end

pro lisapp_getreadparams_event, event

	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisapp_prefs, app_prefs
	common paths, lastpath, currentpath, origpath, shlbfile
	common prefswidids, optionsotd,native,setbutton,savebutton,donebutton, shlb_path_field
	common shlbcom, use_shlb
	
	widget_control, event.id, get_value=buttonvalue
	; print, 'Event: ',event
	; print, buttonvalue
	case 1 of 
		(event.id eq donebutton) :	begin
					widget_control, event.top, /destroy
				end
		(event.id eq savebutton):begin
					app_prefs.input.lis.area 		= setparams(0)
					app_prefs.input.lis.flash		= setparams(1)
					app_prefs.input.lis.group		= setparams(2)
					app_prefs.input.lis.event		= setparams(3)
					app_prefs.input.lis.viewtime	= setparams(4)
					app_prefs.input.lis.onesecond	= setparams(5)
					app_prefs.input.otd.area		= setparamsotd(0)
					app_prefs.input.otd.flash		= setparamsotd(1)
					app_prefs.input.otd.group		= setparamsotd(2)
					app_prefs.input.otd.event		= setparamsotd(3)
					app_prefs.input.otd.viewtime	= setparamsotd(4)
					app_prefs.input.otd.onesecond	= setparamsotd(5)
					app_prefs.shlb.use_shlb		= use_shlb
						
					cd,origpath
					openw,lun,'lisapp.prefs',/get_lun
					writeu,lun,app_prefs
					close,lun
					free_lun,lun
					cd,currentpath
					readparams = setparams
					readparamsotd = setparamsotd
					widget_control, event.top, /destroy
				end
		(event.id eq setbutton) :	begin
					; print, 'Done'
					readparams = setparams
					readparamsotd = setparamsotd
					app_prefs.shlb.use_shlb = use_shlb
					widget_control, event.top, /destroy
				end
		(event.id eq native): begin
					x = bytarr(132)
					x(*) = 32
					empty = string(x)
					widget_control,event.id,get_value=buttonvalue
					if (buttonvalue eq 1) then begin
						if (app_prefs.paths.lisapp ne string(replicate(byte(32),132))) then begin
							selectpath = app_prefs.paths.lisapp
						endif else begin
							selectpath = currentpath
						endelse
						dumfile = dialog_pickfile(title='Select a shared library appropriate for your architecture', $
									filter="*.so", /must_exist, path=selectpath, get_path = shlb_path)
						cd,currentpath
						if (dumfile ne '') then begin
							use_shlb = 1
							app_prefs.shlb.use_shlb = 1
							app_prefs.shlb.shlb = pad_132(dumfile)
							shlbfile = dumfile
						endif  else begin
							use_shlb = 0
							app_prefs.shlb.use_shlb = 0
							app_prefs.shlb.shlb = empty
						endelse
					endif else begin
						use_shlb = 0
						app_prefs.shlb.use_shlb = 0
						app_prefs.shlb.shlb = empty
					endelse
				end
	endcase
end
