pro lisapp_LoadCal

	calarr=fltarr(128,128,3)
	filename='calibration_dc.hdf'
		num_requested = 1
		uid=-1
		if HDF_ishdf(filename) ne 1 then begin
			message,"File "+filename+" is not an HDF file."
		endif
		
		fileid=HDF_OPEN(filename,/read)
		printf,uid," FILENAME       : ",filename
	
		sd_id=HDF_SD_START(filename,/read)
		HDF_SD_FILEINFO,sd_id,nmfsds,nglobatts
		
		; print,sd_id,nmfsds,nglobatts
		
		;wset,bgwaitdraw_id & 	device,pseu=8
		
		;tvlct,red,green,blue
		
		for i=0,nmfsds-1 do begin
		     ; print,i
			sds_id=HDF_SD_SELECT(sd_id,i)
		     	HDF_SD_GETINFO,sds_id,name=n,ndims=r,type=t,natts=nats,$
		                         hdf_type=h,unit=u
		      ; print,'   GETINFO    ',sds_id,n,r,t,nats,h,u    	
		     	if r gt 0 then HDF_SD_GETINFO,sds_id,dims=dims else dims=0
			; print,'    GETINFO(2) ',sds_id,dims
			for j=0,nats-1 do begin
			 	HDF_SD_ATTRINFO,sds_id,j,name=n,type=t,count=c,data=d,$
		                            hdf_type=h
		           ; print,'       ATTRINFO ',j,n,t,c,d,h
		     	endfor
		       		  
	          	inbg = intarr(128,128)
	          	for iii=0,num_requested-1,1 do begin
	          		; print,iii
	          		hdf_sd_getdata,sds_id,inbg ;start=[0,0,0],count=[128,128,1]
	          		; print,'      GETDATA ',iii
	          		help,inbg
	          		; if (i lt 2) then print,inbg
				;calarr(*,*,iii) = inbg	
				;msgstr = string(format='("Loading image ",(I3)," of ",(I3))',iii+1,num_requested)
	          	endfor
	
			HDF_SD_ENDACCESS,sds_id
		endfor
		for i=0,nglobatts-1 do begin
			HDF_SD_ATTRINFO,sd_id,i,name=n,type=t,count=c,data=d
		endfor
				   
		HDF_SD_END,sd_id
		
		stop
end

pro create_cal_hdfs

	dc = fltarr(2,128,128,3)
	ac = fltarr(2,41,128,4)
	
	DC_fn = transpose([['OTD.DC.0','OTD.DC.1','OTD.DC.2'], $
				   ['LIS.DC.0','LIS.DC.1','LIS.DC.2']])
	AC_fn = transpose([['OTD.AC.1','OTD.AC.2','OTD.AC.3','OTD.AC.4'], $
				   ['LIS.AC.1','LIS.AC.2','LIS.AC.3','LIS.AC.4']])	
	
	for sensor = 0,1,1 do begin		
		 for order=0,2,1 do begin		 
			filename = DC_fn(sensor,order)
			fileid = HDF_OPEN(filename)
			sd_id = HDF_SD_START(filename,/read)
			sds_id = HDF_SD_SELECT(sd_id,2)
			hdf_sd_getdata,sds_id,inarr
			dc(sensor,*,*,order) = inarr
			hdf_sd_endaccess,sds_id
			hdf_sd_end,sd_id
			hdf_close,fileid
			close,/all
		 endfor
		 for quad=0,3,1 do begin
		 	filename = AC_fn(sensor,quad)
		 	fileid = HDF_OPEN(filename)
		 	sd_id = HDF_SD_START(filename,/read)
		 	sds_id = HDF_SD_SELECT(sd_id,2)
		 	hdf_sd_getdata,sds_id,inarr
		 	ac(sensor,*,*,quad) = rotate(inarr,7)
		 	hdf_sd_endaccess,sds_id
		 	hdf_sd_end,sd_id
		 	hdf_close,fileid
		 	close,/all
		 endfor
	endfor
	
	sd_id = HDF_SD_START("calibration_dc.hdf",/create)
	sds_id = HDF_SD_CREATE(sd_id,'DC Calibrations',[2,128,128,3],/float)
	HDF_SD_SETINFO,sds_id,label='OTD and LIS DC Cal'
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,0),NAME='Sensor',Label='OTD or LIS',/bw_incomp,scale=findgen(2)
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,1),NAME='X',Label='X Pixel',/bw_incomp,scale=findgen(128)
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,2),NAME='Y',Label='Y Pixel',/bw_incomp,scale=findgen(128)
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,3),NAME='Order',Label='Coeff Order',/bw_incomp,scale=findgen(3)
	HDF_SD_ADDDATA, sds_id, dc
	HDF_SD_ENDACCESS, sds_id
	HDF_SD_END, sd_id
	
	sd_id = HDF_SD_START("calibration_ac.hdf",/create)
	sds_id = HDF_SD_CREATE(sd_id,'AC Calibrations',[2,41,128,4],/float)
	HDF_SD_SETINFO,sds_id,label='OTD and LIS AC Cal'
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,0),name='Sensor',label='OTD or LIS',/bw_incomp,scale=findgen(2)
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,1),name='BG Radiance',label='BG Radiance',/bw_incomp,scale=findgen(41)*10.
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,2),name='Amplitude',label='Event Amplitude',/bw_incomp,scale=findgen(128)
	HDF_SD_DIMSET,HDF_SD_DIMGETID(sds_id,3),name='Quadrant',label='Quadrant',/bw_incomp,scale=findgen(4)+1
	HDF_SD_ADDDATA, sds_id, ac
	HDF_SD_ENDACCESS, sds_id
	HDF_SD_END, sd_id
end
		 
pro read_cal_hdfs, ac, dc

	dc = fltarr(2,128,128,3)
	ac = fltarr(2,41,128,4)

	filename 	= 'calibration_dc.hdf'
	fileid   	= HDF_OPEN(filename)
	sd_id 	= HDF_SD_START(filename,/read)
	sds_id	= HDF_SD_SELECT(sd_id,0)
	HDF_SD_GETDATA,sds_id,dc
	HDF_SD_ENDACCESS,sds_id	
	HDF_SD_END,sd_id
	HDF_CLOSE,fileid
	close,/all
	
	filename 	= 'calibration_ac.hdf'
	fileid   	= HDF_OPEN(filename)
	sd_id 	= HDF_SD_START(filename,/read)
	sds_id	= HDF_SD_SELECT(sd_id,0)
	HDF_SD_GETDATA,sds_id,ac
	HDF_SD_ENDACCESS,sds_id	
	HDF_SD_END,sd_id
	HDF_CLOSE,fileid
	close,/all
		  
end
	