@lisapp_GlobalRoutines.pro

pro verify_data_inbounds, topid
	common datafiles, orbit, fname
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common prefs2, prefb, sensor_select, options, enact, sensor_selected
	common sensor_read, this_sensor, file_format
	common sysinfo, version
	common sliders1, bounds_tai93_min, bounds_tai93_max, bounds_thr8_min, bounds_thr8_max, bounds_lat_min, bounds_lat_max, $
				 bounds_lon_min, bounds_lon_max, bounds_obs_min, bounds_obs_max, bounds_rad_min, bounds_rad_max, $
				 bounds_fp_min, bounds_fp_max, bounds_bg_min, bounds_bg_max, bounds_pos_min, $
				 bounds_pos_max, bounds_vel_min, bounds_vel_max
	common sliders0, tai93_min, tai93_max, thr8_min, thr8_max, lat_min, lat_max, lon_min, lon_max
	
	sensor_selected = 0
	if (this_sensor eq 'otd') then begin
		latmin = -80 & latmax = 80
		obsmin = 1 & obsmax = 310
	endif else begin
		latmin = -40 & latmax = 40
		obsmin = 1 & obsmax = 150
	endelse
	
	tai93_min = 7 & tai93_max = 31 
	thr8_min  = 14 & thr8_max = 64
	lat_min = -80 & lat_max = 80
	lon_min = -180 & lon_max = 180
	
	if (version eq 5) then begin
		verinbb = Widget_Base(row=2, title='Verify Data in Bounds', tlb_frame_attr=8, scroll=0, event_pro='inbounds_prefs_event',/modal,$
						group_leader=topid, /base_align_center)
	endif else begin
		verinbb = Widget_Base(row=2, title='Verify Data in Bounds', tlb_frame_attr=8, scroll=0, event_pro='inbounds_prefs_event',$
						group_leader=topid, /base_align_center)
	endelse
	
	; Make general
	
		verinbgenb = widget_base(verinbb,column=2, title='General',scroll=0)
		
		verinbgenb1 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_tai93_lab = widget_label(verinbgenb1,value='TAI93 times (x 10^7)',/align_center)
		bounds_tai93_min = widget_slider(verinbgenb1,/drag,minimum=7,maximum=31,title='Min',value=7,scroll=2,event_pro='sliderupdate',xsize=150)
		bounds_tai93_max = widget_slider(verinbgenb1,/drag,minimum=7,maximum=31,title='Max',value=28, scroll=2,event_pro='sliderupdate',xsize=150)
		
		
		verinbgenb2 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_thr8_lab = widget_label(verinbgenb2,value='8-bit threshold         ',/align_center)
		bounds_thr8_min = widget_slider(verinbgenb2,/drag,minimum=1,maximum=256,title='Min',value=14,scroll=5,event_pro='sliderupdate',xsize=150)
		bounds_thr8_max = widget_slider(verinbgenb2,/drag,minimum=1,maximum=256,title='Max',value=64,scroll=5,event_pro='sliderupdate',xsize=150)
		
		
		verinbgenb3 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_lat_lab = widget_label(verinbgenb3,value='Latitude (deg)        ',/align_center)
		bounds_lat_min = widget_slider(verinbgenb3,/drag,minimum=-80,maximum=80,title='Min',value=latmin,scroll=5,event_pro='sliderupdate',xsize=150)
		bounds_lat_max = widget_slider(verinbgenb3,/drag,minimum=-80,maximum=80,title='Max',value=latmax,scroll=5,event_pro='sliderupdate',xsize=150)
		
		
		verinbgenb4 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_lon_lab = widget_label(verinbgenb4,value='Longitude (deg)        ',/align_center)
		bounds_lon_min = widget_slider(verinbgenb4,/drag,minimum=-180,maximum=180,title='Min',value=-180,scroll=10,event_pro='sliderupdate',xsize=150)
		bounds_lon_max = widget_slider(verinbgenb4,/drag,minimum=-180,maximum=180,title='Max',value=180,scroll=10,event_pro='sliderupdate',xsize=150)
		
	
		verinbgenb5 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_obs_lab = widget_label(verinbgenb5,value='Observe time (sec)     ',/align_center)
		bounds_obs_min = widget_slider(verinbgenb5,/drag,minimum=0,maximum=320,title='Min',value=1,scroll=30,event_pro='sliderupdate',xsize=150)
		bounds_obs_max = widget_slider(verinbgenb5,/drag,minimum=0,maximum=320,title='Max',value=obsmax,scroll=30,event_pro='sliderupdate',xsize=150)
		
		verinbgenb6 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_rad_lab = widget_label(verinbgenb6,value='Log Cal Radiance  ',/align_center)
		bounds_rad_min = widget_slider(verinbgenb6,/drag,minimum=3,maximum=10,title='Min',value=3,scroll=1,event_pro='sliderupdate',xsize=150)
		bounds_rad_max = widget_slider(verinbgenb6,/drag,minimum=3,maximum=10,title='Max',value=8,scroll=1,event_pro='sliderupdate',xsize=150)
		
		verinbgenb7 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_fp_lab = widget_label(verinbgenb7,value='Log Footprint      ',/align_center)
		bounds_fp_min = widget_slider(verinbgenb7,/drag,minimum=0,maximum=5,title='Min',value=0,scroll=1,event_pro='sliderupdate',xsize=150)
		bounds_fp_max = widget_slider(verinbgenb7,/drag,minimum=0,maximum=5,title='Max',value=4,scroll=1,event_pro='sliderupdate',xsize=150)
		
		verinbgenb8 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_bg_lab = widget_label(verinbgenb8,value='12-bit Background  ',/align_center)
		bounds_bg_min = widget_slider(verinbgenb8,/drag,minimum=1,maximum=4096,title='Min',value=10,scroll=1,event_pro='sliderupdate',xsize=150)
		bounds_bg_max = widget_slider(verinbgenb8,/drag,minimum=1,maximum=4096,title='Max',value=3500,scroll=50,event_pro='sliderupdate',xsize=150)
		
		verinbgenb9 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_pos_lab = widget_label(verinbgenb9,value='Position (Mm)     ',/align_center)
		bounds_pos_min = widget_slider(verinbgenb9,/drag,minimum=-10,maximum=10,title='Min',value=-8,scroll=2,event_pro='sliderupdate',xsize=150)
		bounds_pos_max = widget_slider(verinbgenb9,/drag,minimum=-10,maximum=10,title='Max',value=8,scroll=2,event_pro='sliderupdate',xsize=150)
		
		verinbgenb10 = widget_base(verinbgenb,row=1,scroll=0,frame=3)
		
		bounds_vel_lab = widget_label(verinbgenb10,value='Velocity (km/sec)',/align_center)
		bounds_vel_min = widget_slider(verinbgenb10,/drag,minimum=-10,maximum=10,title='Min',value=-8,scroll=2,event_pro='sliderupdate',xsize=150)
		bounds_vel_max = widget_slider(verinbgenb10,/drag,minimum=-10,maximum=10,title='Max',value=8,scroll=2,event_pro='sliderupdate',xsize=150)
		
		widget_control,verinbgenb,/realize
		
	
		
		; TAI93 times
		; lat/lons
	
	; Make specific
	
	if (total(gotparams(0:3) ne 0)) then begin
		; point data prefs
	endif
	
	
	enact = Widget_base(verinbb, column=2, group_leader = topid,/align_center)
	
;	Widget_Control, enact, /realize
	
	setbutton = Widget_Button(enact, value='Verify',/align_center)
	donebutton = Widget_Button(enact, value='Cancel',/align_center)
	if (version eq 5) then Widget_Control, verinbb, cancel_button = donebutton
	Widget_Control, verinbb, /realize
	xmanager, 'verify_data_inbounds', verinbb, event='verify_data_inbounds_event'
	
end

pro sliderupdate, event
	common sliders1, bounds_tai93_min, bounds_tai93_max, bounds_thr8_min, bounds_thr8_max, bounds_lat_min, bounds_lat_max, $
				 bounds_lon_min, bounds_lon_max, bounds_obs_min, bounds_obs_max, bounds_rad_min, bounds_rad_max, $
				 bounds_fp_min, bounds_fp_max, bounds_bg_min, bounds_bg_max, bounds_pos_min, $
				 bounds_pos_max, bounds_vel_min, bounds_vel_max
	common sliders0, tai93_min, tai93_max, thr8_min, thr8_max, lat_min, lat_max, lon_min, lon_max

	widget_control, bounds_tai93_min, get_value=this_tai93_min
	widget_control, bounds_tai93_max, get_value=this_tai93_max
	widget_control, bounds_thr8_min, get_value = this_thr8_min
	widget_control, bounds_thr8_max, get_value = this_thr8_max
	widget_control, bounds_lat_min, get_value = this_lat_min
	widget_control, bounds_lat_max, get_value = this_lat_max
	widget_control, bounds_lon_min, get_value = this_lon_min
	widget_control, bounds_lon_max, get_value = this_lon_max
	widget_control, bounds_obs_min, get_value = this_obs_min
	widget_control, bounds_obs_max, get_value = this_obs_max
	widget_control, bounds_rad_min, get_value = this_rad_min
	widget_control, bounds_rad_max, get_value = this_rad_max
	widget_control, bounds_fp_min, get_value = this_fp_min
	widget_control, bounds_fp_max, get_value = this_fp_max
	widget_control, bounds_bg_min, get_value = this_bg_min
	widget_control, bounds_bg_max, get_value = this_bg_max
	widget_control, bounds_pos_min, get_value = this_pos_min
	widget_control, bounds_pos_max, get_value = this_pos_max
	widget_control, bounds_vel_min, get_value = this_vel_min
	widget_control, bounds_vel_max, get_value = this_vel_max
	
	widget_control, bounds_tai93_min, set_value = min([this_tai93_min,this_tai93_max])
	widget_control, bounds_tai93_max, set_value = max([this_tai93_min,this_tai93_max])
	widget_control, bounds_thr8_min, set_value = min([this_thr8_min,this_thr8_max])
	widget_control, bounds_thr8_max, set_value = max([this_thr8_min,this_thr8_max])
	widget_control, bounds_lat_min, set_value = min([this_lat_min,this_lat_max])
	widget_control, bounds_lat_max, set_value = max([this_lat_min,this_lat_max])
	widget_control, bounds_lon_min, set_value = min([this_lon_min,this_lon_max])
	widget_control, bounds_lon_max, set_value = max([this_lon_min,this_lon_max])
	widget_control, bounds_obs_min, set_value = min([this_obs_min,this_obs_max])
	widget_control, bounds_obs_max, set_value = max([this_obs_min,this_obs_max])
	widget_control, bounds_rad_min, set_value = min([this_rad_min,this_rad_max])
	widget_control, bounds_rad_max, set_value = max([this_rad_min,this_rad_max])
	widget_control, bounds_fp_min, set_value = min([this_fp_min,this_fp_max])
	widget_control, bounds_fp_max, set_value = max([this_fp_min,this_fp_max])
	widget_control, bounds_bg_min, set_value = min([this_bg_min,this_bg_max])
	widget_control, bounds_bg_max, set_value = max([this_bg_min,this_bg_max])
	widget_control, bounds_pos_min, set_value = min([this_pos_min,this_pos_max])
	widget_control, bounds_pos_max, set_value = max([this_pos_min,this_pos_max])
	widget_control, bounds_vel_min, set_value = min([this_vel_min,this_vel_max])
	widget_control, bounds_vel_max, set_value = max([this_vel_min,this_vel_max])
	
		
end	
		
pro verify_data_inbounds_event, event

	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common sliders2, selected_tai93_min, selected_tai93_max, selected_thr8_min, selected_thr8_max, selected_lat_min, selected_lat_max, $
				 selected_lon_min, selected_lon_max, selected_obs_min, selected_obs_max, selected_rad_min, selected_rad_max, $
				 selected_fp_min, selected_fp_max, selected_bg_min, selected_bg_max, selected_pos_min, selected_pos_max, $
				 selected_vel_min, selected_vel_max
	common sliders1, bounds_tai93_min, bounds_tai93_max, bounds_thr8_min, bounds_thr8_max, bounds_lat_min, bounds_lat_max, $
				 bounds_lon_min, bounds_lon_max, bounds_obs_min, bounds_obs_max, bounds_rad_min, bounds_rad_max, $
				 bounds_fp_min, bounds_fp_max, bounds_bg_min, bounds_bg_max, bounds_pos_min, $
				 bounds_pos_max, bounds_vel_min, bounds_vel_max

	
	widget_control, event.id, get_value=buttonvalue
	; print, 'Event: ',event
	; print, buttonvalue
	case buttonvalue of 
		'Cancel' :	begin
					widget_control, event.top, /destroy
				end
		'Verify' :	begin
					widget_control, bounds_tai93_min, get_value = selected_tai93_min
					widget_control, bounds_tai93_max, get_value = selected_tai93_max
					widget_control, bounds_lat_min, get_value = selected_lat_min
					widget_control, bounds_lat_max, get_value = selected_lat_max
					widget_control, bounds_lon_min, get_value = selected_lon_min
					widget_control, bounds_lon_max, get_value = selected_lon_max
					widget_control, bounds_thr8_min, get_value = selected_thr8_min
					widget_control, bounds_thr8_max, get_value = selected_thr8_max
					widget_control, bounds_obs_min, get_value = selected_obs_min
					widget_control, bounds_obs_max, get_value = selected_obs_max
					widget_control, bounds_rad_min, get_value = selected_rad_min
					widget_control, bounds_rad_max, get_value = selected_rad_max
					widget_control, bounds_fp_min, get_value = selected_fp_min
					widget_control, bounds_fp_max, get_value = selected_fp_max
					widget_control, bounds_bg_min, get_value = selected_bg_min
					widget_control, bounds_bg_max, get_value = selected_bg_max
					widget_control, bounds_pos_min, get_value = selected_pos_min
					widget_control, bounds_pos_max, get_value = selected_pos_max
					widget_control, bounds_vel_min, get_value = selected_vel_min
					widget_control, bounds_vel_max, get_value = selected_vel_max
					selected_rad_min = 10L^long(selected_rad_min)
					selected_rad_max = 10L^long(selected_rad_max)
					selected_fp_min = 10L^long(selected_fp_min)
					selected_fp_max = 10L^long(selected_fp_max)
					selected_pos_min = selected_pos_min * 10L^6
					selected_pos_max = selected_pos_max * 10L^6
					selected_vel_min = selected_vel_min * 10L^3
					selected_vel_max = selected_vel_max * 10L^3
					
					verify_data
					widget_control, event.top, /destroy
				end
	endcase
end

function sz2str, szarr

	if (szarr(0) eq 0) then begin
		if (szarr(1) eq 0) then begin
			retval = '-'
		endif else begin
			retval = '0'
		endelse
	endif else begin
		retval = string(szarr(1))
		bretval = byte(retval)
		nonspace = where(bretval ne 32)
		substringb = bretval(nonspace)
		substring = string(substringb)
		retval = substring
	endelse
	
	return,retval
end

pro verify_data
	common datafiles, orbit, fname
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common sliders2, selected_tai93_min, selected_tai93_max, selected_thr8_min, selected_thr8_max, selected_lat_min, selected_lat_max, $
				 selected_lon_min, selected_lon_max, selected_obs_min, selected_obs_max, selected_rad_min, selected_rad_max, $
				 selected_fp_min, selected_fp_max, selected_bg_min, selected_bg_max, selected_pos_min, selected_pos_max, $
				 selected_vel_min, selected_vel_max
	common lisbase, lisb

	selected_tai93_min = long(selected_tai93_min) * 10L^7
	selected_tai93_max = long(selected_tai93_max) * 10L^7
	
	; Orbit summary
	
	orbit_summary_tai93 = ((orbit.orbit_summary.TAI93_start lt selected_tai93_min) or (orbit.orbit_summary.TAI93_end gt selected_tai93_max))
	orbit_summary_lon   = ((orbit.orbit_summary.start_longitude lt selected_lon_min) or (orbit.orbit_summary.start_longitude gt selected_lon_max) $
	 				  or (orbit.orbit_summary.end_longitude lt selected_lon_min) or (orbit.orbit_summary.end_longitude gt selected_lon_max))
	
	; Point summary (n/a)
	
	; Area
	
	if (gotparams(0) eq 1) then begin
		area_tai93 = where((orbit.point.lightning.area(*).TAI93_time lt selected_tai93_min) or $
					   (orbit.point.lightning.area(*).TAI93_time gt selected_tai93_max))
		area_lat   = where((orbit.point.lightning.area(*).location(0) lt selected_lat_min) or $
					   (orbit.point.lightning.area(*).location(0) gt selected_lat_max))
		area_lon   = where((orbit.point.lightning.area(*).location(1) lt selected_lon_min) or $
					   (orbit.point.lightning.area(*).location(1) gt selected_lon_max))			   
		area_thr	= where((orbit.point.lightning.area(*).approx_threshold lt selected_thr8_min) or $
					   (orbit.point.lightning.area(*).approx_threshold gt selected_thr8_max))
		area_obs   = where((orbit.point.lightning.area(*).observe_time lt selected_obs_min) or $
					   (orbit.point.lightning.area(*).observe_time gt selected_obs_max))
		area_rad	= where((orbit.point.lightning.area(*).net_radiance lt selected_rad_min) or $
					   (orbit.point.lightning.area(*).net_radiance gt selected_rad_max))
		area_fp    = where((orbit.point.lightning.area(*).footprint lt selected_fp_min) or $
					   (orbit.point.lightning.area(*).footprint gt selected_fp_max))
	endif
	
	; Flash
	
	if (gotparams(1) eq 1) then begin
		flash_tai93 = where((orbit.point.lightning.flash(*).TAI93_time lt selected_tai93_min) or $
					   (orbit.point.lightning.flash(*).TAI93_time gt selected_tai93_max))
		flash_lat   = where((orbit.point.lightning.flash(*).location(0) lt selected_lat_min) or $
					   (orbit.point.lightning.flash(*).location(0) gt selected_lat_max))
		flash_lon   = where((orbit.point.lightning.flash(*).location(1) lt selected_lon_min) or $
					   (orbit.point.lightning.flash(*).location(1) gt selected_lon_max))			   
		flash_thr	= where((orbit.point.lightning.flash(*).approx_threshold lt selected_thr8_min) or $
					   (orbit.point.lightning.flash(*).approx_threshold gt selected_thr8_max))
		flash_obs   = where((orbit.point.lightning.flash(*).observe_time lt selected_obs_min) or $
					   (orbit.point.lightning.flash(*).observe_time gt selected_obs_max))
		flash_rad	= where((orbit.point.lightning.flash(*).radiance lt selected_rad_min) or $
					   (orbit.point.lightning.flash(*).radiance gt selected_rad_max))
		flash_fp    = where((orbit.point.lightning.flash(*).footprint lt selected_fp_min) or $
					   (orbit.point.lightning.flash(*).footprint gt selected_fp_max))
	endif
	
	; Group
	
	if (gotparams(2) eq 1) then begin
		group_tai93 = where((orbit.point.lightning.group(*).TAI93_time lt selected_tai93_min) or $
					   (orbit.point.lightning.group(*).TAI93_time gt selected_tai93_max))
		group_lat   = where((orbit.point.lightning.group(*).location(0) lt selected_lat_min) or $
					   (orbit.point.lightning.group(*).location(0) gt selected_lat_max))
		group_lon   = where((orbit.point.lightning.group(*).location(1) lt selected_lon_min) or $
					   (orbit.point.lightning.group(*).location(1) gt selected_lon_max))			   
		group_thr	= where((orbit.point.lightning.group(*).approx_threshold lt selected_thr8_min) or $
					   (orbit.point.lightning.group(*).approx_threshold gt selected_thr8_max))
		group_obs   = where((orbit.point.lightning.group(*).observe_time lt selected_obs_min) or $
					   (orbit.point.lightning.group(*).observe_time gt selected_obs_max))
		group_rad	= where((orbit.point.lightning.group(*).radiance lt selected_rad_min) or $
					   (orbit.point.lightning.group(*).radiance gt selected_rad_max))
		group_fp    = where((orbit.point.lightning.group(*).footprint lt selected_fp_min) or $
					   (orbit.point.lightning.group(*).footprint gt selected_fp_max))
	endif
	
	; Event
	
	if (gotparams(3) eq 1) then begin
		event_tai93 = where((orbit.point.lightning.event(*).TAI93_time lt selected_tai93_min) or $
					   (orbit.point.lightning.event(*).TAI93_time gt selected_tai93_max))
		event_lat   = where((orbit.point.lightning.event(*).location(0) lt selected_lat_min) or $
					   (orbit.point.lightning.event(*).location(0) gt selected_lat_max))
		event_lon   = where((orbit.point.lightning.event(*).location(1) lt selected_lon_min) or $
					   (orbit.point.lightning.event(*).location(1) gt selected_lon_max))			   
		event_thr	= where((orbit.point.lightning.event(*).approx_threshold lt selected_thr8_min) or $
					   (orbit.point.lightning.event(*).approx_threshold gt selected_thr8_max))
		event_obs   = where((orbit.point.lightning.event(*).observe_time lt selected_obs_min) or $
					   (orbit.point.lightning.event(*).observe_time gt selected_obs_max))
		event_rad	= where((orbit.point.lightning.event(*).radiance lt selected_rad_min) or $
					   (orbit.point.lightning.event(*).radiance gt selected_rad_max))
		event_fp    = where((orbit.point.lightning.event(*).footprint lt selected_fp_min) or $
					   (orbit.point.lightning.event(*).footprint gt selected_fp_max))
		event_bg	 = where((orbit.point.lightning.event(*).bg_value lt selected_bg_min) or $
					    (orbit.point.lightning.event(*).bg_value gt selected_bg_max))
	endif
	
	; Viewtime
	
	if (gotparams(4) eq 1) then begin
		viewtime_tai93 = where((orbit.point.viewtime(*).TAI93_start lt selected_tai93_min) or $
					       (orbit.point.viewtime(*).TAI93_start gt selected_tai93_max) or $
					       (orbit.point.viewtime(*).TAI93_end lt selected_tai93_min) or $
					       (orbit.point.viewtime(*).TAI93_end gt selected_tai93_max))
		viewtime_lat   = where((orbit.point.viewtime(*).location(0) lt selected_lat_min) or $
						  (orbit.point.viewtime(*).location(0) gt selected_lat_max))
		viewtime_lon	= where((orbit.point.viewtime(*).location(1) lt selected_lon_min) or $
						  (orbit.point.viewtime(*).location(1) gt selected_lon_max))
		viewtime_thr	= where((orbit.point.viewtime(*).approx_threshold lt selected_thr8_min) or $
						   (orbit.point.viewtime(*).approx_threshold gt selected_thr8_max))
		viewtime_obs    = where((orbit.point.viewtime(*).effective_obs lt selected_obs_min) or $
						   (orbit.point.viewtime(*).effective_obs gt selected_obs_max))
	endif
	
	; One second
	
	if (gotparams(5) eq 1) then begin
		onesecond_tai93 = where((orbit.one_second(*).TAI93_time lt selected_tai93_min) or $
						   (orbit.one_second(*).TAI93_time gt selected_tai93_max))
		onesecond_thr   = where((orbit.one_second(*).thresholds(0) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(0) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(1) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(1) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(2) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(2) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(3) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(3) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(4) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(4) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(5) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(5) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(6) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(6) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(7) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(7) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(8) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(8) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(9) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(9) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(10) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(10) gt selected_thr8_max) or $
						   (orbit.one_second(*).thresholds(11) lt selected_thr8_min) or $
						   (orbit.one_second(*).thresholds(11) gt selected_thr8_max))
		onesecond_pos 	= where((orbit.one_second(*).position_vector(0) lt selected_pos_min) or $
					        (orbit.one_second(*).position_vector(0) gt selected_pos_max) or $
					        (orbit.one_second(*).position_vector(1) lt selected_pos_min) or $
					        (orbit.one_second(*).position_vector(1) gt selected_pos_max) or $
					        (orbit.one_second(*).position_vector(2) lt selected_pos_min) or $
					        (orbit.one_second(*).position_vector(2) gt selected_pos_max))
		onesecond_vel 	= where((orbit.one_second(*).velocity_vector(0) lt selected_vel_min) or $
					        (orbit.one_second(*).velocity_vector(0) gt selected_vel_max) or $
					        (orbit.one_second(*).velocity_vector(1) lt selected_vel_min) or $
					        (orbit.one_second(*).velocity_vector(1) gt selected_vel_max) or $
					        (orbit.one_second(*).velocity_vector(2) lt selected_vel_min) or $
					        (orbit.one_second(*).velocity_vector(2) gt selected_vel_max))
	endif
	
	bres = strarr(10,6)
	
	bres(0,0) = sz2str(size(area_tai93))
	bres(0,1) = sz2str(size(flash_tai93))
	bres(0,2) = sz2str(size(group_tai93))
	bres(0,3) = sz2str(size(event_tai93))
	bres(0,4) = sz2str(size(viewtime_tai93))
	bres(0,5) = sz2str(size(onesecond_tai93))
	
	bres(1,0) = sz2str(size(area_thr))
	bres(1,1) = sz2str(size(flash_thr))
	bres(1,2) = sz2str(size(group_thr))
	bres(1,3) = sz2str(size(event_thr))
	bres(1,4) = sz2str(size(viewtime_thr))
	bres(1,5) = sz2str(size(onesecond_thr))
	
	bres(2,0) = sz2str(size(area_lat))
	bres(2,1) = sz2str(size(flash_lat))
	bres(2,2) = sz2str(size(group_lat))
	bres(2,3) = sz2str(size(event_lat))
	bres(2,4) = sz2str(size(viewtime_lat))
	bres(2,5) = 'N/A'
	
	bres(3,0) = sz2str(size(area_lon))
	bres(3,1) = sz2str(size(flash_lon))
	bres(3,2) = sz2str(size(group_lon))
	bres(3,3) = sz2str(size(event_lon))
	bres(3,4) = sz2str(size(viewtime_lon))
	bres(3,5) = 'N/A'
	
	bres(4,0) = sz2str(size(area_obs))
	bres(4,1) = sz2str(size(flash_obs))
	bres(4,2) = sz2str(size(group_obs))
	bres(4,3) = sz2str(size(event_obs))
	bres(4,4) = sz2str(size(viewtime_obs))
	bres(4,5) = 'N/A'
	
	bres(5,0) = sz2str(size(area_rad))
	bres(5,1) = sz2str(size(flash_rad))
	bres(5,2) = sz2str(size(group_rad))
	bres(5,3) = sz2str(size(event_rad))
	bres(5,4) = 'N/A'
	bres(5,5) = 'N/A'
	
	bres(6,0) = sz2str(size(area_fp))
	bres(6,1) = sz2str(size(flash_fp))
	bres(6,2) = sz2str(size(group_fp))
	bres(6,3) = sz2str(size(event_fp))
	bres(6,4) = 'N/A'
	bres(6,5) = 'N/A'
	
	bres(7,0) = 'N/A'
	bres(7,1) = 'N/A'
	bres(7,2) = 'N/A'
	bres(7,3) = sz2str(size(event_bg))
	bres(7,4) = 'N/A'
	bres(7,5) = 'N/A'
	
	bres(8,0) = 'N/A'
	bres(8,1) = 'N/A'
	bres(8,2) = 'N/A'
	bres(8,3) = 'N/A'
	bres(8,4) = 'N/A'
	bres(8,5) = sz2str(size(onesecond_pos))
	
	bres(9,0) = 'N/A'
	bres(9,1) = 'N/A'
	bres(9,2) = 'N/A'
	bres(9,3) = 'N/A'
	bres(9,4) = 'N/A'
	bres(9,5) = sz2str(size(onesecond_vel))
	bresout = transpose(bres)
	
	bresid = widget_base(row=2,title='Number of Vdatas Out of Bounds',group_leader=lisb)
	brestb = widget_table(bresid,value=bresout,column_labels=['Area','Flash','Group','Event','ViewTime','OneSec'], $
					row_labels=['TAI93 Time','8-bit Thr','Latitude','Longitude','Observe Time','Radiance','Footprint','12-bit BG','Position','Velocity'],alignment=1)
	
	msgstr = strarr(12)
	msgstr(0) = 'Values above indicate the number of each vdata elements out of the specified bounds.  "N/A" indicates the bounds are '+$
				'not relevant for the vdata.  "-" indicates the necessary data was not loaded from the HDF file.  The bounds you selected were:'
	msgstr(1) = ' '
	msgstr(2) = string(format='("   TAI93 Time  :",(I10),  " to ",(I10))',long(selected_tai93_min),long(selected_tai93_max))
	msgstr(3) = string(format='("   8-bit Thresh:",(I10),  " to ",(I10)  )',fix(selected_thr8_min),fix(selected_thr8_max))
	msgstr(4) = string(format='("   Latitude    :",(I10),  " to ",(I10))',fix(selected_lat_min),fix(selected_lat_max))
	msgstr(5) = string(format='("   Longitude   :",(I10),  " to ",(I10))',fix(selected_lon_min),fix(selected_lon_max))
	msgstr(6) = string(format='("   Observe time:",(I10),  " to ",(I10))  ',fix(selected_obs_min),fix(selected_obs_max))
	msgstr(7) = string(format='("   Cal Radiance:",(I10),  " to ",(I10))',long(selected_rad_min),long(selected_rad_max))
	msgstr(8) = string(format='("   Footprint   :",(I10),  " to ",(I10))  ',fix(selected_fp_min),fix(selected_fp_max))
	msgstr(9) = string(format='("   12-bit BG   :",(I10),  " to ",(I10))  ',fix(selected_bg_min),fix(selected_bg_max))
	msgstr(10)= string(format='("   Position    :",(I10),  " to ",(I10))',long(selected_pos_min),long(selected_pos_max))
	msgstr(11)= string(format='("   Velocity    :",(I10),  " to ",(I10))',long(selected_vel_min),long(selected_vel_max))
	
	bresm = widget_text(bresid,ysize=15,scr_xsize=540,value=msgstr,/wrap,/scroll)
	widget_control,bresm,set_text_top_line=0
	widget_control, bresid,/realize

						   
end

pro verify_regeolocation, event
	common sensor_read, this_sensor, file_format
	common datafiles, orbit, fname
	common lisbase, lisb

	nearsec = where((orbit.point.lightning.event(*).TAI93_time-long(orbit.point.lightning.event(*).TAI93_time)) lt 1.000)
	
	get_vector_pointing_vector,this_sensor,orbit.point.lightning.event(nearsec).x_pixel, $
							       orbit.point.lightning.event(nearsec).y_pixel, $
							       look_vector
	get_vector_earth_intersection,look_vector,orbit.point.lightning.event(nearsec).TAI93_time,	$
								  vector_location, 12000.0D , return_code
								  
	quick_ground_range = 6370.*acos(sin(!dtor*orbit.point.lightning.event(nearsec).location(0))* $
					           sin(!dtor*vector_location(*,0)) + $
					           cos(!dtor*orbit.point.lightning.event(nearsec).location(0))* $
					           cos(!dtor*vector_location(*,0))* $
					           cos(abs(!dtor*orbit.point.lightning.event(nearsec).location(1)- $
					           	   !dtor*vector_location(*,1))))
	
	min_rg_err = min(quick_ground_range)
	med_rg_err = median(quick_ground_range)
	mom_rg_err = moment(quick_ground_range)
	mea_rg_err = mom_rg_err(0)
	max_rg_err = max(quick_ground_range)
	good = where(quick_ground_range le 10.,num_good)
	bad = where(quick_ground_range gt 10.,num_bad)
	real_bad = where(quick_ground_range gt 25.,num_real_bad)
	awful = where(quick_ground_range gt 100.,num_awful)
	
;	print,'Minimum: ',min_rg_err
;	print,'Median : ',med_rg_err
;	print,'Mean   : ',mea_rg_err
;	print,'Max    : ',max_rg_err
;	print,'Num <10: ',num_good
;	print,'Num >10: ',num_bad
;	print,'Num >20: ',num_real_bad
;	print,'Num>100: ',num_awful
	
	numbg = orbit.point.point_summary.bg_count
	bglat = fltarr(5*numbg)
	bglon = fltarr(5*numbg)
	bgtim = dblarr(5*numbg)
	bgx   = fltarr(5*numbg)
	bgy   = fltarr(5*numbg)
	
	bglat(0:numbg-1)         = orbit.point.bg_summary(*).boresight(0)
	bglat(numbg:2*numbg-1)   = orbit.point.bg_summary(*).corners(0)
	bglat(2*numbg:3*numbg-1) = orbit.point.bg_summary(*).corners(2)
	bglat(3*numbg:4*numbg-1) = orbit.point.bg_summary(*).corners(4)
	bglat(4*numbg:5*numbg-1) = orbit.point.bg_summary(*).corners(6)
	
	bglon(0:numbg-1)         = orbit.point.bg_summary(*).boresight(1)
	bglon(numbg:2*numbg-1)   = orbit.point.bg_summary(*).corners(1)
	bglon(2*numbg:3*numbg-1) = orbit.point.bg_summary(*).corners(3)
	bglon(3*numbg:4*numbg-1) = orbit.point.bg_summary(*).corners(5)
	bglon(4*numbg:5*numbg-1) = orbit.point.bg_summary(*).corners(7)
	
	bgtim(0:numbg-1)         = orbit.point.bg_summary(*).TAI93_time
	bgtim(numbg:2*numbg-1)   = orbit.point.bg_summary(*).TAI93_time
	bgtim(2*numbg:3*numbg-1) = orbit.point.bg_summary(*).TAI93_time
	bgtim(3*numbg:4*numbg-1) = orbit.point.bg_summary(*).TAI93_time
	bgtim(4*numbg:5*numbg-1) = orbit.point.bg_summary(*).TAI93_time
	
	bgx(0:numbg-1)			= 63.5
	bgy(0:numbg-1)			= 63.5
	bgx(numbg:2*numbg-1)		= 0.
	bgy(numbg:2*numbg-1)		= 0.
	bgx(2*numbg:3*numbg-1)	= 0.
	bgy(2*numbg:3*numbg-1)	= 127.
	bgx(3*numbg:4*numbg-1)	= 127.
	bgy(3*numbg:4*numbg-1)	= 0.
	bgx(4*numbg:5*numbg-1)	= 127.
	bgy(4*numbg:5*numbg-1)	= 127.

	get_vector_pointing_vector,this_sensor,bgx,bgy,bg_look_vector
	
	get_vector_earth_intersection,bg_look_vector,bgtim,bg_location, 0.0D, return_code
	
	bg_quick_ground_range = 6370.*acos(sin(!dtor*bglat)*sin(!dtor*bg_location(*,0)) + $
							   cos(!dtor*bglat)*cos(!dtor*bg_location(*,0))* $
							   cos(abs(!dtor*bglon-!dtor*bg_location(*,1))))
							   
	bg_min_rg_err = min(bg_quick_ground_range)
	bg_med_rg_err = median(bg_quick_ground_range)
	bg_mom_rg_err = moment(bg_quick_ground_range)
	bg_mea_rg_err = bg_mom_rg_err(0)
	bg_max_rg_err = max(bg_quick_ground_range)
	bg_good = where(bg_quick_ground_range le 10.,bg_num_good)
	bg_bad = where(bg_quick_ground_range gt 10.,bg_num_bad)
	bg_real_bad = where(bg_quick_ground_range gt 25.,bg_num_real_bad)
	bg_awful = where(bg_quick_ground_range gt 100.,bg_num_awful)
	
;	print,' '
;	print,'Minimum: ',bg_min_rg_err
;	print,'Median : ',bg_med_rg_err
;	print,'Mean   : ',bg_mea_rg_err
;	print,'Max    : ',bg_max_rg_err
;	print,'Num <10: ',bg_num_good
;	print,'Num >10: ',bg_num_bad
;	print,'Num >20: ',bg_num_real_bad
;	print,'Num>100: ',bg_num_awful

	res = fltarr(8,2)
	res(0,0) = min_rg_err
	res(0,1) = bg_min_rg_err
	res(1,0) = med_rg_err
	res(1,1) = bg_med_rg_err
	res(2,0) = mea_rg_err
	res(2,1) = bg_mea_rg_err
	res(3,0) = max_rg_err
	res(3,1) = bg_max_rg_err
	res(4,0) = num_good
	res(4,1) = bg_num_good
	res(5,0) = num_bad
	res(5,1) = bg_num_bad
	res(6,0) = num_real_bad
	res(6,1) = bg_num_real_bad
	res(7,0) = num_awful
	res(7,1) = bg_num_awful
		
	fmtstr = [ ['(F7.1)','(F7.1)'], $
			['(F7.1)','(F7.1)'], $
			['(F7.1)','(F7.1)'], $
			['(F7.1)','(F7.1)'], $
			['(I5)','(I5)'], $
			['(I5)','(I5)'], $
			['(I5)','(I5)'], $
			['(I5)','(I5)']]
	
	rgeob = widget_base(title='Re-Geolocation Statistics',group_leader=lisb,row=2,/base_align_center)
	evtab = widget_table(rgeob,value=transpose(res),/resizeable_columns,xsize=2,ysize=8,column_labels= $
		['Event Pixels','BG Control Pts'], row_labels=['Range Diff, minimum (km)','Range Diff, median  (km)','Range Diff, mean   (km)',$
			'Range Diff, maximum (km)',$
		 '# < 10 km','# > 10 km','# > 25 km','# > 100 km'], column_widths=[180,180], $
		/alignment,format= $
		 fmtstr)
	rgeobm = widget_text(rgeob,ysize=6,scr_xsize=520,value='Values above show the differences betwen geolocations stored with the '+$
	   'event and background point data, and the same geolocations recomputed from the ephemeris/attitudes in the one-second array.'+$
	   '  Discrepancies indicate bad initial geolocation of the point data, indexing problems in the one-second array, or data problems in the one-second array.',/wrap,/scroll)
	 
	widget_control,rgeob,/realize
	
	;window,colors=220,12,xsize=600,ysize=400,retain=2
	;plot,histogram(quick_ground_range,min=0,max=700)

end

 pro verify_groupfrag
 	common datafiles, orbit, fname
 	common lisbase, lisb
 	
 	timarr = orbit.point.lightning.group(*).TAI93_time
 	stidx = sort(timarr)
 	num_gr = orbit.point.point_summary.group_count
 	num_multiple = lonarr(40)
 	for i=0L, num_gr-1L, 1L do begin
 		num = 0
 		this_time = orbit.point.lightning.group(stidx(i)).TAI93_time
 		; Find previous time
 		;earlier = where(orbit.point.lightning.group(stidx).TAI93_time lt (this_time-1.0D),earlier_ct)
 		;if (earlier_ct le 0) then begin
 		;	j0 = 0
 		;endif else begin
 		;	j0 = max(earlier)
 		;endelse
 		j0 = max([0L,i-50L])
 		; Find later time
 		;later = where(orbit.point.lightning.group(stidx).TAI93_time gt (this_time+1.0D),later_ct)
 		;if (later_ct ge num_gr) then begin
 		;	j1 = num_gr-1
 		;endif else begin
 		;	j1 = min(later)
 		;endelse
 		j1 = min([num_gr-1L,i+50L])
 		for j = j0, j1, 1L do begin
 			if (orbit.point.lightning.group(stidx(j)).TAI93_time eq this_time) then begin
 				num = num + 1
 			endif
 		endfor
 		if (num gt 39) then begin
 			num = 39
 		endif
 		num_multiple(num) = num_multiple(num) + 1L
 	endfor
 	; print,num_multiple
		 		
 end
  
pro verify_doublepixels
	common datafiles, orbit, fname
	common lisbase, lisb
	
	repstrs = strarr(6100)
	timarr = orbit.point.lightning.event(*).TAI93_time
	uniqtimes = timarr(uniq(timarr,sort(timarr)))
	uniqsz = size(uniqtimes)
	numuniq = uniqsz(1)
	xgrid = bytarr(128,128)
	ygrid = bytarr(128,128)
	for i=0,127,1 do begin
		xgrid(i,*) = i
		ygrid(*,i) = i
	endfor
	totsumgrid = intarr(128,128)
	totsumgrid(*,*)=0
	timarr(*) = 0.0
	timeswithbad = 0
	pctinc = numuniq/20
	pcttic = 0
	waitb = widget_base(title='Working',tlb_frame_attr=0,scroll=0,/modal,column=1,group_leader=lisb)
	waitm = widget_label(waitb,value='0% done...')
	widget_control,waitb,/realize
	
	for timidx = 0L, numuniq-1L, 1L do begin
				
		thistime = uniqtimes(timidx)
		evthistime = where(orbit.point.lightning.event(*).TAI93_time eq thistime,evct)
		if (evct gt 1) then begin
			sumgrid = intarr(128,128)
			sumgrid(*,*)=0
			for evidx = 0L, evct-1L, 1L do begin
				x = orbit.point.lightning.event(evthistime(evidx)).x_pixel
				y = orbit.point.lightning.event(evthistime(evidx)).y_pixel
				sumgrid(x,y) = temporary(sumgrid(x,y)) + 1
			endfor
			repeats = where(sumgrid gt 1, repeatct)
			; print,format='("Pixels with multiple hits at time ",(F14.3))',thistime

			if (repeatct gt 0) then begin
				outstr = string(format='((I3)," of ",(I4)," pixels had multiple hits at time ",(F13.3),":")',repeatct,evct,thistime)
				totsumgrid(repeats) = temporary(totsumgrid(repeats))+sumgrid(repeats)
				;print,repeats
				for k = 0,repeatct-1,1 do begin
					x = xgrid(repeats(k))
					y = ygrid(repeats(k))
					thisloc = string(format='("(",(I3),",",(I3),")")',x,y)
					outstr = outstr + thisloc
					repstrs(timeswithbad) = outstr
					timeswithbad = timeswithbad + 1
				endfor
				
			endif
		endif
		pcttic = pcttic + 1
		if (pcttic gt pctinc) then begin
			pcttic = 0
			pct = 100.*float(timidx)/float(numuniq)
			msgstr = string(format='((I2),"% done...")',fix(pct))
			widget_control,waitm,set_value=msgstr
		endif
	endfor
	widget_control,waitb,/destroy
	if (timeswithbad gt 0) then begin
		newrep = repstrs(0:timeswithbad-1)
		;print,newrep
		;loadct,39
		;window,13,xsize=512,ysize=512,retain=2
		;tvscl,rebin(totsumgrid,512,512,/sample)
		;print,total(totsumgrid)
		dbpxb = widget_base(group_leader=lisb,column=1,title='Repeat Event Analysis')
		ysz = min([timeswithbad,20])
		dbpxtxt = widget_text(dbpxb,value=newrep,/scroll,xsize=68,ysize=ysz)
		widget_control,dbpxb,/realize
	endif else begin
		result = dialog_message('No pixels had multiple simultaneous hits during this orbit.',/information)
	endelse
end

pro verify_afge_tree
	common datafiles, orbit, fname
	common lisbase, lisb
	common lisapp_colors,red,green,blue
	common sensor_read, this_sensor, file_format

	waitb = widget_base(title='Working',tlb_frame_attr=0,scroll=0,/modal,column=1,group_leader=lisb)
	waitm = widget_label(waitb,value='Verifying AFGE hierarchy and pointers... area      ',/align_center)
	widget_control,waitb,/realize

	num_bad_flash_parents = 0
	num_bad_group_parents = 0
	num_bad_event_parents = 0
	event_to_group_dist = fltarr(orbit.point.point_summary.event_count)
	event_to_flash_dist = fltarr(orbit.point.point_summary.event_count)
	event_to_area_dist  = fltarr(orbit.point.point_summary.event_count)
	group_to_flash_dist = fltarr(orbit.point.point_summary.group_count)
	group_to_area_dist  = fltarr(orbit.point.point_summary.group_count)
	flash_to_area_dist  = fltarr(orbit.point.point_summary.flash_count)
	
	flash_refs = intarr(orbit.point.point_summary.flash_count)
	group_refs = intarr(orbit.point.point_summary.group_count)
	event_refs = intarr(orbit.point.point_summary.event_count)
	
	eidx = 0L & gidx = 0L & fidx = 0L & adix = 0L
	fct  = 0L & gct = 0L & ect = 0L
	
	for aidx = 0L, orbit.point.point_summary.area_count-1L, 1L do begin
	
		msgstr = string(format='("Verifying AFGE hierarchy and pointers... area ",(I5))',aidx)
		widget_control,waitm,set_value=msgstr
		
		for fidx = orbit.point.lightning.area(aidx).child_address, $
				orbit.point.lightning.area(aidx).child_address+orbit.point.lightning.area(aidx).child_count-1L, $
				1L do begin
				
			flash_refs(fidx) = flash_refs(fidx) + 1
			
			if (orbit.point.lightning.flash(fidx).parent_address ne aidx) then begin
				num_bad_flash_parents = num_bad_flash_parents + 1L
			endif
			
			flash_to_area_dist(fct) = 6370.*acos(sin(!dtor*orbit.point.lightning.flash(fidx).location(0))* $
			           sin(!dtor*orbit.point.lightning.area(aidx).location(0)) + $
			           cos(!dtor*orbit.point.lightning.flash(fidx).location(0))* $
			           cos(!dtor*orbit.point.lightning.area(aidx).location(0))* $
			           cos(abs(!dtor*orbit.point.lightning.flash(fidx).location(1)- $
			           	   !dtor*orbit.point.lightning.area(aidx).location(1))))

			for gidx = orbit.point.lightning.flash(fidx).child_address, $
				orbit.point.lightning.flash(fidx).child_address+orbit.point.lightning.flash(fidx).child_count-1L, $
				1L do begin
				
				group_refs(gidx) = group_refs(gidx) + 1
				
				if (orbit.point.lightning.group(gidx).parent_address ne fidx) then begin
					num_bad_group_parents = num_bad_group_parents + 1L
				endif
				
				group_to_flash_dist(gct) = 6370.*acos(sin(!dtor*orbit.point.lightning.group(gidx).location(0))* $
				           sin(!dtor*orbit.point.lightning.flash(fidx).location(0)) + $
				           cos(!dtor*orbit.point.lightning.group(gidx).location(0))* $
				           cos(!dtor*orbit.point.lightning.flash(fidx).location(0))* $
				           cos(abs(!dtor*orbit.point.lightning.group(gidx).location(1)- $
				           	   !dtor*orbit.point.lightning.flash(fidx).location(1))))
				group_to_area_dist(gct) = 6370.*acos(sin(!dtor*orbit.point.lightning.group(gidx).location(0))* $
				           sin(!dtor*orbit.point.lightning.area(aidx).location(0)) + $
				           cos(!dtor*orbit.point.lightning.group(gidx).location(0))* $
				           cos(!dtor*orbit.point.lightning.area(aidx).location(0))* $
				           cos(abs(!dtor*orbit.point.lightning.group(gidx).location(1)- $
				           	   !dtor*orbit.point.lightning.area(aidx).location(1))))

				for eidx = orbit.point.lightning.group(gidx).child_address, $
					orbit.point.lightning.group(gidx).child_address+orbit.point.lightning.group(gidx).child_count-1L, $
					1L do begin
					
					event_refs(eidx) = event_refs(eidx) + 1
					
					if (orbit.point.lightning.event(eidx).parent_address ne gidx) then begin
						num_bad_group_parents = num_bad_group_parents + 1L
					endif
					event_to_group_dist(ect) = 6370.*acos(sin(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           sin(!dtor*orbit.point.lightning.group(gidx).location(0)) + $
					           cos(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           cos(!dtor*orbit.point.lightning.group(gidx).location(0))* $
					           cos(abs(!dtor*orbit.point.lightning.event(eidx).location(1)- $
					           	   !dtor*orbit.point.lightning.group(gidx).location(1))))
					event_to_flash_dist(ect) = 6370.*acos(sin(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           sin(!dtor*orbit.point.lightning.flash(fidx).location(0)) + $
					           cos(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           cos(!dtor*orbit.point.lightning.flash(fidx).location(0))* $
					           cos(abs(!dtor*orbit.point.lightning.event(eidx).location(1)- $
					           	   !dtor*orbit.point.lightning.flash(fidx).location(1))))
					event_to_area_dist(ect) = 6370.*acos(sin(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           sin(!dtor*orbit.point.lightning.area(aidx).location(0)) + $
					           cos(!dtor*orbit.point.lightning.event(eidx).location(0))* $
					           cos(!dtor*orbit.point.lightning.area(aidx).location(0))* $
					           cos(abs(!dtor*orbit.point.lightning.event(eidx).location(1)- $
					           	   !dtor*orbit.point.lightning.area(aidx).location(1))))
					
					ect = ect + 1L
					
				endfor
				
				gct = gct + 1L
				
			endfor
			
			fct = fct+1L
			
		endfor
	
	endfor
	
	reftab = lonarr(3,3)
	
	flashnever = where(flash_refs eq 0,fct)
	if (fct eq -1) then begin
		fct = 0
	endif
	reftab(0,0) = fct
	flashonce = where(flash_refs eq 1, fct)
	if (fct eq -1) then begin
		fct = 0
	endif
	reftab(1,0) = fct
	flashtwoplus = where(flash_refs gt 1,fct)	
	if (fct eq -1) then begin
		fct = 0
	endif
	reftab(2,0) = fct

	groupnever = where(group_refs eq 0,gct)
	if (gct eq -1) then begin
		gct = 0
	endif
	reftab(0,1) = gct
	grouponce = where(group_refs eq 1, gct)
	if (gct eq -1) then begin
		gct = 0
	endif
	reftab(1,1) = gct
	grouptwoplus = where(group_refs gt 1,gct)	
	if (gct eq -1) then begin
		gct = 0
	endif
	reftab(2,1) = gct
	
	eventnever = where(event_refs eq 0,ect)
	if (ect eq -1) then begin
		ect = 0
	endif
	reftab(0,2) = ect
	eventonce = where(event_refs eq 1, ect)
	if (ect eq -1) then begin
		ect = 0
	endif
	reftab(1,2) = ect
	eventtwoplus = where(event_refs gt 1,ect)	
	if (ect eq -1) then begin
		ect = 0
	endif
	reftab(2,2) = ect
	
	widget_control,waitb,/destroy
	
	badevstr = string(format='("Events  with bad parents: ",(I5))',num_bad_event_parents)
	badgrstr = string(format='("Groups  with bad parents: ",(I5))',num_bad_group_parents)
	badflstr = string(format='("Flashes with bad parents: ",(I5))',num_bad_flash_parents)
	
	afgeb = widget_base(group_leader=lisb,title='Data Hierarchy Integrity Check',row=3)
	afgetop = widget_base(afgeb,row=3)
	afgetop1 = widget_label(afgetop,value=badevstr)
	afgetop2 = widget_label(afgetop,value=badgrstr)
	afgetop3 = widget_label(afgetop,value=badflstr)
	disttab = fltarr(4,6)

	disttab(0,0) = min(event_to_group_dist)
	disttab(1,0) = median(event_to_group_dist)
	temp = moment(event_to_group_dist)
	disttab(2,0) = temp(0)
	disttab(3,0) = max(event_to_group_dist)

	disttab(0,1) = min(event_to_flash_dist)
	disttab(1,1) = median(event_to_flash_dist)
	temp = moment(event_to_flash_dist)
	disttab(2,1) = temp(0)
	disttab(3,1) = max(event_to_flash_dist)
	
	disttab(0,2) = min(event_to_area_dist)
	disttab(1,2) = median(event_to_area_dist)
	temp = moment(event_to_area_dist)
	disttab(2,2) = temp(0)
	disttab(3,2) = max(event_to_area_dist)	

	disttab(0,3) = min(group_to_flash_dist)
	disttab(1,3) = median(group_to_flash_dist)
	temp = moment(group_to_flash_dist)
	disttab(2,3) = temp(0)
	disttab(3,3) = max(group_to_flash_dist)	

	disttab(0,4) = min(group_to_area_dist)
	disttab(1,4) = median(group_to_area_dist)
	temp = moment(group_to_area_dist)
	disttab(2,4) = temp(0)
	disttab(3,4) = max(group_to_area_dist)	

	disttab(0,5) = min(flash_to_area_dist)
	disttab(1,5) = median(flash_to_area_dist)
	temp = moment(flash_to_area_dist)
	disttab(2,5) = temp(0)
	disttab(3,5) = max(flash_to_area_dist)	
	
	formatstr = strarr(4,6)
	formatstr(*,*) = '(F7.1)'
	
	afgebot = widget_table(afgeb,value=disttab,column_labels=['Min','Median','Mean','Max'], $
					row_labels=['Event to Group Dist','Event to Flash Dist','Event to Area Dist', $
							 'Group to Flash Dist','Group to Area Dist','Flash to Area Dist'],alignment=1,$
							 format=formatstr,frame=5)

	formatstr2 = strarr(3,3)
	formatstr2(*,*) = '(I7)'
	afgerefs = widget_table(afgeb,value=reftab,column_labels=['Zero refs','One ref','Mult refs'], $
				     row_labels=['Flashes','Groups','Events'],alignment=1,format=formatstr2,frame=5)
				     
	widget_control,afgeb,/realize
	
	;print,'Bad Parents (F,G,E): ',num_bad_flash_parents, num_bad_group_parents, num_bad_event_parents
	;print,'Events to Groups ',min(event_to_group_dist),max(event_to_group_dist),moment(event_to_group_dist)
	;print,'Events to Flashes ',min(event_to_flash_dist),max(event_to_flash_dist),moment(event_to_flash_dist)
	;print,'Events to Areas ',min(event_to_area_dist),max(event_to_area_dist),moment(event_to_area_dist)
	;print,'Groups to Flashes ',min(group_to_flash_dist),max(group_to_flash_dist),moment(group_to_flash_dist)
	;print,'Groups to Areas ',min(group_to_area_dist),max(group_to_area_dist),moment(group_to_area_dist)
	;print,'Flashes to Areas ',min(flash_to_area_dist),max(flash_to_area_dist),moment(flash_to_area_dist)
	event_to_group_dist = 0 & event_to_flash_dist = 0 & event_to_area_dist = 0
	group_to_flash_dist = 0 & group_to_area_dist  = 0
	flash_to_area_dist  = 0
	
	
end