/* Sample C code to read an orbit and
   export the flashes' UTC date/time, 
   latitude, longitude and radiance to 
   an ASCII file */

#include <stdio.h>
#include <math.h>
#include "liblisotd_read_LISOTD.h"

main(int argc, char *argv[])
{
	struct lis_orbit TheData;
	struct anOTDBoundset Bounds;

    Initialize();
    ResetAllBounds(&Bounds);
  
  	TheData = GetData("TRMM_LIS_SC.03.4_1998.026.00933",
  					  &Bounds);
 	
 	/* UTC, lat and lon are exported by default.
 	   Add the radiance in manually. */
 	   
 	AddASCIIOutputField(F, RADIANCE, DEFAULT);
 	
 	WriteData(TheData,  ASCII_SINGLE, "orbit.out",
 								!O, !A, F, !G, !E);
	FreeData(&TheData);

}
