#include "liblisotd_read_LISOTD.h"
#include <stdio.h>
/* #include <ansi_fp.h> */
#include <stdio.h>
#include "netcdf.h"
#include "hdf.h"

struct theWriteParams	WriteParams;

void lis_Area2Buf(area,buf)
struct lis_area	*area;
unsigned char buf[128];
{
	float ftemp=0;
	long  ltemp=0;
	
	memcpy(&buf[0], &area->TAI93_time, 8);
	memcpy(&buf[8], &area->delta_time, 4);
	memcpy(&buf[12],&area->observe_time, 2);
	memcpy(&buf[14],&area->location[0], 8);
	memcpy(&buf[22],&area->net_radiance,4);
	memcpy(&buf[26],&area->footprint,4);
	memcpy(&buf[30],&area->address,4);
	memcpy(&buf[34],&area->parent_address,4);
	memcpy(&buf[38],&area->child_address,4);
	memcpy(&buf[42],&area->child_count,4);
	memcpy(&buf[46],&area->grandchild_count,4);
	memcpy(&buf[50],&area->greatgrandchild_count,4);
	memcpy(&buf[54],&area->approx_threshold,1);
	memcpy(&buf[55],&area->alert_flag,1);
	memcpy(&buf[56],&area->cluster_index,1);
	memcpy(&buf[57],&area->density_index,1);
	memcpy(&buf[58],&area->noise_index,1);
#if defined(MAC) || defined(macintosh)
	memcpy(&buf[59],&ftemp,4);
	memcpy(&buf[63],&ltemp,4);
#else
	memcpy(&buf[59],&area->oblong_index,4);
	memcpy(&buf[63],&area->grouping_sequence,4);
#endif
	memcpy(&buf[67],&area->grouping_status,1);
}

void lis_Flash2Buf(flash,buf)
struct lis_flash	*flash;
unsigned char buf[128];
{
	float ftemp=0;
	long  ltemp=0;

	memcpy(&buf[0],&flash->TAI93_time,8);
	memcpy(&buf[8],&flash->delta_time,4);
	memcpy(&buf[12],&flash->observe_time,2);
	memcpy(&buf[14],&flash->location[0],8);
	memcpy(&buf[22],&flash->radiance,4);
	memcpy(&buf[26],&flash->footprint,4);
	memcpy(&buf[30],&flash->address,4);
	memcpy(&buf[34],&flash->parent_address,4);
	memcpy(&buf[38],&flash->child_address,4);
	memcpy(&buf[42],&flash->child_count,4);
	memcpy(&buf[46],&flash->grandchild_count,4);
	memcpy(&buf[50],&flash->approx_threshold,1);
	memcpy(&buf[51],&flash->alert_flag,1);
	memcpy(&buf[52],&flash->cluster_index,1);
	memcpy(&buf[53],&flash->density_index,1);
	memcpy(&buf[54],&flash->noise_index,1);
	memcpy(&buf[55],&flash->glint_index,4);
#if defined(MAC) || defined(macintosh)
	memcpy(&buf[59],&ftemp,4);
	memcpy(&buf[63],&ltemp,4);
#else
	memcpy(&buf[59],&flash->oblong_index,4);
	memcpy(&buf[63],&flash->grouping_sequence,4);
#endif
	memcpy(&buf[67],&flash->grouping_status,1);
}
	
void lis_Group2Buf(group,buf)
struct lis_group	*group;
unsigned char buf[128];
{
	float ftemp=0;
	long  ltemp=0;

	memcpy(&buf[0],&group->TAI93_time,8);
	memcpy(&buf[8],&group->observe_time,2);
	memcpy(&buf[10],&group->location[0],8);
	memcpy(&buf[18],&group->radiance,4);
	memcpy(&buf[22],&group->footprint,4);
	memcpy(&buf[26],&group->address,4);
	memcpy(&buf[30],&group->parent_address,4);
	memcpy(&buf[34],&group->child_address,4);
	memcpy(&buf[38],&group->child_count,4);
	memcpy(&buf[42],&group->approx_threshold,1);
	memcpy(&buf[43],&group->alert_flag,1);
	memcpy(&buf[44],&group->cluster_index,1);
	memcpy(&buf[45],&group->density_index,1);
	memcpy(&buf[46],&group->noise_index,1);
	memcpy(&buf[47],&group->glint_index,4);
#if defined(MAC) || defined(macintosh)
	memcpy(&buf[51],&ftemp,4);
	memcpy(&buf[55],&ltemp,4);
#else
	memcpy(&buf[51],&group->oblong_index,4);
	memcpy(&buf[55],&group->grouping_sequence,4);
#endif
	memcpy(&buf[59],&group->grouping_status,1);
}

void lis_Event2Buf(event,buf)
struct lis_event	*event;
unsigned char buf[128];
{
	float ftemp=0;
	long  ltemp=0;

	memcpy(&buf[0],&event->TAI93_time,8);
	memcpy(&buf[8],&event->observe_time,2);
	memcpy(&buf[10],&event->location[0],8);
	memcpy(&buf[18],&event->radiance,4);
	memcpy(&buf[22],&event->footprint,4);
	memcpy(&buf[26],&event->address,4);
	memcpy(&buf[30],&event->parent_address,4);
	memcpy(&buf[34],&event->x_pixel,1);
	memcpy(&buf[35],&event->y_pixel,1);
	memcpy(&buf[36],&event->bg_value,2);
	memcpy(&buf[38],&event->bg_radiance,2);
	memcpy(&buf[40],&event->amplitude,1);
	memcpy(&buf[41],&event->sza_index,1);
	memcpy(&buf[42],&event->glint_index,1);
	memcpy(&buf[43],&event->approx_threshold,1);
	memcpy(&buf[44],&event->alert_flag,1);
	memcpy(&buf[45],&event->cluster_index,1);
	memcpy(&buf[46],&event->density_index,1);
	memcpy(&buf[47],&event->noise_index,1);
	memcpy(&buf[48],&event->bg_value_flag,1);
	memcpy(&buf[49],&event->grouping_sequence,4);
}

void lis_PointSummary2Buf(ps,buf)
struct lis_point_summary *ps;
unsigned char buf[128];
{
	memcpy(&buf[0],&ps->parent_address,4);
	memcpy(&buf[4],&ps->event_count,4);
	memcpy(&buf[8],&ps->event_address,4);
	memcpy(&buf[12],&ps->group_count,4);
	memcpy(&buf[16],&ps->group_address,4);
	memcpy(&buf[20],&ps->flash_count,4);
	memcpy(&buf[24],&ps->flash_address,4);
	memcpy(&buf[28],&ps->area_count,4);
	memcpy(&buf[32],&ps->area_address,4);
	memcpy(&buf[36],&ps->bg_count,4);
	memcpy(&buf[40],&ps->bg_address,4);
	memcpy(&buf[44],&ps->vt_count,4);
	memcpy(&buf[48],&ps->vt_address,4);
}

void lis_Viewtime2Buf(vt,buf)
struct lis_viewtime *vt;
unsigned char buf[128];
{
	memcpy(&buf[0],&vt->location[0],8);
	memcpy(&buf[8],&vt->TAI93_start,4);
	memcpy(&buf[12],&vt->TAI93_end,4);
	memcpy(&buf[16],&vt->effective_obs,4);
	memcpy(&buf[20],&vt->alert_flag,1);
	memcpy(&buf[21],&vt->approx_threshold,1);
}

void lis_BGSummary2Buf(bgs,buf)
struct lis_bg_summary *bgs;
unsigned char buf[128];
{
	memcpy(&buf[0],&bgs->TAI93_time,8);
	memcpy(&buf[8],&bgs->address,4);
	memcpy(&buf[12],&bgs->boresight[0],8);
	memcpy(&buf[20],&bgs->corners[0],32);
}

void lis_OrbitSummary2Buf(orbsum,buf)
struct lis_orbit_summary *orbsum;
unsigned char buf[128];
{
	memcpy(&buf[0],&orbsum->id_number,4);
	memcpy(&buf[4],&orbsum->TAI93_start,8);
	memcpy(&buf[12],&orbsum->UTC_start,28);
	memcpy(&buf[40],&orbsum->GPS_start,8);
	memcpy(&buf[48],&orbsum->TAI93_end,8);
	memcpy(&buf[56],&orbsum->start_longitude,4);
	memcpy(&buf[60],&orbsum->end_longitude,4);
	memcpy(&buf[64],&orbsum->point_data_count,2);
	memcpy(&buf[66],&orbsum->point_data_address,2);
	memcpy(&buf[68],&orbsum->one_second_count,4);
	memcpy(&buf[72],&orbsum->one_second_address,4);
	memcpy(&buf[76],&orbsum->summary_image_count,2);
	memcpy(&buf[78],&orbsum->summary_image_address,2);
	memcpy(&buf[80],&orbsum->inspection_code,2);
	memcpy(&buf[82],&orbsum->configuration_code,2);
}

void lis_OneSecond2Buf(os,buf)
struct lis_one_second *os;
unsigned char buf[128];
{
	memcpy(&buf[0],&os->TAI93_time,8);
	memcpy(&buf[8],&os->alert_summary,1);
	memcpy(&buf[9],&os->instrument_alert,1);
	memcpy(&buf[10],&os->platform_alert,1);
	memcpy(&buf[11],&os->external_alert,1);
	memcpy(&buf[12],&os->processing_alert,1);
	memcpy(&buf[13],&os->position_vector[0],12);
	memcpy(&buf[25],&os->velocity_vector[0],12);
	memcpy(&buf[37],&os->transform_matrix[0],36);
	memcpy(&buf[73],&os->solar_vector[0],12);
	memcpy(&buf[85],&os->ephemeris_quality_flag,4);
	memcpy(&buf[89],&os->attitude_quality_flag,4);
	memcpy(&buf[93],&os->boresight_threshold,1);
	memcpy(&buf[94],&os->thresholds[0],16);
	memcpy(&buf[110],&os->noise_index,1);
	memcpy(&buf[111],&os->event_count[0],12);
}

void   WriteData(TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev)
struct  lis_orbit	TheData;
int	output_type;
char	filename[132];
int     dump_or, dump_ar, dump_fl, dump_gr, dump_ev;
{
    union   aFileID FileID;
    long    orbit, area, flash, group, event;
    char indentstr[5][132];
    int dump_flags[5];
    
    
    dump_flags[O] = (dump_or==O);
    dump_flags[A] = (dump_ar==A);
    dump_flags[F] = (dump_fl==F);
    dump_flags[G] = (dump_gr==G);
    dump_flags[E] = (dump_ev==E);
    
    FileID = OpenFileID(output_type, filename, dump_flags,"LIS");

    switch(output_type) {
	case ASCII_TREE:
		
	    {
		strcpy(indentstr[O], "\0");
		strcpy(indentstr[A], "\0");
		strcpy(indentstr[F], "\0");
		strcpy(indentstr[G], "\0");
		strcpy(indentstr[E], "\0");
		
		if (dump_flags[O]) {
		    strcat(indentstr[O], "");
		    strcat(indentstr[A], INDSTR);
		    strcat(indentstr[F], INDSTR);
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		}
		if (dump_flags[A]) {
		    strcat(indentstr[A], "");
		    strcat(indentstr[F], INDSTR);
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[F]) {
		    strcat(indentstr[F], "");
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[G]) {
		    strcat(indentstr[G], "");
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[E]) {
		    strcat(indentstr[E], "");
		};
		for (orbit = 0; orbit < 1; orbit++) {
		    if (dump_flags[O]) {
			Write_LIS_Orbit_ASCII(FileID.out_stream[T], indentstr[O], orbit, TheData);
		    }
		    for (area = TheData.point.point_summary.area_address; area <  TheData.point.point_summary.area_address +
									 TheData.point.point_summary.area_count; area++) {
			if (dump_flags[A]) {
				Write_LIS_Area_ASCII(FileID.out_stream[T], indentstr[A], area, TheData);
			}
			for (flash=TheData.point.lightning.area[area].child_address; flash<=TheData.point.lightning.area[area].child_address +
						TheData.point.lightning.area[area].child_count; flash++) {
			    if (dump_flags[F]) {
				    Write_LIS_Flash_ASCII(FileID.out_stream[T], indentstr[F], flash, TheData);
			    }
			    for (group=TheData.point.lightning.flash[flash].child_address; group<=TheData.point.lightning.flash[flash].child_address +
			    		TheData.point.lightning.flash[flash].child_count; group++) {
				    if (dump_flags[G]) {	
					Write_LIS_Group_ASCII(FileID.out_stream[T], indentstr[G], group, TheData);
				    }
				    for (event=TheData.point.lightning.group[group].child_address; event<=TheData.point.lightning.group[group].child_address +
				    		TheData.point.lightning.group[group].child_count; event++) {
					if (dump_flags[E]) {
					    Write_LIS_Event_ASCII(FileID.out_stream[T], indentstr[E], event, TheData);
					}
				    }
			    }
			}
		    }
		}
		break;
	    }
	case ASCII_SINGLE:
	    {
		if (dump_flags[O]) {
		    strcpy(indentstr[O], "");
		    for (orbit = 0; orbit < 1; orbit++)
			Write_LIS_Orbit_ASCII(FileID.out_stream[O], indentstr[O], orbit, TheData);
		    fflush(FileID.out_stream[O]);
		}
		if (dump_flags[A]) {
		    strcpy(indentstr[A], "");
		    for (area = 0; area < TheData.point.point_summary.area_count; area++) 
			Write_LIS_Area_ASCII(FileID.out_stream[A], indentstr[A], area, TheData);
		    fflush(FileID.out_stream[A]);
		}
		if (dump_flags[F]) {
		    strcpy(indentstr[F], "");
		    for (flash = 0; flash < TheData.point.point_summary.flash_count; flash++)
			Write_LIS_Flash_ASCII(FileID.out_stream[F], indentstr[F], flash, TheData);
		    fflush(FileID.out_stream[F]);
		}
		if (dump_flags[G]) {
		    strcpy(indentstr[G], "");
		    for (group = 0; group < TheData.point.point_summary.group_count; group++)
		        Write_LIS_Group_ASCII(FileID.out_stream[G], indentstr[G], group, TheData);
		    fflush(FileID.out_stream[G]);
		}
		if (dump_flags[E]) {
		    strcpy(indentstr[E], "");
		    for (event = 0; event < TheData.point.point_summary.event_count; event++)
			Write_LIS_Event_ASCII(FileID.out_stream[E], indentstr[E], event, TheData);
		    fflush(FileID.out_stream[E]);
		}
		break;
	    }
	    
	case BINARY:
	    {
		/* Obsolete */
	    }
	case MINI_HDF:
	    {
		Write_LIS_Mini_HDF(FileID, TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev);
		break;
	    }
	case SDS:
	    {
		/* NYI
		WriteSDS(TheData, filename);
		*/
		break;
	    }
    case METADATA:
	    {
	    /* NYI
		WriteMetadata(&TheData, FileID.out_stream[M]);
		*/
	    break;
		}
	    
    }
    CloseFileID(FileID, output_type, dump_flags);
    return;
}

void   Write_LIS_Mini_HDF(FileID, TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev)
   union   aFileID FileID;
struct  lis_orbit	TheData;
int	output_type;
char	filename[132];
int     dump_or, dump_ar, dump_fl, dump_gr, dump_ev;
{
    long num_or=0, num_ar=0, num_fl=0, num_gr=0, num_ev=0, num_md =0, 
    		num_bg=0, num_vt=0, num_os=0;
    extern struct theMetadataHandling	HandleMetadata;
    unsigned char outbuf[128], empty[128];
    short int *emptyimage;
    int   multievent = FALSE;
    long area, flash, group, event, md;
    long image, viewtime, ephem;
    long areas_written=0, flashes_written=0, groups_written=0, events_written=0, 
	 browses_written=0, images_written=0, image_attributes_written=0, 
	 grids_written=0, viewtimes_written=0, ephemeris_written=0, thresholds_written=0;
    long orbits_written=0, rates_written=0;

    struct lis_area dummy_area;
    struct lis_flash dummy_flash;
    struct lis_group dummy_group;
    struct lis_event dummy_event,  dummy_event2;

	/*
    emptyimage = (short int *)calloc(16384, sizeof(short int));
    */
    num_or = 1;
    num_ar = TheData.point.point_summary.area_count;
    num_fl = TheData.point.point_summary.flash_count;
    num_gr = TheData.point.point_summary.group_count;
    num_ev = TheData.point.point_summary.event_count;    
	num_bg = TheData.point.point_summary.bg_count;
	num_vt = TheData.point.point_summary.vt_count;
	num_os = TheData.orbit_summary.one_second_count;
	
    if ((!dump_ar && !dump_fl && !dump_gr && !dump_ev) || 
        ((num_ar <= 1) && (num_fl <= 1) && (num_gr <= 1) && (num_ev <= 1)))
    {
	/* Either no point data requested for output or a single-event
	 *  file is requested.  No-can-do.  Replace with a dummy tree
	 *  with a single multi-event flash to prevent software crashes
	 *  the next time this file is read.
	 */
	if (!dump_ar && !dump_fl && !dump_gr && !dump_ev) {
	    puts("Metadata-only HDF file requested.");
	} else {
	    puts("No point data passed the selected filter criteria.");
	}
	dummy_area.TAI93_time = -999.;
	dummy_area.delta_time  = 0.0;
	dummy_area.observe_time = 0;
	dummy_area.location[0] = dummy_area.location[1] = -999.;
	dummy_area.net_radiance = 0.0;
	dummy_area.footprint = 0.0;
	dummy_area.address = 0;
	dummy_area.parent_address = 0;
	dummy_area.child_address = 0;
	dummy_area.child_count =0;
	dummy_area.grandchild_count = 0;
	dummy_area.greatgrandchild_count = 0;
	dummy_area.approx_threshold = 0;
	dummy_area.alert_flag = 0;
	dummy_area.cluster_index = 0;
	dummy_area.noise_index = 0;
	dummy_area.grouping_status = 0;
	
	dummy_flash.TAI93_time = -999.;
	dummy_flash.delta_time  = 0.0;
	dummy_flash.observe_time = 0;
	dummy_flash.location[0] = dummy_flash.location[1] = -999.;
	dummy_flash.radiance = 0.0;
	dummy_flash.footprint = 0.0;
	dummy_flash.address = 0;
	dummy_flash.parent_address = 0;
	dummy_flash.child_address = 0;
	dummy_flash.child_count =0;
	dummy_flash.grandchild_count = 0;
	dummy_flash.approx_threshold = 0;
	dummy_flash.alert_flag = 0;
	dummy_flash.cluster_index = 0;
	dummy_flash.density_index = 0;
	dummy_flash.noise_index = 0;
	dummy_flash.glint_index = 0.0;
	dummy_flash.grouping_status = 0;
	
	dummy_group.TAI93_time = -999.;
	dummy_group.observe_time = 0;
	dummy_group.location[0] = dummy_group.location[1] = -999.;
	dummy_group.radiance = 0.0;
	dummy_group.footprint = 0.0;
	dummy_group.address = 0;
	dummy_group.parent_address = 0;
	dummy_group.child_address = 0;
	dummy_group.child_count =0;
	dummy_group.approx_threshold = 0;
	dummy_group.alert_flag = 0;
	dummy_group.cluster_index = 0;
	dummy_group.density_index = 0;
	dummy_group.noise_index = 0;
	dummy_group.glint_index = 0.0;
	dummy_group.grouping_status = 0;
	
	dummy_event.TAI93_time = -999.;
	dummy_event.observe_time = 0;
	dummy_event.location[0] = dummy_event.location[1] = -999.;
	dummy_event.radiance = 0.0;
	dummy_event.footprint = 0.0;
	dummy_event.address = 0;
	dummy_event.parent_address = 0;
	dummy_event.x_pixel = dummy_event.y_pixel = 0;
	dummy_event.bg_value = 0;
	dummy_event.bg_radiance = 0;
	dummy_event.amplitude = 0;
	dummy_event.sza_index = 0;
	dummy_event.approx_threshold = 0;
	dummy_event.alert_flag = 0;
	dummy_event.cluster_index = 0;
	dummy_event.density_index = 0;
	dummy_event.noise_index = 0;
	dummy_event.glint_index = 0.0;
	dummy_event.grouping_sequence = 0;
	dummy_event.bg_value_flag = 0;

	dummy_event2 = dummy_event;
	dummy_event2.grouping_sequence = 1;
	dummy_event2.address = 1;
	
	lis_Area2Buf(&dummy_area, outbuf);
	write_lis_AREA(FileID.hdf_id,outbuf);
	areas_written++;
	printf("Wrote %5ld dummy area to HDF\n", areas_written);
	
	lis_Flash2Buf(&dummy_flash, outbuf);
	write_lis_FLASH(FileID.hdf_id,outbuf);
	flashes_written++;
	printf("Wrote %5ld dummy flash to HDF\n", flashes_written);
	
	lis_Group2Buf(&dummy_group, outbuf);
	write_lis_GROUP(FileID.hdf_id,outbuf);
	groups_written++;
        printf("Wrote %5ld dummy group to HDF\n", groups_written);
        
	lis_Event2Buf(&dummy_event, outbuf);
	write_lis_EVENT(FileID.hdf_id,outbuf);
	events_written++;
	lis_Event2Buf(&dummy_event2, outbuf);
	write_lis_EVENT(FileID.hdf_id,outbuf);
	events_written++;
        printf("Wrote %5ld dummy events to HDF\n", events_written);
    } else {
    
	
	lis_OrbitSummary2Buf(&TheData.orbit_summary,outbuf);
	write_lis_ORBIT_SUMMARY(FileID.hdf_id,outbuf);
	
	lis_PointSummary2Buf(&TheData.point.point_summary,outbuf);
	write_lis_POINT_SUMMARY(FileID.hdf_id,outbuf);
	
	for (area = 0; area < num_ar; area++) {
	    lis_Area2Buf(&TheData.point.lightning.area[area], outbuf);
	    write_lis_AREA(FileID.hdf_id,outbuf);
	    areas_written++;
	}
	printf("Wrote %5ld areas to HDF\n", areas_written);
    
	for (flash = 0; flash < num_fl; flash++) {
	    lis_Flash2Buf(&TheData.point.lightning.flash[flash], outbuf);
	    write_lis_FLASH(FileID.hdf_id,outbuf);
	    flashes_written++;
	}
	printf("Wrote %5ld flashes to HDF\n", flashes_written);
	
	for (group = 0; group < num_gr; group++) {
	    lis_Group2Buf(&TheData.point.lightning.group[group], outbuf);
	    write_lis_GROUP(FileID.hdf_id,outbuf);
	    groups_written++;
	}
	printf("Wrote %5ld groups to HDF\n", groups_written);
    
	for (event = 0; event < num_ev; event++) {
	    lis_Event2Buf(&TheData.point.lightning.event[event], outbuf);
	    write_lis_EVENT(FileID.hdf_id,outbuf);
	    events_written++;
	}
	printf("Wrote %5ld events to HDF\n", events_written);
	
    }
    /*
    for (md = 0; md < num_md; md++) {
	write_otd_METADATA(TheData.Metadata[md].metadata);
    }
	*/
 	for (ephem = 0; ephem < TheData.orbit_summary.one_second_count; ephem++) {
	    lis_OneSecond2Buf(&TheData.one_second[ephem], outbuf);
	    write_lis_ONE_SECOND(FileID.hdf_id,outbuf);
	    ephemeris_written++;
	}
	printf("   Wrote %5ld one second records to HDF\n", ephemeris_written);
	
	for (image =0; image<TheData.point.point_summary.bg_count; image++) {
		lis_BGSummary2Buf(&TheData.point.bg_summary[image],outbuf);
		write_lis_BG_SUMMARY(FileID.hdf_id,outbuf);
		images_written++;
	}
	printf("   Wrote %5ld background summaries to HDF\n",images_written);
	

    if (HandleMetadata.Viewtimes) {
	    for (viewtime = 0; viewtime < TheData.point.point_summary.vt_count; viewtime++) {
		lis_Viewtime2Buf(&TheData.point.viewtime[viewtime], outbuf);
		write_lis_VIEWTIME(FileID.hdf_id,outbuf);
		viewtimes_written++;
	    }
	}
	printf("   Wrote %5ld view times to HDF\n", viewtimes_written);


   
    if (!areas_written) {
	write_lis_AREA(FileID.hdf_id,empty); 
	areas_written=1;
    }
    if (!flashes_written) {
       write_lis_FLASH(FileID.hdf_id,empty);
       flashes_written=1;
    }
    if (!groups_written) {
       write_lis_GROUP(FileID.hdf_id,empty);
       groups_written=1;
    }
    if (!events_written) {
       write_lis_EVENT(FileID.hdf_id,empty);
       events_written=1;
    }
    if (!viewtimes_written) {
	write_lis_VIEWTIME(FileID.hdf_id,empty);
	viewtimes_written=1;
    }
    if (!ephemeris_written) {
	write_lis_ONE_SECOND(FileID.hdf_id,empty);
	ephemeris_written=1;
    }
    if (!images_written) {
	write_lis_BG_SUMMARY(FileID.hdf_id,empty);
	browses_written=1;
    }
    /*
    write_otd_METADATA(empty);   
    */
    close_LIS_ORBIT_HDF(FileID.hdf_id);
    return;
}

void Write_LIS_Orbit_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct lis_orbit	TheData;
{

    
    fprintf(outfile, "%s", indstr);
    fprintf(outfile, "%07ld  %14.3lf  %14.3lf   %5.0lf   %5ld %5ld  Thr:%5ld Bg:%5ld Vt:%5ld Eph:%5ld\n", idx, TheData.orbit_summary.TAI93_start, 
	    TheData.orbit_summary.TAI93_end, (TheData.orbit_summary.TAI93_end-TheData.orbit_summary.TAI93_start), 
	    TheData.point.point_summary.area_count, 0, 1, TheData.point.point_summary.bg_count, TheData.point.point_summary.vt_count, 
	    TheData.orbit_summary.one_second_count);
}

void Write_LIS_Area_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct lis_orbit  TheData;
{
    int idx2, thr;
    struct lis_area	data;
    long    idx3, orb;
    struct aUTCDateTime UTC;
	int yroffset;

	data = TheData.point.lightning.area[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Area.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Area.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			fprintf(outfile,"%3d",data.approx_threshold);
			break;
		}
	    case VIEW_TIME:
		{
		    idx3 = LatLon2Grid(data.location[0], data.location[1], 0.5);
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
			(int)data.observe_time);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
			(int)data.observe_time);
		    }
		    break;
		}
	    case TIME_UTC: 
		{
			UTC = TAI93_to_UTC(data.TAI93_time);
			yroffset = 1900;
			if (UTC.year >= 2000) {
				yroffset = 2000;
			}

		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, data.TAI93_time);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, data.TAI93_time);
		    }
		    break;
		}
        case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.location[0], (float)data.location[1]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.location[0], data.location[1]);
		    }
		    break;		    
		}
	    case DURATION:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile,"%6.3lf ",
				    data.delta_time);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.delta_time);
		    }
		    break;
		}
	    case D_N_T:  
		{	
			/* NYI
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFArea.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.d_n_t);
		    }
		    */
		    break;		   
		}
	    case ORBIT_NUM:
		{
			/* NYI 
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    data.HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.orbit_id);
		    }
		    */
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.child_count);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.child_count);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
			/* NYI
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Flashes_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.Flashes_Rejected);
		    }
		    */
		    break;		   
		}
		/* NYI
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFArea.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFArea.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFArea.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFArea.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[3]);
		    }
		    break;		   
		}	
		*/
	}
	
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_LIS_Flash_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct lis_orbit TheData;
{
    int idx2, thr;
    struct lis_flash	data;
    char outstr[132];
    double dum;
    struct aUTCDateTime UTC;
	int yroffset;
    
    data = TheData.point.lightning.flash[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Flash.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Flash.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = data.approx_threshold;
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{	UTC = TAI93_to_UTC(data.TAI93_time);
                        yroffset = 1900;
                        if (UTC.year >= 2000) {
                                yroffset = 2000;
                        }


		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
		    sprintf(outstr,  "%02d  %03d  %02d %02d  %02d %02d %6.3f ", 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, (float)UTC.second);
			fprintf(outfile, "%s", outstr);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, (float)UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3f ", data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, (float)data.TAI93_time);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3f ", (float)TAI93_to_GPS+data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, TAI93_to_GPS+data.TAI93_time);
		    }
		    break;
		}
        case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2f  %7.2f ", 
				    (float)data.location[0], (float)data.location[1]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.location[0], data.location[1]);
		    }
		    break;		    
		}
	    case DURATION:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile,"%6.3f ",
				    (float)data.delta_time);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.delta_time);
		    }
		    break;
		}
	    case D_N_T:
		{
			/* NYI
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFFlash.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.d_n_t);
		    }
		    */
		    break;		   
		}
	    case ORBIT_NUM:
		{
			/* NYI
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    */
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.child_count);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.child_count);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
			/* NYI
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Groups_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.Groups_Rejected);
		    }
		    */
		    break;		   
		}
	    case ENERGY:
		{
			/* NYI
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2e", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, data.energy);
		    }
		    */
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
		case FOOTPRINT:
	    case SIZE:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4.0f ", (float)data.footprint);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, (float)data.footprint);
		    }
		    break;
		}
		/* NYI
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFFlash.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFFlash.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFFlash.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFFlash.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[3]);
		    }
		    break;		   
		}	
		*/
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_LIS_Group_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct lis_orbit TheData;
{
    int idx2, thr;
    struct lis_group	data;
    struct aUTCDateTime	UTC;
	int yroffset;
    
    data = TheData.point.lightning.group[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Group.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Group.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = data.approx_threshold;
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{
			UTC = TAI93_to_UTC(data.TAI93_time);
                        yroffset = 1900;
                        if (UTC.year >= 2000) {
                                yroffset = 2000;
                        }


		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.TAI93_time);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, TAI93_to_GPS+data.TAI93_time);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.location[0], (float)data.location[1]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.location[0], data.location[1]);
		    }
		    break;		    
		}
	    case D_N_T:
		{
			/* NYI
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFGroup.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.d_n_t);
		    }
		    */
		    break;		   
		}
	    case ORBIT_NUM:
		{
			/* NYI
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    */
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.child_count);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.child_count);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
			/* NYI
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Events_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.Events_Rejected);
		    }
		    */
		    break;		   
		}
		/* NYI
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFGroup.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFGroup.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFGroup.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFGroup.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[3]);
		    }
		    break;		   
		}
		*/
	    case ENERGY:
		{
			/* NYI
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.energy);
		    }
		    */
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_LIS_Event_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct lis_orbit TheData;
{
    int idx2, thr;
    struct lis_event	data;
    struct aUTCDateTime	UTC;
	int yroffset;
    
    data = TheData.point.lightning.event[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Event.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Event.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = data.approx_threshold;
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{
			UTC = TAI93_to_UTC(data.TAI93_time);
                        yroffset = 1900;
                        if (UTC.year >= 2000) {
                                yroffset = 2000;
                        }


		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
			    UTC.year-yroffset, UTC.doy, UTC.month, UTC.day, 
			    UTC.hour, UTC.minute, UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.TAI93_time);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.TAI93_time);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, TAI93_to_GPS+data.TAI93_time);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.location[0], (float)data.location[1]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.location[0], data.location[1]);
		    }
		    break;		    
		}
	    case D_N_T:
		{
			/* NYI
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFEvent.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.d_n_t);
		    }
		    */
		    break;		   
		}
	    case ORBIT_NUM:
		{
			/* NYI
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    */
		    break;		   
		}
		/* NYI
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFEvent.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFEvent.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFEvent.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFEvent.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[3]);
		    }
		    break;		   
		}	
		*/
	    case ENERGY:
		{
			/* NYI
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.energy);
		    }
		    */
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
	}
    }
    fprintf(outfile, "\n"); 
    return;
}


