#include "liblisotd_read_LISOTD.h"
#define otd_SUCCESS	0
#include "liblisotd_err_defs.h"
#define otd_NoMetadata (FAIL|otd_inventory_metadata_FAIL|otd_archived_metadata_FAIL)

struct theMetadataHandling  HandleMetadata;

void AddMetadataLine(TheData,Line)
struct anOTDDataset *TheData;
char   Line[256];
{
    long nm;
    nm = TheData->num_metadata;
    strcpy(TheData->Metadata[nm].metadata,Line);
    TheData->num_metadata += 1; nm++;
    return;
}

void AddMetadataCount(TheData,o,a,f,g,e,i,v)
struct anOTDDataset *TheData;
long o,a,f,g,e,i,v;
{
    char Line[256];


    sprintf(Line,"     Orbits    : %6ld",o);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Areas     : %6ld",a);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Flashes   : %6ld",f);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Groups    : %6ld",g);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Events    : %6ld",e);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Images    : %6ld",i);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    sprintf(Line,"     Viewtimes : %6ld",v);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
 
    return;
}

void AddMetadataBounds(TheData,Bounds)
struct anOTDDataset *TheData;
struct anOTDBoundset *Bounds;
{
    char Line[256];
    char active[2][20];
    struct anXYTDataset *XYT;
    
    sprintf(active[0],"NOT ACTIVE");
    sprintf(active[1],"ACTIVE");

    sprintf(Line,"     Time      : %s",active[Bounds->TimeWindow.Active]);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    if (Bounds->TimeWindow.Active) {
	sprintf(Line, "          Window Start: %02d/%02d/%02d %02d:%02d:%06.3f", 
			Bounds->TimeWindow.Start.UTC.month, 
			Bounds->TimeWindow.Start.UTC.day, 
			Bounds->TimeWindow.Start.UTC.year-1900, 
			Bounds->TimeWindow.Start.UTC.hour, 
			Bounds->TimeWindow.Start.UTC.minute, 
			Bounds->TimeWindow.Start.UTC.second);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Window   End: %02d/%02d/%02d %02d:%02d:%06.3f", 
			Bounds->TimeWindow.End.UTC.month, 
			Bounds->TimeWindow.End.UTC.day, 
			Bounds->TimeWindow.End.UTC.year-1900, 
			Bounds->TimeWindow.End.UTC.hour, 
			Bounds->TimeWindow.End.UTC.minute, 
			Bounds->TimeWindow.End.UTC.second);
	AddMetadataLine(TheData, Line);	
	AddMetadataLine(TheData," ");
    }   
    sprintf(Line,"     Area      : %s",active[Bounds->AreaBound.Active]);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    if (Bounds->AreaBound.Active) {
	switch (Bounds->AreaBound.BoundType) {
	    case BOX: {
		sprintf(Line, "          Box Bound,  LL       : (%7.2f, %7.2f)", 
		    Bounds->AreaBound.Bounds.Box.LL.Latitude, 
		    Bounds->AreaBound.Bounds.Box.LL.Longitude);
		AddMetadataLine(TheData, Line);
		sprintf(Line, "          Box Bound,  UR       : (%7.2f, %7.2f)", 
		    Bounds->AreaBound.Bounds.Box.UR.Latitude, 
		    Bounds->AreaBound.Bounds.Box.UR.Longitude);
		AddMetadataLine(TheData, Line);
		break;
	    }
	    case CIRCLE: {
		sprintf(Line, "          Circle Bound, Center : (%7.2f, %7.2f)", 
		    Bounds->AreaBound.Bounds.Circle.Center.Latitude,  
		    Bounds->AreaBound.Bounds.Circle.Center.Longitude);
		AddMetadataLine(TheData, Line);
		sprintf(Line, "          Circle Bound, Ranges : (%5.0f - %5.0f km)", 
		    Bounds->AreaBound.Bounds.Circle.Min_Range_km,  
		    Bounds->AreaBound.Bounds.Circle.Max_Range_km);
		AddMetadataLine(TheData, Line);
		break;
	    }
	}
	AddMetadataLine(TheData," ");
    }
    sprintf(Line,"     Quality   : %s",active[Bounds->QualityBound.Active]);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    if (Bounds->QualityBound.Active) {
        sprintf(Line, "                      PROB     GLINT       SNR       TAC");
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          A:");
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MIN:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[A].Param[PROB].lo, 
		   Bounds->QualityBound.Level[A].Param[GLINT].lo, 
		   Bounds->QualityBound.Level[A].Param[SNR].lo, 
		   Bounds->QualityBound.Level[A].Param[TAC].lo);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MAX:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[A].Param[PROB].hi, 
		   Bounds->QualityBound.Level[A].Param[GLINT].hi, 
		   Bounds->QualityBound.Level[A].Param[SNR].hi, 
		   Bounds->QualityBound.Level[A].Param[TAC].hi);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          F:");
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MIN:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[F].Param[PROB].lo, 
		   Bounds->QualityBound.Level[F].Param[GLINT].lo, 
		   Bounds->QualityBound.Level[F].Param[SNR].lo, 
		   Bounds->QualityBound.Level[F].Param[TAC].lo);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MAX:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[F].Param[PROB].hi, 
		   Bounds->QualityBound.Level[F].Param[GLINT].hi, 
		   Bounds->QualityBound.Level[F].Param[SNR].hi, 
		   Bounds->QualityBound.Level[F].Param[TAC].hi);
	AddMetadataLine(TheData, Line);	
	sprintf(Line, "          G:");
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MIN:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[G].Param[PROB].lo, 
		   Bounds->QualityBound.Level[G].Param[GLINT].lo, 
		   Bounds->QualityBound.Level[G].Param[SNR].lo, 
		   Bounds->QualityBound.Level[G].Param[TAC].lo);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MAX:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[G].Param[PROB].hi, 
		   Bounds->QualityBound.Level[G].Param[GLINT].hi, 
		   Bounds->QualityBound.Level[G].Param[SNR].hi, 
		   Bounds->QualityBound.Level[G].Param[TAC].hi);
	AddMetadataLine(TheData, Line);	
	sprintf(Line, "          E:");
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MIN:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[E].Param[PROB].lo, 
		   Bounds->QualityBound.Level[E].Param[GLINT].lo, 
		   Bounds->QualityBound.Level[E].Param[SNR].lo, 
		   Bounds->QualityBound.Level[E].Param[TAC].lo);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "            MAX:%10d%10d%10d%10d", 
	           Bounds->QualityBound.Level[E].Param[PROB].hi, 
		   Bounds->QualityBound.Level[E].Param[GLINT].hi, 
		   Bounds->QualityBound.Level[E].Param[SNR].hi, 
		   Bounds->QualityBound.Level[E].Param[TAC].hi);
	AddMetadataLine(TheData, Line);
	AddMetadataLine(TheData, " ");
    }
    sprintf(Line,"     Attribute : %s",active[Bounds->AttributeBounds.Active]);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    if (Bounds->AttributeBounds.Active) {
	sprintf(Line, "                               MIN       MAX");
	AddMetadataLine(TheData, Line);
	if (Bounds->AttributeBounds.AreaActive) {
	    sprintf(Line, "          A: NUM_CHILDREN%10d%10d", 
		    Bounds->AttributeBounds.Area.num_children.lo, 
		    Bounds->AttributeBounds.Area.num_children.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          A:     DURATION%10.2f%10.2f", 
		    Bounds->AttributeBounds.Area.duration.lo, 
		    Bounds->AttributeBounds.Area.duration.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          A:     COVERAGE%10.2f%10.2f", 
		    Bounds->AttributeBounds.Area.coverage.lo, 
		    Bounds->AttributeBounds.Area.coverage.hi);
	    AddMetadataLine(TheData, Line);
	}
	if (Bounds->AttributeBounds.FlashActive) {
	    sprintf(Line, "          F: NUM_CHILDREN%10d%10d", 
		    Bounds->AttributeBounds.Flash.num_children.lo, 
		    Bounds->AttributeBounds.Flash.num_children.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          F:     DURATION%10.2f%10.2f", 
		    Bounds->AttributeBounds.Flash.duration.lo, 
		    Bounds->AttributeBounds.Flash.duration.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          F:       ENERGY%10.2le%10.2le", 
		    Bounds->AttributeBounds.Flash.energy.lo, 
		    Bounds->AttributeBounds.Flash.energy.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          F:         SIZE%10.0f%10.0f", 
		    Bounds->AttributeBounds.Flash.area.lo, 
		    Bounds->AttributeBounds.Flash.area.hi);
	    AddMetadataLine(TheData, Line);
	}
	if (Bounds->AttributeBounds.GroupActive) {
	    sprintf(Line, "          G: NUM_CHILDREN%10d%10d", 
		    Bounds->AttributeBounds.Group.num_children.lo, 
		    Bounds->AttributeBounds.Group.num_children.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          G:       ENERGY%10.2le%10.2le", 
		    Bounds->AttributeBounds.Group.energy.lo, 
		    Bounds->AttributeBounds.Group.energy.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          G:         SIZE%10.0f%10.0f", 
		    Bounds->AttributeBounds.Group.area.lo, 
		    Bounds->AttributeBounds.Group.area.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          G:     RADIANCE%10.2le%10.2le", 
		    Bounds->AttributeBounds.Group.radiance.lo, 
		    Bounds->AttributeBounds.Group.radiance.hi);
	    AddMetadataLine(TheData, Line);
	}
	if (Bounds->AttributeBounds.EventActive) {
 	    sprintf(Line, "          E:       ENERGY%10.2le%10.2le", 
		    Bounds->AttributeBounds.Group.energy.lo, 
		    Bounds->AttributeBounds.Group.energy.hi);
	    AddMetadataLine(TheData, Line);
	    sprintf(Line, "          E:     RADIANCE%10.2le%10.2le", 
		    Bounds->AttributeBounds.Group.radiance.lo, 
		    Bounds->AttributeBounds.Group.radiance.hi);
	    AddMetadataLine(TheData, Line);
	}
	AddMetadataLine(TheData, " ");
    }
    sprintf(Line,"     Track     : %s",active[Bounds->XYTBound.Active]);
    AddMetadataLine(TheData,Line);
    AddMetadataLine(TheData," ");
    if (Bounds->XYTBound.Active) {
	XYT = Bounds->XYTBound.XYT;
	sprintf(Line, "          From     : %s", XYT->filename);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Vertices : %ld", XYT->num_raw);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Min range: %7.2f", Bounds->XYTBound.min_range_km);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Max range: %7.2f", Bounds->XYTBound.max_range_km);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Min  elev: %7.0f", Bounds->XYTBound.min_elev);
	AddMetadataLine(TheData, Line);
	sprintf(Line, "          Max  elev: %7.0f", Bounds->XYTBound.max_elev);
	AddMetadataLine(TheData, Line);
	sprintf(Line, " ");
	AddMetadataLine(TheData, Line);
    }

    return;
    
}

struct anOTDDataset   GetOTDData(hdfname, Bounds)
char   hdfname[132];
struct anOTDBoundset 		*Bounds;
{
    FILE		    *HDFListFile;
    char		    inputLine[128], aline[128], firsthalf[128], probs[128];
    double		    start, end, baddur;
    int			    *use_this_orbit;
    int			    num_files=0, file_num, old_platform_OK, isbad, foundbad;
    int			    SensorOffFlag, OOCFlag, EphemerisFlag, WarmupFlag, ConnectorFlag;
    int			    gotanorbit, gotanarea, gotaflash, gotagroup, gotanevent, single_event_file, 
			    got_any_orbits, got_any_areas, got_any_flashes, got_any_groups, got_any_events;
    long		    sec, totsecs, delsec, addsec;
    long		    which_orbit;
    long		    hdffile;
    long		    areas_this_orbit, flashes_this_orbit, groups_this_orbit, events_this_orbit, er, eridx;
    long		    browse, total_browse, image, total_images, viewtime, total_viewtime;
    long		    ephem, total_ephems;
    long		    orbit, area, flash, group, event, gridpoint, first_new_orbit;
    long		    total_areas = 0, total_flashes = 0, images_found=0, 
			    area_num, flash_num, group_num, event_num;
    long		    total_oas, oa, total_thresh;
    long		    num_found, viewtimes_found = 0, orbits_found = 0, areas_found = 0, flashes_found=0, groups_found=0, events_found=0;
    long		    flashid, groupid, eventid, md, mdtot;
    short   int		    erbuffer[6100];
    struct  anOTDDataset    TheData;
    struct  otd_AREA	    anarea;
    struct  otd_BROWSE	    *TempBrowse,  abrowse;
    struct  CImageAttribute *TempImageAttributes;
    struct  CSmallOrbit	    *TempOrbits;
    struct  CViewTime	    *TempViewTime;
    struct  otd_EPHEMERIS	    anephem, *TempEphems;
    struct  otd_EVENT	    anevent;
    struct  otd_FLASH	    aflash;
    struct  otd_GROUP	    agroup;
    struct  otd_IMAGE_ATTRIBUTE animageattribute;
    struct  otd_Orbit_attributes	anorbitattribute;
    struct  Orbit_summary	asummary;
    struct  otd_View_time	    aviewtime;
    struct  aUTCDateTime    badUTC, goodUTC;
    struct  anHDFFileEntry  FilesToRead[26];
    extern  char	    RawFilePath[132];
    char		    Line[128], Line2[128];

    /* Check if file indirect (list of HDF files rather than single file) */
    
    if (strstr(hdfname, "mlab")==NULL) {
		if ((HDFListFile=(fopen(hdfname, "r"))) != NULL) {
		    while (fgets(inputLine,128,HDFListFile) != NULL) {
				num_files++;
				inputLine[strlen(inputLine)-1] = '\0';
				sprintf(FilesToRead[num_files].hdfname, "%s%s", RawFilePath, inputLine);
		    }
		    fclose(HDFListFile);
		} else {
		    fprintf(stderr, "Error opening HDF List File %s for input.\n", hdfname);
		    exit(-1);
		}
    } else {
		num_files = 1;
		sprintf(FilesToRead[num_files].hdfname, "%s%s", RawFilePath, hdfname);
    }
    
    /* 
     * First make a quick estimate of how much space will need to be
     *  allocated.  Filter only on area quality tags; assume all flashes, 
     *  groups and events will be accepted.  Later, more stringent filtering
     *  will be performed 
     */
    TheData.Metadata = (struct CMetadata *)calloc(1000,sizeof(struct CMetadata));
    TheData.num_metadata = TheData.num_areas = TheData.num_flashes = TheData.num_events =
       TheData.num_orbits= 0;
    sprintf(Line,"Input HDF File: %s",hdfname);
    AddMetadataLine(&TheData,Line);

    num_found = 0;

    for (file_num = 1; file_num <= num_files; file_num++) {
    	hdffile=open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname);
        if((hdffile<0)&&((hdffile&0xffffff00)!=otd_NoMetadata)){
	    	printf("Error opening HDF file %s; skipping to next.\n",
						    FilesToRead[file_num].hdfname);
	    	goto SKIPHDF;    
            hdffile = hdffile&0xff;
        }
        if(((hdffile&0xffffff00)==otd_NoMetadata))hdffile = hdffile^otd_NoMetadata;
	
	
		orbits_found += get_total_otd_orbit_attribute();
		areas_found += get_total_otd_areas(); 
		flashes_found += get_total_otd_flashes();
		groups_found += get_total_otd_groups();
		events_found += get_total_otd_events();
		images_found += get_total_otd_image();
        viewtimes_found += get_total_otd_view_time();

SKIPHDF:	
		/* free(TheData.Metadata); */
        close_OTD_HDF_FILE();
	;

    }


 
    printf("Allocating space for %ld, %ld, %ld, %ld, %ld orbits/areas/flashes/groups/events.\n", orbits_found, 
	areas_found, flashes_found, groups_found, events_found);
    TheData.Orbits  = (struct COrbit *)calloc((int)(orbits_found), sizeof(struct COrbit));
    for (orbit=0; orbit<((int)(orbits_found)); orbit++) 
      TheData.Orbits[orbit].Backgrounds = (struct CBackground *)calloc(images_found, sizeof(struct CBackground));
    TheData.Areas   = (struct CArea  *)calloc((int)(areas_found+num_files*5),   sizeof(struct CArea));	
    TheData.Flashes = (struct CFlash *)calloc((int)(flashes_found+num_files*5), sizeof(struct CFlash));
    TheData.Groups  = (struct CGroup *)calloc((int)(groups_found+num_files*5),  sizeof(struct CGroup));
    TheData.Events  = (struct CEvent *)calloc((int)(events_found+num_files*5),  sizeof(struct CEvent));

    orbits_found  = 0;
    areas_found   = 0;
    flashes_found = 0;
    groups_found  = 0;
    events_found  = 0;
    
    got_any_orbits = FALSE;
    for (file_num = 1; file_num <= num_files; file_num++) {
	first_new_orbit = orbits_found;
	got_any_areas = FALSE;
	printf("Processing file %s...\n", FilesToRead[file_num].hdfname);
    FilesToRead[file_num].hdffile=open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname);
    if(!((hdffile<0)&&((hdffile&0xffffff00)!=otd_NoMetadata))){
    	if(((hdffile&0xffffff00)==otd_NoMetadata))hdffile = hdffile^otd_NoMetadata;

/*	if ((FilesToRead[file_num].hdffile = open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname))==otd_SUCCESS) {
*/
	    single_event_file = FALSE;
	    
	    /* Is this a single-event file? */
	    
	    if ((get_total_otd_areas()==1) && (get_total_otd_flashes()==1) && (get_total_otd_groups()==1) 
		&& (get_total_otd_events()==1)) {
		    puts("Detected a single-event file - rejecting.");
		    single_event_file = TRUE;
		    got_any_areas = FALSE;
		    goto SINGLE_EVENT_FILE;
	    }
	    /* First load all orbit attributes to figure out what orbits we may need to 
	     *	slot things into...
	     */
   	    sprintf(Line,"File contains an orbit from file %s",FilesToRead[file_num].hdfname);
	    AddMetadataLine(&TheData," ");
	    AddMetadataLine(&TheData,Line);
	    AddMetadataLine(&TheData," ");
	    sprintf(Line, "File %d Initial Stats:", file_num);
	    AddMetadataLine(&TheData,Line);
	    AddMetadataLine(&TheData,"----------------------------------------------------");
	    AddMetadataLine(&TheData," ");
	    AddMetadataLine(&TheData,"     Existing metadata:");
	    AddMetadataLine(&TheData," ");
	    mdtot = get_total_otd_metadata();
	    for (md=0; md < mdtot; md++) {
		read_metadata_struct(Line,md);
                sprintf(Line2,"     > %s",Line);
		AddMetadataLine(&TheData,Line2);
	    }
	    AddMetadataLine(&TheData," ");
	    AddMetadataLine(&TheData,"     Begins with:");
            AddMetadataLine(&TheData," ");
	    AddMetadataCount(&TheData,
		get_total_otd_orbit_attribute(),
		get_total_otd_areas(),
		get_total_otd_flashes(),
		get_total_otd_groups(),
		get_total_otd_events(),
		get_total_otd_image(),
		get_total_otd_view_time());
	     
	    total_oas = get_total_otd_orbit_attribute();
	    TempOrbits       = (struct CSmallOrbit *)calloc(total_oas+5, sizeof(struct CSmallOrbit));
	    use_this_orbit   = (int *)calloc(total_oas, sizeof(int));
	    for (oa=0; oa<total_oas; oa++) {
		read_otd_orbit_attributes_struct(&anorbitattribute, oa); 
		read_orbit_summary_struct(&asummary, oa);
		TempOrbits[oa].Attributes = anorbitattribute;
		TempOrbits[oa].Summary = asummary;
		
		/* Set clips for any info in this file > a nominal 100 minute orbit (5979 is precise) */
		if (TempOrbits[oa].Attributes.TAI93_end > 
		    TempOrbits[oa].Attributes.TAI93_start+6099.)
			TempOrbits[oa].Attributes.TAI93_end = TempOrbits[oa].Attributes.TAI93_start+6099;
		sprintf(TempOrbits[oa].filename, "%s", FilesToRead[file_num].hdfname);
	    }
	    printf("     Found %ld orbits in this file.\n", total_oas);

	    /* Load the ephemeris data and group into orbits.  We need this (as well as platform flags)
	     *    to decide whether or not we can load a given area/flash/...
	     */
	  
	    total_ephems = get_total_otd_ephemeris();
	    TempEphems = (struct otd_EPHEMERIS *)calloc(total_ephems, sizeof(struct otd_EPHEMERIS));

	    for (ephem = 0; ephem < total_ephems; ephem++) {
		read_otd_ephemeris_struct(&anephem, ephem);
		TempEphems[ephem] = anephem;
		for (oa = 0; oa < total_oas; oa++) {
		    if ((anephem.GPS >= (double)((int)TempOrbits[oa].Attributes.TAI93_start)) &&
			 (anephem.GPS <  (double)((int)TempOrbits[oa].Attributes.TAI93_end)) ) {
			     TempOrbits[oa].num_ephemeris++;
			 }
		}
	    }

	    for (oa = 0; oa < total_oas; oa++) {
		TempOrbits[oa].Ephemeris = (struct otd_EPHEMERIS *)calloc(TempOrbits[oa].num_ephemeris, 
						    sizeof(struct otd_EPHEMERIS));
		TempOrbits[oa].num_ephemeris = 0;
		for (ephem = 0; ephem < total_ephems; ephem++) {
		    if ((TempEphems[ephem].GPS >= (double)((int)TempOrbits[oa].Attributes.TAI93_start)) &&
			 (TempEphems[ephem].GPS <  (double)((int)TempOrbits[oa].Attributes.TAI93_end)) ) {
			     TempOrbits[oa].Ephemeris[TempOrbits[oa].num_ephemeris] = TempEphems[ephem];
			     TempOrbits[oa].num_ephemeris += 1;
			 }
		}

		if ((TempOrbits[oa].Ephemeris[TempOrbits[oa].num_ephemeris-1].GPS != 
		    TempOrbits[oa].Ephemeris[0].GPS+(double)(TempOrbits[oa].num_ephemeris)-1) &&
		    (TempOrbits[oa].Ephemeris[TempOrbits[oa].num_ephemeris-1].GPS != 0.0)) {
			fprintf(stderr, "Ephemeris integrity problem!\n");
		    }
		    
		/* Set clips for any tail-end data that has no ephemeris recorded.  When/if the production
		 *	code is fixed,  this should be irrelevant.
		 */
		 
		if ((TempOrbits[oa].num_ephemeris-1) < 
		     (long)((double)TempOrbits[oa].Attributes.TAI93_end - TempOrbits[oa].Attributes.TAI93_start)) {
			 if (TempOrbits[oa].Ephemeris[0].GPS == 0) {
			     TempOrbits[oa].TAI93_ephem_end = TempOrbits[oa].Attributes.TAI93_start +
							(double)TempOrbits[oa].num_ephemeris;
			 } else {
			     TempOrbits[oa].TAI93_ephem_end = TempOrbits[oa].Attributes.TAI93_start +
							(double)TempOrbits[oa].num_ephemeris;
			 }
		     }

	    }
	    
	    /* Load event rate arrays */
	   
	    for (oa = 0; oa < total_oas; oa++) {
		
		totsecs = (long)(((double)TempOrbits[oa].Attributes.TAI93_end)-
				(double)TempOrbits[oa].Attributes.TAI93_start);
		for (er=0; er<19; er++) {
		    eridx = er + oa*19;
		    read_otd_ORBIT_EVENT_RATE(erbuffer, &eridx);
		    for (sec = 0; sec < totsecs; sec++) 
			TempOrbits[oa].Event_Rate.Column[er].Datum[sec] = erbuffer[sec];
		}
		
		/* Smooth the values */
		
		for (er = 13; er < 17; er++) {
		    TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[0] = 0;
		    TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[0] = 0;
		    TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[0] = 0;
		    TempOrbits[oa].Platform_Data.FIFO_full.Datum[0]      = 0;
		    TempOrbits[oa].Platform_Data.Out_of_control.Datum[0] = 0;
		    TempOrbits[oa].Platform_Data.No_ephemeris.Datum[0]   = 0;
		    TempOrbits[oa].Platform_Data.Warmup.Datum[0]	 = 0;
		    TempOrbits[oa].Platform_Data.Connector_problem.Datum[0] = 0;
		    TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[0]  = 0;
		    for (sec = 0; sec <= (long)(SMOOTHING_WINDOW/2.0); sec++) {
			switch (er) {
			    case 13:
				{
				    TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[0] += 
					    TempOrbits[oa].Event_Rate.Column[er].Datum[sec];
				    break;
				}
			    case 14:
				{
				    TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[0] +=
					    TempOrbits[oa].Event_Rate.Column[er].Datum[sec];
				    break;
				}
			    case 15:
				{
				    TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[0] +=
					    TempOrbits[oa].Event_Rate.Column[er].Datum[sec];
				    break;
				}
			    case 16:
				{
				    TempOrbits[oa].Platform_Data.FIFO_full.Datum[0] += 
					    ((TempOrbits[oa].Event_Rate.Column[er].Datum[sec] >> 0) & 1);
				    TempOrbits[oa].Platform_Data.Out_of_control.Datum[0] += 
					    ((TempOrbits[oa].Event_Rate.Column[er].Datum[sec] >> 1) & 1);
				    TempOrbits[oa].Platform_Data.No_ephemeris.Datum[0] += 
					    ((TempOrbits[oa].Event_Rate.Column[er].Datum[sec] >> 2) & 1);
				    TempOrbits[oa].Platform_Data.Warmup.Datum[0] += 
					    ((TempOrbits[oa].Event_Rate.Column[er].Datum[sec] >> 3) & 1);
				    TempOrbits[oa].Platform_Data.Connector_problem.Datum[0] += 
					    ((TempOrbits[oa].Event_Rate.Column[er].Datum[sec] >> 4) & 1);
				    break;
				}
			}
		    }
		    for (sec = 0; sec < (long)(SMOOTHING_WINDOW/2.0); sec++) {
		        if (sec <= TempOrbits[oa].num_ephemeris)
			    TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[0] +=
				(TempOrbits[oa].Ephemeris[sec].GPS == 0.0);
		    }
    		   
		    for (sec = 1; sec < totsecs; sec++) {
		        
			delsec = sec - (long)(SMOOTHING_WINDOW/2.0);
			addsec = sec + (long)(SMOOTHING_WINDOW/2.0);
			
			switch (er) {
			    case 13:
				{
				    TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec] -= 
					TempOrbits[oa].Event_Rate.Column[er].Datum[delsec];
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec] += 
					TempOrbits[oa].Event_Rate.Column[er].Datum[addsec];
				    break;
				}
			    case 14:
				{
				    TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec] -= 
					TempOrbits[oa].Event_Rate.Column[er].Datum[delsec];
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec] += 
					TempOrbits[oa].Event_Rate.Column[er].Datum[addsec];
				    break;				    
				}
			    case 15:
				{
				    TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec] -= 
					TempOrbits[oa].Event_Rate.Column[er].Datum[delsec];
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec] += 
					TempOrbits[oa].Event_Rate.Column[er].Datum[addsec];
				    break;	
				}
			    case 16:
				{
				    TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec] = 
					TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec] -= 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[delsec] >> 0) & 1);
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec] += 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[addsec] >> 0) & 1);
				    TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec] -= 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[delsec] >> 1) & 1);
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec] += 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[addsec] >> 1) & 1);
				    TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec] = 
					TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec] -= 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[delsec] >> 2) & 1);
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec] += 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[addsec] >> 2) & 1);
				    TempOrbits[oa].Platform_Data.Warmup.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Warmup.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Warmup.Datum[sec] -= 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[delsec] >> 3) & 1);
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Warmup.Datum[sec] += 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[addsec] >> 3) & 1);
				    TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec] = 
					TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec-1];
				    if (delsec >= 0)	    TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec] -= 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[delsec] >> 4) & 1);
				    if (addsec < totsecs)   TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec] += 
					((TempOrbits[oa].Event_Rate.Column[er].Datum[addsec] >> 4) & 1);

				    break;	
				}
			}
			
			TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec] =
			    TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec-1];
			if ((delsec >= 0) && (delsec < (TempOrbits[oa].num_ephemeris-2))) TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec] -=
			    (TempOrbits[oa].Ephemeris[delsec].GPS == 0.0);
			if ((addsec < (TempOrbits[oa].num_ephemeris-2)) && (addsec < totsecs))
				 TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec] +=
			    (TempOrbits[oa].Ephemeris[addsec].GPS == 0.0);
		    }
		}
		
		for (sec=0; sec<6100; sec++) {
		    TempOrbits[oa].Platform_Data.PlatformOK.Datum[sec] =
			((TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec] > 0) &&
			(TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec] <= 5) &&
			(TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec]   <= 15) &&
			(TempOrbits[oa].Platform_Data.Warmup.Datum[sec]         <= 15) &&
			(TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec] <= 30));
		}
		
	    }

	    TempBrowse       = (struct otd_BROWSE *)calloc(total_oas*10368, sizeof(struct otd_BROWSE));
	    
		{
		total_areas = get_total_otd_areas();
		gotanarea = FALSE;
		for (area_num = 0; area_num < total_areas; area_num++) {
		    got_any_flashes = FALSE;
		    read_otd_area_struct(&anarea, area_num);
		    /* Which orbit is it in? */
		    /*   Note - an area must be completely encompassed by the orbit to be
		     *     accepted ... from area start to area finish! 
		     */
		    oa = 0; which_orbit = FALSE;
		    while (oa < total_oas  && !which_orbit) {
			if (!((anarea.TAI93 >= TempOrbits[oa].Attributes.TAI93_start) &&
			      ((anarea.TAI93+anarea.delta) <= TempOrbits[oa].Attributes.TAI93_end))) {
			      oa++;
			} else {
			    which_orbit = TRUE;
			}
		    }
		    if (oa >= total_oas) 
			{
			    fprintf(stderr, "     No orbit match, area %02ld of %02ld at %14.3f  (%3ld flashes)\n", 
				area_num+1, total_areas, anarea.TAI93, anarea.children);
			    goto NO_ORBIT_MATCH;
			}
		    which_orbit = oa;

		    if (AreaOK(anarea, Bounds) &&
		        PlatformOK(anarea.TAI93, anarea.TAI93+anarea.delta, 
				    TempOrbits[which_orbit].Attributes, &TempOrbits[which_orbit].Platform_Data)) {
			gotaflash = FALSE;
			flashid = anarea.child_rec;
			for (flash_num = 1; flash_num <= anarea.children; flash_num++) {
			    got_any_groups = FALSE;
			    read_otd_flash_struct(&aflash, flashid);
			    if (FlashOK(aflash, Bounds)) {
				gotagroup = FALSE;
				groupid = aflash.child_rec;
				for (group_num = 1; group_num <= aflash.children; group_num++) {
				    got_any_events = FALSE;
				    read_otd_group_struct(&agroup, groupid);
				    if (GroupOK(agroup, Bounds)) {
					gotanevent = FALSE;
					eventid = agroup.child_rec;
					for (event_num = 1; event_num <= agroup.children; event_num++) {
					    read_otd_event_struct(&anevent, eventid);
					    if (EventOK(anevent, Bounds)) {
						got_any_events = TRUE;
						TheData.Events[events_found].HDFEvent = anevent;
						TheData.Events[events_found].UTC = TAI93_to_UTC(anevent.TAI93);
						if (!gotanevent) {
						    gotanevent = TRUE;
						    TheData.Groups[groups_found].FirstEvent = events_found;
						}
						TheData.Groups[groups_found].LastEvent = events_found;
						TheData.Events[events_found].Parent = groups_found;
						events_found++;
					    }
					    eventid++;
					}
					if (got_any_events) {
					    got_any_groups = TRUE;
					    if (!gotagroup) {
						gotagroup = TRUE;
						TheData.Flashes[flashes_found].FirstGroup = groups_found;
					    }
					    TheData.Flashes[flashes_found].LastGroup = groups_found;
					    TheData.Groups[groups_found].HDFGroup = agroup;
					    TheData.Groups[groups_found].UTC = TAI93_to_UTC(agroup.TAI93);
					    TheData.Groups[groups_found].Events_Accepted = TheData.Groups[groups_found].LastEvent - 
											    TheData.Groups[groups_found].FirstEvent+1;
					    TheData.Groups[groups_found].Events_Rejected = TheData.Groups[groups_found].HDFGroup.children -
											    TheData.Groups[groups_found].Events_Accepted;
					    TheData.Groups[groups_found].Parent = flashes_found;
					    groups_found++;
					}
				    }
				    groupid++;
				}
				if (got_any_groups) {
				    got_any_flashes = TRUE;
				    if (!gotaflash) {
					gotaflash = TRUE;
					TheData.Areas[areas_found].FirstFlash = flashes_found;
				    }
				    TheData.Areas[areas_found].LastFlash = flashes_found;
				    TheData.Flashes[flashes_found].HDFFlash = aflash;
				    TheData.Flashes[flashes_found].UTC = TAI93_to_UTC(aflash.TAI93);	
				    TheData.Flashes[flashes_found].Groups_Accepted = TheData.Flashes[flashes_found].LastGroup -
										      TheData.Flashes[flashes_found].FirstGroup+1;
				    TheData.Flashes[flashes_found].Groups_Rejected = TheData.Flashes[flashes_found].HDFFlash.children - 
										      TheData.Flashes[flashes_found].Groups_Accepted;	
				    TheData.Flashes[flashes_found].Parent = areas_found;    
				    flashes_found++;
				}
			    }
			    flashid++;
			}
			if (got_any_flashes) {
			    got_any_areas = TRUE;
			    if (!use_this_orbit[which_orbit]) {
				use_this_orbit[which_orbit] = TRUE;
				TempOrbits[which_orbit].FirstArea = areas_found;
			    }
			    TempOrbits[which_orbit].LastArea = areas_found;
			    TempOrbits[which_orbit].NumChildren += 1;
			    TheData.Areas[areas_found].Orbit = which_orbit;
			    TheData.Areas[areas_found].HDFArea = anarea;
			    TheData.Areas[areas_found].UTC = TAI93_to_UTC(anarea.TAI93);
			    TheData.Areas[areas_found].Flashes_Accepted = TheData.Areas[areas_found].LastFlash
									    - TheData.Areas[areas_found].FirstFlash+1;
			    TheData.Areas[areas_found].Flashes_Rejected = TheData.Areas[areas_found].HDFArea.children -
								  TheData.Areas[areas_found].Flashes_Accepted;
			    areas_found++;
			}
		    }
NO_ORBIT_MATCH:	    ;
		}
PROCESS_ORBITS:	/* if (got_any_areas)  */
		if (TRUE) {

		    got_any_orbits = TRUE;
		    if (!gotanorbit) {
			gotanorbit = TRUE;
		    }
		    /* Load the remaining metadata */
		    total_thresh = get_total_otd_threshold();
		    total_browse = get_total_otd_browse();
		    total_images = get_total_otd_image();
		    total_viewtime = get_total_otd_view_time();
		    TempViewTime = (struct CViewTime *)calloc(total_viewtime, sizeof(struct CViewTime));
		    for (viewtime = 0; viewtime < total_viewtime; viewtime++) {
			read_otd_view_time_struct(&aviewtime, viewtime);
			TempViewTime[viewtime].HDFViewTime = aviewtime;
		    }
		    TempImageAttributes = (struct CImageAttribute *)
					calloc(total_images, sizeof(struct CImageAttribute));
		    for (image = 0; image < total_images; image++) {
			read_otd_image_attribute_struct(&animageattribute, image);
			TempImageAttributes[image].HDFImageAttribute = animageattribute;
		    }
		    for (oa = 0; oa < total_oas; oa++) {
			for (browse = 0; browse < 10368; browse++) {
			    read_otd_browse_struct (&abrowse, browse);
			    TempBrowse[browse] = abrowse;
			    TheData.Orbits[orbits_found].Browse[browse].location[0] = TempBrowse[browse].location[0];
			    TheData.Orbits[orbits_found].Browse[browse].location[1] = TempBrowse[browse].location[1];
			}
			TheData.Orbits[orbits_found].Attributes = TempOrbits[oa].Attributes;
			read_orbit_summary_struct(&asummary, oa);
			sprintf(TheData.Orbits[orbits_found].filename, "%s", TempOrbits[oa].filename);
			    
			TheData.Orbits[orbits_found].FirstArea = TempOrbits[oa].FirstArea;
			TheData.Orbits[orbits_found].LastArea  = TempOrbits[oa].LastArea;
			TheData.Orbits[orbits_found].Areas_Accepted = TempOrbits[oa].NumChildren;
			TheData.Orbits[orbits_found].Areas_Rejected = TempOrbits[oa].Summary.areas -
									TempOrbits[oa].NumChildren;
			TheData.Orbits[orbits_found].NumChildren = TempOrbits[oa].NumChildren;
			printf("     After processing: areas accepted:%5ld areas rejected:%5ld\n", 
			    TheData.Orbits[orbits_found].Areas_Accepted,  TheData.Orbits[orbits_found].Areas_Rejected);
			    
			TheData.Orbits[orbits_found].Ephemeris = (struct otd_EPHEMERIS *)
			    calloc(TempOrbits[oa].num_ephemeris, sizeof(struct otd_EPHEMERIS));
			for (ephem = 0; ephem < TempOrbits[oa].num_ephemeris; ephem++) {
			    TheData.Orbits[orbits_found].Ephemeris[ephem] = TempOrbits[oa].Ephemeris[ephem];
			    TheData.Orbits[orbits_found].num_ephemeris = TempOrbits[oa].num_ephemeris;
			}
			TheData.Orbits[orbits_found].TAI93_ephem_end = 
			    TempOrbits[oa].TAI93_ephem_end;
			    
			LoadPlatformData(oa, orbits_found, TempOrbits, &TheData);
			InitBrowse(orbits_found, TempOrbits, &TheData);
			TheData.Orbits[orbits_found].Thresholds = 
				(struct otd_THRESHOLD *)calloc(total_thresh, sizeof(struct otd_THRESHOLD));
				
			areas_this_orbit = 0;
			flashes_this_orbit = 0;
			groups_this_orbit = 0;
			events_this_orbit = 0;
			{
			    for (area = TheData.Orbits[orbits_found].FirstArea; 
				 area < TheData.Orbits[orbits_found].FirstArea + TheData.Orbits[orbits_found].NumChildren; area++) {
				     areas_this_orbit++;
				     gridpoint = LatLon2Grid((double)(TheData.Areas[area].HDFArea.cent[0]), 
							       (double)(TheData.Areas[area].HDFArea.cent[1]), 2.5);
				     TheData.Orbits[orbits_found].Browse[gridpoint].EGFA[3] += 1;
				     TheData.Areas[area].Orbit = orbits_found;
				     for (image = 0; image < total_images; image++) {
						 start = (TempImageAttributes[image].HDFImageAttribute.TAI93)-180.0;
						 end   = start+360.0;
						 if (((TheData.Areas[area].HDFArea.d_n_t == 'd') || 
						      (TheData.Areas[area].HDFArea.d_n_t == 't')    ) && 
						     ((TheData.Areas[area].HDFArea.TAI93 >= start) &&
						      (TheData.Areas[area].HDFArea.TAI93 <= end))) {
								TempImageAttributes[image].Use = TRUE;
						    } 
						 if (TempImageAttributes[image].Use && Bounds->XYTBound.Active) {
						 	TempImageAttributes[image].Use = 
						 	(CheckXYT(TempImageAttributes[image].HDFImageAttribute.nadir_location[0],
						 	 		  TempImageAttributes[image].HDFImageAttribute.nadir_location[1],
						 	 		  TempImageAttributes[image].HDFImageAttribute.TAI93, Bounds) ||
						 	 CheckXYT(TempImageAttributes[image].HDFImageAttribute.NW_location[0],
						 	 		  TempImageAttributes[image].HDFImageAttribute.NW_location[1],
						 	 		  TempImageAttributes[image].HDFImageAttribute.TAI93, Bounds) ||
						 	 CheckXYT(TempImageAttributes[image].HDFImageAttribute.SW_location[0],
						 	 		  TempImageAttributes[image].HDFImageAttribute.SW_location[1],
						 	 		  TempImageAttributes[image].HDFImageAttribute.TAI93, Bounds) ||
						 	 CheckXYT(TempImageAttributes[image].HDFImageAttribute.SE_location[0],
						 	 		  TempImageAttributes[image].HDFImageAttribute.SE_location[1],
						 	 		  TempImageAttributes[image].HDFImageAttribute.TAI93, Bounds) ||
						 	 CheckXYT(TempImageAttributes[image].HDFImageAttribute.NE_location[0],
						 	 		  TempImageAttributes[image].HDFImageAttribute.NE_location[1],
						 	 		  TempImageAttributes[image].HDFImageAttribute.TAI93, Bounds));
						 }
				     }
				     if (TheData.Areas[area].HDFArea.events == 1)
					TheData.Orbits[orbits_found].Browse[gridpoint].single_event_areas += 1;
				     for (flash = TheData.Areas[area].FirstFlash;
					  flash <= TheData.Areas[area].LastFlash; flash++) {
					      flashes_this_orbit++;
					      TheData.Flashes[flash].Orbit = orbits_found;
					      gridpoint = LatLon2Grid((double)(TheData.Flashes[flash].HDFFlash.cent[0]), 
									(double)(TheData.Flashes[flash].HDFFlash.cent[1]), 2.5);
					      TheData.Orbits[orbits_found].Browse[gridpoint].EGFA[2] += 1;
					      /* Replace with more accurate version 
					      TheData.Flashes[flash].size = Cmax_stroke_area(TheData, TheData.Flashes[flash]);
					      */
					      TheData.Flashes[flash].size = total_flash_area(TheData.Flashes[flash].HDFFlash);
					      TheData.Flashes[flash].radiance = Cflash_rad(&TheData, TheData.Flashes[flash]);
					      TheData.Flashes[flash].energy = rad_to_energy(TheData.Flashes[flash].radiance);
					      for (group = TheData.Flashes[flash].FirstGroup;
						   group <= TheData.Flashes[flash].LastGroup; group++) {
						       groups_this_orbit++;
						       TheData.Groups[group].Orbit = orbits_found;
						       gridpoint = LatLon2Grid((double)(TheData.Groups[group].HDFGroup.cent[0]), 
										 (double)(TheData.Groups[group].HDFGroup.cent[1]), 2.5);
						       TheData.Orbits[orbits_found].Browse[gridpoint].EGFA[1] += 1;
						       TheData.Groups[group].radiance = Cgroup_rad(&TheData, TheData.Groups[group]);
						       TheData.Groups[group].energy = rad_to_energy(TheData.Groups[group].radiance);
						       for (event = TheData.Groups[group].FirstEvent;
							    event <= TheData.Groups[group].LastEvent; event++) {
								events_this_orbit++;
								TheData.Events[event].Orbit = orbits_found;
								gridpoint = LatLon2Grid((double)(TheData.Events[event].HDFEvent.location[0]), 
											(double)(TheData.Events[event].HDFEvent.location[1]),  2.5);
								TheData.Orbits[orbits_found].Browse[gridpoint].EGFA[0] += 1;
								TheData.Events[event].radiance = event_rad(TheData.Events[event].HDFEvent);
								TheData.Events[event].energy = rad_to_energy(TheData.Events[event].radiance);
							    }
						   }
					  }
				 }
				 printf("     AFGE found: %4ld %5ld %5ld %5ld\n", areas_this_orbit, flashes_this_orbit, groups_this_orbit, events_this_orbit);
				 TheData.Orbits[orbits_found].Summary.areas = TheData.Orbits[orbits_found].NumChildren;
				 TheData.Orbits[orbits_found].Summary.flashes = flashes_this_orbit;
				 TheData.Orbits[orbits_found].Summary.groups = groups_this_orbit;
				 TheData.Orbits[orbits_found].Summary.events = events_this_orbit;
				 TheData.Orbits[orbits_found].Summary.total_cal_radiance = 0.0;
			     }
			     
			orbits_found++;
		    }
		    puts("     Processing backgrounds...");
		    ProcessBackgrounds(first_new_orbit, orbits_found, total_images, TempImageAttributes, &TheData, flashes_found);
		    ProcessThresholds(first_new_orbit, orbits_found, total_thresh, &TheData);
		    puts("     Processing viewtimes...");
		    ProcessViewTimes(first_new_orbit, orbits_found, total_viewtime, TempViewTime, &TheData, 
								Bounds, flashes_found);
		}
		/* close_OTD_HDF_FILE(); */
		free(use_this_orbit);
		for (oa=0; oa<total_oas; oa++) {
		    free(TempOrbits[oa].Ephemeris);
		}
		free(TempOrbits);
		free(TempImageAttributes);
		free(TempBrowse);
		free(TempViewTime);
		free(TempEphems);
	    }
	} else {
	    close_OTD_HDF_FILE();
	    fprintf(stderr, "Error opening HDF file %s for input\n", FilesToRead[file_num].hdfname);
	    exit(-1);
	}
SINGLE_EVENT_FILE: ;
SKIP_FILE: ;
        close_OTD_HDF_FILE();
  }
    
    TheData.num_orbits = orbits_found;
    TheData.num_areas = areas_found;
    TheData.num_flashes = flashes_found;
    TheData.num_groups = groups_found;
    TheData.num_events = events_found;
    
    images_found = 0;
    viewtimes_found = 0;

    if (orbits_found > 0) {
    for (oa = 0; oa < orbits_found; oa++) {
	images_found += TheData.Orbits[oa].num_backgrounds;
	viewtimes_found += TheData.Orbits[oa].num_viewtimes;
    }
    }

    CompressData(&TheData);

    AddMetadataLine(&TheData,"Bounds:");
    AddMetadataLine(&TheData," ");
    AddMetadataBounds(&TheData,Bounds);
    AddMetadataLine(&TheData,"After filtering:");
    AddMetadataLine(&TheData," ");
    puts("Final");
    AddMetadataCount(&TheData,orbits_found,areas_found,flashes_found,groups_found,
		events_found,images_found,viewtimes_found);
 
    /* Include a summary of bad platform times */

    old_platform_OK = -1;
    foundbad = FALSE;
    SensorOffFlag = OOCFlag = EphemerisFlag = WarmupFlag = ConnectorFlag = isbad = FALSE;
    for (oa = 0; oa < orbits_found; oa++) {
	for (sec = 1; sec < 6100; sec++) {
	    if (isbad) {
		if (TheData.Orbits[oa].Platform_Data.Rate_Prefilter.Datum[sec] < 1) SensorOffFlag = TRUE;
		if (TheData.Orbits[oa].Platform_Data.Out_of_control.Datum[sec] > 5) OOCFlag = TRUE;
		if (TheData.Orbits[oa].Platform_Data.No_ephemeris.Datum[sec] > 15) EphemerisFlag = TRUE;
		if (TheData.Orbits[oa].Platform_Data.Warmup.Datum[sec] > 15)WarmupFlag = TRUE;
		if (TheData.Orbits[oa].Platform_Data.Connector_problem.Datum[sec] > 30) ConnectorFlag = TRUE;		
	    }
	    if (TheData.Orbits[oa].Platform_Data.PlatformOK.Datum[sec] != old_platform_OK) {
		old_platform_OK = TheData.Orbits[oa].Platform_Data.PlatformOK.Datum[sec];
		if (!old_platform_OK) {
		    badUTC = TAI93_to_UTC(TheData.Orbits[oa].Attributes.TAI93_start+sec);
		    sprintf(firsthalf, "   Platform bad from: %4d %02d %02d  %02d:%02d:%02.0lf", 
			badUTC.year, badUTC.month, badUTC.day, badUTC.hour, badUTC.minute, badUTC.second);
		    isbad = TRUE;
		} else {
		    if (isbad) {
			goodUTC = TAI93_to_UTC(TheData.Orbits[oa].Attributes.TAI93_start+sec);
			baddur = UTC_to_TAI93(goodUTC)-UTC_to_TAI93(badUTC);
			if (baddur > 2.0) {
			    sprintf(probs, " ");
			    if (SensorOffFlag)	sprintf(probs, "%sSensorOff ", probs);
			    if (OOCFlag)	sprintf(probs, "%sOutOfControl ", probs);
			    if (EphemerisFlag)	sprintf(probs, "%sNoEphemeris ", probs);
			    if (WarmupFlag)	sprintf(probs, "%sWarmup ", probs);
			    if (ConnectorFlag)	sprintf(probs, "%sConnectors ", probs);			    
			    sprintf(aline, "%s to %4d %02d %02d  %02d:%02d:%02.0lf (%6.0f  sec) (%s)", firsthalf, 
				goodUTC.year, goodUTC.month, goodUTC.day, goodUTC.hour, goodUTC.minute, goodUTC.second, 
				baddur, probs);
			    AddMetadataLine(&TheData, aline);
			    foundbad = TRUE;
			}
			isbad = FALSE;
			SensorOffFlag = OOCFlag = EphemerisFlag = WarmupFlag = ConnectorFlag = FALSE;

		    }
		}
	    }
	}
    }
    if (isbad) {
	    goodUTC = TAI93_to_UTC(TheData.Orbits[orbits_found-1].Attributes.TAI93_end);
	    baddur = UTC_to_TAI93(goodUTC)-UTC_to_TAI93(badUTC);
	    if (baddur > 30.0) {
		sprintf(probs, " ");
		if (SensorOffFlag)	sprintf(probs, "%sSensorOff ", probs);
		if (OOCFlag)	sprintf(probs, "%sOutOfControl ", probs);
		if (EphemerisFlag)	sprintf(probs, "%sNoEphemeris ", probs);
		if (WarmupFlag)	sprintf(probs, "%sWarmup ", probs);
		if (ConnectorFlag)	sprintf(probs, "%sConnectors ", probs);
		sprintf(aline, "%s  to  %4d  %02d %02d  %02d:%02d:%02.0lf  (%6.0f  sec) (%s)", firsthalf, 
		    goodUTC.year, goodUTC.month, goodUTC.day, goodUTC.hour, goodUTC.minute, goodUTC.second, 
		    baddur, probs);
		AddMetadataLine(&TheData, aline);
	    }
	    isbad = FALSE;
    }
    if (foundbad) { 
	sprintf(aline, "   Lightning data and viewtimes during above window(s) have _not_ been included in this run.");
	AddMetadataLine(&TheData, aline);
    }
    
    puts("Returning");
/*    close_OTD_HDF_FILE();  */
    return(TheData);
}

void   FreeOTDData(TheData)
struct anOTDDataset *TheData;
{   
    int orbits,  orb, im;
    
    orbits = TheData->num_orbits;
    
    free(TheData->Metadata);
    for (orb = 0; orb < orbits; orb++) {
         if (HandleMetadata.Images) {
	    for (im = 0; im < TheData->Orbits[orb].num_backgrounds; im++) {
		free(TheData->Orbits[orb].Backgrounds[im].Image);
	    }
	}
	free(TheData->Orbits[orb].Backgrounds);
	free(TheData->Orbits[orb].Thresholds);
	free(TheData->Orbits[orb].Ephemeris);
	free(TheData->Orbits[orb].ViewTimes);
	free(TheData->Orbits[orb].ViewTimeGrid);
	free(TheData->Orbits[orb].ViewTimeGridStart);
	free(TheData->Orbits[orb].ViewTimeGridEnd);
    }
    free(TheData->Orbits);
    free(TheData->Areas);
    free(TheData->Flashes);
    free(TheData->Groups);
    free(TheData->Events);
    /* free(TheData->Gaps); */
    TheData->num_orbits = TheData->num_areas = TheData->num_flashes =
	TheData->num_groups = TheData->num_events = 0;
        
}

long	LatLon2Grid(latitude, longitude, resolution)
double  latitude, longitude, resolution;
{
    long idx, idx1, idx2, lonsize;
    
    lonsize = (long)(360.0/resolution);
    idx1 = lonsize * (long)((latitude+90.0)/resolution);
    idx2 = (long)((longitude+180.0)/resolution);
    idx = idx1 + idx2;
    return(idx);
}



void    Grid2LatLon(idx, res, lat, lon)
long idx;
double res,  *lat,  *lon;
{
    long numlon, numlat, llon, llat;
    
    numlon = (long)(360.0/res);
    numlat = (long)(180.0/res);
    llon = idx%numlon;
    llat = (long)(((double)idx/(double)numlon));
    *lon = -180.0 + llon*res;
    *lat = -90.0 + llat*res;
}

int PlatformOK(start, end, orb_att, platform_data)
double start, end;
struct otd_Orbit_attributes		orb_att;
struct aLongEventRateArray	*platform_data;
{
    long stidx, edidx;
    int  platok;
    
    if (start <  (double)((long)orb_att.TAI93_start)) {
	start = (double)((long)orb_att.TAI93_start)+1.;
	stidx = 1;
    } else {
	stidx = (long)((double)start - (double)((long)orb_att.TAI93_start));
    }
    if (end   >= (double)((long)orb_att.TAI93_end)) end   = (double)((long)orb_att.TAI93_end)-1.;
    edidx = (long)((double)end - (double)((long)orb_att.TAI93_start));
    if (edidx < stidx) edidx = stidx;
    platok = ((platform_data->PlatformOK.Datum[stidx]) && (platform_data->PlatformOK.Datum[edidx]));
/*    if (!platok) fprintf(stderr, "Platform problem: (%04ld:%04ld) %4d %3d %3d %3d %3d %3d (%d)  %4d %3d %3d %3d %3d %3d (%d)\n", 
	stidx, edidx, 
	platform_data->Rate_Prefilter.Datum[stidx], platform_data->FIFO_full.Datum[stidx], 
	platform_data->Out_of_control.Datum[stidx], platform_data->No_ephemeris.Datum[stidx], 
	platform_data->Warmup.Datum[stidx], platform_data->Connector_problem.Datum[stidx], 
	platform_data->PlatformOK.Datum[stidx], 
	platform_data->Rate_Prefilter.Datum[edidx], platform_data->FIFO_full.Datum[edidx], 
	platform_data->Out_of_control.Datum[edidx], platform_data->No_ephemeris.Datum[edidx], 
	platform_data->Warmup.Datum[edidx], platform_data->Connector_problem.Datum[edidx], 
	platform_data->PlatformOK.Datum[edidx]);
*/
    return(platok);
}

int OrbitOK(orbit, Bounds)
struct	otd_Orbit_attributes	orbit;
struct  anOTDBoundset		*Bounds;
{
    int	    TimeOK;
    
    TimeOK = ((orbit.TAI93_end > orbit.TAI93_start) &&
	      (orbit.TAI93_start >= Bounds->TimeWindow.Start.TAI93) &&
	      (orbit.TAI93_end <= Bounds->TimeWindow.End.TAI93));
	      
    return(TimeOK); 
}

int AreaOK(area, Bounds)
struct otd_AREA	area;
struct  anOTDBoundset		*Bounds;
{
    int	TimeOK, PositionOK, QualityOK, AttributesOK;
    int passfail[NUM_QUAL];
    
    TimeOK = !Bounds->TimeWindow.Active;
    
    if (!TimeOK) {
	TimeOK = ((area.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
		  (area.TAI93 <= Bounds->TimeWindow.End.TAI93));
    }

    PositionOK = !Bounds->AreaBound.Active;
    
    if (TimeOK && !PositionOK) 
	PositionOK = CheckLocation(area.cent, Bounds);
    
    QualityOK = !Bounds->QualityBound.Active;
    
    if (PositionOK && !QualityOK) QualityOK = TestQuality(A, area.QA, Bounds, passfail);
    
    AttributesOK = !Bounds->AttributeBounds.Active;
    
    if (QualityOK && !AttributesOK) {

	AttributesOK = ( (area.delta >= Bounds->AttributeBounds.Area.duration.lo) && 
			 (area.delta <= Bounds->AttributeBounds.Area.duration.hi) &&
		    	 (area.children >= Bounds->AttributeBounds.Area.num_children.lo) &&
			 (area.children <= Bounds->AttributeBounds.Area.num_children.hi) &&
			 (area.view >= Bounds->AttributeBounds.Area.coverage.lo) &&
			 (area.view <= Bounds->AttributeBounds.Area.coverage.hi) );
    }
    return(TimeOK && PositionOK && QualityOK && AttributesOK);
}

int FlashOK(flash, Bounds)
struct otd_FLASH	flash;
struct  anOTDBoundset		*Bounds;
{
    int	TimeOK, PositionOK, XYTOK, QualityOK, AttributesOK;
    double  flash_energy, flash_area;
    int	    passfail[NUM_QUAL];
    TimeOK = !Bounds->TimeWindow.Active;
    
    if (!TimeOK)    
	TimeOK = ((flash.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
		  (flash.TAI93 <= Bounds->TimeWindow.End.TAI93));

    PositionOK = !Bounds->AreaBound.Active;
    
    if (TimeOK && !PositionOK) 
	PositionOK = CheckLocation(flash.cent, Bounds);
    
    XYTOK = !Bounds->XYTBound.Active;
    
    if (PositionOK && !XYTOK) {
	    XYTOK = CheckXYT((double)flash.cent[0],(double)flash.cent[1],flash.TAI93,Bounds);
    }
	
    QualityOK = !Bounds->QualityBound.Active;
    
    if (XYTOK && !QualityOK) QualityOK = TestQuality(F, flash.QA, Bounds, passfail);
    
    AttributesOK = !Bounds->AttributeBounds.Active;
    
    if (QualityOK && !AttributesOK) {
	flash_energy = rad_to_energy(flash_rad(flash));
	/*flash_area   = max_stroke_area(flash); */
	/* Use precise flash area 2/27/98 */
	flash_area = total_flash_area(flash);
/*	printf("%10.3le %8.3lf\n",flash_energy,flash_area); */
	AttributesOK = ((flash_energy >= Bounds->AttributeBounds.Flash.energy.lo) &&
			(flash_energy <= Bounds->AttributeBounds.Flash.energy.hi) &&
			(flash_area   >= Bounds->AttributeBounds.Flash.area.lo) &&
			(flash_area   <= Bounds->AttributeBounds.Flash.area.hi) &&
			(flash.delta  >= Bounds->AttributeBounds.Flash.duration.lo) &&
			(flash.delta  <= Bounds->AttributeBounds.Flash.duration.hi) &&
			(flash.children >= Bounds->AttributeBounds.Flash.num_children.lo) &&
			(flash.children <= Bounds->AttributeBounds.Flash.num_children.hi));
    }
    
    return(TimeOK && PositionOK && QualityOK && XYTOK && AttributesOK);
}

int GroupOK(group, Bounds)
struct otd_GROUP	group;
struct  anOTDBoundset		*Bounds;
{
    int	TimeOK, PositionOK, QualityOK, AttributesOK;
    double  group_area, group_energy;
    int	    passfail[NUM_QUAL];
    
    TimeOK = !Bounds->TimeWindow.Active;
    
    if (!TimeOK) 
	TimeOK = ((group.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
		  (group.TAI93 <= Bounds->TimeWindow.End.TAI93));

    PositionOK = !Bounds->AreaBound.Active;
    
    if (TimeOK && !PositionOK) 
	PositionOK = CheckLocation(group.cent, Bounds);
    
    QualityOK = !Bounds->QualityBound.Active;
    
    if (PositionOK && !QualityOK) QualityOK = TestQuality(G, group.QA, Bounds, passfail);
    
    AttributesOK = !Bounds->AttributeBounds.Active;
    
    if (QualityOK && !AttributesOK) {
	group_energy = rad_to_energy(group_rad(group));
	group_area   = 100.0*group.children;
	AttributesOK = ((group.rad >= Bounds->AttributeBounds.Group.radiance.lo) &&
			(group.rad <= Bounds->AttributeBounds.Group.radiance.hi) &&
			(group_energy >= Bounds->AttributeBounds.Group.energy.lo) &&
			(group_energy <= Bounds->AttributeBounds.Group.energy.hi) &&
			(group_area >= Bounds->AttributeBounds.Group.area.lo) &&
			(group_area <= Bounds->AttributeBounds.Group.area.hi) &&
			(group.children >= Bounds->AttributeBounds.Group.num_children.lo) &&
			(group.children <= Bounds->AttributeBounds.Group.num_children.hi));
    }
    return(TimeOK && PositionOK && QualityOK && AttributesOK);
}

int EventOK(event, Bounds)
struct otd_EVENT	event;
struct  anOTDBoundset		*Bounds;
{
    int	TimeOK, PositionOK, QualityOK, AttributesOK;
    double  event_energy;
    int	    passfail[NUM_QUAL];
    
    TimeOK = !Bounds->TimeWindow.Active;
    
    if (!TimeOK) 
	TimeOK = ((event.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
		  (event.TAI93 <= Bounds->TimeWindow.End.TAI93));

    PositionOK = !Bounds->AreaBound.Active;
    
    if (TimeOK && !PositionOK) 
	PositionOK = CheckLocation(event.location, Bounds);
    
    QualityOK = !Bounds->QualityBound.Active;
    
    if (PositionOK && !QualityOK) QualityOK = TestQuality(E, event.QA, Bounds, passfail);
    
    AttributesOK = !Bounds->AttributeBounds.Active;
    
    if (QualityOK && !AttributesOK) {
	event_energy = rad_to_energy(event.cal_radiance);
	AttributesOK = ((event.cal_radiance >= Bounds->AttributeBounds.Event.radiance.lo) &&
			(event.cal_radiance <= Bounds->AttributeBounds.Event.radiance.hi) &&
			(event_energy >= Bounds->AttributeBounds.Event.energy.lo) &&
			(event_energy <= Bounds->AttributeBounds.Event.energy.hi));
    }
    return(TimeOK && PositionOK && QualityOK && AttributesOK);
}

int TestQuality(level, qa, Bounds, pf)
int	    level, pf[NUM_QUAL];
short int   qa[4];
struct	    anOTDBoundset   *Bounds;
{
    int	test;
    int passfail = TRUE;
    
    for (test = 0; test < NUM_QUAL; test++) {
	pf[test] = (qa[test] >= Bounds->QualityBound.Level[level].Param[test].lo &&
		    qa[test] <= Bounds->QualityBound.Level[level].Param[test].hi);
	passfail = (passfail && pf[test]);
    }
    return(passfail);
}

int CheckLocation(latlon, Bounds)
float	latlon[2];
struct  anOTDBoundset		*Bounds;
{
    int	    PositionOK = 0;
    double  backrange, backaz1, backaz2;
    
    switch(Bounds->AreaBound.BoundType) {
	case BOX:
	    {
		if (Bounds->AreaBound.Bounds.Box.LL.Longitude < Bounds->AreaBound.Bounds.Box.UR.Longitude) {
		    PositionOK = ((latlon[0] >= Bounds->AreaBound.Bounds.Box.LL.Latitude) &&
				  (latlon[0] <= Bounds->AreaBound.Bounds.Box.UR.Latitude) &&
				  (latlon[1] >= Bounds->AreaBound.Bounds.Box.LL.Longitude) &&
				  (latlon[1] <= Bounds->AreaBound.Bounds.Box.UR.Longitude));
		} else {
		    PositionOK = ((latlon[0] >= Bounds->AreaBound.Bounds.Box.LL.Latitude) &&
				  (latlon[0] <= Bounds->AreaBound.Bounds.Box.UR.Latitude) &&
				  (latlon[1] <= Bounds->AreaBound.Bounds.Box.LL.Longitude) &&
				  (latlon[1] >= Bounds->AreaBound.Bounds.Box.UR.Longitude));
		}
		break;
	    }
	case CIRCLE:
	    {
		LatLons2RgAz(Bounds->AreaBound.Bounds.Circle.Center.Latitude, 
		       		 Bounds->AreaBound.Bounds.Circle.Center.Longitude, 
		       		 latlon[0], latlon[1], 
		       		 &backaz1, &backaz2, &backrange);
		backrange /= 1e3;
		PositionOK = ((backrange >= Bounds->AreaBound.Bounds.Circle.Min_Range_km) &&
			  		  (backrange <= Bounds->AreaBound.Bounds.Circle.Max_Range_km));
		break;
	    }
    }
    return(PositionOK);
}

void SetTimeWindow_YMD(Bounds, syr, smo, sdy, shr, smi, sse, 
			   eyr, emo, edy, ehr, emi, ese)
struct  anOTDBoundset	*Bounds;
int syr, smo, sdy, shr, smi, eyr, emo, edy, ehr, emi;
double sse, ese;
{
    struct aTimeWindow	TimeWindow;
    int	sdoy, edoy;
    
    TimeWindow.Active = 1;
    
    if ((syr >= 95) && (syr <= 99)) syr += 1900;
    if ((eyr >= 95) && (eyr <= 99)) eyr += 1900;
    
    TimeWindow.Start.UTC.year  = syr;
    TimeWindow.Start.UTC.month = smo;
    TimeWindow.Start.UTC.day   = sdy;
    TimeWindow.Start.UTC.hour  = shr;
    TimeWindow.Start.UTC.minute= smi;
    TimeWindow.Start.UTC.second= sse;
    getDate(getDayNum(sdy, smo, syr), &syr, &smo, &sdy, &sdoy);
    TimeWindow.Start.UTC.doy   = sdoy;
    TimeWindow.Start.GPS       = UTC_to_GPS(TimeWindow.Start.UTC);
    TimeWindow.Start.TAI93     = UTC_to_TAI93(TimeWindow.Start.UTC);
    
    TimeWindow.End.UTC.year  = eyr;
    TimeWindow.End.UTC.month = emo;
    TimeWindow.End.UTC.day   = edy;
    TimeWindow.End.UTC.hour  = ehr;
    TimeWindow.End.UTC.minute= emi;
    TimeWindow.End.UTC.second= ese;
    getDate(getDayNum(edy, emo, eyr), &eyr, &emo, &edy, &edoy);
    TimeWindow.End.UTC.doy   = edoy;
    TimeWindow.End.GPS       = UTC_to_GPS(TimeWindow.End.UTC);
    TimeWindow.End.TAI93     = UTC_to_TAI93(TimeWindow.End.UTC);
    
    Bounds->TimeWindow = TimeWindow;
    return;
}

void SetTimeWindow_JD(Bounds, syr, sdoy, shr, smi, sse,
		          eyr, edoy, ehr, emi, ese)
struct  anOTDBoundset	*Bounds;
int syr, sdoy, shr, smi, eyr, edoy, ehr, emi;
double sse, ese;
{
    struct aTimeWindow TimeWindow;
    int smo, sdy, emo, edy;

    TimeWindow.Active = 1;
    
    InvJulian(syr, sdoy, &smo, &sdy);
    TimeWindow.Start.UTC.year  = syr;
    TimeWindow.Start.UTC.month = smo;
    TimeWindow.Start.UTC.day   = sdy;
    TimeWindow.Start.UTC.hour  = shr;
    TimeWindow.Start.UTC.minute= smi;
    TimeWindow.Start.UTC.second= sse;
    TimeWindow.Start.UTC.doy   = sdoy;
    TimeWindow.Start.GPS       = UTC_to_GPS(TimeWindow.Start.UTC);
    TimeWindow.Start.TAI93     = UTC_to_TAI93(TimeWindow.Start.UTC);
    
    InvJulian(eyr, edoy, &emo, &edy);
    TimeWindow.End.UTC.month = emo;
    TimeWindow.End.UTC.day   = edy;
    TimeWindow.End.UTC.hour  = ehr;
    TimeWindow.End.UTC.minute= emi;
    TimeWindow.End.UTC.second= ese;
    TimeWindow.End.UTC.doy   = edoy;
    TimeWindow.End.GPS       = UTC_to_GPS(TimeWindow.End.UTC);
    TimeWindow.End.TAI93     = UTC_to_TAI93(TimeWindow.End.UTC);    
    
    Bounds->TimeWindow = TimeWindow;
    return;
}
    
void  SetAreaBound(Bounds, type, par1, par2, par3, par4)
struct  anOTDBoundset	*Bounds;
int type;
double par1, par2, par3, par4;
{
    struct  anAreaBound	AreaBound;
    
    AreaBound.Active = 1;
    AreaBound.BoundType = type;
    
    switch(AreaBound.BoundType) {
	case BOX:
	    {
		AreaBound.Bounds.Box.LL.Latitude  = par1;
		AreaBound.Bounds.Box.LL.Longitude = par2;
		AreaBound.Bounds.Box.UR.Latitude  = par3;
		AreaBound.Bounds.Box.UR.Longitude = par4;
		break;
	    }
	case CIRCLE:
	    {
		AreaBound.Bounds.Circle.Center.Latitude  = par1;
		AreaBound.Bounds.Circle.Center.Longitude = par2;
		AreaBound.Bounds.Circle.Min_Range_km     = par3;
		AreaBound.Bounds.Circle.Max_Range_km     = par4;
		break;
	    }
    }   
    
    Bounds->AreaBound = AreaBound;
    
    return;
}

void	SetXYTBound(Bounds, type, XYTData, par1, par2, par3, par4)
struct anOTDBoundset *Bounds;
int type;
struct anXYTDataset *XYTData;
double par1,par2,par3,par4;
{
	Bounds->XYTBound.Active = TRUE;
	Bounds->XYTBound.XYT_bound_type = type;
	Bounds->XYTBound.XYT = XYTData;
	Bounds->XYTBound.min_range_km = par1;
	Bounds->XYTBound.max_range_km = par2;
	if (par3 != par4) {
		Bounds->XYTBound.min_elev = par3;
		Bounds->XYTBound.max_elev = par4;
	}
	return;
}

void SetQualityBound(Bounds, level, type, lower, upper)
struct  anOTDBoundset	*Bounds;
int type, lower, upper;
{
    int	ilev;
    
    Bounds->QualityBound.Active = TRUE;
    switch(level) { 
	case GLOBAL:
	    {
		for (ilev = A; ilev <= E; ilev++) {
		    Bounds->QualityBound.Level[ilev].Param[type].lo = lower;
		    Bounds->QualityBound.Level[ilev].Param[type].hi = upper;
		}
		break;
	    }
	case A:
	case F:
	case G:
	case E:
	    {
		Bounds->QualityBound.Level[level].Param[type].lo = lower;
		Bounds->QualityBound.Level[level].Param[type].hi = upper;		
		break;
	    }
    }
    return;
}

void SetDataAttributeBound(Bounds, level, type, lower, upper)
struct  anOTDBoundset	*Bounds;
int	level;
enum    data_parameters type;
double  lower, upper;
{
    Bounds->AttributeBounds.Active = TRUE;
    
    switch(level) { 
	case GLOBAL:
	    {
		Bounds->AttributeBounds.AreaActive  = TRUE;
		Bounds->AttributeBounds.FlashActive = TRUE;
		Bounds->AttributeBounds.GroupActive = TRUE;
		Bounds->AttributeBounds.EventActive = TRUE;
		switch(type) {
		    case RADIANCE:
			{
			    Bounds->AttributeBounds.Group.radiance.lo = lower;
			    Bounds->AttributeBounds.Group.radiance.hi = upper;
			    Bounds->AttributeBounds.Event.radiance.lo = lower;
			    Bounds->AttributeBounds.Event.radiance.hi = upper;
			    break;
			}
		    case ENERGY:
			{
			    Bounds->AttributeBounds.Flash.energy.lo   = lower;
			    Bounds->AttributeBounds.Flash.energy.hi   = upper;
			    Bounds->AttributeBounds.Group.energy.lo   = lower;
			    Bounds->AttributeBounds.Group.energy.hi   = upper;
			    Bounds->AttributeBounds.Event.energy.lo   = lower;
			    Bounds->AttributeBounds.Event.energy.hi   = upper;
			    break;
			}
		    case SIZE:
			{
			    Bounds->AttributeBounds.Flash.area.lo   = lower;
			    Bounds->AttributeBounds.Flash.area.hi   = upper;
			    Bounds->AttributeBounds.Group.area.lo   = lower;
			    Bounds->AttributeBounds.Group.area.hi   = upper;
			    break;
			}
		    case DURATION:
			{
			    Bounds->AttributeBounds.Area.duration.lo    = 0.0;
			    Bounds->AttributeBounds.Area.duration.hi    = 600.0;
			    Bounds->AttributeBounds.Flash.duration.lo   = lower;
			    Bounds->AttributeBounds.Flash.duration.hi   = upper;
			    break;
			}
		    case COVERAGE:
			{
			    Bounds->AttributeBounds.Area.coverage.lo	= lower;
			    Bounds->AttributeBounds.Area.coverage.hi	= upper;
			    break;
			}
		    case NUM_CHILDREN:
			{
			    Bounds->AttributeBounds.Area.num_children.lo    = (int)lower;
			    Bounds->AttributeBounds.Area.num_children.hi    = (int)upper;
			    Bounds->AttributeBounds.Flash.num_children.lo   = (int)lower;
			    Bounds->AttributeBounds.Flash.num_children.hi   = (int)upper;
			    Bounds->AttributeBounds.Group.num_children.lo   = (int)lower;
			    Bounds->AttributeBounds.Group.num_children.hi   = (int)upper;
			    break;
			}
		}
		break;
	    }
	case A:
	    {
	        Bounds->AttributeBounds.AreaActive = TRUE;
		switch (type) {
		    case RADIANCE:
			{
			   fprintf(stderr, "Radiance bounds on areas are meaningless ... ignored.\n");
			   break; 
			}
		    case ENERGY:
			{
			   fprintf(stderr, "Energy bounds on areas are meaningless ... ignored.\n");
			   break; 			    
			}
		    case SIZE:
			{
			   fprintf(stderr, "Areal bounds on areas are meaningless ... ignored.\n");
			   break; 			    
			}
		    case DURATION:
			{
			   Bounds->AttributeBounds.Area.duration.lo = lower;
			   Bounds->AttributeBounds.Area.duration.hi = upper;
			   break; 				    
			}
		    case COVERAGE:
			{
			    Bounds->AttributeBounds.Area.coverage.lo	= lower;
			    Bounds->AttributeBounds.Area.coverage.hi	= upper;
			    break;
			}
		    case NUM_CHILDREN:
			{
			    Bounds->AttributeBounds.Area.num_children.lo    = (int)lower;
			    Bounds->AttributeBounds.Area.num_children.hi    = (int)upper;
			    break;			    
			}
		}
		break;
	    }
	case F:
	    {
	        Bounds->AttributeBounds.FlashActive = TRUE;
		switch (type) {
		    case RADIANCE:
			{
			   fprintf(stderr, "Radiance bounds on flashes are meaningless ... ignored.\n");
			   break; 			    
			}
		    case ENERGY:
			{
			    Bounds->AttributeBounds.Flash.energy.lo   = lower;
			    Bounds->AttributeBounds.Flash.energy.hi   = upper;
			    break;			    
			}
		    case SIZE:
			{
			    Bounds->AttributeBounds.Flash.area.lo   = lower;
			    Bounds->AttributeBounds.Flash.area.hi   = upper;
			    break;			    
			}
		    case DURATION:
			{
			    Bounds->AttributeBounds.Flash.duration.lo   = lower;
			    Bounds->AttributeBounds.Flash.duration.hi   = upper;	
			    break;		    
			}
		    case COVERAGE:
			{
			    fprintf(stderr, "Coverage bounds on flashes are meaningless ... ignored\n");
			    break;
			}
		    case NUM_CHILDREN:
			{
			    Bounds->AttributeBounds.Flash.num_children.lo   = (int)lower;
			    Bounds->AttributeBounds.Flash.num_children.hi   = (int)upper;
			    break;			    
			}
		}
		break;
	    }
	case G:
	    {
	        Bounds->AttributeBounds.GroupActive = TRUE;
		switch (type) {
		    case RADIANCE:
			{
			    Bounds->AttributeBounds.Group.radiance.lo = lower;
			    Bounds->AttributeBounds.Group.radiance.hi = upper;
			    break;
			}
		    case ENERGY:
			{
			    Bounds->AttributeBounds.Group.energy.lo   = lower;
			    Bounds->AttributeBounds.Group.energy.hi   = upper;
			    break;			    
			}
		    case SIZE:
			{
			    Bounds->AttributeBounds.Group.area.lo   = lower;
			    Bounds->AttributeBounds.Group.area.hi   = upper;
			    break;			    
			}
		    case DURATION:
			{
			   fprintf(stderr, "Duration bounds on groups are meaningless ... ignored.\n");
			   break; 				    
			}
		    case COVERAGE:
			{
			    fprintf(stderr, "Coverage bounds on groups are meaningless ... ignored\n");
			    break;
			}
		    case NUM_CHILDREN:
			{
			    Bounds->AttributeBounds.Group.num_children.lo   = (int)lower;
			    Bounds->AttributeBounds.Group.num_children.hi   = (int)upper;
			    break;			    
			}
		}
		break;
	    }
	case E:
	    {
	        Bounds->AttributeBounds.EventActive = TRUE;
		switch (type) {
		    case RADIANCE:
			{
			    Bounds->AttributeBounds.Event.radiance.lo = lower;
			    Bounds->AttributeBounds.Event.radiance.hi = upper;
			    break;
			}
		    case ENERGY:
			{
			    Bounds->AttributeBounds.Event.energy.lo   = lower;
			    Bounds->AttributeBounds.Event.energy.hi   = upper;
			    break;			    
			}
		    case SIZE:
			{
			   fprintf(stderr, "Areal bounds on events are meaningless ... ignored.\n");
			   break; 	
			}
		    case DURATION:
			{
			   fprintf(stderr, "Duration bounds on events are meaningless ... ignored.\n");
			   break; 				    
			}
		    case COVERAGE:
			{
			    fprintf(stderr, "Coverage bounds on events are meaningless ... ignored\n");
			    break;
			}
		    case NUM_CHILDREN:
			{
			   fprintf(stderr, "Num_children bounds on events are meaningless ... ignored.\n");
			   break; 			    
			}
		}
		break;
	    }
    }
    return;
}

void Initialize()
{
    ResetMetadataHandling();
    ResetSDSOutputFields();
    ResetASCIIOutputFields(A, DEFAULT);
    ResetASCIIOutputFields(F, DEFAULT);
    ResetASCIIOutputFields(G, DEFAULT);
    ResetASCIIOutputFields(E, DEFAULT);
    return;
}

void ResetMetadataHandling()
{
    SetMetadataHandling(BROWSES, KEEP);
    SetMetadataHandling(VIEWTIMES, KEEP);
    SetMetadataHandling(IMAGES, KEEP);    
}

void SetMetadataHandling(type, setting)
int type, setting;
{
    switch (type) {
	case VIEWTIMES:
	    {
		HandleMetadata.Viewtimes = setting;
		break;
	    }
	case IMAGES:
	    {
		HandleMetadata.Images = setting;
		break;
	    }
	case BROWSES:
	    {
		HandleMetadata.Browses = setting;
		break;
	    }
    }
}

void ResetAllBounds(Bounds)
struct	anOTDBoundset *Bounds;
{
    ResetTimeWindow(Bounds);
    ResetAreaBound(Bounds);
    ResetXYTBound(Bounds);
    ResetQualityBound(Bounds);
    ResetDataAttributeBound(Bounds);
    return;    
}


void  ResetTimeWindow(Bounds)
struct	anOTDBoundset *Bounds;
{
    SetTimeWindow_YMD(Bounds, 1995, 04, 01, 00, 00, 00, 
			      1999, 12, 31, 23, 59, 59);
    Bounds->TimeWindow.Active = FALSE;
    
    return;
}

void  ResetAreaBound(Bounds)
struct	anOTDBoundset *Bounds;
{
    SetAreaBound(Bounds, BOX, -90.0, -180.0, 90.0, 180.0);
    Bounds->AreaBound.Active = FALSE;
    
    return;
}

void ResetXYTBound(Bounds)
struct anOTDBoundset *Bounds;
{
	if (Bounds->XYTBound.Active) {
		free(Bounds->XYTBound.XYT);
	}
	Bounds->XYTBound.Active = FALSE;
	Bounds->XYTBound.min_elev = -90.0;
	Bounds->XYTBound.max_elev = 90.0;
	Bounds->XYTBound.min_range_km = 0;
	Bounds->XYTBound.max_range_km = 20000.;
	return;
}

void ResetQualityBound(Bounds)
struct	anOTDBoundset *Bounds;
{
    SetQualityBound(Bounds, GLOBAL, SNR,   SNR_WORST,   SNR_BEST);
    SetQualityBound(Bounds, GLOBAL, GLINT, GLINT_WORST, GLINT_BEST);
    SetQualityBound(Bounds, GLOBAL, PROB,   PROB_WORST,   PROB_BEST);
    SetQualityBound(Bounds, GLOBAL, TAC, TAC_WORST, TAC_BEST);
    Bounds->QualityBound.Active = FALSE;
    return;
}

void ResetDataAttributeBound(Bounds)
struct	anOTDBoundset *Bounds;
{
    SetDataAttributeBound(Bounds, GLOBAL, RADIANCE, RADIANCE_MIN, RADIANCE_MAX);
    SetDataAttributeBound(Bounds, GLOBAL, ENERGY, ENERGY_MIN, ENERGY_MAX);
    SetDataAttributeBound(Bounds, GLOBAL, SIZE, SIZE_MIN, SIZE_MAX);
    SetDataAttributeBound(Bounds, GLOBAL, DURATION, DURATION_MIN, DURATION_MAX);
    SetDataAttributeBound(Bounds, GLOBAL, COVERAGE, COVERAGE_MIN, COVERAGE_MAX);
    SetDataAttributeBound(Bounds, GLOBAL, NUM_CHILDREN, NUM_CHILDREN_MIN, NUM_CHILDREN_MAX);
    Bounds->AttributeBounds.Active = FALSE;
    Bounds->AttributeBounds.AreaActive = FALSE;
    Bounds->AttributeBounds.FlashActive = FALSE;
    Bounds->AttributeBounds.GroupActive = FALSE;
    Bounds->AttributeBounds.EventActive = FALSE;
    return;
}

long read_orbit_summary_struct(sum, record)
struct Orbit_summary	*sum;
long record;
{
    unsigned char buf[128];
    
    if (read_otd_ORBIT_SUMMARY(buf, &record)==FAIL) return -1;
    memcpy(&sum->areas, &buf[0], 4);
    memcpy(&sum->flashes, &buf[4], 4);
    memcpy(&sum->groups, &buf[8], 4);
    memcpy(&sum->events, &buf[12], 4);
    memcpy(&sum->total_cal_radiance, &buf[16], 4);
    return 0;
}

long read_metadata_struct(md, record)
char *md;
long record;
{
    unsigned char buf[128];
    if (read_otd_METADATA(buf, &record)==FAIL) return-1;
    memcpy(md,&buf[0],128);
    return 0;
}

void ProcessViewTimes(first_new_orbit, orbits_found, total_viewtime, TempViewTime, TheData, 
			Bounds, ff)
long first_new_orbit, orbits_found, total_viewtime, ff;
struct CViewTime *TempViewTime;
struct anOTDDataset  *TheData;
struct anOTDBoundset *Bounds;
{
	int PassArea, PassXYT, PassTime, PassPlatform;
    long oa, viewtime, vtct, idx, gridlon;
    /* Viewtimes */
    for (oa = first_new_orbit; oa < orbits_found; oa++) {
        if ((HandleMetadata.Viewtimes==KEEP) || ((HandleMetadata.Viewtimes==IF_FLASHES) && (ff > 0))) {
	for (viewtime = 0; viewtime < total_viewtime; viewtime++) {
 	    if ((TempViewTime[viewtime].HDFViewTime.TAI93_start >= (double)((long)TheData->Orbits[oa].Attributes.TAI93_start)) && 
		(TempViewTime[viewtime].HDFViewTime.TAI93_start < (double)((long)TheData->Orbits[oa].Attributes.TAI93_end))) {
		    PassTime =  !(Bounds->TimeWindow.Active); 
		    PassArea = (!Bounds->AreaBound.Active);
		    PassXYT = (!Bounds->XYTBound.Active);
		    PassPlatform = FALSE;
		    if (!PassTime) {
			PassTime =  ((TempViewTime[viewtime].HDFViewTime.TAI93_start >= (double)((long)Bounds->TimeWindow.Start.TAI93)) &&
			    (TempViewTime[viewtime].HDFViewTime.TAI93_start+(double)TempViewTime[viewtime].HDFViewTime.duration) <=
				(double)((long)((double)Bounds->TimeWindow.End.TAI93+(double)TempViewTime[viewtime].HDFViewTime.duration)));
		    }
		    if (PassTime && !PassArea) {
			PassArea = (CheckLocation(TempViewTime[viewtime].HDFViewTime.grid_point, Bounds));
		    }
		    if (PassArea && !PassXYT) {
			PassXYT = (CheckXYT((double)TempViewTime[viewtime].HDFViewTime.grid_point[0],
			                     (double)TempViewTime[viewtime].HDFViewTime.grid_point[1],
				                     TempViewTime[viewtime].HDFViewTime.TAI93_start +
					            (TempViewTime[viewtime].HDFViewTime.duration/2.), Bounds));
		    }
		    if (PassXYT) {
			    PassPlatform = PlatformOK(TempViewTime[viewtime].HDFViewTime.TAI93_start+1., 
						      TempViewTime[viewtime].HDFViewTime.TAI93_start+
						       (double)TempViewTime[viewtime].HDFViewTime.duration-1., 
					              TheData->Orbits[oa].Attributes, 
					              &TheData->Orbits[oa].Platform_Data);
		    }
		    if (PassTime && PassArea && PassXYT && PassPlatform) {
			    TempViewTime[viewtime].Use = TRUE;
			    TheData->Orbits[oa].num_viewtimes += 1;    
		    } else {     	
			    TempViewTime[viewtime].Use = FALSE;
		    } 
		}
	}
	TheData->Orbits[oa].ViewTimes = 
	    (struct otd_View_time *)calloc(TheData->Orbits[oa].num_viewtimes,
				       sizeof(struct otd_View_time)); 
    } else {
	TheData->Orbits[oa].ViewTimes = (struct otd_View_time *)calloc(1, sizeof(struct otd_View_time));
	TheData->Orbits[oa].num_viewtimes = 0;
    }
    }
    if ((HandleMetadata.Viewtimes==KEEP) || ((HandleMetadata.Viewtimes==IF_FLASHES) && (ff>0))) {
	for (oa=first_new_orbit; oa < orbits_found; oa++) {
	    vtct = 0;
	    for (viewtime = 0; viewtime < total_viewtime; viewtime++) {
		if (TempViewTime[viewtime].Use) {
		    if ((TempViewTime[viewtime].HDFViewTime.TAI93_start >= (double)((long)TheData->Orbits[oa].Attributes.TAI93_start)) && 
			(TempViewTime[viewtime].HDFViewTime.TAI93_start <  (double)((long)TheData->Orbits[oa].Attributes.TAI93_end))) {

			TheData->Orbits[oa].ViewTimes[vtct] = TempViewTime[viewtime].HDFViewTime;
			TempViewTime[viewtime].Use = FALSE;
			if (Bounds->TimeWindow.Active) {
			    if ((TempViewTime[viewtime].HDFViewTime.TAI93_start < Bounds->TimeWindow.Start.TAI93) &&
				((TempViewTime[viewtime].HDFViewTime.TAI93_start+(double)TempViewTime[viewtime].HDFViewTime.duration) >=
				  Bounds->TimeWindow.Start.TAI93)) {
				    TheData->Orbits[oa].ViewTimes[vtct].duration -= 
					(Bounds->TimeWindow.Start.TAI93-TheData->Orbits[oa].ViewTimes[vtct].TAI93_start);
				    TheData->Orbits[oa].ViewTimes[vtct].TAI93_start = Bounds->TimeWindow.Start.TAI93;
				}
			    if ((TheData->Orbits[oa].ViewTimes[vtct].TAI93_start >= Bounds->TimeWindow.Start.TAI93) &&
				(TheData->Orbits[oa].ViewTimes[vtct].TAI93_start <= Bounds->TimeWindow.End.TAI93) &&
				((TempViewTime[viewtime].HDFViewTime.TAI93_start+(double)TempViewTime[viewtime].HDFViewTime.duration) >=
				  Bounds->TimeWindow.End.TAI93))
				  TheData->Orbits[oa].ViewTimes[vtct].duration = 
				    (short int)(Bounds->TimeWindow.End.TAI93 - TheData->Orbits[oa].ViewTimes[vtct].TAI93_start);					      
			    }
			vtct++;
		    }
		}
	    }
	}
    } else {
	vtct = 0;
    }
    for (oa = first_new_orbit; oa<orbits_found; oa++) {
	TheData->Orbits[oa].ViewTimeGrid = (int *)calloc(720*360, sizeof(int));
 	TheData->Orbits[oa].ViewTimeGridStart = (double *)calloc(720*360, sizeof(double));
 	TheData->Orbits[oa].ViewTimeGridEnd   = (double *)calloc(720*360, sizeof(double));
	for (idx = 0; idx < TheData->Orbits[oa].num_viewtimes; idx++) {
	    gridlon = LatLon2Grid(TheData->Orbits[oa].ViewTimes[idx].grid_point[0], 
				  TheData->Orbits[oa].ViewTimes[idx].grid_point[1],  0.5);
	    TheData->Orbits[oa].ViewTimeGrid[gridlon] +=
				    (int)(TheData->Orbits[oa].ViewTimes[idx].duration);
	    if (TheData->Orbits[oa].ViewTimeGridStart[gridlon] < 1) {
		TheData->Orbits[oa].ViewTimeGridStart[gridlon] = TheData->Orbits[oa].ViewTimes[idx].TAI93_start;
		TheData->Orbits[oa].ViewTimeGridEnd[gridlon]   = TheData->Orbits[oa].ViewTimes[idx].TAI93_start +
								 TheData->Orbits[oa].ViewTimes[idx].duration;
	    } else {
		if ((TheData->Orbits[oa].ViewTimes[idx].TAI93_start + TheData->Orbits[oa].ViewTimes[idx].duration) >
			TheData->Orbits[oa].ViewTimeGridEnd[gridlon])
			TheData->Orbits[oa].ViewTimeGridEnd[gridlon] = 
				(TheData->Orbits[oa].ViewTimes[idx].TAI93_start + TheData->Orbits[oa].ViewTimes[idx].duration);
	    }
	}
    }
}

void ProcessThresholds(first_new_orbit, orbits_found, total_thresh, TheData)
long first_new_orbit, orbits_found, total_thresh;
struct anOTDDataset *TheData;
{
    long thresh, oa2, oa;
    struct otd_THRESHOLD athreshold;
    int  fnd;
   
    /* Group the thresholds into the appropriate orbits */
    for (thresh=0; thresh<total_thresh; thresh++) {
	read_otd_threshold_struct(&athreshold, thresh);
	for (oa = first_new_orbit; oa < orbits_found; oa++) {
	    if ((athreshold.TAI93 >= TheData->Orbits[oa].Attributes.TAI93_start) &&
		(athreshold.TAI93 <= TheData->Orbits[oa].Attributes.TAI93_end)) {
		    fnd = FALSE;
		    for (oa2 = 0; oa2 < TheData->Orbits[oa].num_thresholds; oa2++) {
			if (athreshold.TAI93 == TheData->Orbits[oa].Thresholds[oa2].TAI93) fnd=TRUE;
		    }
		    if ((!fnd) || (TheData->Orbits[oa].num_thresholds==0) || (oa==0)) {
			TheData->Orbits[oa].Thresholds[
			    TheData->Orbits[oa].num_thresholds] = athreshold;
			TheData->Orbits[oa].num_thresholds++;
		    }
		}
	}
    }
}

int GetThreshold(TheData, orbit, TAI93)
struct anOTDDataset *TheData;
long	orbit;
double  TAI93;
{
	long orb, thr;
	int	 found;
	
	if (orbit < 0) {
		found = FALSE;	
		orb = 0;
		while ((orb < TheData->num_orbits) && !found) {
			thr = 0;
			while ((thr < TheData->Orbits[orb].num_thresholds) && !found) {
				found = (TAI93 >= TheData->Orbits[orb].Thresholds[thr].TAI93);
				thr++;
			}
			if (found) {
				thr--;
				return(TheData->Orbits[orb].Thresholds[thr].values[0]);
			} else {
				orb++;
			}
		}
		return(-1);
	} else {
		orb = orbit;
		found = FALSE;
		thr = 0;
		while ((thr < TheData->Orbits[orb].num_thresholds) && !found) {
			found = (TAI93 >= TheData->Orbits[orb].Thresholds[thr].TAI93);
			thr++;
		}
		if (found) {
			thr--;
			return(TheData->Orbits[orb].Thresholds[thr].values[0]);
		} else {
			return(-1);
		}
	}
}
void ProcessBackgrounds(first_new_orbit, orbits_found, total_images, TempImageAttributes, TheData, ff)
long first_new_orbit, orbits_found, total_images, ff;
struct CImageAttribute *TempImageAttributes;
struct anOTDDataset *TheData;
{
    long image, images_used, oa;
    long sp_offset, im_offset, oa3;
    
    images_used = 0;
    for (image = 0; image<total_images; image++) {
	if (TempImageAttributes[image].Use) {
	    images_used++;
	}
    }
    /* Note ... only retain images within the start, end ephemeris range. */

    for (image = 0; image<total_images; image++) {
	if (TempImageAttributes[image].Use) {
	    for (oa = first_new_orbit; oa < orbits_found; oa++) {
		if ((TempImageAttributes[image].HDFImageAttribute.TAI93 >=
		    TheData->Orbits[oa].Attributes.TAI93_start) &&
		    (TempImageAttributes[image].HDFImageAttribute.TAI93 <= 
		    TheData->Orbits[oa].TAI93_ephem_end) &&
		    PlatformOK(TempImageAttributes[image].HDFImageAttribute.TAI93, 
			       TempImageAttributes[image].HDFImageAttribute.TAI93, 
			       TheData->Orbits[oa].Attributes, 
			       &TheData->Orbits[oa].Platform_Data)) {
			TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute =
			    TempImageAttributes[image].HDFImageAttribute;
			if ((HandleMetadata.Images==KEEP) || ((HandleMetadata.Images==IF_FLASHES) && (ff>0))) {
			    TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].Image =
				(short int *)calloc(128*128, sizeof(short int));
			    read_otd_IMAGE(TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].Image, 
				&image);
			    sp_offset = 0;
			    for (oa3 = 0; oa3 < oa; oa3++)
				sp_offset += TheData->Orbits[oa3].num_ephemeris;
			    im_offset = 0;
			    for (oa3 = 0; oa3 < oa; oa3++)
				im_offset += TheData->Orbits[oa3].num_backgrounds;
			    TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.spice_pointer =
				(long)((double)TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.TAI93 -
					    TheData->Orbits[oa].Attributes.TAI93_start)+sp_offset;
			    TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.image_pointer =
				TheData->Orbits[oa].num_backgrounds + im_offset;
			} else {
			    TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.spice_pointer =
				(long)((double)TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.TAI93 -
					    TheData->Orbits[oa].Attributes.TAI93_start)+sp_offset;
			    TheData->Orbits[oa].Backgrounds[TheData->Orbits[oa].num_backgrounds].ImageAttribute.image_pointer = -1;
			}
			TheData->Orbits[oa].num_backgrounds += 1;
		}
	    }
	}
    }
    for (oa = first_new_orbit; oa < orbits_found; oa++) {
	TheData->Orbits[oa].Summary.backgrounds = TheData->Orbits[oa].num_backgrounds;
    }		    
}

void LoadPlatformData(oa, orbits_found, TempOrbits, TheData)
long oa, orbits_found;
struct CSmallOrbit *TempOrbits;
struct anOTDDataset *TheData;
{
    long sec, er;

/*     debug = fopen("debug","w"); */

    for (sec = 0; sec < 6100; sec++) {
	for (er = 0; er < 19; er++) {
	    TheData->Orbits[orbits_found].Event_Rate.Column[er].Datum[sec] =
		TempOrbits[oa].Event_Rate.Column[er].Datum[sec];
            /* Delete me! */
/*
            if ((er==1) || (er==2) || (er==5) || (er==6) || (er==7) || (er==8) ||
		(er==11) || (er==12) || (er==13) || (er==14) || (er==15)) 
            fprintf(debug,"%5d ",TempOrbits[oa].Event_Rate.Column[er].Datum[sec]);
 */           
	}
/*
        fprintf(debug,"%5d %5d %5d %5d %5d %5d %5d %5d %5d %5d\n",
	  TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec],
  	  TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec],
          TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec],
	  TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec],
	  TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec],
	  TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec],
	  TempOrbits[oa].Platform_Data.Warmup.Datum[sec],
	  TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec],
	  TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec],
	  TempOrbits[oa].Platform_Data.PlatformOK.Datum[sec]);
*/
	TheData->Orbits[orbits_found].Platform_Data.Rate_Prefilter.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Rate_Prefilter.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.Rate_Postglint.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Rate_Postglint.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.Rate_Postnoise.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Rate_Postnoise.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.FIFO_full.Datum[sec] =
		       TempOrbits[oa].Platform_Data.FIFO_full.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.Out_of_control.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Out_of_control.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.No_ephemeris.Datum[sec] =
		       TempOrbits[oa].Platform_Data.No_ephemeris.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.Warmup.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Warmup.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.Connector_problem.Datum[sec] =
		       TempOrbits[oa].Platform_Data.Connector_problem.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.No_ephemeris2.Datum[sec] =
		       TempOrbits[oa].Platform_Data.No_ephemeris2.Datum[sec];
	TheData->Orbits[orbits_found].Platform_Data.PlatformOK.Datum[sec] = 
		       TempOrbits[oa].Platform_Data.PlatformOK.Datum[sec];
    }
    /* fclose(debug); */
}

void InitBrowse(orbits_found, TempOrbits, TheData)
long orbits_found;
struct CSmallOrbit *TempOrbits;
struct anOTDDataset *TheData;
{
    long browse;
    
    for (browse=0; browse<10368; browse++) {
	TheData->Orbits[orbits_found].Browse[browse].EGFA[0] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA[1] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA[2] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA[3] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA_cal_rad[0] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA_cal_rad[1] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA_cal_rad[2] = 0;
	TheData->Orbits[orbits_found].Browse[browse].EGFA_cal_rad[3] = 0;
	TheData->Orbits[orbits_found].Browse[browse].max_rate = 0;
	TheData->Orbits[orbits_found].Browse[browse].single_event_areas = 0;
	TheData->Orbits[orbits_found].Browse[browse].highres_locs = 0;
	TheData->Orbits[orbits_found].Browse[browse].bkgnds = 0;
	TheData->Orbits[orbits_found].Browse[browse].iloper = 0;
	TheData->Orbits[orbits_found].Browse[browse].bkgnd_pointer = 0;
	TheData->Orbits[orbits_found].Flash_Density_25[browse].location[0] = 
	    TheData->Orbits[orbits_found].Browse[browse].location[0];
	TheData->Orbits[orbits_found].Flash_Density_25[browse].location[1] = 
	    TheData->Orbits[orbits_found].Browse[browse].location[1];
	TheData->Orbits[orbits_found].Flash_Density_25[browse].flash_count = 0;
    }
}

void CompressData(Data)
struct anOTDDataset *Data;
{
    long nvt, nf, na, ng, ne, no, o;
    
    nvt = 0;
    no = Data->num_orbits;
    na = Data->num_areas;
    nf = Data->num_flashes;
    ng = Data->num_groups;
    ne = Data->num_events;
    
    for (o=0; o<no; o++) {
	nvt = Data->Orbits[o].num_viewtimes;
	Data->Orbits[o].ViewTimes = (struct otd_View_time *)
		realloc(Data->Orbits[o].ViewTimes, nvt*sizeof(struct otd_View_time));
    }
    Data->Areas = (struct CArea *)realloc(Data->Areas, na*sizeof(struct CArea));
    Data->Flashes = (struct CFlash *)realloc(Data->Flashes, nf*sizeof(struct CFlash));
    Data->Groups = (struct CGroup *)realloc(Data->Groups, ng*sizeof(struct CGroup));
    Data->Events = (struct CEvent *)realloc(Data->Events, ne*sizeof(struct CEvent));

/*
    for (o=0; o<no; o++) {
		nvt = Data->Orbits[o].num_viewtimes;
		TempViewTimes = (struct View_time *)calloc(nvt, sizeof(struct View_time));
		for (vt = 0; vt < nvt; vt++) {
	    	memcpy(&TempViewTimes[vt], &Data->Orbits[o].ViewTimes[vt], 
		    	sizeof(struct View_time));
		}
		free(Data->Orbits[o].ViewTimes);
		Data->Orbits[o].ViewTimes = (struct View_time *)calloc(nvt, sizeof(struct View_time));
		for (vt=0; vt < nvt; vt++) {
	    memcpy(&Data->Orbits[o].ViewTimes[vt], &TempViewTimes[vt], 
		    	sizeof(struct View_time));
		}
		free(TempViewTimes);
    }
    
    TempAreas = (struct CArea *)calloc(na, sizeof(struct CArea));
    for (a=0; a<na; a++) {
	memcpy(&TempAreas[a], &Data->Areas[a], sizeof(struct CArea));
    }
    free(Data->Areas);
    Data->Areas = (struct CArea *)calloc(na, sizeof(struct CArea));
    for (a=0; a<na; a++) {
	memcpy(&Data->Areas[a], &TempAreas[a], sizeof(struct CArea));
    }
    free(TempAreas);
    
    TempFlashes = (struct CFlash *)calloc(nf, sizeof(struct CFlash));
    for (f=0; f<nf; f++) {
	memcpy(&TempFlashes[f], &Data->Flashes[f], sizeof(struct CFlash));
    }
    free(Data->Flashes);
    Data->Flashes = (struct CFlash *)calloc(nf, sizeof(struct CFlash));
    for (f=0; f<nf; f++) {
	memcpy(&Data->Flashes[f], &TempFlashes[f], sizeof(struct CFlash));
    }
    free(TempFlashes);
    
    TempGroups = (struct CGroup *)calloc(ng, sizeof(struct CGroup));
    for (g=0; g<ng; g++) {
	memcpy(&TempGroups[g], &Data->Groups[g], sizeof(struct CGroup));
    }
    free(Data->Groups);
    Data->Groups = (struct CGroup *)calloc(ng, sizeof(struct CGroup));
    for (g=0; g<ng; g++) {
	memcpy(&Data->Groups[g], &TempGroups[g], sizeof(struct CGroup));
    }
    free(TempGroups);
    
    TempEvents = (struct CEvent *)calloc(ne, sizeof(struct CEvent));
    for (e=0; e<ne; e++) {
	memcpy(&TempEvents[e], &Data->Events[e], sizeof(struct CEvent));
    }
    free(Data->Events);
    Data->Events = (struct CEvent *)calloc(ne, sizeof(struct CEvent));
    for (e=0; e<ne; e++) {
	memcpy(&Data->Events[e], &TempEvents[e], sizeof(struct CEvent));
    }
    free(TempEvents);
    */
}


void GetTimeBounds(hdfname, Start, Stop)
char hdfname[132];
struct aDateTime *Start, *Stop;
{
   FILE *HDFListFile;
   char inputLine[128];
   long num_files = 0, file_num;
    struct  anHDFFileEntry  FilesToRead[30];
    extern  char	    RawFilePath[132];
    double min_TAI, max_TAI;
   long oa, total_oas, hdffile;
    struct  otd_Orbit_attributes	anorbitattribute;

   /* Check if file indirect (list of HDF files rather than single file) */
    
    if (strstr(hdfname, "mlab")==NULL) {
	if ((HDFListFile=(fopen(hdfname, "r"))) != NULL) {
	    while (fgets(inputLine,128,HDFListFile) != NULL) {
		num_files++;
		inputLine[strlen(inputLine)-1] = '\0';
		sprintf(FilesToRead[num_files].hdfname, "%s%s", RawFilePath, inputLine);
	    }
	    fclose(HDFListFile);
	} else {
	    fprintf(stderr, "Error opening HDF List File %s for input.\n", hdfname);
	    exit(-1);
	}
    } else {
	num_files = 1;
	sprintf(FilesToRead[num_files].hdfname, "%s%s", RawFilePath, hdfname);
    }
    
     for (file_num = 1; file_num <= num_files; file_num++) {
    	hdffile=open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname);
        if((hdffile<0)&&((hdffile&0xffffff00)!=otd_NoMetadata)){
	    	printf("Error opening HDF file %s; skipping to next.\n",
						    FilesToRead[file_num].hdfname);
	    	goto SKIPHDF;    
            hdffile = hdffile&0xff;
        }
        if(((hdffile&0xffffff00)==otd_NoMetadata))hdffile = hdffile^otd_NoMetadata;
	
SKIPHDF:	
        close_OTD_HDF_FILE();
	;

    }	
    
    min_TAI = 1e13; max_TAI = 0;
    for (file_num = 1; file_num <= num_files; file_num++) {
    FilesToRead[file_num].hdffile=open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname);
    if(!((hdffile<0)&&((hdffile&0xffffff00)!=otd_NoMetadata))){
    	if(((hdffile&0xffffff00)==otd_NoMetadata))hdffile = hdffile^otd_NoMetadata;
/*	if ((FilesToRead[file_num].hdffile = open_OTD_HDF_READONLY(FilesToRead[file_num].hdfname))==otd_SUCCESS) {	     
*/
	    total_oas = get_total_otd_orbit_attribute();
	    for (oa=0; oa<total_oas; oa++) {
		read_otd_orbit_attributes_struct(&anorbitattribute, oa); 
		if (anorbitattribute.TAI93_end > 
		    anorbitattribute.TAI93_start+6099.)
			anorbitattribute.TAI93_end = anorbitattribute.TAI93_start+6099;
		if (anorbitattribute.TAI93_start < min_TAI) min_TAI = anorbitattribute.TAI93_start;
		if (anorbitattribute.TAI93_end > max_TAI)   max_TAI = anorbitattribute.TAI93_end;
	    }
	    close_OTD_HDF_FILE();
 	}
   }
    Start->TAI93 = min_TAI;
    Start->UTC   = TAI93_to_UTC(min_TAI);
    Stop->TAI93  = max_TAI;
    Stop->UTC    = TAI93_to_UTC(max_TAI);
    return;
}
