#include "liblisotd_read_LISOTD.h"
#include <stdio.h>
/* #include <ansi_fp.h> */
#include <stdio.h>
#include "netcdf.h"
#include "hdf.h"


struct theWriteParams	WriteParams;

struct theSDSFields	SDSFields;
struct anAreaBound	SDSBounds;

void   WriteOTDData(TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev)
struct  anOTDDataset	TheData;
int	output_type;
char	filename[132];
int     dump_or, dump_ar, dump_fl, dump_gr, dump_ev;
{
    union   aFileID FileID;
    long    orbit, area, flash, group, event;
    char indentstr[5][132];
    int dump_flags[5];
    
    if (TheData.num_orbits == 0) {
	fprintf(stderr, "No orbits were found!  File not written.\n");
	return;
    }
    
    dump_flags[O] = (dump_or==O);
    dump_flags[A] = (dump_ar==A);
    dump_flags[F] = (dump_fl==F);
    dump_flags[G] = (dump_gr==G);
    dump_flags[E] = (dump_ev==E);
    
    FileID = OpenFileID(output_type, filename, dump_flags,"OTD");

    switch(output_type) {
	case ASCII_TREE:
	    {
		strcpy(indentstr[O], "\0");
		strcpy(indentstr[A], "\0");
		strcpy(indentstr[F], "\0");
		strcpy(indentstr[G], "\0");
		strcpy(indentstr[E], "\0");
		
		if (dump_flags[O]) {
		    strcat(indentstr[O], "");
		    strcat(indentstr[A], INDSTR);
		    strcat(indentstr[F], INDSTR);
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		}
		if (dump_flags[A]) {
		    strcat(indentstr[A], "");
		    strcat(indentstr[F], INDSTR);
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[F]) {
		    strcat(indentstr[F], "");
		    strcat(indentstr[G], INDSTR);
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[G]) {
		    strcat(indentstr[G], "");
		    strcat(indentstr[E], INDSTR);
		};
		if (dump_flags[E]) {
		    strcat(indentstr[E], "");
		};
		for (orbit = 0; orbit < TheData.num_orbits; orbit++) {
		    if (dump_flags[O]) {
			Write_Orbit_ASCII(FileID.out_stream[T], indentstr[O], orbit, TheData);
		    }
		    for (area = TheData.Orbits[orbit].FirstArea; area <  TheData.Orbits[orbit].FirstArea +
									 TheData.Orbits[orbit].NumChildren; area++) {
			if (dump_flags[A]) {
				Write_Area_ASCII(FileID.out_stream[T], indentstr[A], area, TheData);
			}
			for (flash=TheData.Areas[area].FirstFlash; flash<=TheData.Areas[area].LastFlash; flash++) {
			    if (dump_flags[F]) {
				    Write_Flash_ASCII(FileID.out_stream[T], indentstr[F], flash, TheData);
			    }
			    for (group=TheData.Flashes[flash].FirstGroup; group<=TheData.Flashes[flash].LastGroup; group++) {
				    if (dump_flags[G]) {	
					Write_Group_ASCII(FileID.out_stream[T], indentstr[G], group, TheData);
				    }
				    for (event=TheData.Groups[group].FirstEvent; event<=TheData.Groups[group].LastEvent; event++) {
					if (dump_flags[E]) {
					    Write_Event_ASCII(FileID.out_stream[T], indentstr[E], event, TheData);
					}
				    }
			    }
			}
		    }
		}
		break;
	    }
	case ASCII_SINGLE:
	    {
		if (dump_flags[O]) {
		    strcpy(indentstr[O], "");
		    for (orbit = 0; orbit < TheData.num_orbits; orbit++)
			Write_Orbit_ASCII(FileID.out_stream[O], indentstr[O], orbit, TheData);
		    fflush(FileID.out_stream[O]);
		}
		if (dump_flags[A]) {
		    strcpy(indentstr[A], "");
		    for (area = 0; area < TheData.num_areas; area++) 
			Write_Area_ASCII(FileID.out_stream[A], indentstr[A], area, TheData);
		    fflush(FileID.out_stream[A]);
		}
		if (dump_flags[F]) {
		    strcpy(indentstr[F], "");
		    for (flash = 0; flash < TheData.num_flashes; flash++)
			Write_Flash_ASCII(FileID.out_stream[F], indentstr[F], flash, TheData);
		    fflush(FileID.out_stream[F]);
		}
		if (dump_flags[G]) {
		    strcpy(indentstr[G], "");
		    for (group = 0; group < TheData.num_groups; group++)
		        Write_Group_ASCII(FileID.out_stream[G], indentstr[G], group, TheData);
		    fflush(FileID.out_stream[G]);
		}
		if (dump_flags[E]) {
		    strcpy(indentstr[E], "");
		    for (event = 0; event < TheData.num_events; event++)
			Write_Event_ASCII(FileID.out_stream[E], indentstr[E], event, TheData);
		    fflush(FileID.out_stream[E]);
		}
		break;
	    }
	case BINARY:
	    {
		if (dump_flags[A]) Write_Binary_Browse(TheData, A, FileID.out_stream[A], TheData.num_areas, 0);
		if (dump_flags[F]) Write_Binary_Browse(TheData, F, FileID.out_stream[F], TheData.num_flashes, 0);
		if (dump_flags[G]) Write_Binary_Browse(TheData, G, FileID.out_stream[G], TheData.num_groups, 0);
		if (dump_flags[E]) Write_Binary_Browse(TheData, E, FileID.out_stream[E], TheData.num_events, 0);
		break;
	    }
	case MINI_HDF:
	    {
		Write_Mini_HDF(TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev);
		break;
	    }
	case SDS:
	    {
		WriteSDS(TheData, filename);
		break;
	    }
        case METADATA:
	    {
		WriteMetadata(&TheData, FileID.out_stream[M]);
		break;
	    }
	
    }
    CloseFileID(FileID, output_type, dump_flags);
    return;
}

void Write_Binary_Browse(TheData, type, outfile, num_elements, num_gaps)
struct anOTDDataset TheData;
int type;
FILE *outfile;
long num_elements, num_gaps;
{
    long		    *times;
    float		    *lats,  *lons;
    long		    idx;
    
    times = (long *)calloc(num_elements, sizeof(long));
    lats  = (float *)calloc(num_elements, sizeof(float));
    lons  = (float *)calloc(num_elements, sizeof(float));
        
    switch(type) {
	case A: 
	    {
		for (idx=0; idx<num_elements; idx++) {
		    times[idx] = (long)TheData.Areas[idx].HDFArea.TAI93;
		    lats[idx]  = (float)(TheData.Areas[idx].HDFArea.cent[0]);
		    lons[idx]  = (float)(TheData.Areas[idx].HDFArea.cent[1]);
		}
		break;
	    }
	case F:
	    {
		for (idx=0; idx<num_elements; idx++) {
		    times[idx] = (long)TheData.Flashes[idx].HDFFlash.TAI93;
		    lats[idx]  = (float)(TheData.Flashes[idx].HDFFlash.cent[0]);
		    lons[idx]  = (float)(TheData.Flashes[idx].HDFFlash.cent[1]);
		}
		break;
	    }
	case G:
	    {
		for (idx=0; idx<num_elements; idx++) {
		    times[idx] = (long)TheData.Groups[idx].HDFGroup.TAI93;
		    lats[idx]  = (float)(TheData.Groups[idx].HDFGroup.cent[0]);
		    lons[idx]  = (float)(TheData.Groups[idx].HDFGroup.cent[1]);
		}
		break;
	    }
	case E:
	    {
		for (idx=0; idx<num_elements; idx++) {
		    times[idx] = (long)TheData.Events[idx].HDFEvent.TAI93;
		    lats[idx]  = (float)(TheData.Events[idx].HDFEvent.location[0]);
		    lons[idx]  = (float)(TheData.Events[idx].HDFEvent.location[1]);
		}
		break;
	    }
    }
    

    Write_Binary_Header1(TheData, outfile, 1, num_elements, 0);
    Write_Binary_Header2(TheData, outfile, num_elements, "TAI93", 0);
    Write_Binary_Data(outfile, num_elements, times);
    Write_Binary_FData(outfile, num_elements, lats);
    Write_Binary_FData(outfile, num_elements, lons);
    
    free(times);
    free(lats);
    free(lons);
}

void Write_Binary_Header1(TheData, outfile, num_granules, total_elements, total_gaps)
struct anOTDDataset TheData;
FILE *outfile;
long num_granules, total_elements, total_gaps;
{
    fwrite(&num_granules,    sizeof(long), 1, outfile);
    fwrite(&total_elements,  sizeof(long), 1, outfile);
    fwrite(&total_gaps,	     sizeof(long), 1, outfile);
    return;
}

void Write_Binary_Header2(TheData, outfile, num_elements, time_format, num_gaps)
struct anOTDDataset TheData;
FILE *outfile;
long num_elements, num_gaps;
char time_format[8];
{
    long idx, start_time, end_time;
    
    fwrite(&num_elements,   sizeof(long),	    1,	outfile);
    fwrite(time_format,     sizeof(unsigned char),  8,	outfile);
    fwrite(&num_gaps,	    sizeof(long),	    1,	outfile);
    for (idx = 0; idx < num_gaps; idx++) {
	start_time = (long)(TheData.Gaps[idx].Start.TAI93);
	end_time   = (long)(TheData.Gaps[idx].End.TAI93);
	fwrite(&start_time,  sizeof(long),	    1,	outfile);
	fwrite(&end_time,    sizeof(long),	    1,	outfile);
    }
    return;
}

void Write_Binary_Data(outfile, num_elements, binary_data)
FILE *outfile;
long num_elements;
long *binary_data;
{
    fwrite(binary_data,	    sizeof(long),   num_elements, outfile); 
    return;
}

void Write_Binary_FData(outfile, num_elements, binary_data)
FILE *outfile;
long num_elements;
float *binary_data;
{
    fwrite(binary_data,	    sizeof(float),  num_elements, outfile);
    return;
}

void WriteMetadata(TheData, outfile)
struct anOTDDataset *TheData;
FILE *outfile;
{
    long md;
    
    for (md=0; md < TheData->num_metadata; md++) {
	fprintf(outfile, "%s\n", TheData->Metadata[md].metadata);
    }
    return;    
    
}

void Write_Orbit_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct anOTDDataset	TheData;
{

    
    fprintf(outfile, "%s", indstr);
    fprintf(outfile, "%07ld  %14.3lf  %14.3lf   %5.0lf   %5ld %5ld  Thr:%5ld Bg:%5ld Vt:%5ld Eph:%5ld\n", idx, TheData.Orbits[idx].Attributes.TAI93_start, 
	    TheData.Orbits[idx].Attributes.TAI93_end, (TheData.Orbits[idx].Attributes.TAI93_end-TheData.Orbits[idx].Attributes.TAI93_start), 
	    TheData.Orbits[idx].NumChildren, TheData.Orbits[idx].Areas_Rejected, TheData.Orbits[idx].num_thresholds, TheData.Orbits[idx].num_backgrounds, TheData.Orbits[idx].num_viewtimes, 
	    TheData.Orbits[idx].num_ephemeris);
}

void Write_Area_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct anOTDDataset  TheData;
{
    int idx2, thr;
    struct CArea	data;
    long    idx3, orb;
	int yroffset;

    data = TheData.Areas[idx];
	
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Area.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Area.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = GetThreshold(&TheData, -1, data.HDFArea.TAI93);
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case VIEW_TIME:
		{
		    idx3 = LatLon2Grid(data.HDFArea.cent[0], data.HDFArea.cent[1], 0.5);
		    orb = data.Orbit;
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
			(int)TheData.Orbits[orb].ViewTimeGrid[idx3]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
			(int)TheData.Orbits[orb].ViewTimeGrid[idx3]);
		    }
		    break;
		}
	    case TIME_UTC: 
		{
			yroffset = 1900;
			if (data.UTC.year >= 2000) {
				yroffset = 2000;
			}
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.HDFArea.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, data.HDFArea.TAI93);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.HDFArea.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, data.HDFArea.TAI93);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.HDFArea.cent[0], (float)data.HDFArea.cent[1]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.cent[0], data.HDFArea.cent[1]);
		    }
		    break;		    
		}
	    case DURATION:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile,"%6.3lf ",
				    data.HDFArea.delta);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.delta);
		    }
		    break;
		}
	    case D_N_T:  
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFArea.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.d_n_t);
		    }
		    break;		   
		}
	    case ORBIT_NUM:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    data.HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.orbit_id);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Flashes_Accepted);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.Flashes_Accepted);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Flashes_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.Flashes_Rejected);
		    }
		    break;		   
		}
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFArea.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFArea.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFArea.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Area.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFArea.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Area.Param[idx2].CFormat, 
				    data.HDFArea.QA[3]);
		    }
		    break;		   
		}	
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_Flash_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct anOTDDataset TheData;
{
    int idx2, thr;
    struct CFlash	data;
    char outstr[132];
    double dum;
	int yroffset;
    
    data = TheData.Flashes[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Flash.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Flash.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = GetThreshold(&TheData, -1, data.HDFFlash.TAI93);
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{
			yroffset = 1900;
                        if (data.UTC.year >= 2000) {
                                yroffset = 2000;
                        }
 
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
		    sprintf(outstr,  "%02d  %03d  %02d %02d  %02d %02d %6.3f ", 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, (float)data.UTC.second);
			fprintf(outfile, "%s", outstr);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, (float)data.UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3f ", data.HDFFlash.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, (float)data.HDFFlash.TAI93);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3f ", (float)TAI93_to_GPS+data.HDFFlash.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, TAI93_to_GPS+data.HDFFlash.TAI93);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2f  %7.2f ", 
				    (float)data.HDFFlash.cent[0], (float)data.HDFFlash.cent[1]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.cent[0], data.HDFFlash.cent[1]);
		    }
		    break;		    
		}
	    case DURATION:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile,"%6.3f ",
				    (float)data.HDFFlash.delta);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.delta);
		    }
		    break;
		}
	    case D_N_T:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFFlash.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.d_n_t);
		    }
		    break;		   
		}
	    case ORBIT_NUM:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Groups_Accepted);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.Groups_Accepted);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Groups_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.Groups_Rejected);
		    }
		    break;		   
		}
	    case ENERGY:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2e", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, data.energy);
		    }
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
	    case SIZE:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4.0f ", (float)data.size);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, (float)data.size);
		    }
		    break;
		}
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFFlash.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFFlash.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFFlash.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Flash.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFFlash.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Flash.Param[idx2].CFormat, 
				    data.HDFFlash.QA[3]);
		    }
		    break;		   
		}	
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_Group_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct anOTDDataset TheData;
{
    int idx2, thr;
    struct CGroup	data;
	int yroffset;
    
    data = TheData.Groups[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Group.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Group.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = GetThreshold(&TheData, -1, data.HDFGroup.TAI93);
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{
                      yroffset = 1900;
                        if (data.UTC.year >= 2000) {
                                yroffset = 2000;
                        }
 
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.HDFGroup.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.HDFGroup.TAI93);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.HDFGroup.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, TAI93_to_GPS+data.HDFGroup.TAI93);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.HDFGroup.cent[0], (float)data.HDFGroup.cent[1]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.cent[0], data.HDFGroup.cent[1]);
		    }
		    break;		    
		}
	    case D_N_T:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFGroup.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.d_n_t);
		    }
		    break;		   
		}
	    case ORBIT_NUM:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_ACCEPTED:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Events_Accepted);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.Events_Accepted);
		    }
		    break;		   
		}
	    case NUM_CHILDREN_REJECTED:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.Events_Rejected);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.Events_Rejected);
		    }
		    break;		   
		}
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFGroup.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFGroup.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFGroup.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFGroup.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, 
				    data.HDFGroup.QA[3]);
		    }
		    break;		   
		}	
	    case ENERGY:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.energy);
		    }
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Group.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Group.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void Write_Event_ASCII(outfile, indstr, idx, TheData)
FILE *outfile;
char indstr[132];
long idx;
struct anOTDDataset TheData;
{
    int idx2, thr;
    struct CEvent	data;
	int yroffset;
    
    data = TheData.Events[idx];
    
    fprintf(outfile, "%s", indstr);
    for (idx2=0; idx2 < WriteParams.Event.NumParams; idx2++) {
        fprintf(outfile, " ");
	switch (WriteParams.Event.Param[idx2].Var) {
	    case INDEX:
		{
		    fprintf(outfile, "%05ld", idx);
		    break;
		}
	  	case THRESH:
		{
			thr = GetThreshold(&TheData, -1, data.HDFEvent.TAI93);
			fprintf(outfile,"%3d", thr);
			break;
		}
	    case TIME_UTC: 
		{
			                      yroffset = 1900;
                        if (data.UTC.year >= 2000) {
                                yroffset = 2000;
                        }
 
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%02d  %03d  %02d %02d  %02d %02d %6.3lf ", 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
			    data.UTC.year-yroffset, data.UTC.doy, data.UTC.month, data.UTC.day, 
			    data.UTC.hour, data.UTC.minute, data.UTC.second);
		    }
		    break;
		}
	    case TIME_TAI93:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", data.HDFEvent.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.HDFEvent.TAI93);
		    }
		    break;
		}
	    case TIME_GPS:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%14.3lf ", TAI93_to_GPS+data.HDFEvent.TAI93);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, TAI93_to_GPS+data.HDFEvent.TAI93);
		    }
		    break;
		}
            case POSITION:
	    case LOCATION:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%6.2lf  %7.2lf ", 
				    (float)data.HDFEvent.location[0], (float)data.HDFEvent.location[1]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.location[0], data.HDFEvent.location[1]);
		    }
		    break;		    
		}
	    case D_N_T:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, " %c ", 
				    data.HDFEvent.d_n_t);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.d_n_t);
		    }
		    break;		   
		}
	    case ORBIT_NUM:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%06ld", 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    TheData.Areas[data.Parent].HDFArea.orbit_id);
		    }
		    break;		   
		}
	    case QUAL_PROB:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFEvent.QA[0]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[0]);
		    }
		    break;		   
		}	
	    case QUAL_GLINT:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%3d", 
				    data.HDFEvent.QA[1]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[1]);
		    }
		    break;		   
		}
	    case QUAL_SNR:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%4d", 
				    data.HDFEvent.QA[2]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[2]);
		    }
		    break;		   
		}	
	    case QUAL_TAC:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%5d", 
				    data.HDFEvent.QA[3]);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, 
				    data.HDFEvent.QA[3]);
		    }
		    break;		   
		}	
	    case ENERGY:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.energy);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.energy);
		    }
		    break;
		}
	    case RADIANCE:
		{
		    if (!strcmp(WriteParams.Event.Param[idx2].CFormat, DEFAULT)) {
			fprintf(outfile, "%8.2le", data.radiance);
		    } else {
			fprintf(outfile, WriteParams.Event.Param[idx2].CFormat, data.radiance);
		    }
		    break;
		}
	}
    }
    fprintf(outfile, "\n"); 
    return;
}

void WriteSDS(TheData, filename)
struct anOTDDataset TheData;
char filename[132];
{
	extern struct anAreaBound SDSBounds;
    long num_or, area, flash, group, event;
    int lat_size, lon_size, gridlat, gridlon, gridx, gridy;
    double  lon_binsize, lat_binsize, lon_min, lon_max, lat_min, lat_max;
    float32 *lonptr, *latptr, *grid;

    char sdsname[132], sdstitle[132];
    long    idx, orb;
    intn    rank;
    int32   dims[2];
    int	    egfa;
    int	    first_SDS = TRUE;
    float32 *xptr, *yptr;
    long    image;
    struct  aUTCDateTime    image_UTC;
    extern  struct theMetadataHandling  HandleMetadata;
    extern  char    OutFilePath[132];
    struct  anSDS	*oldgrid, *newgrid;
    
    oldgrid = (struct anSDS *)calloc(1,sizeof(struct anSDS));
    newgrid = (struct anSDS *)calloc(1,sizeof(struct anSDS));
    
    num_or = TheData.num_orbits;
    
    lon_min = -180.0; lon_max = 180.0;
    lat_min = -90.0;  lat_max = 90.0;
    sprintf(sdsname, "%s%s.sds.hdf", OutFilePath, filename);
    if (SDSFields.HiresBrowse) {
    	puts("Writing SDS Hi Res Browse");
    	lon_binsize = 0.5;
    	lat_binsize = 0.5;
		lat_size = (int)((lat_max-lat_min)/lat_binsize);
		lon_size = (int)((lon_max-lon_min)/lon_binsize);
		rank = 2;
		oldgrid->dims[0] = lat_size;
		oldgrid->dims[1] = lon_size;
		oldgrid->lonptr = (float32 *)calloc(lon_size, sizeof(float32));
		oldgrid->latptr = (float32 *)calloc(lat_size, sizeof(float32));
		for (gridlon=0; gridlon <= lon_size-1; gridlon++)
		    oldgrid->lonptr[gridlon] = (float32)((lon_min+(lon_binsize/2.))+(double)gridlon*lon_binsize);
		for (gridlat=lat_size-1; gridlat >= 0; gridlat--)
		    oldgrid->latptr[gridlat] = (float32)((lat_min+(lat_binsize/2.))+(double)(lat_size-gridlat-1)*lat_binsize);
	    puts("Recalculating count grids");
	    for (egfa = 0; egfa < 4; egfa++) {
	    	oldgrid->grid = (float32 *)calloc(lat_size*lon_size, sizeof(float32));
	    	switch (egfa) {
	    		        case 3: {
	    			for (area = 0; area < TheData.num_areas; area++) {
	    				gridlon = (int)((TheData.Areas[area].HDFArea.cent[1]-lon_min)/lon_binsize);
	    				gridlat = (int)((TheData.Areas[area].HDFArea.cent[0]-lat_min)/lat_binsize);
	    				oldgrid->grid[gridlon+(lat_size-gridlat-1)*lon_size] += 1;
	    			}
	    			sprintf(sdstitle, "Hi res Area count");
					break;
				}
				case 2: {
					for (flash = 0; flash < TheData.num_flashes; flash++) {
	    				gridlon = (int)((TheData.Flashes[flash].HDFFlash.cent[1]-lon_min)/lon_binsize);
	    				gridlat = (int)((TheData.Flashes[flash].HDFFlash.cent[0]-lat_min)/lat_binsize);
	    				oldgrid->grid[gridlon+(lat_size-gridlat-1)*lon_size] += 1;
	    			}
	    			sprintf(sdstitle, "Hi res Flash count");
					break;
				}
				case 1: {
					for (group = 0; group < TheData.num_groups; group++) {
	    				gridlon = (int)((TheData.Groups[group].HDFGroup.cent[1]-lon_min)/lon_binsize);
	    				gridlat = (int)((TheData.Groups[group].HDFGroup.cent[0]-lat_min)/lat_binsize);
	    				oldgrid->grid[gridlon+(lat_size-gridlat-1)*lon_size] += 1;
	    			}
	    			sprintf(sdstitle, "Hi res Group count");
					break;
				}
				case 0: {
					for (event = 0; event < TheData.num_events; event++) {
	    				gridlon = (int)((TheData.Events[event].HDFEvent.location[1]-lon_min)/lon_binsize);
	    				gridlat = (int)((TheData.Events[event].HDFEvent.location[0]-lat_min)/lat_binsize);
	    				oldgrid->grid[gridlon+(lat_size-gridlat-1)*lon_size] += 1;
	    			}
	    			sprintf(sdstitle, "Hi res Event count");
					break;
				}
			}
			if (SDSBounds.Active) {
				ReduceSDS(oldgrid, newgrid);
				DFSDsetNT(DFNT_FLOAT32);
			    DFSDsetdims(rank, newgrid->dims);
			    DFSDsetdimstrs(1, "Latitude", "deg", "F6.2");
			    DFSDsetdimstrs(2, "Longitude", "deg", "F7.2");
			    DFSDsetdimscale(1, newgrid->dims[0], (void *)newgrid->latptr);
			    DFSDsetdimscale(2, newgrid->dims[1], (void *)newgrid->lonptr);
				DFSDsetdatastrs(sdstitle, "counts", "F6.0", "-");
			    if (first_SDS) {
					DFSDputdata(sdsname, 2, newgrid->dims, (void *)newgrid->grid);
					first_SDS = FALSE;
			    }
			    else {
					DFSDadddata(sdsname, 2, newgrid->dims, (void *)newgrid->grid);
			    }		   
			    free(newgrid->grid);
			    free(oldgrid->grid);
			} else {
				DFSDsetNT(DFNT_FLOAT32);
			    DFSDsetdims(rank, oldgrid->dims);
			    DFSDsetdimstrs(1, "Latitude", "deg", "F6.2");
			    DFSDsetdimstrs(2, "Longitude", "deg", "F7.2");
			    DFSDsetdimscale(1, oldgrid->dims[0], (void *)oldgrid->latptr);
			    DFSDsetdimscale(2, oldgrid->dims[1], (void *)oldgrid->lonptr);
				DFSDsetdatastrs(sdstitle, "counts", "F6.0", "-");
			    if (first_SDS) {
					DFSDputdata(sdsname, 2, oldgrid->dims, (void *)oldgrid->grid);
					first_SDS = FALSE;
			    }
			    else {
					DFSDadddata(sdsname, 2, oldgrid->dims, (void *)oldgrid->grid);
			    }		    
			    free(oldgrid->grid);
			}
	    }
	}
    if (SDSFields.Browse) {
    	puts("Writing SDS Browse");
		lon_binsize = 2.5;
		lat_binsize = 2.5;
		lat_size = (int)((lat_max-lat_min)/lat_binsize);
		lon_size = (int)((lon_max-lon_min)/lon_binsize);
		rank = 2;
		dims[0] = lat_size;
		dims[1] = lon_size;
		lonptr = (float32 *)calloc(lon_size, sizeof(float32));
		latptr = (float32 *)calloc(lat_size, sizeof(float32));
		for (gridlon=0; gridlon <= lon_size-1; gridlon++)
		    lonptr[gridlon] = (float32)((lon_min+(lon_binsize/2.))+(double)gridlon*lon_binsize);
		for (gridlat=lat_size-1; gridlat >= 0; gridlat--)
		    latptr[gridlat] = (float32)((lat_min+(lat_binsize/2.))+(double)(lat_size-gridlat-1)*lat_binsize);
	    
		for (egfa = 0; egfa < 4; egfa++) {
		    grid = (float32 *)calloc(lat_size*lon_size, sizeof(float32));
		    for (orb = 0; orb<num_or; orb++) {
			for (idx = 0; idx < 10368; idx++) {
				gridlon = (int)((TheData.Orbits[orb].Browse[idx].location[1]-lon_min)/lon_binsize);
				gridlat = (int)((TheData.Orbits[orb].Browse[idx].location[0]-lat_min)/lat_binsize);
				if (TheData.Orbits[orb].Browse[idx].EGFA[egfa] > 0) {
	    			    grid[gridlon+(lat_size-gridlat-1)*lon_size] +=
					(float32)(TheData.Orbits[orb].Browse[idx].EGFA[egfa]);
				}
			}
		    }
		    DFSDsetNT(DFNT_FLOAT32);
		    DFSDsetdims(rank, dims);
		    DFSDsetdimstrs(1, "Latitude", "deg", "F6.2");
		    DFSDsetdimstrs(2, "Longitude", "deg", "F7.2");
		    DFSDsetdimscale(1, dims[0], (void *)latptr);
		    DFSDsetdimscale(2, dims[1], (void *)lonptr);
		    switch (egfa) {
			case 0:
			    {
				sprintf(sdstitle, "Event count");
				break;
			    }
			case 1:
			    {
				sprintf(sdstitle, "Group count");
				break;
			    }
			case 2:
			    {
				sprintf(sdstitle, "Flash count");
				break;
			    }
			case 3:
			    {
				sprintf(sdstitle, "Area count");
				break;
			    }
		    }
		    DFSDsetdatastrs(sdstitle, "counts", "F6.0", "-");
		    if (first_SDS) {
			DFSDputdata(sdsname, 2, dims, (void *)grid);
			first_SDS = FALSE;
		    }
		    else {
			DFSDadddata(sdsname, 2, dims, (void *)grid);
		    }
		    
		    free(grid);
		}
		free(latptr);
		free(lonptr);
	    
    }
    
    /* Viewtime grid */
    
    if (SDSFields.Viewtime) {
    	puts("Writing SDS Viewtimes");

		lon_binsize = 0.5;
		lat_binsize = 0.5;
		lat_size = (int)((lat_max-lat_min)/lat_binsize);
		lon_size = (int)((lon_max-lon_min)/lon_binsize);
		rank = 2;
		oldgrid->dims[0] = lat_size;
		oldgrid->dims[1] = lon_size;
		oldgrid->lonptr = (float32 *)calloc(lon_size, sizeof(float32));
		oldgrid->latptr = (float32 *)calloc(lat_size, sizeof(float32));
		for (gridlon=0; gridlon <= lon_size-1; gridlon++)
		    oldgrid->lonptr[gridlon] = (float32)((lon_min+(lon_binsize/2.))+(double)gridlon*lon_binsize);
		for (gridlat=lat_size-1; gridlat >= 0; gridlat--)
		    oldgrid->latptr[gridlat] = (float32)((lat_min+(lat_binsize/2.))+(double)(lat_size-gridlat-1)*lat_binsize);
		oldgrid->grid = (float32 *)calloc(lat_size*lon_size, sizeof(float32));
		for (orb = 0; orb < num_or; orb++) {
		    for (idx = 0; idx < TheData.Orbits[orb].num_viewtimes; idx++) {
			gridlon = (int)((TheData.Orbits[orb].ViewTimes[idx].grid_point[1] -  lon_min)/lon_binsize);
			gridlat = (int)((TheData.Orbits[orb].ViewTimes[idx].grid_point[0] -  lat_min)/lat_binsize);
			oldgrid->grid[gridlon+(lat_size-gridlat-1)*lon_size] +=
			    (float32)(TheData.Orbits[orb].ViewTimes[idx].duration);
		    }
		}
		if (SDSBounds.Active) {
			ReduceSDS(oldgrid, newgrid);
			DFSDsetNT(DFNT_FLOAT32);
		    DFSDsetdims(rank, newgrid->dims);
		    DFSDsetdimstrs(1, "Latitude", "deg", "F6.2");
		    DFSDsetdimstrs(2, "Longitude", "deg", "F7.2");
		    DFSDsetdimscale(1, newgrid->dims[0], (void *)newgrid->latptr);
		    DFSDsetdimscale(2, newgrid->dims[1], (void *)newgrid->lonptr);
		    sprintf(sdstitle, "Viewtime");
		    DFSDsetdatastrs(sdstitle, "seconds", "F6.0", "-");
		    if (first_SDS) {
				DFSDputdata(sdsname, 2, newgrid->dims, (void *)newgrid->grid);
				first_SDS = FALSE;
		    }
		    else {
				DFSDadddata(sdsname, 2, newgrid->dims, (void *)newgrid->grid);
		    }		   
		    free(newgrid->grid);
		    free(oldgrid->grid); 
		} else {
			DFSDsetNT(DFNT_FLOAT32);
		    DFSDsetdims(rank, oldgrid->dims);
		    DFSDsetdimstrs(1, "Latitude", "deg", "F6.2");
		    DFSDsetdimstrs(2, "Longitude", "deg", "F7.2");
		    DFSDsetdimscale(1, oldgrid->dims[0], (void *)oldgrid->latptr);
		    DFSDsetdimscale(2, oldgrid->dims[1], (void *)oldgrid->lonptr);
	    	sprintf(sdstitle, "Viewtime");
		    DFSDsetdatastrs(sdstitle, "seconds", "F6.0", "-");
	
		    if (first_SDS) {
				DFSDputdata(sdsname, 2, oldgrid->dims, (void *)oldgrid->grid);
				first_SDS = FALSE;
		    }
		    else {
				DFSDadddata(sdsname, 2, oldgrid->dims, (void *)oldgrid->grid);
		    }		    
		    free(oldgrid->grid); 
		}

    }
    
    if (SDSFields.Images && HandleMetadata.Images) {
    	puts("Writing SDS Images");
		rank = 2;
		dims[0] = 128;
		dims[1] = 128;
		xptr = (float32 *)calloc(128, sizeof(float32));
		yptr = (float32 *)calloc(128, sizeof(float32));
		for (gridx = 0; gridx < 128; gridx++) xptr[gridx] = gridx;
		for (gridy = 0; gridy < 128; gridy++) yptr[gridy] = gridy;
		DFSDsetNT(DFNT_FLOAT32);
		DFSDsetdims(rank, dims);
		DFSDsetdimstrs(1, "y", "pixel", "F3.0");
		DFSDsetdimstrs(2, "x", "pixel", "F3.0");
		DFSDsetdimscale(1, dims[0], (void *)yptr);
		DFSDsetdimscale(2, dims[1], (void *)xptr);
	
		for (orb = 0; orb < num_or; orb++) {
		    for (image = 0; image < TheData.Orbits[orb].num_backgrounds; image++) {
				image_UTC = TAI93_to_UTC(TheData.Orbits[orb].Backgrounds[image].ImageAttribute.TAI93);
				sprintf(sdstitle, "Orbit%02d_Time_%02d_%03d_%02d_%02d_%02d", 
				    				orb, image_UTC.year-1900, image_UTC.doy, image_UTC.hour, image_UTC.minute, (int)image_UTC.second);
				DFSDsetdatastrs(sdstitle, "counts", "I3", "-");
				grid = (float32 *)calloc(128*128, sizeof(float32));
				for (gridx = 0; gridx < 16384; gridx++) 
					grid[gridx] = (float32)(TheData.Orbits[orb].Backgrounds[image].Image[gridx]);
				puts(sdstitle);
				if (first_SDS) {
				    DFSDputdata(sdsname, 2, dims, (void *)grid);
				    first_SDS = FALSE;
				} else {
				    DFSDadddata(sdsname, 2, dims, (void *)grid);
				}
		    }
		}
		free(grid);
		free(xptr);
		free(yptr);
    }
    
    
}

void   Write_Mini_HDF(TheData, output_type, filename, dump_or, dump_ar, dump_fl, dump_gr, dump_ev)
struct  anOTDDataset	TheData;
int	output_type;
char	filename[132];
int     dump_or, dump_ar, dump_fl, dump_gr, dump_ev;
{
    long num_or=0, num_ar=0, num_fl=0, num_gr=0, num_ev=0, num_md =0;
    extern struct theMetadataHandling	HandleMetadata;
    unsigned char outbuf[128], outerbuf[12200], empty[128];
    short int *emptyimage;
    int   multievent = FALSE;
    long thresh;
    long orbit, area, flash, group, event, md;
    long browse, image, grid, viewtime, ephem, rate;
    long areas_written=0, flashes_written=0, groups_written=0, events_written=0, 
	 browses_written=0, images_written=0, image_attributes_written=0, 
	 grids_written=0, viewtimes_written=0, ephemeris_written=0, thresholds_written=0;
    long orbits_written=0, rates_written=0;
    struct otd_AREA dummy_area;
    struct otd_FLASH dummy_flash;
    struct otd_GROUP dummy_group;
    struct otd_EVENT dummy_event,  dummy_event2;


    emptyimage = (short int *)calloc(16384, sizeof(short int));
    
    num_or = TheData.num_orbits;
    num_ar = TheData.num_areas;
    num_fl = TheData.num_flashes;
    num_gr = TheData.num_groups;
    num_ev = TheData.num_events;    
    num_md = TheData.num_metadata;

    if ((!dump_ar && !dump_fl && !dump_gr && !dump_ev) || 
        ((num_ar <= 1) && (num_fl <= 1) && (num_gr <= 1) && (num_ev <= 1)))
    {
	/* Either no point data requested for output or a single-event
	 *  file is requested.  No-can-do.  Replace with a dummy tree
	 *  with a single multi-event flash to prevent software crashes
	 *  the next time this file is read.
	 */
	if (!dump_ar && !dump_fl && !dump_gr && !dump_ev) {
	    puts("Metadata-only HDF file requested.");
	} else {
	    puts("No point data passed the selected filter criteria.");
	}
	dummy_area.seq = 0;
	dummy_area.TAI93 = -999.;
	dummy_area.delta = 0.0;
	dummy_area.view  = 0.0;
	dummy_area.s_z_a = 0;
	dummy_area.d_n_t = 'x';
	dummy_area.events = 2;
	dummy_area.cent[0] = -999.;
	dummy_area.cent[1] = -999.;
	dummy_area.stdev[0] = 0.0;
	dummy_area.stdev[1] = 0.0;
	dummy_area.rad = 0.0;
	dummy_area.orbit_id = 0;
	dummy_area.day = 0;
	dummy_area.children = 1;
	dummy_area.child_seq = 0;
	dummy_area.child_rec = 0;
	dummy_area.QA[0] = dummy_area.QA[1] = dummy_area.QA[2] = dummy_area.QA[3] = 0;
	dummy_flash.seq = 0;
	dummy_flash.TAI93 = -999.;
	dummy_flash.delta = 0.0;
	dummy_flash.view = 0.0;
	dummy_flash.s_z_a = 0;
	dummy_flash.d_n_t = 'x';
	dummy_flash.events = 2;
	dummy_flash.cent[0] = -999.;
	dummy_flash.cent[1] = -999.;
	dummy_flash.stdev[0] = 0.0;
	dummy_flash.stdev[1] = 0.0;
	dummy_flash.rad = 0.0;
	dummy_flash.parent_seq = 0;
	dummy_flash.parent_rec = 0;
	dummy_flash.children = 1;
	dummy_flash.child_seq = 0;
	dummy_flash.child_rec = 0;
	dummy_flash.QA[0] = dummy_flash.QA[1] = dummy_flash.QA[2] = dummy_flash.QA[3] = 0;
	dummy_group.seq = 0;
	dummy_group.TAI93 = -999.;
	dummy_group.delta = 0.0;
	dummy_group.view = 0.0;
	dummy_group.s_z_a = 0;
	dummy_group.d_n_t = 'x';
	dummy_group.events = 2;
	dummy_group.cent[0] = -999.;
	dummy_group.cent[1] = -999.;
	dummy_group.stdev[0] = 0.0;
	dummy_group.stdev[1] = 0.0;
	dummy_group.rad = 0.0;
	dummy_group.children = 2;
	dummy_group.child_seq = 0;
	dummy_group.child_rec = 0;
	dummy_group.QA[0] = dummy_group.QA[1] = dummy_group.QA[2] =
	    dummy_group.QA[3] = 0;
	dummy_event.event_number = 0;
	dummy_event.seq_number = 0;
	dummy_event.TAI93 = -999.;
	dummy_event.s_z_a = 0;
	dummy_event.d_n_t = 'x';
	dummy_event.x_pixel = dummy_event.y_pixel = 0;
	dummy_event.raw_radiance = dummy_event.cal_radiance = 0.0;
	dummy_event.parent_seq = 0;
	dummy_event.parent_rec = 0;
	dummy_event.QA[0] = dummy_event.QA[1] = dummy_event.QA[2] =
	    dummy_event.QA[3] = 0;
	dummy_event.location[0] = -999.;
	dummy_event.location[1] = -999.;
	dummy_event2 = dummy_event;
	dummy_event2.event_number = 1;
	dummy_event2.seq_number = 1;
	Area2Buf(&dummy_area, outbuf);
	write_otd_AREA(outbuf);
	areas_written++;
	printf("Wrote %5ld dummy area to HDF\n", areas_written);
	Flash2Buf(&dummy_flash, outbuf);
	write_otd_FLASH(outbuf);
	flashes_written++;
	printf("Wrote %5ld dummy flash to HDF\n", flashes_written);
	Group2Buf(&dummy_group, outbuf);
	write_otd_GROUP(outbuf);
	groups_written++;
        printf("Wrote %5ld dummy group to HDF\n", groups_written);
	Event2Buf(&dummy_event, outbuf);
	write_otd_EVENT(outbuf);
	events_written++;
	Event2Buf(&dummy_event2, outbuf);
	write_otd_EVENT(outbuf);
	events_written++;
        printf("Wrote %5ld dummy events to HDF\n", events_written);
    } else {
    
	/* Reset pointers ... be sure to recalculate derived params later! */
	
	for (area = 0; area < num_ar; area++) {
	
	    TheData.Areas[area].HDFArea.children = 
		TheData.Areas[area].LastFlash - TheData.Areas[area].FirstFlash + 1;
	    TheData.Areas[area].HDFArea.child_seq =
		TheData.Areas[area].FirstFlash;
	    TheData.Areas[area].HDFArea.child_rec = TheData.Areas[area].FirstFlash;
	    
	    for (flash=TheData.Areas[area].FirstFlash; flash<=TheData.Areas[area].LastFlash; flash++) {
		
		TheData.Flashes[flash].HDFFlash.children =
		    TheData.Flashes[flash].LastGroup - TheData.Flashes[flash].FirstGroup + 1;
		TheData.Flashes[flash].HDFFlash.child_seq = TheData.Flashes[flash].FirstGroup;
		TheData.Flashes[flash].HDFFlash.child_rec = TheData.Flashes[flash].FirstGroup;
		TheData.Flashes[flash].HDFFlash.parent_seq = area;
		TheData.Flashes[flash].HDFFlash.parent_rec = area;
		    
		for (group=TheData.Flashes[flash].FirstGroup; group<=TheData.Flashes[flash].LastGroup; group++) {
    
		    TheData.Groups[group].HDFGroup.children =
			TheData.Groups[group].LastEvent - TheData.Groups[group].FirstEvent + 1;
		    TheData.Groups[group].HDFGroup.child_seq = TheData.Groups[group].FirstEvent;
		    TheData.Groups[group].HDFGroup.child_rec = TheData.Groups[group].FirstEvent;
		    TheData.Groups[group].HDFGroup.parent_seq = flash;
		    TheData.Groups[group].HDFGroup.parent_rec = flash;
		    
		    for (event=TheData.Groups[group].FirstEvent; event<=TheData.Groups[group].LastEvent; event++) {
    
			TheData.Events[event].HDFEvent.parent_seq = group;
			TheData.Events[event].HDFEvent.parent_rec = group;
			
		    }
		}
	    }	
	}
	    
	for (area = 0; area < num_ar; area++) {
	    Area2Buf(&TheData.Areas[area].HDFArea, outbuf);
	    write_otd_AREA(outbuf);
	    areas_written++;
	}
	printf("Wrote %5ld areas to HDF\n", areas_written);
    
	for (flash = 0; flash < num_fl; flash++) {
	    Flash2Buf(&TheData.Flashes[flash].HDFFlash, outbuf);
	    write_otd_FLASH(outbuf);
	    flashes_written++;
	}
	printf("Wrote %5ld flashes to HDF\n", flashes_written);
	
	for (group = 0; group < num_gr; group++) {
	    Group2Buf(&TheData.Groups[group].HDFGroup, outbuf);
	    write_otd_GROUP(outbuf);
	    groups_written++;
	}
	printf("Wrote %5ld groups to HDF\n", groups_written);
    
	for (event = 0; event < num_ev; event++) {
	    Event2Buf(&TheData.Events[event].HDFEvent, outbuf);
	    write_otd_EVENT(outbuf);
	    events_written++;
	}
	printf("Wrote %5ld events to HDF\n", events_written);
	
    }
    
    for (md = 0; md < num_md; md++) {
	write_otd_METADATA(TheData.Metadata[md].metadata);
    }

    for (orbit = 0; orbit < num_or; orbit++) {
	Attribute2Buf(&TheData.Orbits[orbit].Attributes, outbuf);
	write_otd_ORBIT_DATA(outbuf);
	Summary2Buf(&TheData.Orbits[orbit].Summary, outbuf);
	write_otd_ORBIT_SUMMARY(outbuf);
	orbits_written++;
	printf("   Wrote %5ld orbits to HDF\n", orbits_written);

	for (thresh=0; thresh < TheData.Orbits[orbit].num_thresholds; thresh++) {
	    Threshold2Buf(&TheData.Orbits[orbit].Thresholds[thresh], outbuf);
	    write_otd_THRESHOLD(outbuf);
	    thresholds_written++;
	}
	printf("   Wrote %5ld thresholds to HDF\n", thresholds_written);
 
	if (HandleMetadata.Browses) {
	    for (browse=0; browse < 10368; browse++) {
		Browse2Buf(&TheData.Orbits[orbit].Browse[browse], outbuf);
		write_otd_BROWSE_DATA(outbuf);
		browses_written++;
	    }
	}
	printf("   Wrote %5ld browse data to HDF\n", browses_written);
	
	for (image = 0; image < TheData.Orbits[orbit].num_backgrounds; image++) {
	    ImageAttribute2Buf(&TheData.Orbits[orbit].Backgrounds[image].ImageAttribute, outbuf);
	    write_otd_IMAGE_ATTRIBUTE(outbuf);
	    image_attributes_written++;
	    if (HandleMetadata.Images) {
		write_otd_IMAGE(TheData.Orbits[orbit].Backgrounds[image].Image);
		images_written++;
	    }
	}
	printf("   Wrote %5ld image attributes to HDF\n", image_attributes_written);
	printf("   Wrote %5ld images to HDF\n", images_written);

	if (HandleMetadata.Browses) {
	    for (grid = 0; grid < 10368; grid++) {
		Grid2Buf(&TheData.Orbits[orbit].Flash_Density_25[grid], outbuf);
		write_otd_GRID_25(outbuf);
		grids_written++;
	    }
	}
	printf("   Wrote %5ld grids to HDF\n", grids_written);

        if (HandleMetadata.Viewtimes) {
	    for (viewtime = 0; viewtime < TheData.Orbits[orbit].num_viewtimes; viewtime++) {
		ViewTime2Buf(&TheData.Orbits[orbit].ViewTimes[viewtime], outbuf);
		write_otd_VIEW(outbuf);
		viewtimes_written++;
	    }
	}
	printf("   Wrote %5ld view times to HDF\n", viewtimes_written);

	for (ephem = 0; ephem < TheData.Orbits[orbit].num_ephemeris; ephem++) {
	    Ephem2Buf(&TheData.Orbits[orbit].Ephemeris[ephem], outbuf);
	    write_otd_EPHEMERIS(outbuf);
	    ephemeris_written++;
	}
	printf("   Wrote %5ld ephemerises to HDF\n", ephemeris_written);

	for (rate = 0; rate < 19; rate++) {
	    Rate2Buf(&TheData.Orbits[orbit].Event_Rate.Column[rate], outerbuf);
	    write_otd_RATE(outerbuf);
	    rates_written++;
	}
	printf("   Wrote %5ld event rate vectors to HDF\n", rates_written);
    
    }
   
    if (!areas_written) {
	write_otd_AREA(empty); 
	areas_written=1;
    }
    if (!flashes_written) {
       write_otd_FLASH(empty);
       flashes_written=1;
    }
    if (!groups_written) {
       write_otd_GROUP(empty);
       groups_written=1;
    }
    if (!events_written) {
       write_otd_EVENT(empty);
       events_written=1;
    }
    if (!rates_written) {
	write_otd_RATE(empty);
	rates_written=1;
    }
    if (!viewtimes_written) {
	write_otd_VIEW(empty);
	viewtimes_written=1;
    }
    if (!thresholds_written) {
	write_otd_THRESHOLD(empty);
	thresholds_written=1;
    }
    if (!ephemeris_written) {
	write_otd_EPHEMERIS(empty);
	ephemeris_written=1;
    }
    if (!grids_written)	{
        write_otd_GRID_25(empty);
	grids_written=1;
    }
    if (!image_attributes_written) {
	write_otd_IMAGE_ATTRIBUTE(empty);
	image_attributes_written=1;
    }
    if (!browses_written) {
	write_otd_BROWSE_DATA(empty);
	browses_written=1;
    }
    write_otd_METADATA(empty);   
    write_otd_AREA_FLASH_RATE(empty);
    write_otd_VECTOR_PRODUCTS(empty);
    write_otd_GRID_500_KM(empty);
    close_OTD_HDF_FILE();
    free(emptyimage);
    return;
}

void Rate2Buf(rate, buf)
struct anEventRateVector    *rate;
unsigned char buf[12200];
{
    memcpy(&buf[0], &rate->Datum, 12200);    
}


void Ephem2Buf(ephem, buf)
struct otd_EPHEMERIS *ephem;
unsigned char buf[128];
{
    memcpy(&buf[0], &ephem->GPS, 8);
    memcpy(&buf[8], &ephem->kernel, 120);    
}

void Browse2Buf(browse, buf)
struct	otd_BROWSE	*browse;
unsigned char buf[128];
{
    memcpy(&buf[0], &browse->location, 8);
    memcpy(&buf[8], &browse->EGFA, 8);
    memcpy(&buf[16], &browse->EGFA_cal_rad, 16);
    memcpy(&buf[32], &browse->max_rate, 4);
    memcpy(&buf[36], &browse->single_event_areas, 2);
    memcpy(&buf[38], &browse->highres_locs, 2);
    memcpy(&buf[40], &browse->first_highres, 4);
    memcpy(&buf[44], &browse->bkgnds, 4);
    memcpy(&buf[48], &browse->iloper, 2);
    memcpy(&buf[50], &browse->bkgnd_pointer, 4);
    memcpy(&buf[54], &browse->duration, 2);    
}

void ImageAttribute2Buf(imatt, buf)
struct	otd_IMAGE_ATTRIBUTE	*imatt;
unsigned char buf[128];
{
    memcpy(&buf[0], &imatt->TAI93, 8);
    memcpy(&buf[8], &imatt->NW_location, 8);
    memcpy(&buf[16], &imatt->NE_location, 8);
    memcpy(&buf[24], &imatt->SW_location, 8);
    memcpy(&buf[32], &imatt->SE_location, 8);
    memcpy(&buf[40], &imatt->nadir_location, 8);
    memcpy(&buf[48], &imatt->image_pointer, 4);
    memcpy(&buf[52], &imatt->calibration_number, 4);
    memcpy(&buf[56], &imatt->spice_pointer, 4);
}

void Grid2Buf(grid, buf)
struct otd_DENSITY	*grid;
unsigned char buf[128];
{
    memcpy(&buf[0], &grid->location, 8);
    memcpy(&buf[8], &grid->flash_count, 4);
}

void ViewTime2Buf(vt, buf)
struct otd_View_time *vt;
unsigned char buf[128];
{
    memcpy(&buf[0], &vt->grid_point, 8);
    memcpy(&buf[8], &vt->TAI93_start, 8);
    memcpy(&buf[16], &vt->duration, 2);
}

void Attribute2Buf(attribute, buf)
struct otd_Orbit_attributes *attribute;
unsigned char buf[128];
{
    memcpy(&buf[0], &attribute->ID, 4);
    memcpy(&buf[4], &attribute->TAI93_start, 8);
    memcpy(&buf[12], &attribute->start_location, 8);
    memcpy(&buf[20], &attribute->TAI93_end, 8);
    memcpy(&buf[28], &attribute->end_location, 8);
}

void Threshold2Buf(thresh, buf)
struct otd_THRESHOLD    *thresh;
unsigned char buf[128];
{
    memcpy(&buf[0], &thresh->TAI93, 8);
    memcpy(&buf[8], &thresh->values, 16);
}

void Area2Buf(area, buf)
struct otd_AREA *area;
unsigned char buf[128];
{
     
    memcpy(&buf[0], &area->seq, 4); 
    memcpy(&buf[4], &area->TAI93, 8);
    memcpy(&buf[12], &area->delta, 4);
    memcpy(&buf[16], &area->view, 4);
    memcpy(&buf[20], &area->s_z_a, 2);
    memcpy(&buf[22], &area->d_n_t, 1);
    memcpy(&buf[23], &area->end_status, 1);
    memcpy(&buf[24], &area->events, 2);
    memcpy(&buf[26], &area->cent[0], 8);
    memcpy(&buf[34], &area->stdev[0], 8);
    memcpy(&buf[42], &area->loc_count, 2);
    memcpy(&buf[44], &area->rad, 4);
    memcpy(&buf[48], &area->orbit_id, 4);
    memcpy(&buf[52], &area->day, 4);
    memcpy(&buf[56], &area->children, 4);
    memcpy(&buf[60], &area->child_seq, 4);
    memcpy(&buf[64], &area->child_rec, 4);
    memcpy(&buf[68], &area->QA[0], 8);
}

void Flash2Buf(flash, buf)
struct otd_FLASH *flash;
unsigned char buf[128];
{
    memcpy(&buf[0],&flash->seq,4);
    memcpy(&buf[4],&flash->TAI93,8);
    memcpy(&buf[12],&flash->delta,4);
    memcpy(&buf[16],&flash->view,4);
    memcpy(&buf[20],&flash->s_z_a,2);
    memcpy(&buf[22],&flash->d_n_t,1);
    memcpy(&buf[23],&flash->end_status,1);
    memcpy(&buf[24],&flash->events,2);
    memcpy(&buf[26],&flash->cent[0],8);
    memcpy(&buf[34],&flash->stdev[0],8);
    memcpy(&buf[42],&flash->loc_count,2);
    memcpy(&buf[44],&flash->rad,4);
    memcpy(&buf[48],&flash->parent_seq,4);
    memcpy(&buf[52],&flash->parent_rec,4);
    memcpy(&buf[56],&flash->children,4);
    memcpy(&buf[60],&flash->child_seq,4);
    memcpy(&buf[64],&flash->child_rec,4);
    memcpy(&buf[68],&flash->QA[0],8);
}

void Group2Buf(group, buf)
struct otd_GROUP *group;
unsigned char buf[128];
{
    memcpy(&buf[0],&group->seq,4);
    memcpy(&buf[4],&group->TAI93,8);
    memcpy(&buf[12],&group->delta,4);
    memcpy(&buf[16],&group->view,4);
    memcpy(&buf[20],&group->s_z_a,2);
    memcpy(&buf[22],&group->d_n_t,1);
    memcpy(&buf[23],&group->end_status,1);
    memcpy(&buf[24],&group->events,2);
    memcpy(&buf[26],&group->cent[0],8);
    memcpy(&buf[34],&group->stdev[0],8);
    memcpy(&buf[42],&group->loc_count,2);
    memcpy(&buf[44],&group->rad,4);
    memcpy(&buf[48],&group->parent_seq,4);
    memcpy(&buf[52],&group->parent_rec,4);
    memcpy(&buf[56],&group->children,4);
    memcpy(&buf[60],&group->child_seq,4);
    memcpy(&buf[64],&group->child_rec,4);
    memcpy(&buf[68],&group->QA[0],8);
}

void Event2Buf(event, buf)
struct otd_EVENT *event;
unsigned char buf[128];
{
    memcpy(&buf[0],&event->event_number,4);
    memcpy(&buf[4],&event->seq_number,4);
    memcpy(&buf[8],&event->TAI93,8);
    memcpy(&buf[16],&event->s_z_a,2);
    memcpy(&buf[18],&event->d_n_t,1);
    memcpy(&buf[19],&event->x_pixel,2);
    memcpy(&buf[21],&event->y_pixel,2);
    memcpy(&buf[23],&event->raw_radiance,2);
    memcpy(&buf[25],&event->cal_radiance,4);
    memcpy(&buf[29],&event->parent_seq,4);
    memcpy(&buf[33],&event->parent_rec,4);
    memcpy(&buf[37],&event->QA[0],8);
    memcpy(&buf[45],&event->location,8);
}

void Summary2Buf(sum,buf)
struct Orbit_summary *sum;
unsigned char buf[128];
{
    memcpy(&buf[0], &sum->areas, 4);
    memcpy(&buf[4], &sum->flashes, 4);
    memcpy(&buf[8], &sum->groups, 4);
    memcpy(&buf[12], &sum->events, 4);
    memcpy(&buf[16], &sum->total_cal_radiance, 4);
};

void AddASCIIOutputField(type, var, format)
int 	type;
enum    data_parameters  var;
char    format[8];
{
    switch (type) {
	case A:
	    {
		WriteParams.Area.Param[WriteParams.Area.NumParams].Var = var;
		strcpy(WriteParams.Area.Param[WriteParams.Area.NumParams].CFormat, format);
		WriteParams.Area.NumParams++;
		break;
	    }
	case F:
	    {
		WriteParams.Flash.Param[WriteParams.Flash.NumParams].Var = var;
		strcpy(WriteParams.Flash.Param[WriteParams.Flash.NumParams].CFormat, format);
		WriteParams.Flash.NumParams++;	
		break;	
	    }
	case G:
	    {
		WriteParams.Group.Param[WriteParams.Group.NumParams].Var = var;
		strcpy(WriteParams.Group.Param[WriteParams.Group.NumParams].CFormat, format);
		WriteParams.Group.NumParams++;
		break;		
	    }
	case E:
	    {
		WriteParams.Event.Param[WriteParams.Event.NumParams].Var = var;
		strcpy(WriteParams.Event.Param[WriteParams.Event.NumParams].CFormat, format);
		WriteParams.Event.NumParams++;		
		break;
	    }
    }
    return;
}

void ResetSDSOutputFields()
{
    RemoveSDSOutputField(BROWSES);
    RemoveSDSOutputField(VIEWTIMES);
    RemoveSDSOutputField(IMAGES);
}

void AddSDSOutputField(type)
int type;
{
    ChangeSDSOutputField(type, KEEP);
}

void RemoveSDSOutputField(type)
int type;
{
    ChangeSDSOutputField(type, IGNORE);
}

void SetSDSBounds(type, par1, par2, par3, par4)
int type;
double par1,par2,par3,par4;
{
	extern struct SDSBounds;
	
	SDSBounds.Active = TRUE;
	SDSBounds.BoundType = type;
	switch (type) {
		case BOX: {
			SDSBounds.Bounds.Box.LL.Latitude = par1;
			SDSBounds.Bounds.Box.LL.Longitude = par2;
			SDSBounds.Bounds.Box.UR.Latitude = par3;
			SDSBounds.Bounds.Box.UR.Longitude = par4;
			break;
		}
	  	case CIRCLE:
		case CENTERED_BOX: {
			SDSBounds.Bounds.Circle.Center.Latitude = par1;
			SDSBounds.Bounds.Circle.Center.Longitude = par2;
			SDSBounds.Bounds.Circle.Min_Range_km = par3;
			SDSBounds.Bounds.Circle.Max_Range_km = par4;
			break;
		}
	}
}

void ChangeSDSOutputField(type, setting)
int type, setting;
{
    switch (type) {
   	case HIRESBROWSES: {
   		SDSFields.HiresBrowse = setting;
   		break;
   		}
	case BROWSES:
	    {
		SDSFields.Browse = setting;
		break;
	    }
	case VIEWTIMES:
	    {
		SDSFields.Viewtime = setting;
		break;
	    }
	case IMAGES:
	    {
		SDSFields.Images = setting;
		break;
	    }
    }
}

void ResetASCIIOutputFields(type, reset_value)
int type;
char reset_value[8];
{
    
    if (!strcmp(reset_value, "DEFAULT")) 
	    {
		switch (type) {
		    case A:
			{
			    WriteParams.Area.NumParams = 2;
			    WriteParams.Area.Param[0].Var = TIME_UTC;
			    strcpy(WriteParams.Area.Param[0].CFormat, DEFAULT);
			    WriteParams.Area.Param[1].Var = LOCATION;
			    strcpy(WriteParams.Area.Param[1].CFormat, DEFAULT);
			    break;
			}
		    case F:
			{
			    WriteParams.Flash.NumParams = 2;
			    WriteParams.Flash.Param[0].Var = TIME_UTC;
			    strcpy(WriteParams.Flash.Param[0].CFormat, DEFAULT);
			    WriteParams.Flash.Param[1].Var = LOCATION;
			    strcpy(WriteParams.Flash.Param[1].CFormat, DEFAULT);
			    break;
			}
		    case G:
			{
			    WriteParams.Group.NumParams = 2;
			    WriteParams.Group.Param[0].Var = TIME_UTC;
			    strcpy(WriteParams.Group.Param[0].CFormat, DEFAULT);
			    WriteParams.Group.Param[1].Var = LOCATION;
			    strcpy(WriteParams.Group.Param[1].CFormat, DEFAULT);
			    break;
			}
		    case E:
			{
			    WriteParams.Event.NumParams = 2;
			    WriteParams.Event.Param[0].Var = TIME_UTC;
			    strcpy(WriteParams.Event.Param[0].CFormat, DEFAULT);
			    WriteParams.Event.Param[1].Var = LOCATION;
			    strcpy(WriteParams.Event.Param[1].CFormat, DEFAULT);
			    break;
			}
		}
		
	    }
    else if (!strcmp(reset_value, "EMPTY")) 
	    {
		switch (type) {
		    case A:
			{
			    WriteParams.Area.NumParams = 0;
			    break;
			}
		    case F:
			{
			    WriteParams.Flash.NumParams = 0;
			    break;
			}
		    case G:
			{
			    WriteParams.Group.NumParams = 0;
			    break;
			}
		    case E:
			{
			    WriteParams.Event.NumParams = 0;
			    break;
			}
		}
	
	    }
    return;
}

void ReduceSDS(old,new)
struct anSDS *old, *new;
{
	extern struct anAreaBound SDSBounds;
	int crosses_date_line = FALSE;
	int32 min_y, max_y, min_x, max_x, ctr_x, ctr_y;
	long grid_size, lat_size, lon_size;
	double min_lat, max_lat, min_lon, max_lon, lat, lon, baz;
	
	/* Warning ... some of these will fail near the date line! */
	
	switch (SDSBounds.BoundType) {
		case BOX: {
			min_lat = SDSBounds.Bounds.Box.LL.Latitude;
			max_lat = SDSBounds.Bounds.Box.UR.Latitude;
			min_lon = SDSBounds.Bounds.Box.LL.Longitude;
			max_lon = SDSBounds.Bounds.Box.UR.Longitude;
			crosses_date_line = (min_lon > max_lon);
			min_y = (int)((min_lat-(-90))/0.5);
			max_y = (int)((max_lat-(-90))/0.5);
			min_x = (int)((min_lon-(-180.))/0.5);
			max_x = (int)((max_lon-(-180.))/0.5);
			break;
		}
		case CIRCLE: {
			RgAz2LatLon(SDSBounds.Bounds.Circle.Center.Latitude, SDSBounds.Bounds.Circle.Center.Longitude,
						&lat, &lon, 0., &baz, SDSBounds.Bounds.Circle.Max_Range_km*1000.);
			max_lat = lat;
			RgAz2LatLon(SDSBounds.Bounds.Circle.Center.Latitude, SDSBounds.Bounds.Circle.Center.Longitude,
						&lat, &lon, 180., &baz, SDSBounds.Bounds.Circle.Max_Range_km*1000.);
			min_lat = lat;
			RgAz2LatLon(SDSBounds.Bounds.Circle.Center.Latitude, SDSBounds.Bounds.Circle.Center.Longitude,
						&lat, &lon, 270., &baz, SDSBounds.Bounds.Circle.Max_Range_km*1000.);
			if (lon > 180.0) {
				min_lon = -1.*(360.0 - lon);
			} else {
				min_lon = lon;
			}
			RgAz2LatLon(SDSBounds.Bounds.Circle.Center.Latitude, SDSBounds.Bounds.Circle.Center.Longitude,
						&lat, &lon, 90., &baz, SDSBounds.Bounds.Circle.Max_Range_km*1000.);
			if (lon > 180.0) {
				max_lon = -1*(360.0 - lon);
			} else {
				max_lon = lon;	
			}
			crosses_date_line = (min_lon > max_lon);
			min_y = (int)((min_lat-(-90.))/0.5);
			max_y = (int)((max_lat-(-90.))/0.5);
			min_x = (int)((min_lon-(-180.))/0.5);
			max_x = (int)((max_lon-(-180.))/0.5);
			printf("%d,%d  %d,%d  %7.2f ,%7.2f  %7.2f , %7.2f \n",
				min_x,max_x,min_y,max_y,min_lon,max_lon,min_lat,max_lat);
				
			break;
		}
		case CENTERED_BOX: {
			ctr_x = (int)((SDSBounds.Bounds.Circle.Center.Longitude-(-180.))/0.5);
			ctr_y = (int)((SDSBounds.Bounds.Circle.Center.Latitude-(-90.))/0.5);
			min_x = ctr_x - (int)SDSBounds.Bounds.Circle.Min_Range_km;
			max_x = ctr_x + (int)SDSBounds.Bounds.Circle.Min_Range_km;
			min_y = ctr_y - (int)SDSBounds.Bounds.Circle.Max_Range_km;
			max_y = ctr_y + (int)SDSBounds.Bounds.Circle.Max_Range_km;
			crosses_date_line = ((min_x < 0) || (max_x > 720));
			break;
		}
	}
	if (!crosses_date_line) {
		lat_size = (max_y - min_y + 1);
		lon_size = (max_x - min_x + 1);
		grid_size = lat_size*lon_size;
		new->grid   = SubArray(old->grid,   old->dims[1], old->dims[0], min_x, min_y, max_x, max_y);
		new->latptr = SubArray(old->latptr, old->dims[0],            1, old->dims[0]-max_y-1, 0, old->dims[0]-min_y-1,     0);
		new->lonptr = SubArray(old->lonptr, old->dims[1],            1, min_x,     0, max_x,     0);
		new->dims[1] = max_x-min_x+1;
		new->dims[0] = max_y-min_y+1;
	}
	printf("%d %d, %d %d, %d x %d\n", min_x, max_x, min_y, max_y, new->dims[1], new->dims[0]);
	
}

float32 *SubArray(old, d1, d2, min_x, min_y, max_x, max_y)
float32 *old;
int32 d1,d2,min_x,min_y,max_x,max_y;
{
	int32 oldx,oldy,newx,newy,oldxsize,oldysize,newxsize,newysize;
	float32 *new;
	
	oldxsize = d1;
	oldysize = d2;
	newxsize = (max_x-min_x+1);
	newysize = (max_y-min_y+1);
	new = (float32 *)calloc(newxsize*newysize,sizeof(float32));
	for (oldx=min_x,newx=0; oldx <= max_x; oldx++,newx++) {
		for (oldy=min_y,newy=0; oldy <= max_y; oldy++,newy++) {
			new[newx+(newysize-newy-1)*newxsize] = 
				old[oldx+(oldysize-oldy-1)*oldxsize];
		}
	}
	return(new);
}

